<?php

use yii\helpers\Html;
use yii\grid\GridView;


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Compilation Stock Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    table,
    th,
    td {
        border: 1px solid black !important;
        border-collapse: collapse !important;

    }

    th,
    td {
        padding: 5px !important;
        text-align: left !important;
        color: black !important;

    }

    th {
        border: none;
        background-color: slategray;
    }
</style>

<div class="row">

    <div class="col-md-12">
        <h4 style="text-align: center">Monthly Summary</h4>
        <?php if ($model->from_date != '' & $model->to_date != '') { ?>
            <p style="text-align: center">For period <?= Yii::$app->formatter->asDate($model->from_date, 'long'); ?> to <?= Yii::$app->formatter->asDate($model->to_date, 'long'); ?></p>
        <?php } ?>
    </div>
    <div style="width: 48%; float:left">
        <h5 style="text-align: center">Sale</h5>

        <p><b>Name:</b><?= $product; ?> </p>

        <?= GridView::widget([
            'dataProvider' => $dataProvider_1,
            // 'showFooter' => true,
            // 'footerRowOptions'=>['style'=>'font-weight:bold;'],
            'options' => [
                'class' => 'YourCustomTableClass',
            ],
            "id" => "grid",
            'columns' => [
                [
                    'label' => 'Date',
                    // 'attribute'=>'Date',
                    'value' => function ($data) {
                        return $data->Date;
                    }
                ],
                [
                    'label' => 'Qty',
                    // 'attribute'=>'Qty',
                    'value' => function ($data) {
                        return $data->Qty;
                    }
                ],
                [
                    'label' => 'Vch No',
                    // 'attribute'=>'VChNo',
                    'value' => function ($data) {
                        return $data->VChNo;
                    }
                ],
                [
                    'label' => 'Vendor/Branch Name',
                    // 'attribute'=>'VendorName',
                    'value' => function ($data) {
                        return $data->VendorName;
                    }
                ]

            ],
        ]); ?>
    </div>
    <div style="width:48%; float: left; margin-left: 4%">
        <h5 style="text-align: center">Purchase</h5>
        <?= GridView::widget([
            'dataProvider' => $dataProvider_2,
            // 'showFooter' => true,
            'footerRowOptions' => ['style' => 'font-weight:bold;'],
            'options' => [
                'class' => 'YourCustomTableClass',
            ],
            "id" => "grid",
            'columns' => [
                [
                    'label' => 'Date',
                    // 'attribute'=>'Date',
                    'value' => function ($data) {
                        return $data->Date;
                    }
                ],
                [
                    'label' => 'Qty',
                    // 'attribute'=>'Qty',
                    'value' => function ($data) {
                        return $data->Qty;
                    }
                ],
                [
                    'label' => 'Vch No',
                    // 'attribute'=>'VChNo',
                    'value' => function ($data) {
                        return $data->VChNo;
                    }
                ],
                [
                    'label' => 'Customer Name',
                    // 'attribute'=>'Particulars',
                    'value' => function ($data) {
                        return $data->Particulars;
                    }
                ],


            ],
        ]); ?>


    </div>

</div>


<?php ob_start(); ?>

<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>