<?php

namespace backend\modules\master\controllers;

use Yii;
use backend\modules\master\models\LeadsQuotes;
use backend\modules\master\models\LeadsQuotesSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LeadsQuotesController implements the CRUD actions for LeadsQuotes model.
 */
class LeadsQuotesController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all LeadsQuotes models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new LeadsQuotesSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('/leads/leads-quotes/index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single LeadsQuotes model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('/leads/leads-quotes/view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new LeadsQuotes model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new LeadsQuotes();

        // if ($model->load(Yii::$app->request->post()) && $model->save()) {
        //     return $this->redirect(['/leads/leads-quotes/view', 'id' => $model->id]);
        // }
        if ($model->load(Yii::$app->request->post()) ) {
            $data= Yii::$app->request->post();
           // echo "<pre>";print_r($data);die();
            $model->supply_attracts = $data['LeadsQuotes']['supply_attracts'];
            $model->customer = $data['LeadsQuotes']['customer'];
            $model->executive = $data['LeadsQuotes']['executive'];
            $model->notes = $data['LeadsQuotes']['notes'];
            $model->receiver_gstn = $data['LeadsQuotes']['receiver_gstn'];
            $model->sales_type = $data['LeadsQuotes']['sales_type'];
            $model->supply_attracts_rcharge = $data['LeadsQuotes']['supply_attracts_rcharge'];
            $model->supply_type = $data['LeadsQuotes']['supply_type'];
            $model->pricelist = $data['LeadsQuotes']['pricelist'];
            $model->Is_tax = $data['LeadsQuotes']['Is_tax'];
            $model->terms = $data['LeadsQuotes']['terms'];
            $model->Date = $data['LeadsQuotes']['Date'];
            if($model->save()){
                Yii::$app->getSession()->setFlash('success', 'Successfully created the leads');
                return $this->redirect(['index']);
            }
            else{
                print_r($model->getErrors());die();
            }
        }

        return $this->render('/leads/leads-quotes/create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing LeadsQuotes model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['/leads/leads-quotes/view', 'id' => $model->id]);
        }

        return $this->render('/leads/leads-quotes/update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing LeadsQuotes model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the LeadsQuotes model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return LeadsQuotes the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = LeadsQuotes::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
