<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\AccountGroup;

/**
 * AccountGroupSearch represents the model behind the search form of `backend\modules\master\models\AccountGroup`.
 */
class AccountGroupSearch extends AccountGroup
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['account_group_id', 'parent_id', 'type_id', 'status'], 'integer'],
            [['group_name'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = AccountGroup::find()->orderBy(['account_group_id'=>SORT_DESC]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            //$query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'account_group_id' => $this->account_group_id,
            'parent_id' => $this->parent_id,
            'type_id' => $this->type_id,
            'status' => 1,
        ]);

        $query->andFilterWhere(['like', 'group_name', $this->group_name])
        ->andFilterWhere(['like', 'parent_id', $this->parent_id])
        ->andFilterWhere(['like', 'type_id', $this->type_id]);

        return $dataProvider;
    }
}
