<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "account_type".
 *
 * @property int $account_type_id
 * @property string $account_name
 * @property string $created_at
 * @property string $updated_at
 *
 * @property GroupName[] $groupNames
 */
class AccountType extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'account_type';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['account_name'], 'required'],
            [['created_at', 'updated_at'], 'safe'],
            [['account_name'], 'string', 'max' => 50],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'account_type_id' => 'Account Type ID',
            'account_name' => 'Account Name',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[GroupNames]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getGroupNames()
    {
        return $this->hasMany(GroupName::className(), ['account_type_id' => 'account_type_id']);
    }
}
