<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "call_status".
 *
 * @property int $id
 * @property string $call_status_name
 * @property string $created_at
 * @property string $updated_at
 */
class CallStatus extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'call_status';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['call_status_name'], 'required'],
            [['created_at', 'updated_at'], 'safe'],
            [['call_status_name'], 'string', 'max' => 254],
            ['call_status_name', 'unique', 'message' => 'This call status name has already been taken.'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'call_status_name' => 'Call Status Name',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
