<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "category".
 *
 * @property int $id
 * @property string $name
 * @property string $image
 * @property string|null $parent_category
 * @property string $created_at
 * @property string $updated_at
 */
class Category extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'category';
    }

     public $categoryname;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name'], 'required'],
            [['created_at', 'updated_at'], 'safe'],
            [['name', 'parent_category','categoryname'], 'string', 'max' => 128],
            [['image'],'file', 'extensions' => 'png,jpg','maxSize' => 1024*1024,],
            ['name', 'unique', 'message' => 'This category has already been taken.'],

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'image' => 'Image',
            'parent_category' => 'Parent Category',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
