<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "customer".
 *
 * @property int $id
 * @property int|null $page_id
 * @property string|null $business_name
 * @property string|null $mobile
 * @property string|null $account_id
 * @property string|null $customer_code
 * @property string|null $customer_type
 * @property string|null $price_list
 * @property string|null $dob
 * @property string|null $email2
 * @property string|null $email
 * @property string|null $fax
 * @property string|null $website
 * @property string|null $phone
 * @property string|null $phone2
 * @property string|null $executive
 * @property string|null $adderss_line_1
 * @property string|null $adderss_line_2
 * @property string|null $adderss_line_3
 * @property string|null $area
 * @property string|null $city
 * @property string|null $country
 * @property string|null $state
 * @property int|null $pin_code
 * @property string|null $sipping_to_name
 * @property string|null $shipping_address_1
 * @property string|null $shipping_address_2
 * @property string|null $shipping_address_3
 * @property string|null $shipping_city
 * @property int|null $shipping_postcode
 * @property string|null $shipping_state
 * @property string|null $shipping_country
 * @property string|null $opening_as_on
 * @property string|null $customer_gst_type
 * @property string|null $gstin_no
 * @property string|null $ho_state_code
 * @property string|null $type_of_removal
 * @property string|null $importer_exporter
 * @property string|null $pan_number
 * @property string|null $aadhar_number
 * @property string|null $cst_no
 * @property string|null $ecc_no
 * @property string|null $cex_no
 * @property string|null $ledger
 * @property string|null $credit_limit
 * @property string|null $credit_limit2
 * @property string|null $credit_days
 * @property string|null $credit_terms
 * @property string|null $attach_document
 * @property string|null $vendor_brn
 * @property string|null $ic_type
 * @property string|null $tin
 * @property string $created_at
 * @property string|null $updated_at
 *
 * @property CustomerContact[] $customerContacts
 */
class Customer extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'customer';
    }

    public $files;
    public $from_date;
    public $to_date;
    public $findid;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            ['gstin_no', 'required', 'when' => function ($model) { return $model->customer_gst_type == 'Registred';}, 'whenClient' => "function (attribute, value) { return $('#customer-customer_gst_type').val() == 'Registred';}"],
            [['page_id', 'pin_code', 'shipping_postcode'], 'integer'],
            [['business_name','customer_gst_type','from_date','to_date'], 'required'],
            [['dob','created_at', 'updated_at'], 'safe'],
            [['business_name', 'account_id', 'customer_code', 'customer_type', 'email2', 'email', 'fax', 'website', 'executive', 'adderss_line_1', 'adderss_line_2', 'adderss_line_3', 'area', 'city', 'country', 'state', 'sipping_to_name', 'shipping_address_1', 'shipping_address_2', 'shipping_address_3', 'shipping_city', 'shipping_state', 'shipping_country', 'customer_gst_type', 'gstin_no', 'ho_state_code', 'type_of_removal', 'importer_exporter', 'pan_number', 'aadhar_number', 'cst_no', 'ecc_no', 'ledger', 'credit_limit', 'credit_limit2', 'credit_days', 'credit_terms', 'attach_document', 'customer_brn', 'ic_type', 'tin','price_list','findid','from_date','to_date'], 'string', 'max' => 254],
            [['is_shipping_address_same_as_address','opening_as_on'],'string','max'=>30],
            [['mobile', 'phone', 'phone2'], 'string', 'max' => 10],
            [['cex_no'], 'string', 'max' => 255],
            [['pin_code',], 'string','min'=>6, 'max' =>6],
            [['pin_code'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Pin Code Can Contain only numeric characters.'],
            [['shipping_postcode',], 'string','min'=>6, 'max' =>6],
            [['shipping_postcode'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Shipping PostCode Can Contain only numeric characters.'],
             [['email','email2'], 'email'],
             [['country', 'state', 'city','area','shipping_city', 'shipping_state', 'shipping_country'], 'string', 'max' => 56],

             [['phone'], 'string','min'=>10, 'max' => 10],
             [['phone'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Contact No can Contain only numeric characters.'],

             [['phone2'], 'string','min'=>10, 'max' => 10],
             [['phone2'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Contact No can Contain only numeric characters.'],

             [['mobile'], 'string','min'=>10, 'max' => 10],
             [['mobile'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Mobile No can Contain only numeric characters.'],

            //  [[ 'service_task_no'], 'string','min'=>15, 'max' => 15],
            //  [['service_task_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Service Task Number Can Contain only numeric characters.'],

             [['aadhar_number',], 'string','min'=>12, 'max' => 12],
             
             [['aadhar_number'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Aadhar Format should be like numeric.'],

             [['pan_number',], 'string','min'=>10, 'max' => 10],
             [['pan_number'], 'match' ,'pattern'=>'/^([A-Z]){4}([0-9A-Z]){1}([0-9]){4}([A-Z]){1}?$/', 'message'=> 'PAN Format should be like  ABCDE1234Z.'],

             [['gstin_no'], 'string','min'=>15, 'max' => 15],
             [['gstin_no'], 'match' ,'pattern'=>'/^([0-9]){2}([A-Z]){4}([0-9A-Z]){1}([0-9]){4}([A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}?$/', 'message'=> 'PAN Format should be like  12ABCDE1234Z1Z1.'],

             [['tin',], 'string','min'=>10, 'max' => 10],
             [['tin'], 'match' ,'pattern'=>'/^([A-Z]){5}([0-9]){4}([A-Z]){1}?$/', 'message'=> 'TIN Format should be like  ABCDE1234Z.'],

             ['email','unique', 'targetClass' => '\common\models\User', 'message' => 'This email address has already been taken.'],
            ['phone','unique', 'message' => 'This Phone no has already been taken.'],
            ['mobile','unique', 'message' => 'This Phone no has already been taken.'],
            // ['phone1','unique', 'message' => 'This Phone no has already been taken.'],
            // [['file'], 'file', 'skipOnEmpty' => true,'checkExtensionByMimeType'=>false, 'extensions' => 'png,jpg,xls,xlsx,pdf,doc'],
            [['opening_as_on'], 'number','numberPattern'=>'/^\d+(.\d{1,2})?$/', 'message'=> 'Integer or decimal value upto 2 digit is required'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'page_id' => 'Page ID',
            'business_name' => 'Business Name',
            'mobile' => 'Mobile',
            'account_id' => 'Account ID',
            'customer_code' => 'Customer Code',
            'customer_type' => 'Customer Type',
            'price_list' => 'Price List',
            'dob' => 'Dob',
            'email2' => 'Email2',
            'email' => 'Email',
            'fax' => 'Fax',
            'website' => 'Website',
            'phone' => 'Phone',
            'phone2' => 'Phone2',
            'executive' => 'Executive',
            'adderss_line_1' => 'Adderss Line 1',
            'adderss_line_2' => 'Adderss Line 2',
            'adderss_line_3' => 'Adderss Line 3',
            'area' => 'Area',
            'city' => 'City',
            'country' => 'Country',
            'state' => 'State',
            'pin_code' => 'Pin Code',
            'sipping_to_name' => 'Sipping To Name',
            'shipping_address_1' => 'Shipping Address 1',
            'shipping_address_2' => 'Shipping Address 2',
            'shipping_address_3' => 'Shipping Address 3',
            'shipping_city' => 'Shipping City',
            'shipping_postcode' => 'Shipping Postcode',
            'shipping_state' => 'Shipping State',
            'shipping_country' => 'Shipping Country',
            'opening_as_on' => 'Opening As On',
            'customer_gst_type' => 'Customer Gst Type',
            'gstin_no' => 'Gstin No',
            'ho_state_code' => 'Ho State Code',
            'type_of_removal' => 'Type Of Removal',
            'importer_exporter' => 'Importer Exporter',
            'pan_number' => 'Pan Number',
            'aadhar_number' => 'Aadhar Number',
            'cst_no' => 'Cst No',
            'ecc_no' => 'Ecc No',
            'cex_no' => 'Cex No',
            'ledger' => 'Ledger',
            'credit_limit' => 'Credit Limit',
            'credit_limit2' => 'Credit Limit2',
            'credit_days' => 'Credit Days',
            'credit_terms' => 'Credit Terms',
            'attach_document' => 'Attach Document',
            'customer_brn' => 'Customer Brn',
            'ic_type' => 'Ic Type',
            'tin' => 'Tin',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
            'findid'=>'Find Id'
        ];
    }

    /**
     * Gets query for [[CustomerContacts]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getCustomerContacts()
    {
        return $this->hasMany(CustomerContact::className(), ['customer_id' => 'id']);
    }
}
