<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "customer_document".
 *
 * @property int $id
 * @property int $customer_id
 * @property string $document_name
 * @property string $created_at
 * @property string $updated_at
 */
class CustomerDocument extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'customer_document';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            // [['customer_id'], 'required'],
            [['customer_id'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['document_name'], 'file', 'maxFiles' => 5,'extensions'=> 'png, jpg, jpeg, gif, pdf','maxSize'=>2097152, 'message'=>'File has to be smaller than 2MB'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'customer_id' => 'Customer ID',
            'document_name' => 'Document Name',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
