<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "customer_type".
 *
 * @property int $id
 * @property string $customer_type
 * @property string $created_at
 * @property string $updated_at
 */
class CustomerType extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'customer_type';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['customer_type'], 'required'],
            [['created_at', 'updated_at'], 'safe'],
            [['customer_type'], 'string', 'max' => 254],
            ['customer_type', 'unique', 'message' => 'This customer type already exist.'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'customer_type' => 'Customer Type',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
