<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "discount_setting".
 *
 * @property int $id
 * @property int $discount_id
 * @property string|null $valuation_method
 * @property float|null $value
 * @property int|null $max_bill_qty
 * @property string|null $include_product
 * @property string|null $exclude_product
 * @property string $created_at
 * @property string $updated_at
 *
 * @property ProductDiscount $discount
 */
class DiscountSetting extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'discount_setting';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['discount_id'], 'required'],
            [['discount_id', 'max_bill_qty'], 'integer'],
            [['value'], 'number'],
            [['include_product', 'exclude_product'], 'string'],
            [['created_at', 'updated_at'], 'safe'],
            [['valuation_method'], 'string', 'max' => 32],
            [['discount_id'], 'exist', 'skipOnError' => true, 'targetClass' => ProductDiscount::className(), 'targetAttribute' => ['discount_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'discount_id' => 'Discount ID',
            'valuation_method' => 'Valuation Method',
            'value' => 'Value',
            'max_bill_qty' => 'Max Bill Qty',
            'include_product' => 'Include Product',
            'exclude_product' => 'Exclude Product',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[Discount]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getDiscount()
    {
        return $this->hasOne(ProductDiscount::className(), ['id' => 'discount_id']);
    }
}
