<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\GenericTemplate;

/**
 * GenericTemplateSearch represents the model behind the search form of `backend\modules\master\models\GenericTemplate`.
 */
class GenericTemplateSearch extends GenericTemplate
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['gt_id'], 'integer'],
            [['template_name', 'template_for', 'company_name', 'address', 'city', 'state', 'pin', 'country', 'mobile', 'phone_no', 'gst_no', 'fax_no', 'trade_licence', 'email', 'terms_and_condition', 'bank_name', 'account_holder', 'acc_no', 'ifsc_code', 'company_seal', 'company_signature'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = GenericTemplate::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'gt_id' => $this->gt_id,
        ]);

        $query->andFilterWhere(['like', 'template_name', $this->template_name])
            ->andFilterWhere(['like', 'template_for', $this->template_for])
            ->andFilterWhere(['like', 'company_name', $this->company_name])
            ->andFilterWhere(['like', 'address', $this->address])
            ->andFilterWhere(['like', 'city', $this->city])
            ->andFilterWhere(['like', 'state', $this->state])
            ->andFilterWhere(['like', 'pin', $this->pin])
            ->andFilterWhere(['like', 'country', $this->country])
            ->andFilterWhere(['like', 'mobile', $this->mobile])
            ->andFilterWhere(['like', 'phone_no', $this->phone_no])
            ->andFilterWhere(['like', 'gst_no', $this->gst_no])
            ->andFilterWhere(['like', 'fax_no', $this->fax_no])
            ->andFilterWhere(['like', 'trade_licence', $this->trade_licence])
            ->andFilterWhere(['like', 'email', $this->email])
            ->andFilterWhere(['like', 'terms_and_condition', $this->terms_and_condition])
            ->andFilterWhere(['like', 'bank_name', $this->bank_name])
            ->andFilterWhere(['like', 'account_holder', $this->account_holder])
            ->andFilterWhere(['like', 'acc_no', $this->acc_no])
            ->andFilterWhere(['like', 'ifsc_code', $this->ifsc_code])
            ->andFilterWhere(['like', 'company_seal', $this->company_seal])
            ->andFilterWhere(['like', 'company_signature', $this->company_signature]);

        return $dataProvider;
    }
}
