<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "group_name".
 *
 * @property int $group_name_id
 * @property string $name_group
 * @property int $account_type_id
 * @property string $created_at
 * @property string $updated_at
 *
 * @property AccountingLedger[] $accountingLedgers
 * @property AccountType $accountType
 */
class GroupName extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'group_name';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name_group', 'account_type_id'], 'required'],
            [['account_type_id'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['name_group'], 'string', 'max' => 100],
            [['account_type_id'], 'exist', 'skipOnError' => true, 'targetClass' => AccountType::className(), 'targetAttribute' => ['account_type_id' => 'account_type_id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'group_name_id' => 'Group Name ID',
            'name_group' => 'Group Name',
            'account_type_id' => 'Account Type ID',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[AccountingLedgers]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getAccountingLedgers()
    {
        return $this->hasMany(AccountingLedger::className(), ['group_name_id' => 'group_name_id']);
    }

    /**
     * Gets query for [[AccountType]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getAccountType()
    {
        return $this->hasOne(AccountType::className(), ['account_type_id' => 'account_type_id']);
    }
}
