<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\GroupName;

/**
 * GroupNameSearch represents the model behind the search form of `backend\modules\master\models\GroupName`.
 */
class GroupNameSearch extends GroupName
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['group_name_id', 'account_type_id'], 'integer'],
            [['name_group', 'created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = GroupName::find()->where(['is_deleted'=>0])->orderby(['group_name_id'=>SORT_DESC]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'group_name_id' => $this->group_name_id,
            'account_type_id' => $this->account_type_id,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'name_group', $this->name_group]);

        return $dataProvider;
    }
}
