<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "lead_executive".
 *
 * @property int $id
 * @property string $name
 * @property string $type
 * @property string $products
 * @property string $photo
 * @property string $email
 * @property string $phone
 * @property string $executive_ic
 * @property string $ic_type
 * @property string $address_line1
 * @property string $address_line2
 * @property string $city
 * @property string $state
 * @property string $zip_code
 * @property string $target
 * @property string $target_based_on
 * @property int $status
 * @property string $created_at
 * @property string $updated_at
 */
class LeadExecutive extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'lead_executive';
    }
    public $password;
    public $customers;
    public $vendors;
    public $confirm_password;
    public $current_password;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [[ 'type', 'products', 'executive_ic','photo', 'ic_type', 'address_line1', 'address_line2', 'city', 'state', 'zip_code', 'target', 'target_based_on', 'status'], 'safe'],
            [['name', 'email', 'phone'],'required'],
            [['password','confirm_password'], 'required',  'on'=>'create'],
            [['status'], 'integer'],
            [['created_at', 'updated_at','customers','vendors'], 'safe'],
            [['name', 'type', 'ic_type'], 'string', 'max' => 512],
            [['photo'],'file', 'extensions' => 'png,jpg'],
            [['products', 'address_line1', 'address_line2'], 'string', 'max' => 1024],
            [['phone'], 'string', 'max' => 10],
            [['phone'], 'string','min'=>10, 'max' => 10],
            // [['password','confirm_password','current_password'],'safe'],
            [['phone'], 'match' ,'pattern'=>'/^\d{10}$/', 'message'=> 'Phone No should contain 10 digit and only numeric'], 
            [['executive_ic'], 'string', 'max' => 5122],
            [['city', 'state', 'target', 'target_based_on','email'], 'string', 'max' => 128],
            [['zip_code'], 'string', 'max' => 9],
            [['birth_date'], 'string', 'max' => 32],
            [['confirm_password'], 'required', 'when' => function($model) {
                return $model->password ;
            },'whenClient' => "function (attribute, value) {
                return $('#leadexecutive-password').val() ;
            }"],
            [['email'], 'email'],
            ['confirm_password','compare','compareAttribute'=>'password','operator'=>'==','message'=>'*password don\'t match'], 
            ['email', 'unique', 'targetClass' => '\common\models\User','on'=>'create', 'message' => 'This email address has already been taken.'],
            ['email', 'unique', 'message' => 'This email address has already been taken.'],

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'type' => 'Type',
            'products' => 'Products',
            'photo' => 'Photo',
            'email' => 'Email',
            'phone' => 'Phone',
            'executive_ic' => 'Executive Ic',
            'ic_type' => 'Ic Type',
            'address_line1' => 'Address Line1',
            'address_line2' => 'Address Line2',
            'city' => 'City',
            'state' => 'State',
            'zip_code' => 'Zip Code',
            'target' => 'Target',
            'target_based_on' => 'Target Based On',
            'status' => 'Status',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
            'birth_date' => 'Birth Date',
        ];
    }
}
