<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "leads".
 *
 * @property int $id
 * @property int|null $userid
 * @property string|null $enquiry_no
 * @property string|null $appoint_date
 * @property string|null $set_reminder
 * @property string|null $name
 * @property string|null $lead_executive
 * @property string|null $email
 * @property string|null $status
 * @property string|null $mobile
 * @property string|null $city
 * @property string|null $address
 * @property string|null $business_type
 * @property string|null $product_model
 * @property string|null $product_make
 * @property string|null $mode_enquiry
 * @property string|null $remark
 * @property int|null $is_disqualify
 * @property string|null $postponed_date
 * @property string|null $created_at
 * @property string $updated_at
 */
class Leads extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'leads';
    }
     public $from_date,$to_date,$search,$lead_type,$lead_status;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['userid', 'is_disqualify'], 'integer'],
            [['appoint_date', 'postponed_date','postponed_note', 'created_at','lead_date', 'updated_at','search','lead_type','lead_status','status'], 'safe'],
            [['appoint_date','name','mobile','remark','postponed_date','postponed_note'], 'required'],
            [['email'], 'email'],
            [['remark'], 'string'],
            [['enquiry_no', 'set_reminder', 'name', 'lead_executive', 'email', 'status', 'city', 'address', 'business_type', 'product_model', 'product_make', 'mode_enquiry'], 'string', 'max' => 255],
            [['from_date','to_date'],'safe'],
            [['mobile'], 'string', 'max' => 10],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'userid' => 'Userid',
            'enquiry_no' => 'Enquiry No',
            'appoint_date' => 'Appoint Date',
            'set_reminder' => 'Set Reminder',
            'name' => 'Name',
            'lead_executive' => 'Lead Executive',
            'email' => 'Email',
            'status' => 'Status',
            'mobile' => 'Mobile',
            'city' => 'City',
            'address' => 'Address',
            'business_type' => 'Business Type',
            'product_model' => 'Product Model',
            'product_make' => 'Product Make',
            'mode_enquiry' => 'Mode Enquiry',
            'remark' => 'Remark',
            'is_disqualify' => 'Is Disqualify',
            'postponed_date' => 'Postponed Date',
            'postponed_note' => 'Postponed Note',
            'created_at' => 'Created At',
            'lead_date' => 'Lead Date',
            'updated_at' => 'Updated At',
        ];
    }
}
