<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "parent_group".
 *
 * @property int $sno
 * @property int $parent_id
 * @property string $parent_name
 *
 * @property AccountGroup[] $accountGroups
 */
class ParentGroup extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'parent_group';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['sno', 'parent_id', 'parent_name'], 'required'],
            [['sno', 'parent_id'], 'integer'],
            [['parent_name'], 'string', 'max' => 255],
            [['parent_id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'sno' => 'Sno',
            'parent_id' => 'Parent ID',
            'parent_name' => 'Parent Name',
        ];
    }

    /**
     * Gets query for [[AccountGroups]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getAccountGroups()
    {
        return $this->hasMany(AccountGroup::className(), ['parent_id' => 'parent_id']);
    }
}
