<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\ParentGroup;

/**
 * ParentGroupSearch represents the model behind the search form of `backend\modules\master\models\ParentGroup`.
 */
class ParentGroupSearch extends ParentGroup
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['sno', 'parent_id'], 'integer'],
            [['parent_name'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = ParentGroup::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'sno' => $this->sno,
            'parent_id' => $this->parent_id,
        ]);

        $query->andFilterWhere(['like', 'parent_name', $this->parent_name]);

        return $dataProvider;
    }
}
