<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "product_discount".
 *
 * @property int $id
 * @property string $dis_type
 * @property string $dis_name
 * @property string $id_code
 * @property string|null $start_date
 * @property string|null $till_date
 * @property int $status
 * @property string|null $access
 * @property string|null $display_as
 * @property int|null $category_include_exclude
 * @property string $created_at
 * @property string $updated_at
 *
 * @property DiscountCustomer[] $discountCustomers
 * @property DiscountSetting[] $discountSettings
 */
class ProductDiscount extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'product_discount';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['dis_type', 'dis_name', 'id_code'], 'required'],
            [['status', 'category_include_exclude'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['dis_type', 'dis_name', 'id_code'], 'string', 'max' => 128],
            [['start_date', 'till_date', 'access', 'display_as'], 'string', 'max' => 32],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'dis_type' => 'Dis Type',
            'dis_name' => 'Dis Name',
            'id_code' => 'Id Code',
            'start_date' => 'Start Date',
            'till_date' => 'Till Date',
            'status' => 'Status',
            'access' => 'Access',
            'display_as' => 'Display As',
            'category_include_exclude' => 'Category Include Exclude',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[DiscountCustomers]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getDiscountCustomers()
    {
        return $this->hasMany(DiscountCustomer::className(), ['discount_id' => 'id']);
    }

    /**
     * Gets query for [[DiscountSettings]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getDiscountSettings()
    {
        return $this->hasMany(DiscountSetting::className(), ['discount_id' => 'id']);
    }
}
