<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "product_pricelist".
 *
 * @property int $id
 * @property string $name
 * @property string $currency
 * @property string|null $price_list_type
 * @property string|null $display_as
 * @property string|null $start_date
 * @property string|null $till_date
 * @property string|null $based_on
 * @property int $status
 * @property string $created_at
 * @property string $updated_at
 */
class ProductPricelist extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'product_pricelist';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'currency'], 'required'],
            [['status'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['name', 'currency', 'price_list_type', 'display_as'], 'string', 'max' => 128],
            [['start_date', 'till_date', 'based_on'], 'string', 'max' => 32],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'currency' => 'Currency',
            'price_list_type' => 'Price List Type',
            'display_as' => 'Display As',
            'start_date' => 'Start Date',
            'till_date' => 'Till Date',
            'based_on' => 'Based On',
            'status' => 'Status',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
