<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "product_unit".
 *
 * @property int $id
 * @property string $unit_name
 * @property int $is_piece_unit
 * @property string $created_at
 * @property string $updated_at
 */
class ProductUnit extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'product_unit';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['unit_name', 'is_piece_unit'], 'required'],
            [['is_piece_unit'], 'integer'],
            [['created_at', 'updated_at'], 'safe'],
            [['unit_name'], 'string', 'max' => 32],
            ['unit_name', 'unique', 'message' => 'This unit name has already been taken.'],

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'unit_name' => 'Unit Name',
            'is_piece_unit' => 'Is Piece Unit',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
