<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "purchase_against_gr".
 *
 * @property int $id
 * @property int|null $purchase_id
 * @property int|null $gr_id
 * @property int|null $vendor_id
 * @property float|null $total_amount
 * @property string|null $purchase_date
 * @property string|null $source
 * @property int|null $gr_status
 * @property int|null $bill_no
 * @property string|null $convert_to
 * @property string $created_at
 * @property string $updated_at
 * @property int $is_deleted
 */
class PurchaseAgainstGr extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_against_gr';
    }

    public $commonsearch;
    public $purchase_status;
    public $searchproduct;
    public $from_date;
    public $to_date;
    public $vendor;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['purchase_id', 'gr_id', 'vendor_id', 'gr_status', 'bill_no', 'is_deleted'], 'integer'],
            [['total_amount'], 'number'],
            [['purchase_date', 'created_at', 'updated_at','from_date','to_date'], 'safe'],
            [['source'], 'string'],
            [['convert_to'], 'string', 'max' => 254],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'purchase_id' => 'Purchase ID',
            'gr_id' => 'Gr ID',
            'vendor_id' => 'Vendor ID',
            'total_amount' => 'Total Amount',
            'purchase_date' => 'Purchase Date',
            'source' => 'Source',
            'gr_status' => 'Gr Status',
            'bill_no' => 'Bill No',
            'convert_to' => 'Convert To',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
            'is_deleted' => 'Is Deleted',
        ];
    }
}
