<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "purchase_order".
 *
 * @property int $id
 * @property string|null $setting_type
 * @property string|null $vendor_name
 * @property string|null $sendor_gstin
 * @property string|null $bill_type
 * @property string|null $notes
 * @property string|null $delivery_address
 * @property string|null $supply_type
 * @property string|null $supply_attracts
 * @property string|null $currancy
 * @property string|null $point_of_supply
 * @property string|null $eligibity_of_itc
 * @property string|null $prefix
 * @property string|null $po_last
 * @property int|null $suffix
 * @property string|null $date
 * @property string|null $due_date
 * @property string|null $terms_of_payment
 * @property string|null $terms_and_condition
 * @property int|null $updated_by
 * @property string|null $supplier_ref
 * @property string|null $other_ref
 * @property string|null $dispatch_through
 * @property string|null $destination
 * @property string|null $mode_of_payment
 * @property string|null $delivery_date
 * @property string|null $reminder
 * @property string|null $terms_of_delivery
 * @property float|null $sub_total_amount
 * @property float|null $total_amount
 * @property string|null $reminder_for
 * @property string|null $reminder_through
 * @property string|null $reminder_emails
 * @property string|null $reminder_content
 * @property string|null $reminder_repeat_on
 * @property string|null $reminder_from_date
 * @property string|null $reminder_to_date
 */
class PurchaseOrder extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_order';
    }
    public $from_date;
    public $product;
    public $to_date;
    public $customer;
    public $po_no;
    public $suffix_last;
    // public $setting;
    // public $total_amount;
    public $executives_name;
    public $delv_date;
    public $stock_status,$vendor,$sub_total_price,$total_price;
    // public $receipt_setting_type;
    // public $receipt_amount;
    // public $receipt_bank;
    // public $advance_note;
    // public $receipt_total_amount;
    // public $receipt_payment_mode;
    // public $receipt_cheque_no;
    // public $receipt_cheque_date;
    // public $sale_total_amount;
    // public $commonsearch;
    // public $saleorder_status;
    public $files;


    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['notes', 'delivery_address', 'terms_and_condition', 'reminder_emails','advance_settingtype','bank','cheque_no','cheque_date','advance_type','advance_note','po_no_final'], 'string'],
            [['setting_type','vendor_name','sendor_gstin','date'], 'required'],
            [['suffix', 'is_allow_advance','is_deleted','updated_by','is_tcs','billed'], 'integer'],
            [['sendor_gstin'], 'string','min'=>15, 'max' => 15],
            [['sendor_gstin'], 'match' ,'pattern'=>'/^([0-9]){2}([A-Z]){4}([0-9A-Z]){1}([0-9]){4}([A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}?$/', 'message'=> 'GSTN Format should be like  12ABCDE1234Z1Z1.'],
            // [['due_date'], 'compare' ,'compareValue'=>date("Y-m-d"),'operator'=>'>=', 'message'=> 'Due Date must be equal/greater than todays date'],
            [['sub_total_price', 'total_price','round_off_amount'], 'number'],
            // ['total_amount', 'compare', 'compareValue' => 0, 'operator' => '>'],
            ['advance_amount', 'compare', 'compareValue' => 0, 'operator' => '>'],
            [['date', 'due_date', 'delivery_date', 'reminder_from_date', 'reminder_to_date','from_date','to_date','vendor','product','po_no_final'], 'safe'],
            [['sub_total_amount', 'total_amount','advance_amount','cgst','sgst','igst','tcs'], 'number'],
            ['due_date', 'compare', 'compareAttribute' => 'date', 'operator' => '>='],
            // ['advance_amount', 'compare', 'compareAttribute' => 'total_amount', 'operator' => '<='],
            ['reminder_emails','email'],
            [['date'], 'compare' ,'compareValue'=>date(" dd-mm-yy"),'operator'=>'>=', 'message'=> 'Date must be equal/greater than todays date'],
            [['reminder_from_date'], 'compare' ,'compareValue'=>date(" dd-mm-yy"),'operator'=>'>=', 'message'=> 'Reminder date must be equal/greater than todays date'],
            ['reminder_to_date', 'compare', 'compareAttribute' => 'reminder_from_date', 'operator' => '>'],
            [['date'], 'date','format' => 'dd-mm-yy'],
            [['setting_type', 'vendor_name', 'sendor_gstin', 'bill_type', 'supply_type', 'supply_attracts', 'currancy', 'point_of_supply', 'eligibity_of_itc', 'prefix', 'po_last', 'terms_of_payment', 'supplier_ref', 'other_ref', 'dispatch_through', 'destination', 'mode_of_payment', 'reminder', 'terms_of_delivery', 'reminder_for', 'reminder_through', 'reminder_content', 'reminder_repeat_on','advance_settingtype','advance_amount','bank','cheque_no','cheque_date','advance_type','advance_note','po_no_final','status','pending_amount'], 'string', 'max' => 255],
            [['is_round_off','gr_status','suffix_last'], 'string', 'max' => 30],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'setting_type' => 'Setting Type',
            'vendor_name' => 'Vendor Name',
            'sendor_gstin' => 'Sendor Gstin',
            'bill_type' => 'Bill Type',
            'notes' => 'Notes',
            'delivery_address' => 'Delivery Address',
            'supply_type' => 'Supply Type',
            'supply_attracts' => 'Supply Attracts',
            'currancy' => 'Currancy',
            'point_of_supply' => 'Point Of Supply',
            'eligibity_of_itc' => 'Eligibity Of Itc',
            'prefix' => 'Prefix',
            'po_last' => 'Po Last',
            'suffix' => 'Suffix',
            'date' => 'Date',
            'due_date' => 'Due Date',
            'terms_of_payment' => 'Terms Of Payment',
            'terms_and_condition' => 'Terms And Condition',
            'is_allow_advance' => 'Is Allow Advance',
            'is_deleted' => 'Is Deleted',
            'updated_by' => 'Updated By',
            'supplier_ref' => 'Supplier Ref',
            'other_ref' => 'Other Ref',
            'dispatch_through' => 'Dispatch Through',
            'destination' => 'Destination',
            'mode_of_payment' => 'Mode Of Payment',
            'delivery_date' => 'Delivery Date',
            'reminder' => 'Reminder',
            'terms_of_delivery' => 'Terms Of Delivery',
            'sub_total_amount' => 'Sub Total Amount',
            'total_amount' => 'Total Amount',
            'reminder_for' => 'Reminder For',
            'reminder_through' => 'Reminder Through',
            'reminder_emails' => 'Reminder Emails',
            'reminder_content' => 'Reminder Content',
            'reminder_repeat_on' => 'Reminder Repeat On',
            'reminder_from_date' => 'Reminder From Date',
            'reminder_to_date' => 'Reminder To Date',
            'advance_settingtype' => 'Advance Settingtype',
            'advance_amount' => 'Advance Amount',
            'bank' => 'Bank',
            'cheque_no' => 'Cheque No',
            'cheque_date' => 'Cheque Date',
            'advance_type' => 'Advance Type',
            'advance_note' => 'Advance Note',
            'po_no_final' => 'Po No Final',
            'billed'=>'Billed'


        ];
    }
    public function getPurchaseOrderProducts()
    {
        return $this->hasMany(PurchaseOrderProduct::className(), ['purchase_order_id' => 'id']);
    }
}
