<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "purchase_order_products".
 *
 * @property int $id
 * @property int $product_id
 * @property int $purchase_order_id
 * @property int|null $discount_type
 * @property string|null $description
 * @property int $qty
 * @property int|null $unit
 * @property float $price
 * @property float|null $discount
 * @property string|null $tax
 * @property int|null $incl_tax
 * @property float $amount
 * @property int $is_deleted
 * @property string $created_at
 * @property string $updated_at
 */
class PurchaseOrderProducts extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_order_products';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['product_id', 'purchase_order_id', 'discount_type', 'qty', 'incl_tax', 'is_deleted'], 'integer'],
            [['description','unit'], 'string'],
            [['price', 'discount', 'amount'], 'number'],
            ['discount', 'compare', 'compareValue' => 0, 'operator' => '>'],
            [['created_at', 'updated_at'], 'safe'],
            [['tax'], 'string', 'max' => 32],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'product_id' => 'Product ID',
            'purchase_order_id' => 'Purchase Order ID',
            'discount_type' => 'Discount Type',
            'description' => 'Description',
            'qty' => 'Qty',
            'unit' => 'Unit',
            'price' => 'Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'incl_tax' => 'Incl Tax',
            'amount' => 'Amount',
            'is_deleted' => 'Is Deleted',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
