<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "taxtype".
 *
 * @property int $id
 * @property string $tax_type
 * @property string $tax_type_name
 * @property string $created_at
 * @property string $updated_at
 */
class Taxtype extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'taxtype';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['tax_type', 'tax_type_name'], 'required'],

            [['created_at', 'updated_at'], 'safe'],
            [['tax_type', 'tax_type_name'], 'string', 'max' => 254],
            [['tax_type_name'],'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'tax_type' => 'Tax Type',
            'tax_type_name' => 'Tax Type Name',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    public function checkUniq($attribute, $params)
{
    $user = Taxtype::find()->where(['tax_type'=>$this->tax_type,'tax_type_name'=>$this->tax_type_name])->one();
    if (isset($user) && $user!=null)
        $this->addError($attribute, 'Tax name is already Taken.');
}
}
