<?php

namespace backend\modules\master\models;

use Yii;

/**
 * This is the model class for table "types".
 *
 * @property int $type_id
 * @property string $type_name
 * @property string $created_at
 * @property string $updated_at
 *
 * @property AccountGroup[] $accountGroups
 */
class Types extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'types';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['type_name'], 'required'],
            [['created_at', 'updated_at'], 'safe'],
            [['type_name'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'type_id' => 'Type ID',
            'type_name' => 'Type Name',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    /**
     * Gets query for [[AccountGroups]].
     *
     * @return \yii\db\ActiveQuery
     */
    public function getAccountGroups()
    {
        return $this->hasMany(AccountGroup::className(), ['type_id' => 'type_id']);
    }
}
