<?php

namespace backend\modules\master\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\Vendor;

/**
 * VendorSearch represents the model behind the search form of `backend\modules\master\models\Vendor`.
 */
class VendorSearch extends Vendor
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'mobile_no', 'pricelist', 'phone_no', 'alternative_phone_no', 'pin_code', 'shipping_postcode'], 'integer'],
            [['business_name', 'account_id', 'email', 'vendor_type', 'fax', 'website', 'adderss_line_1', 'adderss_line_2', 'adderss_line_3','city', 'country', 'state', 'sipping_to_name', 'shipping_address_1', 'shipping_address_2', 'shipping_address_3', 'shipping_city', 'shipping_state', 'shipping_country', 'opening_as_on', 'customer_gst_type', 'gstin_no', 'ho_state_code', 'type_of_removal', 'pan_number', 'aadhar_number', 'service_task_no', 'cst_no', 'ledger', 'credit_terms','vendor_ic', 'vendor_brn', 'ic_type', 'tin'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = Vendor::find()->orderBy(['id' => SORT_DESC]);

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'mobile_no' => $this->mobile_no,
            'pricelist' => $this->pricelist,
            'phone_no' => $this->phone_no,
            'alternative_phone_no' => $this->alternative_phone_no,
            'pin_code' => $this->pin_code,
            'shipping_postcode' => $this->shipping_postcode,
            'opening_as_on' => $this->opening_as_on,
        ]);

        $query->andFilterWhere(['like', 'business_name', $this->business_name])
            ->andFilterWhere(['like', 'account_id', $this->account_id])
            ->andFilterWhere(['like', 'email', $this->email])
            ->andFilterWhere(['like', 'vendor_type', $this->vendor_type])
            ->andFilterWhere(['like', 'fax', $this->fax])
            ->andFilterWhere(['like', 'website', $this->website])
            ->andFilterWhere(['like', 'adderss_line_1', $this->adderss_line_1])
            ->andFilterWhere(['like', 'adderss_line_2', $this->adderss_line_2])
            ->andFilterWhere(['like', 'adderss_line_3', $this->adderss_line_3])
            ->andFilterWhere(['like', 'city', $this->city])
            ->andFilterWhere(['like', 'country', $this->country])
            ->andFilterWhere(['like', 'state', $this->state])
            ->andFilterWhere(['like', 'sipping_to_name', $this->sipping_to_name])
            ->andFilterWhere(['like', 'shipping_address_1', $this->shipping_address_1])
            ->andFilterWhere(['like', 'shipping_address_2', $this->shipping_address_2])
            ->andFilterWhere(['like', 'shipping_address_3', $this->shipping_address_3])
            ->andFilterWhere(['like', 'shipping_city', $this->shipping_city])
            ->andFilterWhere(['like', 'shipping_state', $this->shipping_state])
            ->andFilterWhere(['like', 'shipping_country', $this->shipping_country])
            ->andFilterWhere(['like', 'customer_gst_type', $this->customer_gst_type])
            ->andFilterWhere(['like', 'gstin_no', $this->gstin_no])
            ->andFilterWhere(['like', 'ho_state_code', $this->ho_state_code])
            ->andFilterWhere(['like', 'type_of_removal', $this->type_of_removal])
            ->andFilterWhere(['like', 'pan_number', $this->pan_number])
            ->andFilterWhere(['like', 'aadhar_number', $this->aadhar_number])
            ->andFilterWhere(['like', 'service_task_no', $this->service_task_no])
            ->andFilterWhere(['like', 'cst_no', $this->cst_no])
            ->andFilterWhere(['like', 'ledger', $this->ledger])
            ->andFilterWhere(['like', 'credit_terms', $this->credit_terms])
            ->andFilterWhere(['like', 'vendor_ic', $this->vendor_ic])
            ->andFilterWhere(['like', 'vendor_brn', $this->vendor_brn])
            ->andFilterWhere(['like', 'ic_type', $this->ic_type])
            ->andFilterWhere(['like', 'tin', $this->tin]);

        return $dataProvider;
    }
}
