<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\CategorySearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Categories';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="category-index">
<p>
        <?= Html::a('<span class="glyphicon glyphicon-plus"></span> Create Category', ['create'], ['class' => 'btn btn-info']) ?>
    </p>
    <h1><?= Html::encode($this->title) ?></h1>

   

    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>
    <button id='delete' class='btn btn-danger'><span class="glyphicon glyphicon-trash"></span>&nbsp;Delete</button>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\CheckboxColumn'],
            ['class' => 'yii\grid\SerialColumn'],

            // 'id',
            'name',
            // 'image',
            ['attribute'=>'parent_category',
            'filter'=>[]],
            // 'created_at',
            //'updated_at',

            [
                'class' => 'yii\grid\ActionColumn',
                'template' => '{view}{update}{delete}',
                'contentOptions'=>[ 'style'=>'width: 35px'],
                'buttons' => [
                    'view' => function ($url,$data) {
                        return Html::a('<span class="glyphicon glyphicon-eye-open"></span>',['category/view?id='.$data->id],[]);     
                    },
                    'update' => function ($url,$data) {
                        return Html::a('<span class="glyphicon glyphicon-pencil"></span>',['category/update?id='.$data->id],[]);     
                    },
                    'delete' => function ($url,$data) {
                        return Html::a('<span class="glyphicon glyphicon-trash"></span>',['category/delete?id='.$data->id],['data-method'=>"post",]);     
                    },
                ],
                ],
        ],
    ]); ?>


</div>
<?php ob_start();?>
 <script type="text/javascript">
            $(function() {
                $('#delete').click(function(){
var ids = $('#w0').yiiGridView('getSelectedRows');
console.log(ids);
$.post( 'delete-category',{data: ids}, function( data ) {
   });
})
});
        </script>
        <?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>