<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\AccountingLedger;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\AccountingLedgerSearch;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\AccountingLedgerSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Accounting Ledgers';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}

</style>
<div class="accounting-ledger-index">

    <!-- <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Accounting Ledger', ['create'], ['class' => 'btn btn-success']) ?>
    </p> -->
    <?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
                    <?php endif; ?>

    <?php //echo $this->render('_search', ['model' => $searchModel]); ?>
    <div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                            
                                                                <div class="widget-numbers dj-text-success">Account Ledgers</div>
                                                            </div>
															<div class="widget-content-right">
															<a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Enquiry</a>

                                                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/accounting-ledger/create'])->one()!=''){?>
                                                            <a href="<?=Url::base()?>/master/accounting-ledger/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add an Account</a>
                                                           <?php }else {?>

                                                           <?php } ?>
                                                                
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                        <div class="card-body">
						<!-- <div class="row"> -->
						

                             
                             <!-- <div class="card-body"> -->
                           
                            					   
                 
               <!-- <div class="main-card mb-3 card">
                  <div class="card-body"> -->
                    <?php $form = ActiveForm::begin([
                                'action' => ['index'],
                                'method' => 'get',
                            ]); ?> 
                          <div class="row">
                              
                             <div class="col-md-3">
                               <div class="position-relative form-group">
                               <label for="notes">Ledger Name</label>
                               <?= $form->field($searchModel, 'name')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-3">
                               <div class="position-relative form-group">
                               <label for="notes">Account Name</label>
                               <?= $form->field($searchModel, 'ledger_id')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-3">
                               <div class="position-relative form-group" >
                               <label for="notes">Account Type</label>
                                 <?=$form->field($searchModel, 'account_type_id')->dropDownList(ArrayHelper::map($accounttype,'account_type_id','account_name'), ['prompt' => '-Select-', 'class' => "multiselect-dropdown form-control", 'maxlength' => true])->label(false)?>      
                              </div>
                            </div>
                          <div class="col-md-2 dj-btn-align ">                      
                            <button class="btn dj-danger-btn btn-rounded dj-search"><i class="fa fa-search"></i> Search</button>
                          </div> 
                                  
                        </div>
                        <?php ActiveForm::end(); ?>
                 <!--  </div>  
               </div> -->         
               <div class="row">
                    <div class=col-md-6>
                        <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/accounting-ledger/delete'])->one()!=''){?>
                                    <button id='delete' class='mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn' href="<?=Url::base()?>/master/accounting-ledger/delete-accounting-ledger"><i class="fa fa-trash"></i> Delete</button>
                           <?php }else {?>

                           <?php } ?>
                            
                    </div>
                    <div class="col-md-6">
                       <div class="djsec-text-right dj-print-sec">

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/accounting-ledger/excel-export'])->one()!=''){?>
                                    <a href="<?=Url::base();?>/master/accounting-ledger/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                                    <a href="<?=Url::base();?>/master/accounting-ledger/excel-export" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                           <?php }else {?>

                           <?php } ?>
                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/accounting-ledger/export-pdf'])->one()!=''){?>
                                 <a href="<?=Url::base();?>/master/accounting-ledger/export-pdf" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                           <?php }else {?>

                           <?php } ?>
                            
                            
                       </div>
               </div>
               </div>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        //'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\CheckboxColumn'],
            ['class' => 'yii\grid\SerialColumn'],
            //'accounting_ledger_id',
            [
                'contentOptions'=>['style'=>'font-weight:bolder'],
                'label'=>'Account Name',
                'attribute'=>'ledger_id',
               'value' => function ($data) {
                $value=AccountingLedger::find()->where(['accounting_ledger_id'=>$data->accounting_ledger_id])->one();
                return $value?$value->ledger_id:'';
               }
            ],
            [
                'contentOptions'=>['style'=>'font-weight:bolder'],
                'label'=>'Ledger Name',
                'attribute'=>'name',
               'value' => function ($data) {
                $value=AccountingLedger::find()->where(['accounting_ledger_id'=>$data->accounting_ledger_id])->one();
                return $value?$value->name:'';
               }
            ],
            [
                'label'=>'Account Type',
                'attribute'=>'account_type_id',
               'value' => function ($data) {
                $value=AccountType::find()->where(['account_type_id'=>$data->account_type_id])->one();
                return $value?$value->account_name:'';
               }
            ],
            [
                'label'=>'Opening Balance',
                'attribute'=>'opening_balance',
               'value' => function ($data) {
                $value=AccountingLedger::find()->where(['accounting_ledger_id'=>$data->accounting_ledger_id])->one();
                return $value?$value->opening_balance:'';
               }
            ],
            [
                'label' => 'Action',
                'headerOptions' => ['style' => 'color:#495057'],
                'format'=>'raw',
                'value' => function ($data) use ($assign) {

                    $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>'; 

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/accounting-ledger/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/accounting-ledger/view?id='.$data->accounting_ledger_id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }
                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/accounting-ledger/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/accounting-ledger/update?id='.$data->accounting_ledger_id.'>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }
                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/accounting-ledger/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/master/accounting-ledger/delete?id='.$data->accounting_ledger_id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                    return $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$downstring;
                },
            ],
            //'group_name_id',
            //'name',
            //'alias_name',
            //'opening_balance',
            //'msic_code',
            //'created_at',
            //'updated_at',

            // ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>



</div>
<!-- </div> -->
</div>
<?php ob_start();?>
 <script type="text/javascript">
$(function() {
    // console.log(navigator.userAgent);

$('#delete').click(function(){
var ids = $('#w1').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>