<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\GroupName;
use backend\modules\master\models\AccountingLedger;


/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\AccountingLedger */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Accounting Ledgers', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="accounting-ledger-view">
    <div class="app-main__inner">
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">View Accounting Ledger</div>
                                                            </div>
															<div class="widget-content-right">
                                                                <a href="<?=Url::base()?>/master/accounting-ledger/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            //'accounting_ledger_id',
            'taxable_ledger',
            //'ledger_id',
            //'group_name_id',
            [
                'label'=>'Account Name',
               'attribute' => 'ledger_id',
               'value' => function ($data) {
                $value=AccountingLedger::find()->where(['ledger_id'=>$data->ledger_id])->one();
                return $value?$value->ledger_id:'';
               }
            ],
            [
                'label'=>'Group',
               'attribute' => 'group_name_id',
               'value' => function ($data) {
                $value=GroupName::find()->where(['group_name_id'=>$data->group_name_id])->one();
                return $value?$value->name_group:'';
               }
            ],
            //'account_type_id',
            [
                'label'=>'Account Type',
               'value' => function ($data) {
                $value=AccountType::find()->where(['account_type_id'=>$data->account_type_id])->one();
                return $value?$value->account_name:'';
               }
            ],
            [
                'label'=>'Ledger Name',
               'value' => function ($data) {
                $value=AccountingLedger::find()->where(['name'=>$data->name])->one();
                return $value?$value->name:'';
               }
            ],
            'alias_name',
            'opening_balance',
            'msic_code',
            'created_at',
            'updated_at',
        ],
    ]) ?>

</div>
</div>
</div>

