<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\SettingTypes;
/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\Category */
/* @var $form yii\widgets\ActiveForm */

$salessettingtypes = SettingTypes::find()->all();
$salessettinglist = ArrayHelper::map($salessettingtypes, 'setting_type_name', 'setting_type_name');

// print_r($salessettinglist);
// die();
?>
<style>
    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .select2-container .select2-selection--single {
        height: 37px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 37px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 35px;
    }

    .rendered .select2-selection__rendered {
        width: 120px !important;
    }

    .help-error {
        color: red;
        margin-top: -15px;
    }
</style>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success"><?= $update ? 'Update Template' : 'Add Template' ?></div>
                                        </div>
                                        <div class="widget-content-right">
                                            <a href="<?= Url::base(); ?>/master/generic-template/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>


            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <!-- <form class="dj-sale-form"> -->
            <?php $form = ActiveForm::begin(); ?>

            <div class="form-row">
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes" class="">Template/Setting Name <span class="dj-red">*</span></label>
                        <?= $form->field($model, 'template_name')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes" class="">Template For <span class="dj-red">*</span></label>
                        <?= $form->field($model, 'template_for')->dropDownList($salessettinglist, ['maxlength' => true, 'class' => 's_types form-control setting_type', 'prompt' => '--select--'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes" class="">Company Name</label>
                        <?= $form->field($model, 'company_name')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>

                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Address</label>
                        <?= $form->field($model, 'address')->textarea(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Country</label>
                        <?= $form->field($model, 'country')->dropDownList($country,['maxlength' => true,'class'=>'form-control country','prompt'=>'--Select--'])->label(false) ?>
                    </div>
                </div>
                 <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">State</label>
                        <?= $form->field($model, 'state')->dropDownList([],['prompt'=>'--Select--','class'=>"form-control template_name",'maxlength' => true])->label(false) ?>
                        <!-- <?= $form->field($model, 'state')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?> -->
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">City</label>

                        <?php if($model->city!=''){?>

                                                    <?= $form->field($model, 'city') ->dropDownList([$model->city=>$model->city],['options' => [$model->city => ['Selected'=>'selected']],'prompt'=>'--Select--','class' => "form-control city"])->label(false)?>

                                                    
                                                   <?php }else {?>

                                                        <?= $form->field($model, 'city') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control city"])->label(false)?>

                                                   <?php } ?>
                        <!-- <?= $form->field($model, 'city')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?> -->
                    </div>
                </div>
               
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Pin</label>
                        <?= $form->field($model, 'pin')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Mobile</label>
                        <?= $form->field($model, 'mobile')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Phone No.</label>
                        <?= $form->field($model, 'phone_no')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">GST</label>
                        <?= $form->field($model, 'gst_no')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Fax No.</label>
                        <?= $form->field($model, 'fax_no')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Trade License</label>
                        <?= $form->field($model, 'trade_licence')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Email</label>
                        <?= $form->field($model, 'email')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-12">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Terms & Conditions</label>
                        <?= $form->field($model, 'terms_and_condition')->widget(\yii\redactor\widgets\Redactor::className())->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Bank</label>
                        <?= $form->field($model, 'bank_name')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Account Holder</label>
                        <?= $form->field($model, 'account_holder')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Account Number</label>
                        <?= $form->field($model, 'acc_no')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">IFSC Code</label>
                        <?= $form->field($model, 'ifsc_code')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-2">
                    <div class="position-relative form-group">
                        <label for="Documents">Company Seal</label>
                        <?= $form->field($model, 'company_seal')->fileInput(['maxlength' => true, 'class' => "form-control", 'multiple' => true])->label(false) ?>
                        <label for="ftype">Allowed File Formats *.jpg,*.png, *.GIF,*.txt,*.xls,*docs,*.xlsx(Allowed Size 2m)</label>
                    </div>
                    <?php if ($update == '1') {

                    ?>
                        <img src='<?= Url::base() ?>/template_seals/<?= $model->company_seal ?>' width="100px">
                    <?php } ?>
                </div>
                <div class=" col-md-4">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Signature</label>
                        <?= $form->field($model, 'company_signature')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-2">
                    <div class="position-relative form-group">
                        <label for="Documents">QR Code </label>
                        <?= $form->field($model, 'qr_code')->fileInput(['maxlength' => true, 'class' => "form-control", 'multiple' => true])->label(false) ?>
                        <label for="qtype">Allowed File Formats *.jpg,*.png, *.GIF,*.txt,*.xls,*docs,*.xlsx(Allowed Size 2m)</label>
                    </div>
                    <?php if ($update == '1') {

                    ?>
                        <img src='<?= Url::base() ?>/qr_codes/<?= $model->qr_code ?>' width="100px">
                    <?php } ?>

                </div>
            </div>

            <div class="djsec-text-right">
                <?= Html::submitButton($update ? '<i class="fa fa-check-square-o" aria-hidden="true"></i> Update' : '<i class="fa fa-check-square-o" aria-hidden="true"></i> Create', ['class' => 'dj-danger-btn save']) ?>
                <button type=reset onclick="location.href='<?= Url::base() ?>/master/generic-template/index';" class='dj-red-btn reset'> <i class="fa fa-ban" aria-hidden="true"></i> Cancel</a>
            </div>

            <?php ActiveForm::end(); ?>
        </div>
    </div>
</div>

<?php ob_start(); ?>
    <script type="text/javascript">
    $(function() {
        $('.s_types').select2();
        $('.country').select2();
        $('.state').select2();
        $('.city').select2();
        // $('#generictemplate-template_name').val();



        //State as on Country


        country=$('#generictemplate-country').val();
        if(country=='India'){
            $('#generictemplate-state').replaceWith( "<select id='generictemplate-state' class='form-control state template_name' name='GenericTemplate[state]' maxlength='' aria-required='true'></select>" );

              var newOption = print_state("generictemplate-state");
              $('#generictemplate-state').append("<option selected value='<?=$model->state?>'><?=$model->state?></option>");
            
        }
        else if(country!='India')
        {
            $('#generictemplate-state').replaceWith( "<input type='text' id='generictemplate-state' class='form-control state template_name' name='GenericTemplate[state]' maxlength aria-required='true' value='<?=$model->state?>'>" );
        }



        $('#generictemplate-country').change(function(){
          countryname = $(this).val();
          if(countryname!='India'){
            $('#generictemplate-state').replaceWith( "<input type='text' id='generictemplate-state' class='form-control template_name' name='GenericTemplate[state]' maxlength aria-required='true'>" );
            $("#generictemplate-state").blur(function(){
                if($(this).val()=='')
            $(this).siblings('.help-block').text('State cannot be blank.')
            if($(this).val()!=''){
            $(this).siblings('.help-block').text('')
            $(this).parent('.required').addClass('has-success').removeClass('has-error');
            }
        });
          }else if(countryname=='India'){
            $('#generictemplate-state').replaceWith( "<select id='generictemplate-state' class='form-control state template_name' name='GenericTemplate[state]' maxlength='' aria-required='true'></select>" );
             // $('.state').select2();
               print_state("generictemplate-state");
               var newOption = '<?=$model->state?>';
               if(newOption!='')
               {
                  $('#generictemplate-state').append("<option selected value='<?=$model->state?>'><?=$model->state?></option>");
               }      
        $("#generictemplate-state").blur(function(){
                if($(this).val()=='')
            $(this).siblings('.help-block').text('State cannot be blank.')
            if($(this).val()!=''){
            $(this).siblings('.help-block').text('')
            $(this).parent('.required').addClass('has-success').removeClass('has-error');
            }
        });
          }
          else
          {
             $('#generictemplate-state').replaceWith( "<select id='generictemplate-state' class='form-control state template_name' name='GenericTemplate[state]' maxlength='' aria-required='true'><option>--Select--</option></select>" );
             $("#generictemplate-state").blur(function(){
                if($(this).val()=='')
            $(this).siblings('.help-block').text('State cannot be blank.')
            if($(this).val()!=''){
            $(this).siblings('.help-block').text('')
            $(this).parent('.required').addClass('has-success').removeClass('has-error');
            }
           });
          }
        });

        //for city field

        $('.city').select2({
        tags: true,
            ajax: { 
            url: "../vendor/citydetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
               
                return {
                    results: $.map(response, function (i,item) {
                        
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
            },
            cache: true
            }
        });
       
    });

</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>