<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;

use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\ProductSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Products';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
 th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      /* Opera 4-6 */
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
                    <?php endif; ?>
                <div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Products</div>
                                                            </div>
															<div class="widget-content-right">
															<a href="#" class="dj-danger-btn"><i class="fa fa-upload" aria-hidden="true"></i> Export Product</a>
															<a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Product</a>

                                                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/create'])->one()!=''){?>
                                                                <a href="<?=Url::base()?>/master/product/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Product</a>
                                                            <?php }else {?>

                                                            <?php } ?>
                                                                
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['method' => 'get']); ?>
						   <div class="row dj-adv-search-row">
                           
						   <div class="col-md-4">
                               <div class="position-relative form-group">
                               <?= $form->field($model, 'product_name')->textInput(['maxlength' => true,'class'=>"form-control",'placeholder'=>"Name"])->label(false) ?>
                                 <!-- <input name="amount" id="amount" type="text" class="form-control" placeholder="Name/Desc/Model"> -->
                              </div>
                            </div>
        
							<div class="col-md-2">
								<button type="submit" class="search_field_buttons"><i class="fa fa-search"></i> Search</button>
                            </div>
                            <?php ActiveForm::end(); ?>
							<div class="col-md-3">
							<a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-3">
							<a  class="btn search_field_buttons"  href="<?=Url::base().'/master/product/index'?>" role="button" aria-expanded="false" aria-controls="search-look">Refresh <i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
						   </div>
									<!-- <form class="dj-sale-form collapse" id="search-look"> -->
                                    <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                        <div class="form-row">
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Category</label>
                                                    <?=$form->field($model, 'categorysearch')->dropDownList(ArrayHelper::map($category,'id','name'), ['prompt' => '--Select--', 'class' => "multiselect-dropdown form-control", 'maxlength' => true])->label(false)?>
                                                     <!-- <select class="multiselect-dropdown form-control">
														<option value="1">Select a Category</option>
														<option value="2">AIC AGRO</option>
														<option value="3">ACROSS</option>
                                                    </select> -->
                                                </div>
												
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Purpose</label>
                                                    <?=$form->field($model, 'purpose')->dropDownList(['Purchase & Sale(Trading)' => 'Purchase & Sale(Trading)', 'Raw Material' => 'Raw Material', 'Finished Good' => 'Finished Good'], ['prompt' => '--Select--', 'class' => "multiselect-dropdown form-control", 'maxlength' => true])->label(false)?>

                                                     <!-- <select class="multiselect-dropdown form-control">
														<option value="1">Select a Purpose</option>
														<option value="2">Purchase & Sale(Trading)</option>
														<option value="3">Raw Material</option>
                                                    </select> -->
                                                </div>
												
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Display In</label>
                                                    <?=$form->field($model, 'show_inventory')->dropDownList(['1'=>'Inventory'], ['prompt' => '--Select--', 'class' => "multiselect-dropdown form-control", 'maxlength' => true])->label(false)?>

                                                   <!-- <select class="multiselect-dropdown form-control">
														<option value="1">Select a Display</option>
														<option value="2">Point of Sale</option>
														<option value="3">Inventry</option>
                                                    </select> -->
                                                </div>
												
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Units</label>
                                                    <?=$form->field($model, 'units')->dropDownList(ArrayHelper::map($unit,'id','unit_name'), ['prompt' => '--Select--', 'class' => "multiselect-dropdown form-control",'maxlength' => true])->label(false)?>

                                                   <!-- <select class="multiselect-dropdown form-control">
														<option value="">Select an Unit</option>
														<option value="19695">Nos</option>
														<option value="19696">Pcs</option>
														<option value="19697">Pkt</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Product Code(SKU)/Barcode</label>
                                                    <?= $form->field($model, 'product_code_sku')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Vendor</label>
                                                    <?=$form->field($model, 'vendor')->dropDownList(ArrayHelper::map($vendor,'id','business_name'), ['prompt' => '--Select--', 'class' => "multiselect-dropdown form-control", 'maxlength' => true])->label(false)?>
                                                   <!-- <select class="multiselect-dropdown form-control">
														<option value="">Select a Vendors</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Tax wise</label>
                                                    <?=$form->field($model, 'tax_wise')->dropDownList(['1'=>'With Tax - Sales','2'=>'With Tax - Purchases','3'=>'Without Tax - Sales','4'=>'Without Tax - Purchase'], ['prompt' => '--Select--', 'class' => "multiselect-dropdown form-control", 'maxlength' => true])->label(false)?>

                                                   <!-- <select class="multiselect-dropdown form-control">
														<option value="">Select Tax Type</option>
														<option value="19695">With Tax - Sales</option>
														<option value="19696">With Tax - Purchases</option>
														<option value="19697">Without Tax - Sales</option>
                                                    </select> -->
                                                </div>
                                            </div>
                                            
											<div class="col-md-3 dj-btn-align" style="padding-top: 5px">
											<button type="submit" class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search"></i> Search</button>
											</div>
                                        </div>
                                        <?php ActiveForm::end(); ?>
                                    
                                </div>
                        </div>
						  <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						<div class="col-md-6">
                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/delete'])->one()!=''){?>
                                <button id='delete' class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                            <?php }else {?>

                            <?php } ?>
								
							</div>
							<div class="col-md-6">
						<div class="djsec-text-right dj-print-sec">

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/excel-export'])->one()!=''){?>
                                <a href="<?=Url::base();?>/master/product/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                                <a href="<?=Url::base();?>/master/product/excel-export" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                            <?php }else {?>

                            <?php } ?>

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/export-pdf'])->one()!=''){?>
                                <a href="<?=Url::base();?>/master/product/export-pdf" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                            <?php }else {?>

                            <?php } ?>
			
                          </div>
							 </div>
							 </div>
                                     <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'columns' => [
             ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
           

            // 'id',
            [
            'header'=> 'Product Name',
                'contentOptions' => ['class' => 'text-wrap'],
                'attribute' => 'product_name',
                'value'=> function($data){
                    return $data->product_name;
                } 
            ],
            'product_code_sku',
            'barcode',
            'description',
            'conversion_ratio',
            // 'created_at',
            'bying_price',
            'selling_price',
            [
                'label' => 'Action',
                'format'=>'raw',
                'value' => function ($data) use ($assign) {

                    $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>'; 


                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/product/update?id='.$data->id.'&page='.$data->page.'>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item deleteind">
                        <a class="nav-link" href='.Url::base().'/master/product/delete?id='.$data->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/findattachments'])->one()!='')
                    {
                        $attachmentstring = '<li class="nav-item">
                        <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                            <i class="fa fa-paperclip"></i>
                            <span class="dj-icon-gap">Download Attachments</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $attachmentstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/create'])->one()!='')
                    {
                        $duplicatestring = ' <li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/master/product/create?id='.$data->id.' data-method=post>
                           <i class="fa fa-plus"></i>
                            <span class="dj-icon-gap">  Duplicate</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $duplicatestring = '';
                    }

                    return $topstring.''.$editstring.''.$deletestring.''.$attachmentstring.''.$duplicatestring.''.$downstring;
                },
            ],
            // ['class' => 'yii\grid\ActionColumn'],

        
        ],
    ]); ?>           
       </div>
    </div>
</div>


<div class="modal fade" id="document" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle"> Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            
            <table id="dynamic">
               
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>

<?php ob_start();?>
 <script type="text/javascript">
$(function() {
    $('.attachments').click(function(){
     $("#dynamic").empty();
     var id = $(this).attr('value');
     $.get('findattachments',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           if(data.length==0)
           {
               $('#dynamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
           }
           for (var i = 0; i < data.length; i++){
            $('#dynamic').append("<tr><td><a href='<?=Url::base();?>/master/product/download?id="+ data[i].id +"'>"+ data[i].document_name +"</a></td><tr>")
            }
     });
})


$('#delete').click(function(){
var ids = $('#w2').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are u sure you want to delete the selected product ?");
else
alert('Please select some product units to delete!')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are u sure you want to delete the selected product ?");
if (confirm == true)
return true;
else
return false;
})
$('#w1').hide();
$('#advance-search').click(function(){
    $('#w1').toggle();
})
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
