<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Vendor;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Vendor';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
      <h1 style="text-align:center">Purchase Orders</h1>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            [
              'header'=> 'PO #',
              'value'=> function($data){
                  return $data->prefix."-". $data->po_last;
              } 
          ],
          [
            'header'=> 'Vendor Name / Financial Category',
            'attribute' => 'vendor_name',
            'value'=> function($data){
                $vendor=Vendor::find()->where(['id'=>$data->vendor_name])->one();
               return $vendor?$vendor->business_name:'';
            } 
        ],
          [
              'header'=> 'Date',
              'value'=> function($data){
                  return date(("\ F jS  Y"), strtotime($data->date));
              } 
          ],
          [
              'header'=> 'Amount',
              'value'=>'total_amount',
          ],
          [
              'header'=> 'Paid',
              'value'=>'advance_amount',
          ],
          [
              'header'=> 'Pending',
              'value'=> function($data){
                  return ($data->total_amount-$data->advance_amount);
              } 
          ],
          [
              'header'=> 'Status',
              'value'=> function($data){
                  if(isset($data->advance_amount)){
                      return "Paid";
                  }
                  else{
                      return "Draft";
                  }
              } 
          ],
          [
              'header'=> 'Stock Status',
              'value'=> function($data){
                  return "";
              } 
          ],
           
        ],
    ]); ?>


</div>
</div>
</div>
