<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Vendor;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Product;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\PurchaseTemplates;
use backend\modules\master\models\GenericTemplate;

$purchase = GenericTemplate::find()->where(['template_for'=>'Purchase Order'])->all();
$purchaseorder=ArrayHelper::map($purchase, 'gt_id', 'template_name');


$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\PurchaseOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Orders';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
.btn-danger.disabled, .btn-danger:disabled {
    color: #fff;
    background-color: red;
    border-color: red;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>
  <div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                <div class="card">
                    <div class="no-gutters row">
                        <div class="col-md-12 col-lg-12">
                            <ul class="list-group list-group-flush">
                                <li class="bg-transparent list-group-item">
                                    <div class="widget-content p-0">
                                        <div class="widget-content-outer">
                                            <div class="widget-content-wrapper">
                                                <div class="widget-content-left">
                                                    <div class="widget-numbers dj-text-success">Purchase Order</div>
                                                </div>
                                                <div class="widget-content-right">
                                                <a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import PO</a>
                                                   
                                                     <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/create'])->one()!=''){?>
                                                       <a href="<?=Url::base()?>/master/purchase-order/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a PO</a>
                                                       <?php }else {?>

                                                       <?php } ?>

                                                   
                                                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-creditnote" role="button" aria-expanded="false" aria-controls="search-creditnote">Adv Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                                                    <a  class="search_field_buttons"  href="<?=Url::base().'/master/purchase-order/index'?>" role="button" aria-expanded="false" aria-controls="search-look" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </li>
                                
                            </ul>
                        </div>
                        
                        
                    </div>
                </div>
            </div>
            <div class="main-card mb-3 card collapse" id="search-creditnote">
                <div class="card-body">
                     <?php $form = ActiveForm::begin(['method' => 'get','options' => ['class'=>"dj-sale-form",'id' => 'search-look']]); ?>
                            <div class="form-row">
                            
                            <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="notes">From<span class="dj-red">*</span></label>
                                        <?= $form->field($model, 'from_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="notes">To<span class="dj-red">*</span></label>
                                        <?= $form->field($model, 'to_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="date">Vendor/Sender</label>


                                        <?php if($model->vendor!=''){?>

                                        <?php $customer=Vendor::find()->where(['id'=>$model->vendor])->one()?>
                                       <?=$form->field($model, 'vendor')->dropDownList([$model->vendor=>$customer->business_name], ['options' => [$model->vendor => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "findvendor form-control", 'maxlength' => true])->label(false)?>

                                       <?php }else {?>
                                                  
                                        <?= $form->field($model, 'vendor')->dropDownList([],['prompt'=>'Select','class'=>'findvendor form-control'])->label(false);
                                    ?>           
                                       <?php } ?>


                                    </div>
                                    
                                </div>
                                    <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="date">Setting Type</label>
                                        <?= $form->field($model, 'setting_type')->dropdownList($purchaseorder,['class'=>'multiselect-dropdown form-control','prompt'=>'--Select--']
                                        )->label(false) ?>
                                    </div>
                                    
                                </div>
                                <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="notes">Amount</label>
                                        <?= $form->field($model,'total_amount')->textInput(['maxlength' => true,'class' => "form-control total"])->label(false) ?>
                                     </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="notes">PO Number</label>
                                        <?= $form->field($model,'po_last')->textInput(['maxlength' => true,'class' => "form-control total"])->label(false) ?>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="date">Product</label>


                                        <?php if($model->product!=''){?>

                                                    <?php $product=Product::find()->where(['id'=>$model->product])->one()?>
                                                   <?=$form->field($model, 'product')->dropDownList([$model->product=>$product->product_name], ['options' => [$model->product => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "product form-control", 'maxlength' => true])->label(false)?>

                                                   <?php }else {?>
                                                              
                                                   <?= $form->field($model, 'product')->dropDownList([],['prompt'=>'Select','class'=>'product form-control'])->label(false);
                                    ?>             
                                                   <?php } ?>

                                    </div>
                                    
                                </div>
                                <div class="col-md-4">
                                    <div class="position-relative form-group">
                                        <label for="date">Stock Status</label>
                                        <?= $form->field($model, 'stock_status')->dropdownList([
                                                'RECEIVED' => 'RECEIVED', 
                                                'PARTIAL RECEIVED' => 'PARTIAL RECEIVED',
                                                'PARTIAL RECEIVED' => 'PARTIAL RECEIVED',
                                                'BILLED' => 'BILLED',
                                                'NOT RECEIVED/PENDING' => 'NOT RECEIVED/PENDING',
                                            ],
                                            ['prompt'=>'Select']
                                        )->label(false) ?>
                                    </div>
                                    
                                </div>
                                <div class="col-md-4 dj-btn-align" style="padding-top: 5px">
                                <button class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search" ></i> Search</button>
                                

                                </div>
                                
                            </div>
                            <?php ActiveForm::end(); ?> 
                        
                    </div>
            </div>
                <div class="main-card mb-3 card">
            <div class="card-body">
            <div class="row">
            <div class="col-md-6">

            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/delete'])->one()!=''){?>
            <button id='delete' class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
           <?php }else {?>

           <?php } ?>    
            
           
                </div>
                <div class="col-md-6">
            <div class="djsec-text-right dj-print-sec">

            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/excel-export'])->one()!=''){?>
                <?php if(Yii::$app->request->getQueryParams()){?>
                    <a href="<?=Url::current()?>&details=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i>Details  Excel</button></a>         
                <?php } else{ ?>
                    <a href="<?=Url::current()?>?details=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i>Details  Excel</button></a>
                <?php } ?>
           <?php }else {?>

           <?php } ?>   
           
                               
                               
                                
                            </div>
                    </div>
                    </div>
                    <?= GridView::widget([
                    'dataProvider' => $dataProvider,
                    // 'filterModel' => $searchModel,
                    'columns' => [
                        ['class' => 'yii\grid\SerialColumn'],
                        ['class' => 'yii\grid\CheckboxColumn'],


                        [
                            'header'=> 'PO #',
                            'headerOptions' => ['style' => 'color:#495057'],
                            'attribute' => 'po_no_final',
                            'value'=> 'po_no_final',
                        ],
                        [
                            'header'=> 'Vendor Name / Financial Category',
                            'contentOptions' => ['style' => 'font-weight:bold'],
                            'attribute' => 'vendor_name',
                            'value'=> function($data){
                                $vendorname = Vendor::find()->where(['id'=>$data->vendor_name])->one(); 
                                if($vendorname)
                                   return $vendorname->business_name;
                                
                            } 
                        ],
                        [
                            'header'=> 'Date',
                            'headerOptions' => ['style' => 'color:#495057'],
                            'value'=> function($data){
                                return date(("\ F jS  Y"), strtotime($data->date));
                            } 
                        ],
                        [
                            'header'=> 'Amount',
                            'contentOptions'=>[ 'style'=>'text-align:right'],
                            'headerOptions' => ['style' => 'color:#495057'],
                            'attribute' => 'total_amount',
                            'value'=> function($data){
                                // return ($data->total_amount-$data->pending_amount);
                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data->total_amount);
                                return $num;
                                // return number_format($data->total_amount,2);
                            } 
                        ],
                        [
                            'header'=> 'Paid',
                            'contentOptions'=>[ 'style'=>'text-align:right'],
                            'headerOptions' => ['style' => 'color:#495057'],
                            'attribute' => 'advance_amount',
                            'value'=>'advance_amount',
                            'value'=> function($data){
                                // return ($data->total_amount-$data->pending_amount);
                                // return number_format(($data->total_amount-$data->pending_amount),2);
                                 $amount = number_format((float)($data->total_amount-$data->pending_amount), 2, '.', '');
                                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$amount);
                                 return $num;
                            } 
                        ],
                        [
                            'header'=> 'Pending',
                            'contentOptions'=>[ 'style'=>'text-align:right'],
                            'headerOptions' => ['style' => 'color:#495057'],
                            'value'=> function($data){
                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->pending_amount);
                                 if($num<0)
                                 {
                                    return '0.00';
                                 }
                                 else
                                 {
                                    return $num;
                                 }
                                // return number_format($data->pending_amount,2);
                            } 
                        ],
                        [
                            'header'=> 'Payment Status',
                            'format'=>'raw',
                            'headerOptions' => ['style' => 'color:#495057'],
                            'value'=> function($data){

                                if($data->total_amount==$data->pending_amount)
                                {
                                     return '<span class="label-pending">DRAFT</span>';
                                }
                                else if($data->total_amount>$data->pending_amount && $data->pending_amount>0)
                                {
                                    return '<span class="label-partial">PARTIAL</span>';
                                }
                                else if($data->pending_amount<=0)
                                {
                                    return '<span class="label-paid">PAID</span>';
                                }
                                // if(isset($data->advance_amount)){
                                //     return '<span class="label-paid">PAID</span>';
                                // }
                                // else{
                                //     return '<span class="label-pending">DRAFT</span>';
                                    
                                // }
                            } 
                        ],
                        [
                            'header'=> 'Stock   Status',
                            'format'=>'raw',
                            'headerOptions' => ['style' => ''],
                            'value'=> function($data){
                                if($data['status'])
                                {
                                    // return $data['status'];
                                    if($data['status']=='Pending')
                                    {
                                         return '<span class="label-pending">DRAFT</span>';
                                    }
                                    else if($data['status']=='Fully Received')
                                    {
                                        return '<span class="label-received">RECEIVED</span>';
                                    }
                                    else if ($data['status']=='Partially Received') {
                                        return '<span class="label-partial">PARTIAL</span>';
                                    }
            
                                }
                            } 
                        ],
                      

                    [
                    'label' => 'Action',
                    'headerOptions' => ['style' => 'width:35px'],
                    'format'=>'raw',
                    'value' => function ($data) use ($assign){

                        $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                        $downstring =  '</ul></div></div>';
                        if($data->gr_status==2 || $data->gr_status==3 || $data->gr_status==1)
                        {


                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/view'])->one()!='')
                            {
                                $viewstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/purchase-order/view?id='.$data->id.' data-method=post>
                                                <i class="fa fa-eye"></i>
                                                    <span class="dj-icon-gap">  View</span>
                                                </a>
                                            </li>';
                            }
                            else
                            {
                                $viewstring = '';
                            }

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/purchase-order-template'])->one()!='')
                            {
                                $printstring = '

                                 <li class="nav-item">
                                                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/master/purchase-order/printall?id='.$data->id.' title="Print Bill" data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Print</span>
                                                                                    </a>
                                                                                </li>';
                            }
                            else
                            {
                                $printstring = '';
                            } 

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/update'])->one()!='')
                            {
                                $editstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/purchase-order/update?id='.$data->id.'>
                                                    <i class="fa fa-pencil-square"></i>
                                                    <span class="dj-icon-gap"> Edit</span>
                                                </a>
                                            </li>';
                            }
                            else
                            {
                                $editstring = '';
                            }

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/download-attachment'])->one()!='')
                            {
                                $attachmentstring = '<li class="nav-item">
                                            <a class="nav-link" href='.Url::base().'/master/purchase-order/download-attachment?id='.$data->id.'>
                                                <i class="fa fa-file"></i>
                                                <span class="dj-icon-gap"> Download Attachment</span>
                                            </a>
                                        </li>';
                            }
                            else
                            {
                                $attachmentstring = '';
                            }

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/delete'])->one()!='')
                            {
                                $deletestring = '<li class="nav-item">
                                                <a class="nav-link deleteind" href='.Url::base().'/master/purchase-order/delete?id='.$data->id.' data-method=post>
                                                <i class="fa fa-trash"></i>
                                                    <span class="dj-icon-gap">Delete</span>
                                                </a>
                                            </li>';
                            }
                            else
                            {
                                $deletestring = '';
                            }


                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/create'])->one()!='')
                            {
                                $duplicatestring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/master/purchase-order/create?id='.$data->id.'&from=purchase-order'.' data-method=post>
                                        <i class="fa fa-shopping-cart"></i>
                                            <span class="dj-icon-gap">Duplicate PO</span>
                                        </a>
                                    </li>';
                            }
                            else
                            {
                                $duplicatestring = '';
                            }

                            return $topstring.''.$viewstring.''.$printstring.''.$editstring.''.$attachmentstring.''.$deletestring.''.$duplicatestring.''.$downstring;
                        }
                        else if($data->gr_status==0)
                        {


                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/view'])->one()!='')
                            {
                                $viewstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/purchase-order/view?id='.$data->id.' data-method=post>
                                                <i class="fa fa-eye"></i>
                                                    <span class="dj-icon-gap">  View</span>
                                                </a>
                                            </li>';
                            }
                            else
                            {
                                $viewstring = '';
                            }

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/purchase-order-template'])->one()!='')
                            {
                                $printstring = ' <li class="nav-item">
                                                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/master/purchase-order/printall?id='.$data->id.' title="Print Bill" data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Print</span>
                                                                                    </a>
                                                                                </li>';
                            }
                            else
                            {
                                $printstring = '';
                            } 

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/update'])->one()!='')
                            {
                                $editstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/purchase-order/update?id='.$data->id.'>
                                                    <i class="fa fa-pencil-square"></i>
                                                    <span class="dj-icon-gap"> Edit</span>
                                                </a>
                                            </li>';
                            }
                            else
                            {
                                $editstring = '';
                            }

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/download-attachment'])->one()!='')
                            {
                                $attachmentstring = '<li class="nav-item">
                                            <a class="nav-link" href='.Url::base().'/master/purchase-order/download-attachment?id='.$data->id.'>
                                                <i class="fa fa-file"></i>
                                                <span class="dj-icon-gap"> Download Attachment</span>
                                            </a>
                                        </li>';
                            }
                            else
                            {
                                $attachmentstring = '';
                            }

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/delete'])->one()!='')
                            {
                                $deletestring = '<li class="nav-item">
                                                <a class="nav-link deleteind" href='.Url::base().'/master/purchase-order/delete?id='.$data->id.' data-method=post>
                                                <i class="fa fa-trash"></i>
                                                    <span class="dj-icon-gap">Delete</span>
                                                </a>
                                            </li>';
                            }
                            else
                            {
                                $deletestring = '';
                            }

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/create'])->one()!='')
                            {
                                if($data->billed==0){
                                $billstring = '<li class="nav-item">
                                            <a class="nav-link" href='.Url::base().'/users/purchase-bill/create?po='.$data->id.'&from=purchaseorder data-method=post>
                                            <i class="fa fa-credit-card"></i>
                                                <span class="dj-icon-gap">Convert to Bill</span>
                                            </a>
                                        </li>';
                                }
                                else{
                                    $billstring = '';
                                }
                            }
                                // else{
                                //     $billstring = '';
                                // }
                                
                             

                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/purchase-order/create'])->one()!='')
                            {
                                $duplicatestring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/master/purchase-order/create?id='.$data->id.'&from=purchase-order'.' data-method=post>
                                        <i class="fa fa-shopping-cart"></i>
                                            <span class="dj-icon-gap">Duplicate PO</span>
                                        </a>
                                    </li>';
                            }
                            else
                            {
                                $duplicatestring = '';
                            }

                             return $topstring.''.$viewstring.''.$printstring.''.$editstring.''.$attachmentstring.''.$deletestring.''.$billstring.''.$duplicatestring.''.$downstring;


                          
                        }


                        
                    },
            ],
        ],
    ]); ?>
            </div>
        </div>
    </div>
    <?php ob_start();?>
 <script type="text/javascript">
$(function() {
    $('#delete').click(function(){
var ids = $('#w0').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are u sure you want to delete the selected Purchase order?");
else
alert('Please select some Purchase order to delete!')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are u sure you want to delete the Purchase order?");
if (confirm == true)
return true;
else
return false;
})
$('#search-creditnote').hide();
$('#advance-search').click(function(){
    $('#search-creditnote').toggle();
})
$('.product').select2({
            ajax: { 
            url: "../../users/leads-quotes/productdetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                // console.log(response);
                return {
                    results: $.map(response, function (i,item) {
                        // console.log(i,item);
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
                    
               
            },
            cache: true
            }
            })
$('.findvendor').select2({
        ajax: { 
        url: "vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };        
           
        },
        cache: true
        }
    });

$('.properprint').click(function(e){
 e.preventDefault();
 canelUrl = $(this).attr("value");
 window.open($(this).attr("value"), "Mohapatra Scientific Pvt Ltd - "+$(this).attr("title"), "width=700,height=700,scrollbars=yes");
});
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
    