<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\SettingTypes;
use backend\modules\master\models\GenericTemplate;
/* @var $this yii\web\View */
/* @var $model backend\modules\master\models\Category */
/* @var $form yii\widgets\ActiveForm */

$salessettingtypes = SettingTypes::find()->where(['type' => 'Sales'])->all();
$template = GenericTemplate::find()->where(['template_type' => 'Sales'])->all();
// echo '<pre>';
// print_r($template);
// die();
$salessettinglist = ArrayHelper::map($salessettingtypes, 'setting_type_name', 'setting_type_name');
$templatelist = ArrayHelper::map($template, 'template_name', 'template_name');
// print_r($salessettinglist);
// die();
?>
<style>
    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .select2-container .select2-selection--single {
        height: 37px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 37px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 35px;
    }

    .rendered .select2-selection__rendered {
        width: 120px !important;
    }

    .help-error {
        color: red;
        margin-top: -15px;
    }
</style>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success"><?= $update ? 'Update Template' : 'Add Template' ?></div>
                                        </div>
                                        <div class="widget-content-right">
                                            <a href="<?= Url::base(); ?>/master/sales-templates/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>


            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <!-- <form class="dj-sale-form"> -->
            <?php $form = ActiveForm::begin(); ?>

            <div class="form-row">
                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="notes" class="">Setting Type <span class="dj-red">*</span></label>
                        <?= $form->field($model, 'setting_type')->dropDownList($salessettinglist, ['maxlength' => true, 'class' => 's_types form-control setting_type', 'prompt' => '--select--'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="notes" class="">Setting Name <span class="dj-red">*</span></label>
                        <?= $form->field($model, 'template_name')->textInput(['maxlength' => true, 'class' => 'form-control template_name'])->label(false) ?>
                        <div class="help-error">Duplicate entry.</div>
                    </div>
                </div>

                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="exampleFile" class="">Choose Template<span class="dj-red">*</span></label>
                        <?= $form->field($model, 'chosen_template')->dropDownList($templatelist, ['maxlength' => true, 'class' => 's_types form-control setting_type', 'prompt' => '--select--'])->label(false) ?>
                    </div>

                </div>

            </div>

            <div class="djsec-text-right">
                <?= Html::submitButton($update ? '<i class="fa fa-check-square-o" aria-hidden="true"></i> Update' : '<i class="fa fa-check-square-o" aria-hidden="true"></i> Create', ['class' => 'dj-danger-btn save']) ?>
                <button type=reset onclick="location.href='<?= Url::base() ?>/master/sales-templates/index';" class='dj-red-btn reset'> <i class="fa fa-ban" aria-hidden="true"></i> Cancel</a>
            </div>

            <?php ActiveForm::end(); ?>
        </div>
    </div>
</div>
<?php ob_start(); ?>
<script type="text/javascript">
    $(function() {
        $('.s_types').select2();
        $('.help-error').hide();
        $(document).on("change", ".template_name", function() {
            $('.help-error').hide();
        })
        $(document).on("click", ".save", function(e) {
            e.preventDefault();
            var value = false;
            var setting = $('.setting_type').val();
            var template = $('.template_name').val();
            $.get('findsetting', {
                setting: setting,
                template: template
            }, function(data) {
                var data = $.parseJSON(data);
                if (data == '0') {
                    $('.template_name').focus();
                    $('.help-error').show();
                    value = true;
                } else {
                    $('.help-error').hide();
                    value = false;
                }

                if (value == false) {
                    //    $(this).attr("disabled", "disabled");  
                    //    setTimeout(function() {
                    //    $('.save').removeAttr("disabled");
                    //    }, 7000);
                    $(".save").submit();
                }
            })

        })
    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>