<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ActiveForm;
use yii\helpers\Url;

use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\VendorSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Vendors';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
    <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
                <div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Vendors</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                                <a  class="search_field_buttons"  href="<?=Url::base().'/master/vendor/index'?>" role="button" aria-expanded="false" aria-controls="search-look" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                                              <a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Vendors</a>
                                                              <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/vendor/create'])->one()!=''){?>
                                                                <a href="create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Vendors</a>
                                                               <?php }else {?>

                                                               <?php } ?>
                                                                

                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                            <?php $form = ActiveForm::begin(['method' => 'get']); ?>   
                        <div class="row">
                         
                        <div class="col-md-3">
                         <div class="position-relative form-group">
                                <label for="customer" class="">Company</label>
                               <!-- <input name="point" id="point" type="text" class="form-control"> -->
                               <?= $form->field($model, 'findname')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                          </div>
                        </div>
                        <div class="col-md-3">
                         <div class="position-relative form-group">
                                <label for="customer" class="">Mobile</label>
                               <?= $form->field($model, 'mobile')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                          </div>
                        </div>
                        <div class="col-md-2" style="padding-top: 27px">
                                <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'search_field_buttons']) ?>
                            </div>


                        
                        </div>
                        <?php ActiveForm::end(); ?> 

                        <div class="row">
                         <div class="col-sm-6">
                                <div class="djsec-text-left dj-print-sec">
                               <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/vendor/delete'])->one()!=''){?>
                                <button id='delete' class='mb-2 mr-2 btn-icon btn btn-danger '><i class="fa fa-trash"></i> Delete</button> 
                               <?php }else {?>

                               <?php } ?>
                                                
                               </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="djsec-text-right dj-print-sec">

                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/vendor/excel-export'])->one()!=''){?>
                                    <a href="<?=Url::base();?>/master/vendor/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                                    <a href="<?=Url::base();?>/master/vendor/excel-export" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                                   <?php }else {?>

                                   <?php } ?>

                                   <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/vendor/export-pdf'])->one()!=''){?>
                                    <a href="<?=Url::base();?>/master/vendor/export-pdf" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                                   <?php }else {?>

                                   <?php } ?>       

                                </div>
                            </div>
                        
                        </div>
                        
                            
                            <?= GridView::widget([
                                'dataProvider' => $dataProvider,
                                "id" => "grid",
                                'filterModel' => $searchModel,
                                'columns' => [
                                     ['class' => 'yii\grid\CheckboxColumn'],
                                     ['class' => 'yii\grid\SerialColumn',
                                     
                                     'headerOptions' => ['style' => 'color:#495057'],
                                      'contentOptions'=>[ 'style'=>'width: 15px'],],
                                    // 'business_name',
                                    [
                                        'label' => 'Business Name',
                                        'contentOptions'=>['style'=>'font-weight:bold'],
                                        'attribute' => 'business_name',
                                        'value' => function ($data) {
                                            return $data->business_name;
                                        }
                                    ],
                                    [
                                        'label' => 'Email',
                                        'attribute' => 'email',
                                        'value' => function ($data) {
                                            return $data->email;
                                        }
                                    ],
                                    'vendor_type',
                                    'country',

                                    [
                                        'label' => 'Action',
                                        // 'attribute' => 'username',
                                        'headerOptions' => ['style' => 'color:#495057'],
                                        'format'=>'raw',
                                        'contentOptions'=>[ 'style'=>'width: 35px'],
                                        'value' => function ($data) use ($assign) {

                                            $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                                            $downstring =  '</ul></div></div>';  


                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/vendor/view'])->one()!='')
                                            {
                                                $viewstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/vendor/view?id='.$data->id.' data-method=post>
                                                   <i class="fa fa-eye"></i>
                                                    <span class="dj-icon-gap">  View</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $viewstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/vendor/update'])->one()!='')
                                            {
                                                $editstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/master/vendor/update?id='.$data->id.'&&page=1>
                                                    <i class="fa fa-pencil-square"></i>
                                                    <span class="dj-icon-gap"> Edit</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $editstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/vendor/delete'])->one()!='')
                                            {
                                                $deletestring = '<li class="nav-item">
                                                <a class="nav-link confirmdeletevendor" href='.Url::base().'/master/vendor/delete?id='.$data->id.'  data-method=post>
                                                   <i class="fa fa-trash"></i>
                                                    <span class="dj-icon-gap">  Delete</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $deletestring = '';
                                            }

                                            return $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$downstring;
                                        },
                                    ],

                                    // ['class' => 'yii\grid\ActionColumn',
                                    //  'header'=>"Action"],

                                ],
                            ]); ?>

                        </div>

                    </div>
                </div>
<?php ob_start();?>
 <script type="text/javascript">
$(function() {
$('#delete').click(function(){
    var ids = $('#grid').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure you want to delete selected Vendors?");
        if(x)
        {
            var ids = $('#grid').yiiGridView('getSelectedRows');
            console.log(ids);
            $.post( 'delete',{data: ids}, function( data ) {
               });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some Vendors to delete!");
    }
   
})
$('.confirmdeletevendor').click(function(){
var confirm = window.confirm("Are u sure you want to delete the selected Vendor?");
if (confirm == true)
return true;
else
return false;
})

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>

