<?php

namespace backend\modules\reports\controllers;
use backend\modules\reports\models\OtherLedgerOverview;
use backend\modules\reports\models\OtherLedgerDetails;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\GroupName;
use yii\data\ActiveDataProvider;
use Yii;
use Mpdf\Mpdf;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Vendor;
use backend\modules\users\models\AccountingDetails;
use backend\modules\users\models\CreditNote;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\users\models\DebitNote;
use backend\modules\master\models\AccountingLedger;
use backend\modules\reports\models\CustmorLedgerDetails;
use backend\modules\reports\models\CustomerLedgerOverview;
use backend\modules\reports\models\VendorLedgerDetails;

class GeneralLedgerReportController extends \yii\web\Controller
{
    public function actionIndex($print = null, $excel = null)
    {
        $model = new OtherLedgerOverview;
        $searchModel= new OtherLedgerOverview;
        $query = OtherLedgerOverview::find();


            if($model->load(Yii::$app->request->get())){
            $model->load(Yii::$app->request->queryParams);

            $query->andFilterWhere(['like', 'ledgerhead_id', $model->ledger_name]);
             
               if($model->search){
                $query
               ->andFilterWhere(['like', 'ledgerhead_id', $model->search]);
            }


            
            if ($model->sort_by) {
                if ($model->sort_by == 'Debit # Asc') {
                    $query->orderBy(['total_debit_amount' => SORT_ASC]);
                } elseif ($model->sort_by == 'Debit # Dsc') {
                    $query->orderBy(['total_debit_amount' => SORT_DESC]);
                } elseif ($model->sort_by == 'Credit Asc') {
                    $query->orderBy(['total_credit_amount' => SORT_ASC]);
                } elseif ($model->sort_by == 'Credit Dsc') {
                    $query->orderBy(['total_credit_amount' => SORT_DESC]);
                } 

            }

            if ($model->ledg_bal) {
                if ($model->ledg_bal == 'non_zero_ledger') {
                   $query->andWhere(['!=', 'total_debit_amount', new \yii\db\Expression('total_credit_amount')]);
                } elseif ($model->ledg_bal == 'zero_ledger') {
                   $query->andWhere(['=', 'total_debit_amount', new \yii\db\Expression('total_credit_amount')]);
                }
            }  

    }

        $dataProvider = new ActiveDataProvider([
            'query'=>$query,

        ]);


        if ($excel != null) {
            $dataProvider->pagination = false;
           $this->actionGeneralLedgeroverview($dataProvider);
        }

        return $this->render('index',[
            'dataProvider'=>$dataProvider,
            'model'=> $model,
            'print' => $print,

        ]);        
    }

    public function actionGeneralledgerDetails($id=null,$excel=null)
    {

      $ledger = AccountingLedger::find()->where(['accounting_ledger_id'=>$id])->one();
      $ledger_type = 0;
      $ledger_name = '';
      if($ledger->group_name_id==29)
      {
        $cust = Vendor::find()->where(['business_name'=>$ledger->ledger_id])->one();
        $query = VendorLedgerDetails::find()->where(['vendor'=>$cust->id]);
        $ledger_type = 1;
        $ledger_name = $ledger->ledger_id;
        $address = $cust->adderss_line_1;
        $city = $cust->city;
        $country = $cust->country;
        $state =$cust->state;
        $pincode = $cust->pin_code;
        $phone = $cust->mobile;
      }
      else if($ledger->group_name_id==28)
      {
        $cust = Customer::find()->where(['business_name'=>$ledger->ledger_id])->one();
        $query = CustmorLedgerDetails::find()->where(['customer'=>$cust->id]);
        $ledger_type = 2;
        $ledger_name = $ledger->ledger_id;
        $address = $cust->adderss_line_1;
        $city = $cust->city;
        $country = $cust->country;
        $state =$cust->state;
        $pincode = $cust->pin_code;
        $phone = $cust->mobile;
      }
      else{
        $query = OtherLedgerDetails::find()->where(['customer'=>$ledger->ledger_id]);
        $ledger_name = $ledger->ledger_id;
        $address = '';
        $city = '';
        $country = '';
        $state ='';
        $pincode = '';
        $phone = '';
      }
    
      $dataProvider = new ActiveDataProvider([
        'query'=>$query,
    ]);
    if ($excel != null) {
      $dataProvider->pagination = false;
     $this->actionGeneralLedgerDetailsPage($dataProvider,$ledger_name,$address,$city,$country,$state,$pincode,$phone);
    }
      return $this->render('generalledger-details', [
        // 'model' => $model,
         'name' => $id,
         'dataProvider' => $dataProvider,
         'ledger_type' => $ledger_type,
         'ledger_name'  => $ledger_name
        // 'user' => $vendor->business_name,
      ]);
    }




    public function actionGeneralLedgerExcel($data=null,$mod=null)
    {
        if($data!=null){
            $dataProvider = $data; 
       }
       else
       {
         $dataProvider = new ActiveDataProvider([
           'query' => OtherLedgerOverview::find(),
       ]);
       }
     
      $phpExcel = new \PHPExcel;
      $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
      $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel ->getActiveSheet();
      $row =1;
      foreach ($dataProvider->models as $model) {
       $sheet ->getCell('A' . $row)->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
       $sheet->mergeCells("A".($row).":I".($row));
       $sheet ->getCell('A' . ($row+1))->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
       $sheet->mergeCells("A".($row+1).":I".($row+1));
       $sheet ->getCell('A' . ($row+2))->setValue('BHUBANESWAR, Odisha');
       $sheet->mergeCells("A".($row+2).":I".($row+2));

       $sheet->getStyle('A' . $row)->getFont()->setBold(true)->setSize(12);
       $sheet->getStyle('A' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
       $sheet->getStyle('A' . ($row+1))->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
       $sheet->getStyle('A' . ($row+2))->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);

       $sheet ->getCell('A' . ($row+3))->setValue('');
       $sheet->mergeCells("A".($row+3).":I".($row+3));
       
       $model_address = Customer::find()->where(['business_name'=>$model->ledgerhead_id])->one(); 
    //  echo'<pre>';
    //    print_r(gettype($model_address->adderss_line_1));die();
       $sheet ->getCell('A' . ($row+4))->setValue($model->ledgerhead_id);
       $sheet->getStyle('A' . ($row+4))->getFont()->setBold(true)->setSize(10);
       $sheet->mergeCells("A".($row+4).":F".($row+4));
       $sheet ->getCell('A' . ($row+5))->setValue($model_address['adderss_line_1'].','.$model_address['adderss_line_2'].','.$model_address['adderss_line_3']);
       $sheet->mergeCells("A".($row+5).":F".($row+5));
       $sheet ->getCell('A' . ($row+6))->setValue($model_address['city']);
       $sheet->mergeCells("A".($row+6).":F".($row+6));
       $sheet ->getCell('A' . ($row+7))->setValue($model_address['state']);
       $sheet->mergeCells("A".($row+7).":F".($row+7));
       $sheet ->getCell('A' . ($row+8))->setValue($model_address['country'].'-'.$model_address['pin_code']);
       $sheet->mergeCells("A".($row+8).":F".($row+8));
       $sheet ->getCell('A' . ($row+9))->setValue('Phone No-'.(string)$model_address['phone']);  
       $sheet->mergeCells("A".($row+9).":F".($row+9));
        $sheet->mergeCells("G".($row+4).":G".($row+9));
        $sheet ->getCell('H' . ($row+4))->setValue('STATEMENT OF ACCOUNT');
        $sheet->getStyle('H' . ($row+4))->getAlignment()->setVertical(\PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_TOP);
        $sheet->getStyle('H' . ($row+4))->getFont()->setBold(true)->setSize(10);
        $sheet->mergeCells("H".($row+4).":H".($row+9));
   
      if($mod->from_date!=null && $mod->to_date!='')
      {
         $sheet ->getCell('A' . ($row+10))->setValue(date('d/m/Y', strtotime($mod->from_date)).' to '.date('d/m/Y', strtotime($mod->to_date)));
      }
      else{
        $sheet ->getCell('A' . ($row+10))->setValue('');
      }
       $sheet->mergeCells("A".($row+10).":F".($row+10));


       $sheet ->getCell('A' . ($row+11))->setValue('Date');
        $sheet->getColumnDimension('A')->setWidth(20);
       $sheet ->getCell('B' . ($row+11))->setValue('REF.NO.');
       $sheet->getColumnDimension('B')->setWidth(20);
       $sheet ->getCell('C' . ($row+11))->setValue('DESCRIPTION');
       $sheet->getColumnDimension('C')->setWidth(40);
       $sheet ->getCell('D' . ($row+11))->setValue('NOTES');
       $sheet->getColumnDimension('D')->setWidth(40);
       $sheet ->getCell('E' . ($row+11))->setValue('VCH TYPE');
       $sheet->getColumnDimension('E')->setWidth(10);
       $sheet ->getCell('F' . ($row+11))->setValue('DEBIT');
       $sheet->getColumnDimension('F')->setWidth(15);
       $sheet ->getCell('G' . ($row+11))->setValue('CREDIT');
       $sheet->getColumnDimension('G')->setWidth(15);
       $sheet ->getCell('H' . ($row+11))->setValue('BALANCE');
       $sheet->getColumnDimension('H')->setWidth(22);

       $balance =Customer::find()->where(['business_name'=>$model->ledgerhead_id])->one()['opening_as_on'];
//print_r($balance);die();
       $sheet ->getCell('E' . ($row+12))->setValue('Opening');


       $model_details = AccountingDetails::find()->where(['ledgerhead_id'=>$model->ledgerhead_id])->all();
       if($mod->from_date!='' && $mod->to_date!='')
       {
            
            $model_details = AccountingDetails::find()->where(['ledgerhead_id'=>$model->ledgerhead_id])->andWhere(['edit_status'=>0])->andWhere(['or',['transaction_type'=>'Invoice'],['transaction_type'=>'Receipt'],['transaction_type'=>'Credit Note'],['transaction_type'=>'Debit Note']])->andFilterWhere(['>=', 'date',$mod->from_date])->andFilterWhere(['<=', 'date',$mod->to_date])->orderBy(['date' => SORT_ASC ])->all();
       }
       else
       {
           $model_details = AccountingDetails::find()->where(['ledgerhead_id'=>$model->ledgerhead_id])->andWhere(['edit_status'=>0])->andWhere(['or',['transaction_type'=>'Invoice'],['transaction_type'=>'Receipt'],['transaction_type'=>'Credit Note'],['transaction_type'=>'Debit Note']])->orderBy(['date' => SORT_ASC ])->all();
       }
       

      
    
        $i = $row+13;
        $row_amount =0;
        
        $Debit_value =0;
        $Credit_value =0;

        if($mod->from_date!='' && $mod->to_date!='')
      {
        $prev_debit_amount = 0;
            $previous_debit = AccountingDetails::find()->andFilterWhere(['<=', 'date',$mod->from_date])
            ->andFilterWhere(['edit_status'=>0])
            ->andFilterWhere(['in', 'ledgerhead_id',$model->ledgerhead_id])
            ->andFilterWhere(['or', ['transaction_type'=>'Receipt'],['transaction_type'=>'Debit Note']])->orderBy(['date' => SORT_ASC ])->all();
            foreach ($previous_debit as $key => $prev_debit) {
                $prev_debit_amount = $prev_debit_amount + $prev_debit->amount;
            }

        $prev_credit_amount = 0;
            $previous_credit = AccountingDetails::find()->andFilterWhere(['<=', 'date',$mod->from_date])
            ->andFilterWhere(['edit_status'=>0])
            ->andFilterWhere(['in', 'ledgerhead_id',$model->ledgerhead_id])
            ->andFilterWhere(['or', ['transaction_type'=>'Invoice'],['transaction_type'=>'Credit Note']])->orderBy(['date' => SORT_ASC ])->all();
            foreach ($previous_credit as $key => $prev_credit) {
                $prev_credit_amount = $prev_credit_amount + $prev_credit->amount;
            }
           $before_balance = (($balance+$prev_credit_amount)-$prev_debit_amount) ;
          
        $sheet ->getCell('H' . ($row+12))->setValue((string)$before_balance);
      }
      else{
        $sheet ->getCell('H' . ($row+12))->setValue($balance);

      }


       foreach ($model_details as $key => $val) {

      if($mod->from_date!='' && $mod->to_date!='')
      {
        $prev_debit_amount = 0;
            $previous_debit = AccountingDetails::find()->andFilterWhere(['<=', 'date',$mod->from_date])
            ->andFilterWhere(['edit_status'=>0])
            ->andFilterWhere(['in', 'ledgerhead_id',$val->ledgerhead_id])
            ->andFilterWhere(['or', ['transaction_type'=>'Receipt'],['transaction_type'=>'Debit Note']])->orderBy(['date' => SORT_ASC ])->all();
            foreach ($previous_debit as $key => $prev_debit) {
                $prev_debit_amount = $prev_debit_amount + $prev_debit->amount;
            }
        $sheet ->getCell('F' . ($row+12))->setValue((string)$prev_debit_amount);
      }
      else{
        $sheet ->getCell('F' . ($row+12))->setValue('0');
      }

      if($mod->from_date!='' && $mod->to_date!='')
      {
        $prev_debit_amount = 0;
            $previous_debit = AccountingDetails::find()->andFilterWhere(['<=', 'date',$mod->from_date])
            ->andFilterWhere(['edit_status'=>0])
            ->andFilterWhere(['in', 'ledgerhead_id',$val->ledgerhead_id])
            ->andFilterWhere(['or', ['transaction_type'=>'Invoice'],['transaction_type'=>'Credit Note']])->orderBy(['date' => SORT_ASC ])->all();
            foreach ($previous_debit as $key => $prev_debit) {
                $prev_debit_amount = $prev_debit_amount + $prev_debit->amount;
            }
        $sheet ->getCell('G' . ($row+12))->setValue((string)$prev_debit_amount);
      }
      else{
        $sheet ->getCell('G' . ($row+12))->setValue('0');
      }
        $count=0;
        if($val!='')
        $total_trancection = AccountingDetails::find()->where(['transaction_id'=>$val->transaction_id])->andWhere(['edit_status'=>0])->andWhere(['or',['transaction_type'=>'Invoice'],['transaction_type'=>'Receipt'],['transaction_type'=>'Credit Note'],['transaction_type'=>'Debit Note']])->orderBy(['date' => SORT_ASC ])->all();
           $row_amount = $row_amount + count($total_trancection);
           $count =count($total_trancection);
           
           if($row_amount>1)
         $sheet->mergeCells("A".($i).":A".($i+($count-2)));
         $sheet->mergeCells("B".($i).":B".($i+($count-2)));
         $sheet->mergeCells("D".($i).":D".($i+($count-2)));
         $sheet->mergeCells("E".($i).":E".($i+($count-2)));
         $sheet->mergeCells("F".($i).":F".($i+($count-2)));
         $sheet->mergeCells("G".($i).":G".($i+($count-2)));
         $sheet->mergeCells("H".($i).":H".($i+($count-2)));

           foreach ($total_trancection as $key => $value) {
           
           if($value->accounting_type == 'Credit' && $value->ledgerhead_id==$val->ledgerhead_id)
           {
              $Credit_value = $Credit_value + $val->amount;
              if($mod->from_date!='' && $mod->to_date!='')
              {
                if($before_balance!='')
                {
                  $before_balance = (float)$before_balance+ $val->amount;
                }
                else
                {
                  $before_balance = 0+ $val->amount;
                }
                  
              }
              else
              {
                
                if($balance!='')
                {
                  $balance = (float)$balance+$val->amount;
                }
                else
                {
                  $balance = 0+$val->amount;
                }
               
                  
              }
              
           }
           else if($value->accounting_type == 'Debit' && $value->ledgerhead_id==$val->ledgerhead_id)
           {
               if($mod->from_date!='' && $mod->to_date!='')
              {
                if($before_balance!='')
                {
                  $before_balance = (float)$before_balance- $val->amount;
                }
                else
                {
                  $before_balance = 0 - $val->amount;
                }
                  
              }
              else
              { 
                if($balance!='')
                {
                  $balance = (float)$balance-$val->amount;
                }
                else
                {
                 $balance = 0-$val->amount;
                }
                  
              }
              
              $Debit_value = $Debit_value + $val->amount;
           }
           if($value->ledgerhead_id!=$val->ledgerhead_id)
           {
               $sheet ->getCell('A' . ($i))->setValue(date('d/m/Y', strtotime($value->date)));

               if($value->transaction_type=='Receipt')
               {
                    $findbill = ReceiptDetails::find()->where(['id'=>$value->transaction_id])->one();
                    $sheet ->getCell('B' . ($i))->setValue($findbill->receipt_id);
               }
               elseif($value->transaction_type=='Credit Note')
               {
                    $findbill = CreditNote::find()->where(['id'=>$value->transaction_id])->one();
                    $sheet ->getCell('B' . ($i))->setValue($findbill->credit_note_id);
               }
               elseif($value->transaction_type=='Debit Note')
               {
                    $findbill = DebitNote::find()->where(['id'=>$value->transaction_id])->one();
                    $sheet ->getCell('B' . ($i))->setValue($findbill->prefix.'/'.$findbill->po.'/'.$findbill->suffix);
               }
               else
               {
                    $sheet ->getCell('B' . ($i))->setValue($value->transaction_id);
               }
               
               $sheet ->getCell('C' . ($i))->setValue($value->ledgerhead_id);
               $sheet ->getCell('D' . ($i))->setValue($val->ledgerhead_id);
               $sheet ->getCell('E' . ($i))->setValue($value->transaction_type);
               if($value->transaction_type=='Receipt')
               {
                   $sheet ->getCell('G' . ($i))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $val->amount));
		   $sheet->getStyle('F' . ($i))->getNumberFormat()->setFormatCode('0.00'); 
                   $sheet ->getCell('F' . ($i))->setValue("0.00");
               }
               else
               {
			$sheet->getStyle('G' . ($i))->getNumberFormat()->setFormatCode('0.00'); 
                   $sheet ->getCell('G' . ($i))->setValue("0.00");
                   $sheet ->getCell('F' . ($i))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $val->amount)); 
               }   
           }
           else if($value->ledgerhead_id==$val->ledgerhead_id)
           {
              if($mod->from_date!='' && $mod->to_date!='')
              {
                  $sheet ->getCell('H' . (($i)))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $before_balance));
              }
              else
              { 
                  $sheet ->getCell('H' . (($i)))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $balance));
              }
              
              $sheet->getStyle('H' . ($i))->getFont()->setBold(true)->setSize(10);
              // $total_balance = $total_balance + $balance;
           }
             $i++;
           }
       }
       $sheet ->getCell('E' . ($row+13+$row_amount))->setValue('Total (Rs)');
       $sheet->getStyle('E' . ($row+13+$row_amount))->getFont()->setBold(true)->setSize(10);
       $sheet->getStyle('F' . ($row+13+$row_amount))->getNumberFormat()->setFormatCode('0.00');
       $sheet ->getCell('F' . ($row+13+$row_amount))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $Credit_value));
       $sheet->getStyle('F' . ($row+13+$row_amount))->getFont()->setBold(true)->setSize(10);
       $sheet->getStyle('G' . ($row+13+$row_amount))->getNumberFormat()->setFormatCode('0.00');
       $sheet ->getCell('G' . ($row+13+$row_amount))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $Debit_value));
       $sheet->getStyle('G' . ($row+13+$row_amount))->getFont()->setBold(true)->setSize(10);
       if($mod->from_date!='' && $mod->to_date!='')
      {  
          $sheet->getStyle('H' . ($row+13+$row_amount))->getNumberFormat()->setFormatCode('0.00');
          $sheet ->getCell('H' . ($row+13+$row_amount))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $before_balance));
      }
      else
      { 
	   $sheet->getStyle('H' . ($row+13+$row_amount))->getNumberFormat()->setFormatCode('0.00');
          $sheet ->getCell('H' . ($row+13+$row_amount))->setValue((string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $balance));
      }
       
       $sheet->getStyle('H' . ($row+13+$row_amount))->getFont()->setBold(true)->setSize(10);


       $row = $row+16+$row_amount;
      }
      // die();

      ob_clean();
        ob_start();
        
         header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
         header('Content-Disposition: attachment; filename="general-ledger-detailed.xls"'); // Write file to the browser 

      $writer->save('php://output');
      ob_flush();
      exit();

 }

 public function actionGeneralLedgeroverview($data = null)
  {
    if ($data != null) {
      $dataProvider = $data;
    } else {
      $dataProvider = new ActiveDataProvider([
        'query' => OtherLedgerOverview::find(),
      ]);
      $dataProvider->pagination = false;
    }

    $phpExcel = new \PHPExcel;
    $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
    $phpExcel->getProperties()->setDescription("Excel SpreadSheet in PHP");
    $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
    $sheet = $phpExcel->getActiveSheet();
    $sheet->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
    $sheet->getCell('A2')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
    $sheet->getCell('A3')->setValue('BHUBANESWAR, Odisha');
    $sheet->getCell('A4')->setValue('');
    $sheet->getCell('A5')->setValue('Ledgers');
    $sheet->getStyle('A5')->getFont()->setBold(true)->setSize(11);
    $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
    $sheet->getStyle('A2')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
    $sheet->getStyle('A3')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
    $sheet->getStyle('A4')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
    $sheet->getStyle('A5')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
    $sheet->getStyle('A6')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
    $sheet->getStyle('A1:S1')->getFont()->setBold(true)->setSize(12);
    $sheet->getStyle('A2:S2')->getFont()->setSize(11);
    $sheet->getStyle('A3:S3')->getFont()->setSize(11);
    $sheet->getStyle('A4:S4')->getFont()->setSize(11);
    $sheet->getStyle('A5:S5')->getFont()->setSize(11);
    $sheet->getStyle('A6:S6')->getFont()->setSize(11);
    $sheet->getColumnDimension('A')->setWidth(60);
    $sheet->getColumnDimension('B')->setWidth(30);
    $sheet->getColumnDimension('C')->setWidth(30);

    $sheet->mergeCells('A1:C1');
    $sheet->mergeCells('A2:C2');
    $sheet->mergeCells('A3:C3');
    $sheet->mergeCells('A4:C4');
    $sheet->mergeCells('A5:C5');
    $sheet->mergeCells('A6:C6');

    $sheet->setCellValue('A7',  'Ledger Name');
    $sheet->setCellValue('B7',  'Debit');
    $sheet->setCellValue('C7',  'Credit');
    $sheet->getStyle('A7')->getFont()->setBold(true)->setSize(11);
    $sheet->getStyle('B7')->getFont()->setBold(true)->setSize(11);
    $sheet->getStyle('C7')->getFont()->setBold(true)->setSize(11);

    $row = 8;
    $total_debit_amount = 0;
    $total_credit_amount = 0;
    foreach ($dataProvider->models as $model) {
      $sheet->setCellValue('A' . $row,  $model->name);
      $sheet->setCellValue('B' . $row,  (string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $model->total_debit_amount));
      $sheet->setCellValue('C' . $row,  (string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $model->total_credit_amount));

      $sheet->getStyle('B' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
      $sheet->getStyle('C' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);

      $total_debit_amount = $total_debit_amount + $model->total_debit_amount;
      $total_credit_amount = $total_credit_amount + $model->total_credit_amount;

      $row++;

    }

    $sheet->setCellValue('A' . $row, 'Total');
    $sheet->setCellValue('B' . $row,  (string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $total_debit_amount));
    $sheet->setCellValue('C' . $row,  (string)preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $total_credit_amount));
    $sheet->getStyle('B' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
    $sheet->getStyle('C' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
    $sheet->getStyle('A' . $row)->getFont()->setBold(true)->setSize(11)->getColor()->setRGB('FF0000');
    $sheet->getStyle('B' . $row)->getFont()->setBold(true)->setSize(11)->getColor()->setRGB('FF0000');
    $sheet->getStyle('C' . $row)->getFont()->setBold(true)->setSize(11)->getColor()->setRGB('FF0000');

    ob_clean();
    ob_start();

    header('Content-type: application/vnd.ms-excel'); 
    header('Content-Disposition: attachment; filename="general-ledgers.xls"');
    $writer->save('php://output');
    ob_flush();
    exit();


  }
  public function actionGeneralLedgerDetailsPage($dataProvider = null, $ledger_type = null, $address, $city, $country, $state, $pincode, $phone)
{
    if ($dataProvider === null || empty($dataProvider->models)) {
        throw new \Exception('No data available');
    }

    $dataProvider->pagination = false;

    $phpExcel = new \PHPExcel;
    $phpExcel->getDefaultStyle()->getFont()->setName('Calibri');
    $phpExcel->getProperties()->setDescription("Excel SpreadSheet in PHP");
    $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
    $sheet = $phpExcel->getActiveSheet();

    $sheet->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
    $sheet->getCell('A2')->setValue('F2G/30, INDRADHANU MARKET, IRC VILLAGE,');
    $sheet->getCell('A3')->setValue('BHUBANESWAR, Odisha');
    $sheet->getCell('A4')->setValue('');
    $sheet->getCell('A5')->setValue($ledger_type);
    $sheet->getStyle('A5')->getFont()->setBold(true);
    $sheet->getCell('A6')->setValue($address);
    $sheet->getCell('A7')->setValue($city);
    $sheet->getCell('A8')->setValue($state);
    $sheet->getCell('A9')->setValue($country . '-' . $pincode);
    $sheet->getCell('A10')->setValue('Phone no:' . $phone);
    $sheet->getCell('A11')->setValue(''); 

    // Set alignment
    for ($i = 1; $i <= 4; $i++) {
        $sheet->getStyle('A' . $i)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
    }

    // Set styles
    $sheet->getStyle('A1:S1')->getFont()->setBold(true)->setSize(12);
    $sheet->getStyle('A2:S2')->getFont()->setSize(11);
    $sheet->getStyle('A3:S3')->getFont()->setSize(11);
    $sheet->getStyle('A4:S4')->getFont()->setSize(11);

    for ($i = 5; $i <= 11; $i++) {
        $sheet->getStyle('A' . $i . ':S' . $i)->getFont()->setSize(11);
    }

    // Set column dimensions
    $sheet->getColumnDimension('A')->setWidth(30);
    $sheet->getColumnDimension('B')->setWidth(30);
    $sheet->getColumnDimension('C')->setWidth(30);

    // Merge cells for header rows
    $sheet->mergeCells('A1:G1');
    $sheet->mergeCells('A2:G2');
    $sheet->mergeCells('A3:G3');
    $sheet->mergeCells('A4:G4');
    for ($i = 5; $i <= 11; $i++) {
        $sheet->mergeCells('A' . $i . ':G' . $i);
    }

    // Set header row values
    $sheet->setCellValue('A12', 'Date');
    $sheet->setCellValue('B12', 'Ledger Name');
    $sheet->setCellValue('C12', 'Vch No');
    $sheet->setCellValue('D12', 'Vch Type');
    $sheet->setCellValue('E12', 'Notes');
    $sheet->setCellValue('F12', 'Debit(Rs.)');
    $sheet->setCellValue('G12', 'Credit(Rs.)');

    // Set header row styles
    $sheet->getStyle('A12:G12')->getFont()->setBold(true)->setSize(10);

    // Fill data rows
    $row = 13;
    $total_debit_amount = 0;
    $total_credit_amount = 0;

    foreach ($dataProvider->models as $model) {
        if (isset($model->customer)) {
            if ($ledger_type == 2) {
                $cust = Customer::find()->where(['id' => $model->customer])->one();
                $ledger = AccountingLedger::find()->where(['ledger_id' => $cust->business_name])->one();
                $ledger_id = $ledger->ledger_id;
            } else {
                $ledger_id = $model->customer;
            }
        } else {
            $cust = Vendor::find()->where(['id' => $model->vendor])->one();
            $ledger = AccountingLedger::find()->where(['ledger_id' => $cust->business_name])->one();
            $ledger_id = $ledger->ledger_id;
        }

        $sheet->setCellValue('A' . $row, $model->dated);
        $sheet->setCellValue('B' . $row, $ledger_id);
        $sheet->setCellValue('C' . $row, $model->vch_no);
        $sheet->setCellValue('D' . $row, $model->vch_type);
        $sheet->setCellValue('E' . $row, $model->notes);
        $sheet->setCellValue('F' . $row, number_format($model->debit_amount, 2));
        $sheet->setCellValue('G' . $row, number_format($model->credit_amount, 2));

        $sheet->getStyle('F' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
        $sheet->getStyle('G' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);

        $total_debit_amount += $model->debit_amount;
        $total_credit_amount += $model->credit_amount;

        $row++;
    }

    // Set total row
    $sheet->setCellValue('E' . $row, 'Total');
    $sheet->setCellValue('F' . $row, number_format($total_debit_amount, 2));
    $sheet->setCellValue('G' . $row, number_format($total_credit_amount, 2));

    $sheet->getStyle('E' . $row . ':G' . $row)->getFont()->setBold(true)->setSize(11)->getColor()->setRGB('FF0000');

    // Output the spreadsheet
    ob_clean();
    ob_start();

    header('Content-type: application/vnd.ms-excel');
    header('Content-Disposition: attachment; filename="general-ledgers.xls"');
    $writer->save('php://output');
    ob_flush();
    exit();
}

}



