<?php

namespace backend\modules\reports\controllers;

use Yii;
use backend\modules\reports\models\InwardSuppliesDetails;
use yii\data\ActiveDataProvider;
use backend\modules\master\models\HsnCode;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use yii\helpers\ArrayHelper;
use  yii\web\Session;

class InwardSuppliesDetailsController extends \yii\web\Controller
{
    public function actionIndex($excel=null,$from_date=null,$to_date=null)
    {    
        if(isset($from_date) && isset($to_date))
        {
            Yii::$app->session->set('from',$from_date);
            Yii::$app->session->set('to',$to_date);
        }
        $model = new InwardSuppliesDetails();
        $query = InwardSuppliesDetails::find();
        if(Yii::$app->request->get()) {
            $model->load(Yii::$app->request->queryParams);
            $query->andFilterWhere(['=','sender_gst_id', $model->sender_gst_id])
                  ->andFilterWhere(['=','hsn_sac_code',$model->hsn_sac_code])
                  ->andFilterWhere(['=','bill_type',$model->bill_type])
                  ->andFilterWhere(['=','supply_attracts',$model->supply_attracts])
                  ->andFilterWhere(['=','product_id',$model->product_name])
                  ->andFilterWhere(['=','vendor_id',$model->vendor_id])
                  ->andFilterWhere(['=','vendor_id',$model->vendor_id])
                  ->andFilterWhere(['like','city',$model->location]);
                if($model->supply_type){
              if($model->supply_type=='Intra-state'){
                $query->andFilterWhere(['=','point_of_supply', '21']);
              }
             elseif($model->supply_type=='Inter-state'){
                $query->andFilterWhere(['<>','point_of_supply', '21']);
             }
            }
            if($from_date && $to_date){
                $query->andFilterWhere(['between', 'date', $from_date,$to_date]);
            }
            if($model->time_frame){
                if($model->time_frame=='Today'){
                    
                $query->andFilterWhere(['like', 'date', date('Y-m-d')]);
                }elseif($model->time_frame=='Current Week') {
                    $query->andFilterWhere(['>=', 'date',date('Y-m-d',strtotime('last monday')) ]);
                }elseif($model->time_frame=='Current Month') {
                    $query->andFilterWhere(['>=', 'date',date ('Y-m-d', strtotime ('first day of this month')) ]);
                }
                elseif($model->time_frame=='Current Year') {
                    $query->andFilterWhere(['>=', 'date',date('Y-m-d',strtotime(date('Y-04-01')))]);
                }elseif($model->time_frame=='Custom'){

                    $query->andFilterWhere(['between', 'date', $model->from,$model->to]);
                } 
            }

        }
            $dataProvider = new ActiveDataProvider([
            'query'=>$query,
        ]);
        if($excel == true)
        {
            // print_r('dd');
            // die();
            $this->actionGstrexcelreport($dataProvider);
        }
    
        return $this->render('index',[
            'model'=>$model,
            'from_date'=>$from_date,
            'to_date'=>$to_date,
            'dataProvider'=>$dataProvider,
        ]);
    }
    public function actionHsndetails($string=null)
  {
       if($string!=null)
        $data =  HsnCode::find()->where(['like','description',$string])->limit(10)->asArray()->all();
        else
        $data =  HsnCode::find()->limit(10)->asArray()->all();

        $productlist=ArrayHelper::map($data, 'code', 'description');
        
        return json_encode($data);
  }
  public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }
    public function actionCustomerdetails($searchTerm=null)
    {
        if(!$searchTerm)
            $product=Vendor::find()->limit(10)->all();
        else
            $product=Vendor::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'business_name');
        return json_encode($productlist);
    }
    public function actionGstrexcelreport($dataProvider=null)
    {
      // print_r($dataProvider->models);
      // die();
  
      // $dataProvider = new ActiveDataProvider([
      //         'query'=>$query,
      //     ]);
       $phpExcel = new \PHPExcel;
          $phpExcel ->getProperties()->setDescription("Excel SpreadSheet in PHP");
        $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
        $sheet = $phpExcel ->getActiveSheet();
  
        // $inv_details = Gstr1Details::find()->where(['between','invoice_date',$from_date,$to_date])->all();
        // print_r($inv_details);
        // die();
        
        // Making headers text bold and larger
        $sheet->getStyle('A1:F1')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('A2:V2')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('A4:V4')->getFont()->setBold(true)->setSize(12);
        $sheet->getStyle('A3:V3')->getFont()->setBold(true)->setSize(12);
        // $sheet->getColumnDimension('A:Y')->setWidth(30);
        
        $sheet->mergeCells('A1:S1');
        $sheet->mergeCells('A2:S2');
        // $sheet->mergeCells('A3:S3');
  
        $sheet->getColumnDimension('A')->setWidth(30);
        $sheet->getColumnDimension('B')->setWidth(50);
        $sheet->getColumnDimension('C')->setWidth(20);
        $sheet->getColumnDimension('D')->setWidth(20);
        $sheet->getColumnDimension('E')->setWidth(20);
        $sheet->getColumnDimension('F')->setWidth(20);
        $sheet->getColumnDimension('G')->setWidth(20);
        $sheet->getColumnDimension('H')->setWidth(20);
        $sheet->getColumnDimension('I')->setWidth(20);
        $sheet->getColumnDimension('J')->setWidth(20);
        $sheet->getColumnDimension('K')->setWidth(20);
        $sheet->getColumnDimension('L')->setWidth(20);
        $sheet->getColumnDimension('M')->setWidth(20);
        $sheet->getColumnDimension('N')->setWidth(20);
        $sheet->getColumnDimension('O')->setWidth(20);
        $sheet->getColumnDimension('P')->setWidth(20);
        $sheet->getColumnDimension('Q')->setWidth(20);
        $sheet->getColumnDimension('R')->setWidth(20);
        $sheet->getColumnDimension('S')->setWidth(20);
        $sheet->getColumnDimension('T')->setWidth(20);
        $sheet->getColumnDimension('U')->setWidth(20);
        $sheet->getColumnDimension('V')->setWidth(20);
        $sheet->getColumnDimension('W')->setWidth(20);
        $sheet->getColumnDimension('X')->setWidth(20);
        $sheet->getColumnDimension('Y')->setWidth(20);
  
        $sheet ->getCell('A1')->setValue('MOHAPATRA SCIENTIFIC PRIVATE LIMITED');
        $sheet ->getCell('A2')->setValue('F2G/30, INDRADHANU MARKETIRC VILLAGE,');
        // if($from_date!='' && $to_date != '')
        // {
        //    $sheet ->getCell('A3')->setValue(date('d-m-Y', strtotime($from_date)).' to '.date('d-m-Y', strtotime($to_date)));
        // }
        
  
        // $sheet ->getCell('A3')->setValue('Invoice Details');
  
        $sheet->setCellValue('A4',  'Date');
        $sheet->setCellValue('B4',  'Particulars');
        $sheet->setCellValue('C4',  'Vch No');
        $sheet->setCellValue('D4',  'Receiver GST No');
        $sheet->setCellValue('E4',  'Product');
        $sheet->setCellValue('F4',  'HSN/SAC Code');
        $sheet->setCellValue('G4',  'Qty');
        $sheet->setCellValue('H4',  'Rate');
        $sheet->setCellValue('I4',  'Discount');
        $sheet->setCellValue('J4',  'Taxable Value');
        $sheet->setCellValue('K4',  'IGST');
        $sheet->setCellValue('L4',  'CGST');
        $sheet->setCellValue('M4',  'SGST');
        $sheet->setCellValue('N4',  'CESS');
       
        $qty=0;
$price=0;
$discount=0;
$taxable_value=0;
$igst=0;
$cgst=0;
$sgst=0;
    foreach($dataProvider->models as $data)
    {
   $qty+=$data->qty;   
   $price+=$data->price; 
//    $discount+=$data->discount; 
if($data->discount_type=='%'){
    $discount+=($data->qty*$data->price)*($data->discount/100);
    $taxable_value+=($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100));
    // $igst+=$data->amount-($data->qty*$data->price)-($data->qty*$data->price*0.01);
    if($data->point_of_supply==21){
        $sgst+=($data->amount-(($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100))))/2;

    }else{
      $igst+=$data->amount-(($data->qty*$data->price)-(($data->qty*$data->price)*($data->discount/100)));

    }

}elseif ($data->discount_type=='FLAT') {
    $discount+=$data->discount;
    $taxable_value+=($data->price-$data->discount)*$data->qty;
    if($data->point_of_supply==21){
   $sgst+=$data->amount-($data->price*$data->qty-$data->discount)/2;

    }else{
   $igst+=$data->amount-($data->price*$data->qty-$data->discount);

    }
}
}
        // $sheet->getStyle('A1')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
        $sheet->getStyle('A1')->getFont()->setBold(true)->setSize(12);
        $row = 5;
          foreach ($dataProvider->models as $data) {
            //   print_r($data);
            //   die();
            //   $inv = Invoice::find()->where(['id'=>$data['invoice_id']])->one();
            //   $customer = Customer::find()->where(['id'=>$inv->customer_name])->one();
             // $invoice = Invoice::find()->where(['invoice_id'=>$data->invoice_id])->one();
              // $invoiceproduct = InvoiceProduct::find()->where(['invoice_id'=>$invoice->id])->all();
              // $customer = Customer::find()->where(['id'=>$invoice->customer_name])->one();
              
  
              // foreach ($invoiceproduct as $pdt) {
  
                  // $product = Product::find()->where(['id'=>$pdt->product_id])->one();
  
                  $sheet->setCellValue('A' . $row,  date('d-m-Y', strtotime($data->date)));
                  $sheet->setCellValue('B' . $row,  $data['vendor_name']);
                  $sheet->setCellValue('C' . $row,  (string)$data['bill_id']);    
                  $sheet->setCellValue('D' . $row,  $data['sender_gst_id']); 
                  $sheet->setCellValue('E' . $row,  $data['product_name']); 
                  $sheet->setCellValue('F' . $row,  $data['hsn_sac_code']);
                  $sheet->setCellValue('G' . $row,  (string)$data['qty']);
                  $sheet->setCellValue('H' . $row,  $data['price']);
                  $sheet->setCellValue('I' . $row,  $data['discount']);
                  $sheet->setCellValue('J' . $row, (string)(($data['qty']*$data['price'])-(($data['qty']*$data['price'])*($data['discount']/100))));
                  if($data['point_of_supply']!=21){
                    $sheet->setCellValue('K' . $row,  (string)(($data['amount']-(($data['qty']*$data['price'])-(($data['qty']*$data['price'])*($data['discount']/100))))/2));
                    $sheet->setCellValue('L' . $row,  '0');
                    $sheet->setCellValue('M' . $row,  '0');
                  }else{
                    $sheet->setCellValue('K' . $row,  '0.00');
                    $sheet->setCellValue('L' . $row,  (string)(($data['amount']-(($data['qty']*$data['price'])-(($data['qty']*$data['price'])*($data['discount']/100))))/2));
                    $sheet->setCellValue('M' . $row,  (string)(($data['amount']-(($data['qty']*$data['price'])-(($data['qty']*$data['price'])*($data['discount']/100))))/2));

                  }
                  
                  $sheet->setCellValue('N' . $row,  '0.00');
  
                  $row ++;
  
              // }
  
          }
  
          $sheet->getStyle('A' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('G' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('J' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('K' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('L' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('M' . ($row))->getFont()->setBold(true)->setSize(12);
            $sheet->getStyle('N' . ($row))->getFont()->setBold(true)->setSize(12);

            $sheet->getStyle('I' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('J' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('K' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('L' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('M' . ($row))->getNumberFormat()->setFormatCode('0.00');
            $sheet->getStyle('N' . ($row))->getNumberFormat()->setFormatCode('0.00');

            $sheet->getStyle('J' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('K' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('L' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('M' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);
            $sheet->getStyle('N' . $row)->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_RIGHT);

                $sheet->setCellValue('A' . $row,  'Grand Total');
                $sheet->setCellValue('G' . $row,  (string)$qty);
                $sheet->setCellValue('J' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", ($taxable_value)));
                $sheet->setCellValue('K' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", ($igst))); 
                $sheet->setCellValue('L' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", ($sgst)));
                $sheet->setCellValue('M' . $row,  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$sgst));
                $sheet->setCellValue('N' . $row,  '0.00');


  
  
         ob_clean();
          ob_start();
          
           header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
           header('Content-Disposition: attachment; filename="GSTR3-Inward-Report.xls"'); // Write file to the browser 
  
        $writer->save('php://output');
        ob_flush();
        exit();
    }
  

    

}
