<?php

namespace backend\modules\reports\controllers;

use Yii;
use backend\modules\reports\models\SaleOrderReport;
use backend\modules\reports\models\SaleOrderReportSearch;
use backend\modules\reports\models\SaleReportByProduct;
use backend\modules\master\models\Customer;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\SaleOrder;
use backend\modules\master\models\Product;
use yii\helpers\ArrayHelper;
use yii\helpers\Json;
use yii\data\ActiveDataProvider;
use common\models\User;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii2tech\spreadsheet\Spreadsheet;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;


class SaleOrderReportController extends \yii\web\Controller
{
    public function actionIndex($print=null,$detailedprint=null,$viewprint=null,$excel=null)
    {
    	$model = new SaleOrderReport();
    	  $searchModel = new SaleOrderReportSearch();
    	$dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $query=SaleOrderReport::find();
       
 
    	if($model->load(Yii::$app->request->get())){

    		$query->andFilterWhere(['like','customer_type',$model->type_of_customer])
                   ->andFilterWhere(['like', 'Particulars', $model->customer_name])
                   ->andFilterWhere(['in', 'created_by', $model->created_by_user])
                   ->andFilterWhere(['like', 'executive', $model->executive_name]);

             if($model->converted){
                $find=SaleOrderReport::find()->select('converted_to')->where(['converted_to'=>$model->converted])->column();
               $query->andFilterWhere(['in', 'converted_to', $find]);}  
                   
            if($model->sel_date){
                if($model->sel_date=='Today'){
                    
                $query->andFilterWhere(['like', 'Date', date('Y-m-d')]);
                }elseif($model->sel_date=='Current Week') {
                    $query->andFilterWhere(['>=', 'Date',date('Y-m-d',strtotime('last monday')) ]);
                }elseif($model->sel_date=='Current Month') {
                    $query->andFilterWhere(['>=', 'Date',date ('Y-m-d', strtotime ('first day of this month')) ]);
                }
                elseif($model->sel_date=='Current Year') {
                    $query->andFilterWhere(['>=', 'Date',date('Y-m-d',strtotime(date('Y-01-01')))]);
                }elseif($model->sel_date=='Custom'){

                    $query->andFilterWhere(['between', 'Date', $model->from_date,$model->to_date]);
                } 
            } 
            if($model->Sales_orderBy){

                if($model->Sales_orderBy=='Voucher # Asc'){
                 $query->orderBy(['CAST(vch_no as unsigned)' => SORT_ASC]);
                } elseif($model->Sales_orderBy=='Voucher # Dsc'){
                    $query->orderBy(['CAST(vch_no as unsigned)' => SORT_DESC]);
                }elseif($model->Sales_orderBy=='Date Asc'){
                    $query->orderBy(['Date' => SORT_ASC]);
                }elseif($model->Sales_orderBy=='Date Dsc'){
                    $query->orderBy(['Date' => SORT_DESC]);
                }
            }      
    	}
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            
        ]);
        //FOR DETAILED PDF
        if($print!=null)
        {
          $dataProvider->pagination = false;
          $for = "detailpdf";
          $this->actionExportpdf($dataProvider,$model,$for);
        }
        //FOR FOR DETAILED PRINT
       
        //FOR PRINT
        if($viewprint!=null)
        {
          $dataProvider->pagination = false;
          return $this->renderPartial('/sale-order-report/printpdf', [
              'dataProvider' => $dataProvider,
              'model' => $searchModel,
          ]);
        }
        //FOR EXCEL
        if($excel!=null)
        {
            $this->actionExcelSaleorderreport($model,$dataProvider);
        }
        return $this->render('index', [
            'model' => $model,  
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
     public function actionCustomerdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $customer=Customer::find()->limit(10)->all();
        else
        $customer=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

        $customerlist=ArrayHelper::map($customer, 'business_name', 'business_name');
        return json_encode($customerlist);
    }
    public function actionExportpdf($data=null,$model=null,$for=null,$id=null)
    {
	// ini_set("pcre.backtrack_limit", "5000000");
         if($for=='detailpdf')
         {
            $data->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/sale-order-report/printpdf', [
                'dataProvider' => $data,
                'model'=>$model,

            ]));
            $mpdf->Output('saleorderreport.pdf', 'I');
         } 
         else if ($for=='viewprint') {

            // $data->pagination = false;
            // $mpdf = new mPDF;
            // $mpdf->showImageErrors = true;
            // $mpdf->WriteHTML($this->renderPartial('/sale-order-report/printpdf', [
            //     'dataProvider' => $data,
            //     'model'=>$model,

            // ]));
            // $mpdf->Output('saleorderreport.pdf', 'I');
          } 
          else
          {
                $model = SaleOrder::find()->where(['id'=>$id])->one();
                $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                $count=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->count();
                // print_r($count);die();
                $find = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                
                $dataProvider = new ActiveDataProvider([
                    'query' => SaleOrder::find()->where(['id'=>$id])
                ]);
                $dataProvider->pagination = false;
                $mpdf = new mPDF;
                $mpdf->showImageErrors = true;
                $mpdf->WriteHTML($this->renderPartial('/sale-order-report/salereportpdf', [
                    'dataProvider' => $dataProvider,
                    'products' => $products,
                    'count' =>$count,
                    'model' => $model,           
                ]));
                $find=SaleOrder::findOne($id);
                $sale_order_id=$find->sale_order_id;
                $mpdf->Output($sale_order_id.'-SaleOrderReport.pdf', 'I');
          }
    }

    public function actionExcelSaleorderreport($mod=null,$dataProvider)
    { 
      $dataProvider->pagination = false; 
      $phpExcel = new \PHPExcel();
      $phpExcel->getProperties()->setDescription("Sales Order Detailed Report");
      $writer = \PHPExcel_IOFactory::createWriter($phpExcel, "Excel2007");
      $sheet = $phpExcel->getActiveSheet();

// Set the header row
$sheet->getRowDimension('A1')->setRowHeight(35);
$sheet->getCell('A1')->setValue('Sales Order Detailed Report');
$sheet->getStyle('A1')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

// Making headers text bold and larger
$sheet->getStyle('A1:K1')->getFont()->setBold(true)->setSize(12);

// Set date range if available
if ($mod != '') {
    if ($mod->from_date != null) {
        $sheet->setCellValue('A3', date('d-m-Y', strtotime($mod->from_date)) . ' to ' . date('d-m-Y', strtotime($mod->to_date)));
        $sheet->getStyle('A3')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
    }
} else {
    $sheet->setCellValue('A3', '');
}

// Set column widths
$columns = ['A' => 20, 'B' => 9, 'C' => 40, 'D' => 40, 'E' => 5, 'F' => 10, 'G' => 10, 'H' => 10, 'I' => 10, 'J' => 10, 'K' => 10, 'L' => 12];
foreach ($columns as $column => $width) {
    $sheet->getColumnDimension($column)->setWidth($width);
}

// Set header background color
$headerStyle = [
    'fill' => [
        'type' => \PHPExcel_Style_Fill::FILL_SOLID,
        'color' => ['rgb' => 'BBB9B8'],
    ],
];
$sheet->getStyle('A4:L4')->applyFromArray($headerStyle);

// Merge header cells
$sheet->mergeCells('A1:K1');
$sheet->mergeCells('A3:K3');

// Set header titles
$headers = ['Date', 'Particulars', 'VchNo.', 'po_details', 'ExpDate', 'daysleft', 'status', 'Completed', 'Amount'];
foreach ($headers as $index => $title) {
    $sheet->setCellValueByColumnAndRow($index, 4, $title);
}

// Populate data rows
$row = 5;
foreach ($dataProvider->models as $data) {
    $expDate = !empty($data->exp_date) ? $data->exp_date : '';
    $completed = is_numeric($data->completed) ? $data->completed . '%' : '';
    if(isset($data->days_left)){
      if($data->days_left>= 1 ){
      $daysLeft =  $data->days_left;
   }   else{
    $daysLeft = 0;
   }
  }else{
    $daysLeft = 0;
   }
 $sheet->setCellValueByColumnAndRow(0, $row, isset($data->Date) ? $data->Date : '');
    $sheet->setCellValueByColumnAndRow(1, $row, isset($data->Particulars) ? $data->Particulars : '');
    $sheet->setCellValueByColumnAndRow(2, $row, isset($data->sale_order_id_o) ? $data->sale_order_id_o : '');
    $sheet->setCellValueByColumnAndRow(3, $row, isset($data->po_details) ? $data->po_details : '');
    $sheet->setCellValueByColumnAndRow(4, $row, $expDate);
    $sheet->setCellValueByColumnAndRow(5, $row, (string)$daysLeft);
    $sheet->setCellValueByColumnAndRow(6, $row, isset($data->status) ? $data->status : '');
    $sheet->setCellValueByColumnAndRow(7, $row, $completed);
    $sheet->setCellValueByColumnAndRow(8, $row, isset($data->total_amount) ? $data->total_amount : 0);

    $row++;
}

// Save the Excel file
ob_clean();
ob_start();

 header('Content-type: application/vnd.ms-excel'); // It will be called file.xls  
 header('Content-Disposition: attachment; filename="saleorderreport.xls"'); // Write file to the browser 

$writer->save('php://output');
ob_flush();
exit();

    
    }

}
