<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "hsn_view".
 *
 * @property string|null $hsn
 * @property string|null $description
 * @property string $product_id
 * @property string $quantity
 * @property float|null $price
 * @property float|null $amount
 * @property string $tax
 * @property float|null $igst
 * @property float|null $sgst
 * @property float|null $cgst
 */
class HsnView extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'hsn_view';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['hsn', 'description','uqc'], 'string'],
            [['product_id', 'quantity', 'tax'], 'required'],
            [['price', 'amount', 'igst', 'sgst', 'cgst'], 'number'],
            [['product_id', 'tax'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'hsn' => 'Hsn',
            'description' => 'Description',
            'product_id' => 'Product ID',
            'quantity' => 'Quantity',
            'price' => 'Price',
            'amount' => 'Amount',
            'tax' => 'Tax',
            'igst' => 'Igst',
            'sgst' => 'Sgst',
            'cgst' => 'Cgst',
        ];
    }
}
