<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "inventory_closing_stock".
 *
 * @property string|null $product_id
 * @property string $product_name
 * @property int|null $stock_unit
 * @property float|null $inward
 * @property float|null $outward
 * @property float|null $value
 */
class InventoryClosingStock extends \yii\db\ActiveRecord
{
    public $prod_name;
    public $from_date;
    public $to_date;
    public $bar_code;
    public $status;

    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'inventory_closing_stock';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['product_name'], 'required'],
            [['stock_unit'], 'integer'],
            [['from_date','to_date'], 'safe'],
            [['inward', 'outward', 'value','status'], 'number'],
            [['product_id','prod_id'], 'string', 'max' => 254],
            [['product_name','prod_name','bar_code'], 'string', 'max' => 512],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'product_id' => 'Product ID',
            'product_name' => 'Product Name',
            'stock_unit' => 'Stock Unit',
            'inward' => 'Inward',
            'outward' => 'Outward',
            'value' => 'Value',
        ];
    }
}
