<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "leads_report".
 *
 * @property string|null $enquiry_no
 * @property string|null $lead_date
 * @property string|null $name
 * @property string|null $product_model
 * @property string|null $remark
 * @property string|null $assigned
 * @property string|null $email
 * @property string|null $city
 * @property string|null $postponed_date
 * @property int|null $age
 * @property string|null $status
 */
class LeadsReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'leads_report';
    }

    public $date_range;
    public $enq_no;
    public $lead_type;
    public $user;
    public $st;
    public $ct;
    public $exe;
    public $lead_status;
    public $from_date;
    public $to_date;
    public $search;
   public $product;
   public $bus_type;
   

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['lead_date', 'postponed_date'], 'safe'],
            [['remark'], 'string'],
            [['age'], 'integer'],
            [['enquiry_no', 'name', 'product_model', 'assigned', 'email', 'city', 'status','business_type','executive'], 'string', 'max' => 255],
            [['search','enq_no','bus_type','lead_type','st','ct','exe','lead_status','from_date','to_date','product'],'string', 'max' => 255],
            ['to_date', 'compare', 'compareAttribute' => 'from_date', 'operator' => '>=','message'=>'To date must be equal/greater than From date'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'enquiry_no' => 'Enquiry No',
            'lead_date' => 'Lead Date',
            'name' => 'Name',
            'product_model' => 'Product Model',
            'remark' => 'Remark',
            'assigned' => 'Assigned',
            'email' => 'Email',
            'city' => 'City',
            'postponed_date' => 'Postponed Date',
            'age' => 'Age',
            'status' => 'Status',
        ];
    }
}
