<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "purchase_outstanding_expense".
 *
 * @property int $id
 * @property string|null $vendor_category
 * @property string|null $date
 * @property float|null $amount
 * @property int|null $bill_id
 * @property float|null $paid_amount
 * @property string|null $due_date
 */
class PurchaseOutstandingExpense extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $from_date;
    public $to_date;
    public $vendor;
    public $due_days;
    public $setting;
    public $sort;



    public $is_vendor;
    public $vendor_mobile;
    public $bill_date;
    public $bill_referance;
    public $bill_amount;
    public $bill_paid_amount;
    public $bill_unpaid_amount;
    public $bill_bue_date;
    public $bill_days;
    public $bill_notes;
    public $bill_terms;
    public $bill_current_outstanding;
    public $bill_over_due;
    public $bill_total_outstanding;



    public static function tableName()
    {
        return 'purchase_outstanding_expense';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'bill_id','vendor_mobile','is_vendor','bill_date','bill_referance','bill_amount','bill_paid_amount','bill_unpaid_amount','bill_bue_date','bill_days','bill_notes','bill_terms','bill_current_outstanding','bill_over_due','bill_total_outstanding'], 'integer'],
            [['date', 'due_date','from_date','to_date','total','pending_amount','vendor_bill_no','terms','notes'], 'safe'],
            [['amount', 'paid_amount'], 'number'],
            [['vendor_category','setting','vendor','sort','due_days'], 'string', 'max' => 254],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'vendor_category' => 'Vendor Category',
            'date' => 'Date',
            'amount' => 'Amount',
            'bill_id' => 'Bill ID',
            'paid_amount' => 'Paid Amount',
            'due_date' => 'Due Date',
        ];
    }
}
