<?php

namespace backend\modules\reports\models;

use Yii;

/**
 * This is the model class for table "sale_order_report".
 *
 * @property int|null $sale_order_id
 * @property string|null $Date
 * @property string|null $Particulars
 * @property string|null $vch_no
 * @property string|null $po_details
 * @property string|null $exp_date
 * @property int|null $days_left
 * @property string $status
 * @property int $completed
 * @property float|null $amount
 */
class SaleOrderReport extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public $converted;
    public $customer_name;
    public $executive_name;
    public $type_of_customer;
    public $sel_date;
    public $Sales_orderBy;
    public $from_date;
    public $to_date;
    public $amt;
    public $created_by_user;
    public static function tableName()
    {
        return 'sale_order_report';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['sale_order_id', 'days_left', 'completed'], 'integer'],
            [['Date','sel_date','from_date','to_date','total_amount'], 'safe'],
            [['Particulars'], 'string'],
            [['amount','amt'], 'number'],
            [['vch_no', 'exp_date'], 'string', 'max' => 32],
            [['po_details','converted_to','executive','customer_type','Sales_orderBy','executive_name','customer_name','type_of_customer','converted','created_by_user','created_by'], 'string', 'max' => 512],
            [['status'], 'string', 'max' => 16],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'sale_order_id' => 'Sale Order ID',
            'Date' => 'Date',
            'Particulars' => 'Particulars',
            'vch_no' => 'Vch No',
            'po_details' => 'Po Details',
            'exp_date' => 'Exp Date',
            'days_left' => 'Days Left',
            'status' => 'Status',
            'completed' => 'Completed',
            'amount' => 'Amount',
        ];
    }
}
