<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use common\models\User;
use backend\modules\master\models\Product;
use backend\modules\master\models\CallStatus;
use backend\modules\master\models\BusinessType;
use backend\modules\master\models\LeadExecutive;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\GroupName;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\modules\master\models\AccountingLedger;

// $id = Yii::$app->user->identity->id;
// $assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\master\models\LeadsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'General Ledger Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.text-wrap{
white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
white-space: -pre-wrap;      /* Opera 4-6 */
white-space: -o-pre-wrap;    /* Opera 7 */
white-space: pre-wrap;       /* css-3 */
word-wrap: break-word;       /* Internet Explorer 5.5+ */
white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
word-break: break-all;
white-space: normal;
}
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
@media print {
        .dj-adv-search-row,.summary,.pagination{
            display: none !important;
        }

        .dj-print-sec {
            display: none !important;
        }

        .widget-content-wrapper {
            display: none !important;
        }

        .table-responsive {
            overflow: hidden;
        }

        .app-header__menu {
            display: none !important;
        }

        .print_header {
            display: block;
            color: black;
            font-size: 15px;
        }

        .table {
            border: 2px solid #000;
        }

        .table td {
            border: 2px solid #000 !important;
        }

        .table th {
            border: 2px solid #000 !important;
        }

    }
</style>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                <div class="card">
                    <div class="no-gutters row">
                        <div class="col-md-12 col-lg-12">
                            <ul class="list-group list-group-flush">
                                <li class="bg-transparent list-group-item">
                                    <div class="widget-content p-0">
                                        <div class="widget-content-outer">
                                            <div class="widget-content-wrapper">
                                                <div class="widget-content-left">
                                                    <div class="widget-numbers dj-text-success"><?php echo $ledger_name ?> Transaction Details</div>
                                                </div>
                                                <div class="widget-content-right">
                                                <a href="<?= Url::current() ?>&excel=true" data-method="post"> <button class="btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                                <a href="<?= Url::base(); ?>/reports/general-ledger-report/index"><button class="btn-icon btn  btn-success"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</button></a>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </li>
                                
                            </ul>
                        </div>
                        
                    </div>
                </div>
            </div>
          
           
        <?= GridView::widget([
            'dataProvider' => $dataProvider,
            // 'filterModel' => $searchModel,
            'columns' => [
            //    ['class' => 'yii\grid\CheckboxColumn'],
                

                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Date',
                    'attribute'=>'dated',
                    'value'=> function($data){
                        return $data->dated;
                    }
                ],

                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Ledger Name',
                    'attribute'=>'customer',
                   'value'=> function($data) use($ledger_type){
                    if(isset($data->customer))
                    {
                        if($ledger_type==2)
                        {
                            $cust = Customer::find()->where(['id'=>$data->customer])->one();
                            $ledger = AccountingLedger::find()->where(['ledger_id'=>$cust->business_name])->one();
                            return $ledger->ledger_id;
                        }
                        else{
                            return $data->customer;
                        }   
                        
                    }
                    else{
                        $cust = Vendor::find()->where(['id'=>$data->vendor])->one();
                        $ledger = AccountingLedger::find()->where(['ledger_id'=>$cust->business_name])->one();
                        return $ledger->ledger_id;
                    }
                       
                   }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Vch No',
                    'attribute'=>'vch_no',
                   'value'=> function($data){
                       return $data->vch_no;
                   }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057'],
                    'header'=> 'Vch Type',
                    'attribute'=>'vch_type',
                   'value'=> function($data){
                       return $data->vch_type;
                   }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057','class' => 'text-wrap'],
                    'header'=> 'Notes',
                    'attribute'=>'notes',
                   'value'=> function($data){
                       return $data->notes;
                   }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057','width:70px'],
		    'contentOptions'=>[ 'style'=>'text-align:right'],
                    'header'=> 'Debit(Rs.)',
                    'attribute'=>'debit_amount',
                   'value'=> function($data){
		      return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($data->debit_amount), 2, '.', '')));
                      //return $data->debit_amount;
                   }

                ],
                [
                    'headerOptions' => ['style' => 'color:#495057','width:70px'],
		    'contentOptions'=>[ 'style'=>'text-align:right'],
                    'header'=> 'Credit(Rs.)',
                    'attribute'=>'credit_amount',
                   'value'=> function($data){
			return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($data->credit_amount), 2, '.', '')));
                       //return $data->credit_amount;
                   }

                ],
            ],
        ]); ?>
            </div>
        </div>
    </div>
    <?php ob_start();?>
 <script type="text/javascript">



$(function() {

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
