<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use common\models\User;


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Inventory Product Report';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    .text-wrap{
        white-space: -moz-pre-wrap !important;  /* Mozilla, since 1999 */
        white-space: -pre-wrap;      /* Opera 4-6 */
        white-space: -o-pre-wrap;    /* Opera 7 */
        white-space: pre-wrap;       /* css-3 */
        word-wrap: break-word;       /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap; /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }
    .select2-container .select2-selection--single {
        height: 42px !important;
    }
    .select2-container--default .select2-selection--single .select2-selection__rendered
    {
        line-height: 39px;
    }
    .select2-container--default .select2-selection--single .select2-selection__arrow
    {
        height: 39px;
    }
    .add_product .select2-selection__rendered {
        width: 220px !important;
    }
    th a{
        color:#495057;
    }
    th a:hover{
        color:#495057;
    }
    body{
        font-family:Arial, Helvetica, sans-serif;
        font-size:13px;
    }
    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }
    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }
    .YourCustomTableClass table thead {
        background-color: #16aaff;
    }
</style>
<?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
    <div class="alert alert-danger alert-dismissable" style="text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
        <?= Yii::$app->session->getFlash('error') ?>
    </div>
<?php endif; ?>

<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Inventory Product Report</div>
                                        </div>
                                        <div class="widget-content-right">

                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-11">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-1">
                    <a  class="search_field_buttons"  href="<?=Url::base().'/reports/inventory-closing-stock/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                </div>
            </div>
            <div class="dj-sale-form collapse" id="search-report">
                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                <form>
                   <div class="form-row">

                       <div class="col-md-4">
                       <div class="position-relative form-group">
                                <label for="notes">Product</label>
                           <?php if($model->prod_name != ''){?>
                               <?php $product =Product::find()->where(['id'=>$model->prod_name])->one(); ?>
                               <?= $form->field($model, 'prod_name')->dropDownList([$model->prod_name=>$product->product_name],['prompt'=>'--Select--' , 'class'=>' findproduct select form-control'])->label(false) ?>
                           <?php }else {?>
                               <?=$form->field($model, 'prod_name')->dropDownList([], ['prompt' => '--Select--', 'class' => "findproduct form-control", 'maxlength' => true])->label(false)?>
                           <?php } ?>
                       </div>
                       </div>
                       <div class="col-md-4">
                           <div class="position-relative form-group">
                               <label for="notes">Barcode</label>
                               <?=$form->field($model, 'bar_code')->textInput(['prompt' => '--Select--', 'class' => "form-control", 'maxlength' => true])->label(false)?>
                           </div>
                       </div>
                       <div class="col-md-4">
                           <div class="position-relative form-group">
                               <label for="notes">Stock Availibility</label>
                                   <?=$form->field($model, 'status')->dropDownList([2=>'All',1=>'Available',3=>'No stock'], ['prompt' => '--Select--', 'class' => "form-control", 'maxlength' => true])->label(false)?>
                           </div>
                       </div>
                   </div>
                    <div class="col-md-12 dj-btn-align djsec-text-right">
                        <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                    </div>

                </form>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">

            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'showFooter' => true,
                'footerRowOptions'=>['style'=>'font-weight:bold;'],
                'options' => [
                    'class' => 'YourCustomTableClass',
                ],
                "id" => "grid",
                'columns' => [
                        [
                                'label'=>'List Of Product Name',
                                'value'=> function($data) {
                                    return $data->product_name;
                                }
                        ],
                    [
                         'label'=> 'Monthly Summary',
                        'format'=>'raw',
                        'value' => function($data){
                            return Html::a(Html::encode('Monthly Summary'), Url::base().'/reports/inventory-closing-stock/monthly-summary?prod_id=' .$data->product_id);
                        }
                    ],
                    [
                        'label'=> 'Stock Query',
                        'format'=>'raw',
                        'value' => function($data){
                            return Html::a(Html::encode('Stock Query'), Url::base().'/reports/inventory-closing-stock/stock-query?prod_id=' .$data->product_id);

                        }
                    ]


                ],
            ]); ?>
        </div>
    </div>
</div>



<?php ob_start();?>
<script type="text/javascript">
    $(function() {
        $('#advance-search').click(function(){
            $('#search-report').toggle();
        });

        $('.findproduct').select2({
            ajax: {
                url: "productdetails",
                type: "get",
                dataType: 'json',
                delay: 250,
                data: function (params) {
                    return {
                        searchTerm: params.term // search term
                    };
                },
                processResults: function (response) {

                    return {
                        results: $.map(response, function (i,item) {

                            return {
                                text: i,
                                slug: "",
                                id: item
                            }
                        })
                    };
                },
                cache: true
            }
        });



    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
