<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Monthly Summary';
$this->params['breadcrumbs'][] = $this->title;

$total_inward = 0;
$total_outward =0;
$stock_unit = 0;
if(!empty($dataProvider->getModels())){
    foreach($dataProvider->getModels() as $key=>$val){
        $total_inward += $val['inward'];
        $total_outward += $val['outward'];
        $stock_unit = $val['stock_unit'];
    }
}
$opening_stock = ($stock_unit+$total_outward)-$total_inward;

?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Product: <?=$product_name;?></div>
                                        </div>
                                        <div class="widget-content-right">
                                            <div class="widget-numbers dj-text-success"><a  class="search_field_buttons"  href="<?=Url::base().'/reports/inventory-closing-stock/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-arrow-left fa-fw" aria-hidden="true"></i>Back</a></div>
                                        </div>
                                        <div class="widget-content-right">

                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-1">
                </div>
            </div>
<table class="table table-striped">
    <thead>
    <tr>
        <th colspan="4"><p><h5 style="text-align: center"><b>Monthly Summary</b></h5>
            <h5 style="text-align: center"><b>For period for: <?=getDate(strtotime($from_date))['month'].'-'.getDate(strtotime($from_date))['year'].' to '.getDate(strtotime($to_date))['month'].'-'.getDate(strtotime($to_date))['year'];?></b></h5>
        </p>
        </th>
    </tr>

    <tr>
        <th colspan="2">Opening Balance</th>
        <th></th>
        <th scope="col"><?= $opening_stock.' Nos'; ?></th>
    </tr>
    <tr>
        <th scope="col">Particular</th>
        <th scope="col">Inward qty.</th>
        <th scope="col">Outward qty.</th>
        <th scope="col">Closing Balance</th>
    </tr>
    </thead>
    <tbody>
    <?php
    $closing = 0;
    foreach($dataProvider->getModels() as $key=>$val){
    ?>
    <tr>
        <td><?= getDate(strtotime($val['created_month_year']))['month'].'-'.$val['created_year'];?></td>
        <td><?= $val['inward'].' Nos';?></td>
        <td><?= $val['outward']. ' Nos'; ?></td>
        <td><?php
            $closing = ($opening_stock+$val['inward'])-$val['outward'];
            $opening_stock = $closing;
            echo $closing.' Nos';

            ?></td>
    </tr>
<?php } ?>
    <tr>
        <td colspan="3"><p style="text-align: center"><b>Current Closing Balance:</b></p></td>
        <td colspan="1"> <p><b><?= $closing.' Nos';?></b></p></td>
    </tr>
    </tbody>
</table>
    </div>
</div>