<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use common\models\User;
use yii\helpers\ArrayHelper;
use backend\modules\reports\models\PurchasePendingReport;

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Pending Report';
$this->params['breadcrumbs'][] = $this->title;
$vendors=ArrayHelper::map(Vendor::find()->all(),'id','business_name');
?>
<style>
    .text-wrap {
        white-space: -moz-pre-wrap !important;
        /* Mozilla, since 1999 */
        white-space: -pre-wrap;
        /* Opera 4-6 */
        white-space: -o-pre-wrap;
        /* Opera 7 */
        white-space: pre-wrap;
        /* css-3 */
        word-wrap: break-word;
        /* Internet Explorer 5.5+ */
        white-space: -webkit-pre-wrap;
        /* Newer versions of Chrome/Safari*/
        word-break: break-all;
        white-space: normal;
    }

    .select2-container .select2-selection--single {
        height: 42px !important;
    }

    .select2-container--default .select2-selection--single .select2-selection__rendered {
        line-height: 39px;
    }

    .select2-container--default .select2-selection--single .select2-selection__arrow {
        height: 39px;
    }

    .add_product .select2-selection__rendered {
        width: 220px !important;
    }

    th a {
        color: #495057;
    }

    th a:hover {
        color: #495057;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }
</style>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Purchase Pending Report</div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <div class="row dj-adv-search-row">
                <div class="col-md-11">
                    <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                </div>
                <div class="col-md-1">
                    <a class="search_field_buttons" href="<?= Url::base() . '/reports/purchase-pending-report/index' ?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                </div>
            </div>
            <div class="dj-sale-form collapse" id="search-report">
                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                <form>
                    <div class="form-row">
                        <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="notes">Vendors</label>
                            <?= $form->field($model, 'vendor_name')->dropDownList($vendors,['prompt'=>'-Select Vendor-','class'=>'select_class form-control'])->label(false) ?>
                        </div>
                        </div>
                        <div class="col-md-4">
                            <div class="position-relative form-group">
                                <label for="notes">VCH NO</label>
                                <?= $form->field($model, 'purchase_orderBy') ->dropDownList(['Voucher # Asc'=>'Voucher # Asc','Voucher # Dsc'=>'Voucher # Dsc','Date Asc'=>'Date Asc','Date Dsc'=>'Date Dsc'],['prompt'=>'--Select--','class' => " select_class form-control",])->label(false)?>
                            </div>
                        </div>

                        <div class="col-md-3">
                            <div class="position-relative form-group">
                                <label for="notes">Date Range</label>

                                <?= $form->field($model, 'purchase_date')
                                    ->dropDownList([
                                        'Today' => 'Today',
                                        'Current Week' => 'Current Week',
                                        'Current Month' => 'Current Month',
                                        'Current Year' => 'Current Year',
                                        'Custom' => 'Custom',
                                    ], ['prompt' => '--Select--', 'class' => 'form-control purchase_date select_class'])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-3 from_date">
                            <div class="position-relative form-group">
                                <label for="notes">From</label>
                                <?= $form->field($model, 'from_date')->textInput(['type' => 'date', 'class' => "form-control from_date_val"])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-3 to_date">
                            <div class="position-relative form-group">
                                <label for="notes">To</label>
                                <?= $form->field($model, 'to_date')->textInput(['type' => 'date', 'class' => "form-control to_date_val"])->label(false) ?>
                            </div>
                        </div>
                        <div class="col-md-12 dj-btn-align djsec-text-right">
                            <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search', 'style' => "padding: 9px 21px"]) ?>
                        </div>
                </form>
                <?php ActiveForm::end(); ?>
            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                'showFooter' => true,
                'footerRowOptions' => ['style' => 'font-weight:bold;'],
                "id" => "grid",
                'columns' => [
                    [
                        'label' => 'Date',
                        'attribute' => 'Date',
                        'value' => function ($data) {
                            return $data->date;
                        }
                    ],
                    [
                        'label' => 'vendor name',
                        'attribute' => 'vendor_name',
                        'value' => function ($data) {
                            $models = Vendor::find()->where(['id'=>$data->particulars])->one();
                            return $models->business_name;
                        }
                    ],

                    [
                        'label' => 'Vch No',
                        'attribute' => 'id',
                        'value' => function ($data) {
                            return $data->id;
                        }
                    ],
                    [
                        'label' => 'Total Amount',
                        'attribute' => 'total_amount',
                        'value' => function ($data) {
                            return $data->total_amount;
                        }
                    ],

                    [
                        'label' => 'Pending Amount',
                        'attribute' => 'pending_amount',
                        'value' => function ($data) {
                            return $data->pending_amount;
                        }
                    ],
                    
                ],


            ]); ?>
        </div>
    </div>
</div>


<?php ob_start();?>
 <script type="text/javascript">
$(function() {
$('.select_class').select2();    
$('#search-report').hide();
$('.to_date').hide();
$('.from_date').hide();
if($('.purchase_date').val()=='Custom')
	{
		$('.to_date').show();
        $('.from_date').show();
	}
	else
	{
		$('.to_date').hide();
        $('.from_date').hide();
        $('.to_date_val').val('');
        $('.from_date_val').val('');
	}
$('.purchase_date').change(function()
{
	if($(this).val()=='Custom')
	{
		$('.to_date').show();
        $('.from_date').show();
	}
	else
	{
		$('.to_date').hide();
        $('.from_date').hide();
        $('.to_date_val').val(' ').trigger('change');
        $('.from_date_val').val(' ').trigger('change');
	}
})
$('#advance-search').click(function(){
    $('#search-report').toggle();
});
    // $('.customer').select2({
    //     ajax: { 
    //     url: "customerdetails",
    //     type: "get",
    //     dataType: 'json',
    //     delay: 250,
    //     data: function (params) {
    //         return {
    //         searchTerm: params.term // search term
    //         };
    //     },
    //     processResults: function (response) {
           
            
    //         $('#customersearch').trigger('change');
    //         return {
    //             results: $.map(response, function (i,item) {
                    
    //             return {
    //                 text: i,
    //                 slug: "",
    //                 id: item
    //             }
    //         })
    //     };
                
           
    //     },
    //     cache: true
    //     }
    // });
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
