<?php

use backend\modules\master\models\Vendor;
use backend\modules\master\models\AccountingLedger;

$model_address = Vendor::find()->where(['id' => $vendor->id])->one();
$ledger = AccountingLedger::find()->where(['ledger_id' => $model_address->business_name])->andWhere(['group_name_id' => 28])->one();

?>
<style>
    body {
        font-size: 13px;
        font-family: Arial, sans-serif;
    }

    table {
        border-collapse: collapse;
        width: 100%;
        border: 1px solid #dddddd;
        margin-bottom: 20px;
    }

    th, td {
        border: 1px solid #dddddd;
        text-align: center;
        padding: 8px;
    }

    th {
        background-color: #f2f2f2;
    }

    .header {
        text-align: center;
        padding-top: 30px;
        font-weight: bold;
    }

    .address {
        text-align: center;
        margin-bottom: 20px;
    }

    .total {
        font-weight: bold;
    }
</style>

<div class="header">
    <p>MOHAPATRA SCIENTIFIC PRIVATE LIMITED<br>F2G/30, INDRADHANU MARKETIRC VILLAGE,<br>BHUBANESWAR, Odisha.</p>
</div>

<div class="address">
    <p>FOR VENDOR-</p>
    <p><?= $model_address->business_name ?><br>
        <?= $model_address->adderss_line_1 ?>, <?= $model_address->adderss_line_2 ?>, <?= $model_address->adderss_line_3 ?>,<br>
        <?= $model_address->city ?>, <?= $model_address->state ?>, <?= $model_address->country ?>.
    </p>
</div>

<table>
    <thead>
        <tr>
            <th>Date</th>
            <th>REF. NO</th>
            <th>NOTES</th>
            <th>VCH TYPE</th>
            <th>DEBIT</th>
            <th>CREDIT</th>
            <th>BALANCE</th>
        </tr>
    </thead>
    <tbody>
        <?php
        $total_credit_amount = 0;
        $total_debit_amount = 0;
        foreach ($dataProvider->getModels() as $model) {
            $total_credit_amount += $model->credit_amount;
            $total_debit_amount += $model->debit_amount;
        ?>
            <tr>
                <td><?= $model->dated ?></td>
                <td><?= $model->vch_no ?></td>
                <td><?= $model->notes ?></td>
                <td><?= $model->vch_type ?></td>
                <td><?= $model->debit_amount ?></td>
                <td><?= $model->credit_amount ?></td>
                <td></td>
            </tr>
        <?php } ?>
        <tr class="total">
            <td colspan="3"></td>
            <td>Total:</td>
            <td><?= number_format((float)$total_debit_amount, 2, '.', ',') ?></td>
            <td><?= number_format((float)$total_credit_amount, 2, '.', ',') ?></td>
            <td>
                <?= number_format((float)abs($total_credit_amount - $total_debit_amount), 2, '.', ',') ?>
            </td>
        </tr>
    </tbody>
</table>
