<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use backend\modules\master\models\LeadExecutive;
use yii\helpers\url;
use yii\grid\GridView;

use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\SaleOrder;
use backend\modules\reports\models\SaleOrderReport;

/* @var $this yii\web\View */
/* @var $model backend\modules\users\models\LeadsQuotes */


\yii\web\YiiAsset::register($this);
?>
<style>
    body
  {
    font-size: 15px;
  }
table, th, td {
  border: 1px solid #CDCBCB;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
th
{
  background-color: #CDCBCB;
  border: none;
}
td
{
  border: 1px solid #CDCBCB;
}
</style>
<div class="app-main__inner">

     <h1 style="text-align:center; font-size: 15px">Sales Order Detail Report</h1>

     <p style="text-align:center">
      <?php
         if($model->from_date!='' && $model->to_date!='')
         {
           echo  date('d/m/Y', strtotime($model->from_date))." to ".date('d/m/Y', strtotime($model->to_date));
         }
         else
         {

         }
      ?>
    </p>


    <?= GridView::widget([
                                'dataProvider' => $dataProvider,
                                // 'filterModel' => $searchModel,
                                "id" => "grid",
                                'columns' => [
                                    
                                    'Date:date',
                                    'Particulars',
                                    [
                                        'label' => 'Vch No.',
                                        'headerOptions' => ['style' => 'width:10%'],
                                        'contentOptions' => ['style' => 'width:10%'],
                                        'value' => function ($data) { 
                                          return $data->sale_order_id_o;
                                    },
                                    ],
                                    'po_details',
                                    [
                                        'label'=>'Exp Date',
                                        'attribute'=>'exp_date',
                                        'value'=>function($data)
                                        {
                                            if($data->exp_date!='')
                                            {
                                                return $data->exp_date;
                                            }
                                        }
                                    ],
                                    'days_left',
                                    'status',
                                    
                                    [
                                        'label' => 'Completed',
                                        'headerOptions' => ['style' => 'width:10%'],
                                        'contentOptions' => ['style' => 'width:10%'],
                                        'attribute' => 'completed',
                                        'value' => function ($data) { 
                                          return $data->completed .'%';
                                    },
                                    ],
                                    [
                                        'label' => 'Amount',
                                        'headerOptions' => ['style' => 'width:10%'],
                                        'contentOptions' => ['style' => 'width:10%'],
                                        'value' => function ($data) { 

                                            // $models = SaleOrder::find()->where(['id'=>$data->sale_order_id])->one();
                                          return $data->total_amount;
                                    },
                                    ],
                                  ],
                                ]);
                       ?>
</div>
