<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use yii\helpers\Url;
use backend\modules\users\models\AccountingContra;
use backend\modules\users\models\AccountingDetails;
use backend\modules\master\models\AccountingLedger;
use backend\modules\master\models\LeadExecutive;
use backend\modules\reports\models\CustmorLedgerDetails;
use backend\modules\master\models\CustomerType;
use backend\modules\master\models\AccountType;
use backend\modules\master\models\Customer;
use backend\modules\master\models\GroupName;


/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\AccountingContraSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Sales Customer Ledger';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
    th a {
        color: #495057;
    }

    th a:hover {
        color: #495057;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .pagination li.active a {
        z-index: 1;
        color: #fff;
        background-color: #16aaff;
        border-color: #16aaff;
    }
</style>
<?php
$customer_items = ArrayHelper::map(Customer::find()->all(), 'business_name', 'business_name');
$executive_items = ArrayHelper::map(LeadExecutive::find()->all(), 'name', 'name');
$customertype_items = ArrayHelper::map(CustomerType::find()->all(), 'customer_type', 'customer_type');
$accounttype_items = ArrayHelper::map(AccountType::find()->all(), 'account_type_id', 'account_name');
$group_items = ArrayHelper::map(GroupName::find()->all(), 'group_name_id', 'name_group');



?>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success">Sales Customer Ledger</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                <a href="<?= Url::current() ?>&excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel</button></a>
                                            <?php } else { ?>
                                                <a href="<?= Url::current() ?>?excel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i> Excel</button></a>
                                            <?php } ?>
                                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                <a href="<?= Url::current() ?>&print=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Ledgers Pdf</button></a>
                                            <?php } else { ?>
                                                <a href="<?= Url::current() ?>?print=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Ledgers Pdf</button></a>
                                            <?php } ?>
                                            <?php if(1 == 2){ ?>
// (Yii::$app->request->getQueryParams()) { ?>
                                                <a href="<?= Url::current() ?>&detailexcel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i> Detailed Excel</button></a>
                                            <?php } ?>

 <?php if(1 == 2) { ?>
                                                <a href="<?= Url::current() ?>?detailexcel=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i> Detailed Excel</button></a>
                                            <?php } ?>

                                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                <a href="<?= Url::current() ?>&detailexcelall=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Customer Sales Excel </button></a>
                                            <?php } else { ?>
                                                <a href="<?= Url::current() ?>?detailexcelall=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Customer Sales Excel </button></a>
                                            <?php } ?>

                                            <?php if (Yii::$app->request->getQueryParams()) { ?>
                                                <a href="<?= Url::current() ?>&detailpdfall=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Customer Sales Print </button></a>
                                            <?php } else { ?>
                                                <a href="<?= Url::current() ?>?detailpdfall=true" data-method="post" target="_blank"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-pdf-o" aria-hidden="true"></i> Customer Sales Print </button></a>
                                            <?php } ?>
                                            
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>

            </div>

        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?php $form = ActiveForm::begin(['action' => ['index'], 'method' => 'get'], ['options' => ['class' => "dj-sale-form collapse"]]); ?>
            <div class="row dj-adv-search-row">
                <div class="col-md-5">
                    <div class="position-relative form-group">
                        <?= $form->field($searchModel, 'business_name')->textInput(['maxlength' => true, 'class' => "form-control", 'placeholder' => "Ledger Name"])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-2">
                    <button class="btn btn-rounded search_field_buttons"><i class="fa fa-search"></i> Search</button>

                </div>
                <?php ActiveForm::end(); ?>
                <div class="col-md-4">
                    <a id='advance-search' class="btn btn-rounded search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>

                    <a style="margin-left: 49px" class="vendorrefresh search_field_buttons" href="<?= Url::base() ?>/reports/sales-customer-ledger/index" role="button"><i class="fa fa-refresh" aria-hidden="true"></i></a>

                </div>

            </div>
            <?php $form = ActiveForm::begin(['action' => ['index'], 'method' => 'get'], ['options' => ['class' => "dj-sale-form collapse"]]); ?>

            <div class="form-row">
		<div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">Customer Name</label>
                        <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                        <?= $form->field($searchModel, 'bs_name')->dropDownList($customer_items, ['prompt' => '-Select Customer-', 'class' => 'select form-control select_class'])->label(false) ?>
                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">From</label>
                        <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                        <?= $form->field($searchModel, 'from_date')->textInput(['maxlength' => true, 'class' => "form-control", 'type' => 'date'])->label(false) ?>

                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">To</label>
                        <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                        <?= $form->field($searchModel, 'to_date')->textInput(['maxlength' => true, 'class' => "form-control", 'type' => 'date'])->label(false) ?>

                    </div>
                </div>

                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">Executive</label>
                        <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                        <?= $form->field($searchModel, 'executive')->dropDownList($executive_items, ['prompt' => '-Select Executive-', 'class' => 'select form-control select_class'])->label(false) ?>

                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">Customer Type</label>
                        <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                        <?= $form->field($searchModel, 'customer_type')->dropDownList($customertype_items, ['prompt' => '-Select Customer Type-', 'class' => 'select form-control select_class'])->label(false) ?>

                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">Sort By</label>
                        <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                        <?= $form->field($searchModel, 'order_by')->dropDownList(['acidasc' => '#Acc ID Asc', 'aciddsc' => ' #Acc ID Dsc'], ['prompt' => '--Select--', 'class' => " select form-control select_class",])->label(false) ?>

                    </div>
                </div>
                <div class="col-md-4">
                    <div class="position-relative form-group">
                        <label for="notes">Ledger Balance</label>
                        <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                        <?= $form->field($searchModel, 'ledger_balance')->dropDownList(['zero' => 'Zero Balance', 'nonzero' => 'Non Zero Balance'], ['prompt' => '--Select--', 'class' => " select form-control select_class",])->label(false) ?>

                    </div>
                </div>
                <div class="col-md-2 dj-btn-align">
                    <button class="btn btn-info btn-rounded dj-search"><i class="fa fa-search"></i> Search</button>
                </div>
            </div>
            <?php ActiveForm::end(); ?>

        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?= GridView::widget([
                'dataProvider' => $dataProvider,
                // 'filterModel' => $searchModel,
                'showFooter' => true,
                'footerRowOptions' => ['style' => 'font-weight:bold;'],
                'columns' => [
                    ['class' => 'yii\grid\SerialColumn'],
                    // ['class' => 'yii\grid\CheckboxColumn'],
                    // 'ledgerhead_id',
                    [
                        'label' => 'Ledger Name',
                        'format' => 'raw',
                        'attribute' => 'ledgerhead_id',
                        'value' => function ($data) use($searchModel) {

                            $customer = Customer::find()->where(['business_name' => $data->business_name])->one();
                            if ($customer)
			    {
				if($searchModel->from_date != '' && $searchModel->to_date !='')
                                {
                                    $customer_details = '<a class="nav-link" href=' . Url::base() . '/reports/sales-customer-ledger/customerdetails?id=' . "$customer->id" . '&from=' . "$searchModel->from_date" . '&to=' . "$searchModel->to_date" . ' data-method=post>' . $data->business_name . ' </a>';
                                }
                                else{
                                    $customer_details = '<a class="nav-link" href=' . Url::base() . '/reports/sales-customer-ledger/customerdetails?id=' . "$customer->id" . ' data-method=post>' . $data->business_name . ' </a>';
                                }
			    }
                               // $customer_details = '<a class="nav-link" href=' . Url::base() . '/reports/sales-customer-ledger/customerdetails?id=' . "$customer->id" . ' data-method=post>' . $data->business_name . ' </a>';
                            //  $vendor_details = $data->ledgerhead_id;
                            else
                                $customer_details = $data->ledgerhead_id;
                            return $customer_details;
                        },
                    ],
                    // 'total_debit_amount',
                    [
                        'contentOptions' => ['style' => 'text-align:right'],
                        'label' => 'Debit (Rs)',
                        'attribute' => 'total_debit_amount',
                        'value' => function ($data) use ($searchModel) {
                            if ($searchModel['from_date'] != '' && $searchModel['to_date'] != '') {
                                $customer = Customer::find()->where(['business_name' => $data->business_name])->one();
                                $debit = CustmorLedgerDetails::find()->andFilterWhere(['in', 'customer', $customer->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                $credit = CustmorLedgerDetails::find()->andFilterWhere(['in', 'customer', $customer->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                $debit_amount = 0;
                                $credit_amount = 0;
                                foreach ($debit as $key => $value) {
                                    $debit_amount = $debit_amount + $value->debit_amount;
                                }
                                foreach ($credit as $key => $value) {
                                    $credit_amount = $credit_amount + $value->credit_amount;
                                }
                                // return $debit_amount-$credit_amount;
                                if (($debit_amount - $credit_amount) > 0) {
                                    return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($debit_amount - $credit_amount), 2, '.', '')));
                                } else {
                                    return '0.00';
                                }
                            } else {
                                if (($data->total_debit_amount - $data->total_credit_amount) > 0) {
                                    return preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($data->total_debit_amount - $data->total_credit_amount), 2, '.', '')));
                                } else {
                                    return '0.00';
                                }
                            }
                        },
                    ],
                    [
                        'contentOptions' => ['style' => 'text-align:right'],
                        'label' => 'Credit (Rs)',
                        'attribute' => 'total_credit_amount',
                        'value' => function ($data) use ($searchModel) {


                            if ($searchModel['from_date'] != '' && $searchModel['to_date'] != '') {
                                $customer = Customer::find()->where(['business_name' => $data->business_name])->one();
                                $debit = CustmorLedgerDetails::find()->andFilterWhere(['in', 'customer', $customer->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                $credit = CustmorLedgerDetails::find()->andFilterWhere(['in', 'customer', $customer->id])->andFilterWhere(['>=', 'date(dated)', $searchModel['from_date']])->andFilterWhere(['<=', 'date(dated)', $searchModel['to_date']])->all();
                                $debit_amount = 0;
                                $credit_amount = 0;
                                foreach ($debit as $key => $value) {
                                    $debit_amount = $debit_amount + $value->debit_amount;
                                }
                                foreach ($credit as $key => $value) {
                                    $credit_amount = $credit_amount + $value->credit_amount;
                                }
                                if (($credit_amount - $debit_amount) > 0) {
                                    $a_amt = $credit_amount - $debit_amount;
                                    if ($a_amt < 0)
                                        $a_amt = -1 * ($a_amt);

                                    $ac_amount =  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($a_amt), 2, '.', '')));
                                    if ($ac_amount > 0)
                                        return $ac_amount;
                                    else
                                        return ($ac_amount);
                                } else {
                                    return '0.00';
                                }
                            } else {
                                if (($data->total_credit_amount - $data->total_debit_amount) > 0) {
                                    $a_amt = $data->total_debit_amount - $data->total_credit_amount;
                                    if ($a_amt < 0)
                                        $a_amt = -1 * ($a_amt);
                                    $ac_amount =  preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", (number_format((float)($a_amt), 2, '.', '')));
                                    if ($ac_amount > 0)
                                        return $ac_amount;
                                    else
                                        return ($ac_amount);
                                } else {
                                    return '0.00';
                                }
                            }
                        },


                    ],
                    // 'total_credit_amount'

                ],

            ]); ?>
        </div>
    </div>
</div>
<?php ob_start(); ?>
<script type="text/javascript">
    $(function() {
        $('#w1').hide();
        $('#advance-search').click(function() {
            $('#w1').toggle();
        });
        $('.select_class').select2();
        // $('.print').on('click',function() {


        // 		w=window.open("http://localhost/mohapatra-scientific/backend/modules/reports/views/sales-customer-ledger/exportpdf.php","","width=800,height=800,resizable=yes,scrollbars=yes");
        //         // w.print(); w.close();
        // });
    });
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>
