<?php

namespace backend\modules\users\controllers;

use Yii;
use backend\modules\users\models\AccountingContra;
use backend\modules\users\models\AccountingContraSearch;
use backend\modules\master\models\AccountingLedger;
use yii\web\Controller;
use backend\modules\users\models\AccountingDetails;
use yii\data\ActiveDataProvider;
use yii2tech\spreadsheet\Spreadsheet;
use Mpdf\Mpdf;
use yii\helpers\ArrayHelper;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * AccountingContraController implements the CRUD actions for AccountingContra model.
 */
class AccountingContraController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all AccountingContra models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new AccountingContraSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        $query = AccountingContra::find();
        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            'sort'=> ['defaultOrder' => ['contra_id' => SORT_DESC]]
        ]);

        if ($searchModel->load(Yii::$app->request->post()) ) {
            $operator1= $searchModel->op1;
            $operator2= $searchModel->op2;
            $query->andFilterWhere(['like', 'contra_type', $searchModel->contra_type])
            ->andFilterWhere(['like', 'voucher_no', $searchModel->voucher_no])
            ->andFilterWhere(['like', 'prefix', $searchModel->prefix])
            ->andFilterWhere(['like', 'suffix', $searchModel->suffix])
            ->andFilterWhere(['like', 'notes', $searchModel->notes])
            ->andFilterWhere(['like', 'user', $searchModel->user])
            ->andFilterWhere(['like', 'contra_no', $searchModel->contra_no])
            ->andFilterWhere(['between', 'date', $searchModel->from_date,$searchModel->to_date])
            ->orFilterWhere(['like', 'source_bank', $searchModel->bank])
            ->orFilterWhere(['like', 'destination_bank', $searchModel->bank]);

           
            $greater= '<'; $greaterthanequal= '<='; $equal='=';$lesser='>';$lesserthanequal='>=';
        if(($searchModel->op1!=null) && ($searchModel->with1!=null) &&  ($searchModel->with2==null))
        {
            if($operator1===$equal){
                $query->andFilterWhere(['=', 'amount', $searchModel->with1]);
            }
            elseif ($operator1===$lesserthanequal) {
                $query->andFilterWhere(['<=', 'amount', $searchModel->with1]);

            }
            elseif ($operator1===$lesser) {
                $query->andFilterWhere(['<', 'amount', $searchModel->with1]);

            }
            elseif ($operator1===$greater) {
                $query->andFilterWhere(['>', 'amount', $searchModel->with1]);

            }
            elseif ($operator1===$greaterthanequal) {
                $query->andFilterWhere(['>=', 'amount', $searchModel->with1]);

            }
        }
        if(($searchModel->op1!=null) && ($searchModel->with1!=null) &&  ($searchModel->with2!=null) && ($searchModel->op2!=null))
        {  
            if($operator1===$lesser && $operator2===$greater){
                $query->andFilterWhere(['<', 'amount', $searchModel->with1])
                      ->andFilterWhere(['>', 'amount', $searchModel->with2]);
            }
            if($operator1===$lesser && $operator2===$greaterthanequal){
                $query->andFilterWhere(['<', 'amount', $searchModel->with1])
                      ->andFilterWhere(['>=', 'amount', $searchModel->with2]);
            }
            if($operator1===$greater && $operator2===$lesser){
                $query->andFilterWhere(['>', 'amount', $searchModel->with1])
                      ->andFilterWhere(['<', 'amount', $searchModel->with2]);
            }
            if($operator1===$greater && $operator2===$lesserthanequal){
                $query->andFilterWhere(['>', 'amount', $searchModel->with1])
                      ->andFilterWhere(['<=', 'amount', $searchModel->with2]);
            }
            if($operator1===$greaterthanequal && $operator2===$lesser){
                $query->andFilterWhere(['>=', 'amount', $searchModel->with1])
                      ->andFilterWhere(['<', 'amount', $searchModel->with2]);
            }
            if($operator1===$greaterthanequal && $operator2===$lesserthanequal){
                $query->andFilterWhere(['>=', 'amount', $searchModel->with1])
                      ->andFilterWhere(['<=', 'amount', $searchModel->with2]);
            }
            if($operator1===$lesserthanequal && $operator2===$greater){
                $query->andFilterWhere(['<=', 'amount', $searchModel->with1])
                      ->andFilterWhere(['>', 'amount', $searchModel->with2]);
            }
            if($operator1===$lesserthanequal && $operator2===$greaterthanequal){
                $query->andFilterWhere(['<=', 'amount', $searchModel->with1])
                      ->andFilterWhere(['>=', 'amount', $searchModel->with2]);
            }
            
        }
        
         
        }
        
        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    
}

    /**
     * Displays a single AccountingContra model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }
    public function actionGetBank()
    {
        $bank=AccountingLedger::find()->where(['account_type_id'=>2])->all();
        $banklist=ArrayHelper::map($bank, 'ledger_id', 'ledger_id');
        return json_encode($banklist);
    }

    /**
     * Creates a new AccountingContra model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new AccountingContra();
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            $model->contra_no = $model->prefix.''.$model->contra_no.'';
            $model->save();
            $ledger = new AccountingDetails();
            $amt = $model->amount;
            $source=$model->source_bank;
            $destination=$model->destination_bank;
            $tran_id=$model->contra_no;
            $tan_date = $model->date;
            $ledger->leadgerentrycontra($amt,$source,$destination,$tran_id,$tan_date);


            Yii::$app->getSession()->setFlash('success', 'Created Successfully');
            return $this->redirect(['index']);
        }
        return $this->render('create', [
            'model' => $model,
            'update'=>0,
            
        ]);
    }

    /**
     * Updates an existing AccountingContra model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            $model->contra_no = $model->prefix.''.$model->contra_no.'';
            $model->save();
            Yii::$app->getSession()->setFlash('success', 'Updated Successfully');
            return $this->redirect(['index']);
        }

        return $this->render('update', [
            'model' => $model,
            'update'=>1,
        ]);
    }
    // public function actionDeleteAccountingContra()
    // {
        
    // }
    // Yii::$app->getSession()->setFlash('success', 'Deleted Successfully');
    //     return $this->redirect(['index']);
    // }

    /**
     * Deletes an existing AccountingContra model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {     
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            if($ids){
            foreach($ids as $id){
            $this->findModel($id)->delete();
               }
            }
        }
        else
        {
            $this->findModel($id)->delete();     
        }
        Yii::$app->getSession()->setFlash('success', 'Deleted Successfully');
        return $this->redirect(['index']);
    }
    public function actionExcelExport($detail=null)
    {
        $dataProvider = new ActiveDataProvider([
            'query' => AccountingContra::find()->orderBy(['contra_id' => SORT_DESC]),
        ]);
        if($detail){
    $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            'amount',
            //'contra_id',
            //'contra_type',
            'date',
            [
                'label'=>'From',
               'attribute' => 'source_bank',
               'value' => function ($data) {
                $value=AccountingContra::find()->where(['contra_id'=>$data->contra_id])->one();
                return $value?$value->source_bank:'';
               }
            ],
            //'destination_bank',
            [
                'label'=>'To',
               'attribute' => 'destination_bank',
               'value' => function ($data) {
                $value=AccountingContra::find()->where(['contra_id'=>$data->contra_id])->one();
                return $value?$value->destination_bank:'';
               }
            ],
            'notes',
            'voucher_no',
            //'prefix',
            //'contra_no',
            //'suffix',
            'ceated_at',
            'update_at',

        ],
    ]);
        }else{
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    'amount',
            //'contra_id',
            //'contra_type',
            'date',
            [
                'label'=>'From',
               'attribute' => 'source_bank',
               'value' => function ($data) {
                $value=AccountingContra::find()->where(['contra_id'=>$data->contra_id])->one();
                return $value?$value->source_bank:'';
               }
            ],
            // 'destination_bank',
            [
                'label'=>'To',
               'attribute' => 'destination_bank',
               'value' => function ($data) {
                $value=AccountingContra::find()->where(['contra_id'=>$data->contra_id])->one();
                return $value?$value->destination_bank:'';
               }
            ],
            'notes',
            'voucher_no',
            //'prefix',
            //'contra_no',
            //'suffix',
            'ceated_at',
            'update_at',
                    
                ],
            ]);
        }
    if($detail)
    return $exporter->send('accounting_contra_details.xlsx');
    return $exporter->send('accounting_contra.xlsx');
    }
    public function actionContraTemplate($id=null,$from=null)
    {
       if($from=='all')
       {
            $dataProvider = new ActiveDataProvider([
            'query' => AccountingContra::find()->orderBy(['contra_id' => SORT_DESC]),
            ]);
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->WriteHTML($this->renderPartial('/accounting-contra/export-pdf', [
                'dataProvider' => $dataProvider,

            ]));
            $mpdf->Output('Accounting_contra.pdf', 'I'); 
       }
       else
       {
          $model = $this->findModel($id);
          $mpdf = new mPDF;
          $mpdf->showImageErrors = true;
          $mpdf->WriteHTML($this->renderPartial('/accounting-contra/contra-template', [
                'model' => $model,
            ]));
          $mpdf->Output('Accounting_contra.pdf', 'I');
       }     
    }
    public function actionContraTemplatePdf($id)
    {
        
      $model = $this->findModel($id);
      $mpdf = new mPDF;

      $mpdf->WriteHTML($this->renderPartial('/accounting-contra/contra-template-pdf', [
            'model' => $model,


        ]));

         $mpdf->Output('Contra-template.pdf', 'D');


    }

    /**
     * Finds the AccountingContra model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return AccountingContra the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = AccountingContra::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
