<?php

namespace backend\modules\users\controllers;

use Yii;
use backend\modules\users\models\Invoice;
use backend\modules\users\models\InvoiceSearch;
use backend\modules\users\models\SalesProduct;
use backend\modules\users\models\InvoiceDocument;
use backend\modules\users\models\InvoiceProduct;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\SaleOrder;
use backend\modules\master\models\Product;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\users\models\AccountingDetails;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use backend\modules\users\models\ProformaInvoice;
use backend\modules\users\models\ProformaInvoiceProduct;
use backend\modules\master\models\AccountingTax;
use backend\modules\users\models\DeliveredProductList;
use backend\modules\users\models\ProductDelivered;
use backend\modules\users\models\AdjustedInvoices;
use backend\modules\users\models\CreditNote;
use backend\modules\users\models\InovicesAdjustedAmounts;
use backend\modules\master\models\AccountingLedger;
use backend\modules\users\models\SaleorderAgainstDc;
use backend\modules\master\models\PurchaseOrderIndent;
use backend\modules\master\models\PurchaseOrderIndentProduct;
use backend\models\AuthAssignment;
use yii\web\Controller;
use yii\helpers\ArrayHelper;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;
use yii\data\ActiveDataProvider;
use yii2tech\spreadsheet\Spreadsheet;
use yii\web\UploadedFile;
use yii\helpers\Json;
use yii\helpers\Url;
use backend\models\UserClient;
use backend\modules\master\models\salesTemplates;
use backend\modules\master\models\GenericTemplate;

/**
 * InvoiceController implements the CRUD actions for Invoice model.
 */
class InvoiceController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    // 'delete' => ['POST'],
                ],
            ],
        ];
    }
    public static $banks_name = [
        "Punjab National Bank" => "Punjab National Bank",
        "Bank of India" => "Bank of India",
        "State Bank of India" => "State Bank of India"
    ];
    public static $country = [
        "India" => "India",
        "Others" => "Others",
    ];
    public static $state = [
        "Others" => "Others", "Odisha" => "Odisha"
    ];
    /**
     * Lists all Invoice models.
     * @return mixed
     */
    public function actionIndex($totalexcel=null,$excel=null,$print=null)
    {
        Yii::$app->view->params['active'] = 32;
        $model = new Invoice();
        $searchModel = new InvoiceSearch();
        $product = Product::find()->all();
        $allproduct = ArrayHelper::map($product, 'id', 'product_name');
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id' => $check_id])->one();
        if ($user_type->item_name == 'Admin') {
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        } else {
            $accessed = LeadExecutive::find()->where(['user_id' => $check_id])->one();
            if ($accessed != '') {
                $accessed_id[] = $accessed['type'];
            } else {
                $loged_user = AuthAssignment::find()->where(['user_id' => $check_id])->one();
                $accessed_id[] = $loged_user['item_name'];
            }

            $dataProvider = $searchModel->search(Yii::$app->request->queryParams, $accessed_id);
        }
        // $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        if ($model->load(Yii::$app->request->get())) {

            if ($user_type->item_name == 'Admin') {
                $query = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC]);
            } else {
                // print_r($check_id);die();
                $all = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC])->all();
                $exe_array = [];
                $i = 0;
                foreach ($all as $key => $val) {
                    $executivedetails = LeadExecutive::find()->where(['name' => $val['executive']])->one();
                    if ($executivedetails != '') {
                        if ($executivedetails->type == $accessed_id[0])
                            $exe_array[$i] = $executivedetails->name;
                        $i++;
                    }
                }
                $exe_array = array_unique($exe_array);

                $customers = UserClient::find()->where(['user_id' => $check_id])->andWhere(['client_type' => 'Customer'])->all();
                $customer_ids = [];
                $j = 0;
                foreach ($customers as $data) {
                    $customer_ids[$j] = $data->client_id;
                    $j++;
                }
                $query = Invoice::find()->where(['is_deleted' => 0])->andWhere(['in', 'customer_name', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
            }


            if ($model->findid != '') {
                if ($model->send_email != '') {
		     $model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                     $file=$model->email_attachment->baseName;
                     $model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                     $model->email_attachment=$file.'.'.$model->email_attachment->extension;
		if($model->email_attachment!='')
		{
		     //$model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                     //$file=$model->email_attachment->baseName;
                     //$model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                     //$model->email_attachment=$file.'.'.$model->email_attachment->extension;


                    $message = Yii::$app->mailer->compose()
                        ->setFrom([trim('mohasyn.bbsr@gmail.com') => "Mohapatra scientific"])
                        ->setTo(trim($model->send_email))
			//->setTo(trim('jyotipanda400@gmail.com'))
                        ->setSubject($model->email_subject)
                        ->setHtmlBody(nl2br($model->email_message))
			->attach(Yii::getAlias('@backend').'/web/email-assets/'.$model->email_attachment);
                    if (!empty($model->cc_to_email != "")) {
                        $message->setBcc(trim($model->bcc_to_email));
                    }
                    if (!empty($model->bcc_to_email != "")) {
                        $message->setBcc(trim($model->bcc_to_email));
                    }
                    Yii::$app->mailer->send($message);
		}	
		else
		{
			 $message = Yii::$app->mailer->compose()
                        ->setFrom([trim('mohasyn.bbsr@gmail.com') => "Mohapatra scientific"])
                        ->setTo(trim($model->send_email))
                        ->setSubject($model->email_subject)
                        ->setHtmlBody(nl2br($model->email_message));
                        if (!empty($model->cc_to_email != "")) {
                           $message->setBcc(trim($model->bcc_to_email));
                         }
                        if (!empty($model->bcc_to_email != "")) {
                           $message->setBcc(trim($model->bcc_to_email));
                         }
                         Yii::$app->mailer->send($message);

		}
		    if($model->email_attachment!='')
		    {
			unlink(Yii::$app->basePath . '/web/email-assets/' . $model->email_attachment);
		     }
                    Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                    return $this->redirect(['invoice/index']);
                } else {
                    Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                    return $this->redirect(['invoice/index']);
                }
            } else {
                $query->andFilterWhere(['in', 'invoice_no', $model->invoice_search])
                    ->andFilterWhere(['between', 'date', $model->from_date, $model->to_date])
                    ->andFilterWhere(['in', 'customer_name', $model->customer])
                    ->andFilterWhere(['like', 'settings_id', $model->setting])
                    ->andFilterWhere(['in', 'shipment_status', $model->shipment])
                    ->andFilterWhere(['in', 'executive', $model->executives_name])
                    ->andFilterWhere(['in', 'sales_type', $model->bill_type])
                    ->andFilterWhere(['in', 'sypply_type', $model->search_supply])
                    ->andFilterWhere(['in', 'po_number', $model->po_no])
                    ->andFilterWhere(['in', 'total_price', $model->total_amount])
                    ->andFilterWhere(['like', 'po_date', $model->po_searchdate]);
                if ($model->find_product) {
                    $productlists = InvoiceProduct::find()->where(['product_id' => $model->find_product, 'is_deleted' => 0])->groupBy(['invoice_id'])->all();
                    $productid = ArrayHelper::map($productlists, 'invoice_id', 'invoice_id');
                    $query->andFilterWhere(['in', 'id', $productid]);
                }
		if ($model->so_number) {
                    $sale_dt = SaleOrder::find()->where(['sale_order_id' => $model->so_number])->one();
                    $query->andFilterWhere(['=', 'sale_order_id', $sale_dt->id]);
                }
                $dataProvider = new ActiveDataProvider(['query' => $query, 'sort' => ['defaultOrder' => ['id' => SORT_DESC]],]);
            }
        }
	

	  if ($model->load(Yii::$app->request->post())) {

            if ($user_type->item_name == 'Admin') {
                $query = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC]);
            } else {
                // print_r($check_id);die();
                $all = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC])->all();
                $exe_array = [];
                $i = 0;
                foreach ($all as $key => $val) {
                    $executivedetails = LeadExecutive::find()->where(['name' => $val['executive']])->one();
                    if ($executivedetails != '') {
                        if ($executivedetails->type == $accessed_id[0])
                            $exe_array[$i] = $executivedetails->name;
                        $i++;
                    }
                }
                $exe_array = array_unique($exe_array);

                $customers = UserClient::find()->where(['user_id' => $check_id])->andWhere(['client_type' => 'Customer'])->all();
                $customer_ids = [];
                $j = 0;
                foreach ($customers as $data) {
                    $customer_ids[$j] = $data->client_id;
                    $j++;
                }
                $query = Invoice::find()->where(['is_deleted' => 0])->andWhere(['in', 'customer_name', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
            }


            if ($model->findid != '') {
                if ($model->send_email != '') {

		$model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                        //$file=$model->email_attachment->baseName;
                        //$model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                        //$model->email_attachment=$file.'.'.$model->email_attachment->extension;
		if($model->email_attachment!='')
		{
		     //$model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                       $file=$model->email_attachment->baseName;
                       $model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                       $model->email_attachment=$file.'.'.$model->email_attachment->extension;


                    $message = Yii::$app->mailer->compose()
                        ->setFrom([trim('mohasyn.bbsr@gmail.com') => "Mohapatra scientific"])
                        ->setTo(trim($model->send_email))
                        ->setSubject($model->email_subject)
                        ->setHtmlBody(nl2br($model->email_message))
			->attach(Yii::getAlias('@backend').'/web/email-assets/'.$model->email_attachment);
                    if (!empty($model->cc_to_email != "")) {
                        $message->setBcc(trim($model->bcc_to_email));
                    }
                    if (!empty($model->bcc_to_email != "")) {
                        $message->setBcc(trim($model->bcc_to_email));
                    }
                    Yii::$app->mailer->send($message);
		}	
		else
		{
			 $message = Yii::$app->mailer->compose()
                        ->setFrom([trim('mohasyn.bbsr@gmail.com') => "Mohapatra scientific"])
                        ->setTo(trim($model->send_email))
                        ->setSubject($model->email_subject)
                        ->setHtmlBody(nl2br($model->email_message));
                        if (!empty($model->cc_to_email != "")) {
                           $message->setBcc(trim($model->bcc_to_email));
                         }
                        if (!empty($model->bcc_to_email != "")) {
                           $message->setBcc(trim($model->bcc_to_email));
                         }
                         Yii::$app->mailer->send($message);

		}
		    if($model->email_attachment!='')
		    {
			unlink(Yii::$app->basePath . '/web/email-assets/' . $model->email_attachment);
		     }
                    Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                    return $this->redirect(['invoice/index']);
                } else {
                    Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                    return $this->redirect(['invoice/index']);
                }
            } else {
                $query->andFilterWhere(['in', 'invoice_id', $model->invoice_search])
                    ->andFilterWhere(['between', 'date', $model->from_date, $model->to_date])
                    ->andFilterWhere(['in', 'customer_name', $model->customer])
                    ->andFilterWhere(['like', 'settings_id', $model->setting])
                    ->andFilterWhere(['in', 'shipment_status', $model->shipment])
                    ->andFilterWhere(['in', 'executive', $model->executives_name])
                    ->andFilterWhere(['in', 'sales_type', $model->bill_type])
                    ->andFilterWhere(['in', 'sypply_type', $model->search_supply])
                    ->andFilterWhere(['in', 'po_number', $model->po_no])
                    ->andFilterWhere(['in', 'total_price', $model->total_amount])
                    ->andFilterWhere(['like', 'po_date', $model->po_searchdate]);
                if ($model->find_product) {
                    $productlists = InvoiceProduct::find()->where(['product_id' => $model->find_product, 'is_deleted' => 0])->groupBy(['invoice_id'])->all();
                    $productid = ArrayHelper::map($productlists, 'invoice_id', 'invoice_id');
                    $query->andFilterWhere(['in', 'id', $productid]);
                }
                $dataProvider = new ActiveDataProvider(['query' => $query, 'sort' => ['defaultOrder' => ['id' => SORT_DESC]],]);
            }
        }


	if($totalexcel!=null)
            { 
                $details = true;
                $this->actionExcelExport($dataProvider,$details);
            }
            if($excel!=null)
            { 
                $this->actionExcelExport($dataProvider);
            }
            if($print!=null)
            { 
                $from = "all";
                $this->actionInvoicePdf($dataProvider,$from);
            }
        return $this->render('index', [
            'model' => $model,
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'sales_types' => ProformaInvoiceController::$sales_types,
            'supply_types' => ProformaInvoiceController::$supply_types,
            'allproduct' => $allproduct,
        ]);
    }

    /**
     * Displays a single Invoice model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id, $from = null)
    {

        $loged_by = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id' => $loged_by])->one();

        if ($user_type->item_name != 'Admin') {
            $check_for_inv = Invoice::find()->where(['id' => $id])->one();
            $check_customer = UserClient::find()->where(['user_id' => $loged_by])->andWhere(['client_id' => $check_for_inv->customer_name])->one();
            if ($check_customer == '') {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['invoice/index']);
            }
        }

        Yii::$app->view->params['active'] = 32;
        $inv = Invoice::find()->where(['id' => $id])->one();
        $products = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $find = InvoiceProduct::find()->where(['invoice_id' => $id])->all();

        $adjusted = new InovicesAdjustedAmounts();
        $mod = new Invoice();
        $total_product = 0;
        // print_r(Yii::$app->request->post());




        foreach ($find as $find) {
            $total_product = $total_product + $find->quantity;
        }
        $tax_amount = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $taxable_amount = 0;
        foreach ($tax_amount as $tax_amount) {
            if ($tax_amount->discount_type == "FLAT") {
                $taxable_amount = $taxable_amount + (($tax_amount->unit_price - $tax_amount->discount) * $tax_amount->quantity);
            }
            if ($tax_amount->discount_type == "%") {
                $taxable_amount = $taxable_amount + ($tax_amount->price - (($tax_amount->price * $tax_amount->discount) / 100));
            }
            if ($tax_amount->discount_type == "") {
                $taxable_amount = $taxable_amount + $tax_amount->price;
            }
        }

        $tax_tot = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $total_tax = 0;
        foreach ($tax_tot as $tax_tot) {

            if ($tax_tot->tax != '')
                $tax_percent = AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $tax_tot->tax])->one()->tax_rate;
            else
                $tax_percent = 0;

            if ($tax_tot->tax_included == 1) {
                if ($tax_tot->discount_type == "FLAT") {
                    $total_tax = $total_tax + (((($tax_tot->unit_price - $tax_tot->discount) * $tax_tot->quantity) * (($tax_percent) / 2)) / 100);
                }
                if ($tax_tot->discount_type == "%") {
                    // $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100))

                    $total_tax = $total_tax + ((($tax_tot->price - (($tax_tot->price * $tax_tot->discount) / 100)) * (($tax_percent) / 2)) / 100);
                }
                if ($tax_tot->discount_type == "") {
                    $total_tax = $total_tax + (($tax_tot->price * (($tax_percent) / 2)) / 100);
                }
            }
        }


        $all_product_total = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $final_total = 0;
        $actual_amount = 0;
        foreach ($all_product_total as $key => $value) {
            $final_total = $final_total + $value->amount;
            $actual_amount = $actual_amount + $value->price;
        }



        $receipt = ReceiptDetails::find()->where(['receipt_id' => $inv->receipt_id])->one();

        $findinvoice = Invoice::find()->where(['id' => $id])->one();
        $qurey1 = ReceiptDetails::find()->where(['invoice_no' => $findinvoice->invoice_id])->all();

        $findadjustedinvoice = AdjustedInvoices::find()->where(['invoice_id' => $id])->all();


        $findcreditnotes = CreditNote::find()->where(['invoice_no' => $findinvoice->invoice_id])->all();



        if ($mod->load(Yii::$app->request->post())) {

            $adj_amount_check = InovicesAdjustedAmounts::find()->where(['invoice_id' => $id])->count();
            if ($adj_amount_check) {
                $adj_check = InovicesAdjustedAmounts::find()->where(['invoice_id' => $id])->all();

                foreach ($adj_check as $key => $value) {

                    $inv->pending_amount = $inv->pending_amount + $value->amount;
                    // $sale->converted_to ='Receipt';
                    $inv->save(false);

                    $ledgerdetails = AccountingLedger::find()->where(['accounting_ledger_id' => $value->account])->one();

                    $ledger = new AccountingDetails();
                    $ledger->ledgerhead_id = $ledgerdetails->ledger_id;
                    $ledger->transaction_type = "Adjusted";
                    $ledger->transaction_id = $value->id;
                    $ledger->inc_exp = "Income";
                    $ledger->accounting_type = "Debit";
                    $ledger->amount = $value->amount;
                    $ledger->date = $inv->date;
                    $ledger->save(false);

                    $findcustomer = Customer::find()->where(['id' => $inv->customer_name])->one();
                    $ledger_details = AccountingLedger::find()->where(['ledger_id' => $findcustomer->business_name])->one();
                    $ledger = new AccountingDetails();
                    $ledger->ledgerhead_id = $ledger_details->ledger_id;
                    $ledger->transaction_type = "Adjusted";
                    $ledger->transaction_id = $value->id;
                    $ledger->inc_exp = "Income";
                    $ledger->accounting_type = "Credit";
                    $ledger->amount = $value->amount;
                    $ledger->date = $inv->date;
                    $ledger->save(false);
                }

                $adj_delete = InovicesAdjustedAmounts::deleteAll(['invoice_id' => $id]);
            }
            $adj = Yii::$app->request->post()['Adj'];
            foreach ($adj as $val) {
                $adjust = new InovicesAdjustedAmounts();
                $adjust->account = $val['accountDD'];
                $adjust->invoice_id = $id;
                $adjust->amount = $val['item_price'];
                $adjust->notes = $val['notes'];
                $adjust->save(false);

                $inv->pending_amount = $inv->pending_amount - $adjust->amount;
                // $sale->converted_to ='Receipt';
                $inv->save(false);

                $ledgerdetails = AccountingLedger::find()->where(['accounting_ledger_id' => $adjust->account])->one();

                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = $ledgerdetails->ledger_id;
                $ledger->transaction_type = "Adjusted";
                $ledger->transaction_id = $adjust->id;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $adjust->amount;
                $ledger->date = $inv->date;
                $ledger->save(false);

                $findcustomer = Customer::find()->where(['id' => $inv->customer_name])->one();
                $ledger_details = AccountingLedger::find()->where(['ledger_id' => $findcustomer->business_name])->one();
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = $ledger_details->ledger_id;
                $ledger->transaction_type = "Adjusted";
                $ledger->transaction_id = $adjust->id;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $adjust->amount;
                $ledger->date = $inv->date;
                $ledger->save(false);
            }
        }
        $adj_amount_of_inv = InovicesAdjustedAmounts::find()->where(['invoice_id' => $id])->all();


        return $this->render('view', [

            'model' => $this->findModel($id),
            'products' => $products,
            'total_product' => $total_product,
            'taxable_amount' => $taxable_amount,
            'total_tax' => $total_tax,
            'receipt' => $receipt,
            'qurey1' => $qurey1,
            'final_total' => $final_total,
            'actual_amount' => $actual_amount,
            'findadjustedinvoice' => $findadjustedinvoice,
            'findcreditnotes' => $findcreditnotes,
            'adjusted' => $adjusted,
            'mod' => $mod,
            'adj_amount_of_inv' => $adj_amount_of_inv,
            'from' => $from,
        ]);
    }



    public function actionPrintall($id,$from=null,$title=null)
    {
          $inv = Invoice::find()->where(['id' => $id])->one();
        $products = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $find = InvoiceProduct::find()->where(['invoice_id' => $id])->all();

        $adjusted = new InovicesAdjustedAmounts();
        $mod = new Invoice();
        $total_product = 0;
        // print_r(Yii::$app->request->post());




        foreach ($find as $find) {
            $total_product = $total_product + $find->quantity;
        }
        $tax_amount = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $taxable_amount = 0;
        foreach ($tax_amount as $tax_amount) {
            if ($tax_amount->discount_type == "FLAT") {
                $taxable_amount = $taxable_amount + (($tax_amount->unit_price - $tax_amount->discount) * $tax_amount->quantity);
            }
            if ($tax_amount->discount_type == "%") {
                $taxable_amount = $taxable_amount + ($tax_amount->price - (($tax_amount->price * $tax_amount->discount) / 100));
            }
            if ($tax_amount->discount_type == "") {
                $taxable_amount = $taxable_amount + $tax_amount->price;
            }
        }

        $tax_tot = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $total_tax = 0;
        foreach ($tax_tot as $tax_tot) {

            if ($tax_tot->tax != '')
                $tax_percent = AccountingTax::find()->select(['tax_rate'])->where(['accounting_tax_id' => $tax_tot->tax])->one()->tax_rate;
            else
                $tax_percent = 0;

            if ($tax_tot->tax_included == 1) {
                if ($tax_tot->discount_type == "FLAT") {
                    $total_tax = $total_tax + (((($tax_tot->unit_price - $tax_tot->discount) * $tax_tot->quantity) * (($tax_percent) / 2)) / 100);
                }
                if ($tax_tot->discount_type == "%") {
                    // $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100))

                    $total_tax = $total_tax + ((($tax_tot->price - (($tax_tot->price * $tax_tot->discount) / 100)) * (($tax_percent) / 2)) / 100);
                }
                if ($tax_tot->discount_type == "") {
                    $total_tax = $total_tax + (($tax_tot->price * (($tax_percent) / 2)) / 100);
                }
            }
        }


        $all_product_total = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
        $final_total = 0;
        $actual_amount = 0;
        foreach ($all_product_total as $key => $value) {
            $final_total = $final_total + $value->amount;
            $actual_amount = $actual_amount + $value->price;
        }




        return $this->renderPartial('printall', [

            'model' => $this->findModel($id),
            'products' => $products,
	     'title' => $title,
            'total_product' => $total_product,
            'taxable_amount' => $taxable_amount,
            'total_tax' => $total_tax,
            'final_total' => $final_total,
            'actual_amount' => $actual_amount,
            'from' => $from,
        ]);
    }




    /**
     * Creates a new Invoice model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($id = null, $from = null, array $dc = null)
    {

        Yii::$app->view->params['active'] = 32;
        $model = new Invoice();
        $document =  new InvoiceDocument();
        $invoiceproducts = new InvoiceProduct();
        $invproduct = new InvoiceProduct();
        $total_quantity = 0;
        $avl_amount = 0;
        $avl_amount = 0;
        $challan_List ='';
        $a = array();
        // print_r(count($dc));
        // die();
        if ($id) {
            if ($from == 'invoice') {
                $data = $this->findModel($id)->attributes;
                $model->setAttributes($data);
                $invoiceproducts = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
            }


            if ($from == 'against_dc') {

                

                // $selection = Yii::$app->request->post('data');
                // print_r($selection);
                $saledata = SaleOrder::find()->where(['id' => $id])->one();
                // print_r($saledata);
                // die()
                $model->customer_name = $saledata->customer_id;
                // print_r($model->customer_name);
                //     die();
                if ($saledata->executive_id != '') {
                    $executive = LeadExecutive::find()->where(['id' => $saledata->executive_id])->one();
                    $model->executive = $executive->name;
                }
                $model->receiver_gstn = $saledata->receiver;
                $model->sales_type = $saledata->sale_type;
                $model->sypply_type = $saledata->supply_type;
                $model->supply_reverse_change = $saledata->reverse_charge;
                $model->price_list = $saledata->price_list;
                $model->po_number = $saledata->po_no;
                $model->po_date = $saledata->po_date;
                $model->tax_status = $saledata->is_invoice_paid_provisional;
                $model->point_of_supply = $saledata->point_of_supply;
                $model->terms_of_payment = $saledata->terms_of_payment;
                $model->due_date = $saledata->due_date;
                $model->notes = $saledata->note;
                $model->status = $saledata->order_status;
                $model->income_terms = $saledata->terms;
                $model->is_tcs = $saledata->is_tcs;
                if ($saledata->advance_payment == 'Advance payment for this Sales Order') {
                    $model->payment_details = 'Add Receipt';
                } else if ($saledata->advance_payment == 'Matched Receipt') {
                    $model->payment_details = 'Match Receipt';
                } else {
                    $model->payment_details = 'None';
                }
                $model->receipt_setting_type = $saledata->receipt_setting_type;
                $model->receipt_total_amount = $saledata->receipt_total_amount;
                $model->receipt_bank = $saledata->receipt_bank;
                $model->receipt_cheque_no = $saledata->receipt_cheque_no;
                $model->receipt_cheque_date = $saledata->receipt_cheque_date;
                $model->advance_note = $saledata->advance_note;
                $model->sale_order_id = $id;
                $model->receipt_id = $saledata->receipt_id;
                

                $invoiceproducts = SaleOrderProduct::find()->where(['sale_order_no' => $id])->all();
                foreach ($invoiceproducts as $key => $value) {
                    $pdt_count = 0;
                    for ($i = 0; $i < count($dc); $i++) {
                        $saleorderagainsdc = SaleorderAgainstDc::find()->where(['id' => $dc[$i]])->andWhere(['saleorder_id' => $id])->one();
                        
                        $finddelivered = ProductDelivered::find()->where(['id' => $saleorderagainsdc->dc_id])->andWhere(['is_invoiced' => 0])->all();


                        foreach ($finddelivered as $key => $val) {
                            $delvproduct = DeliveredProductList::find()->where(['delivered_id' => $val->id])->andWhere(['product_id' => $value->product_id])->one();
                            if ($delvproduct) {
                                $pdt_count = $pdt_count + $delvproduct->qty;
                            } else {
                                $pdt_count = $pdt_count;
                            }
                        }
                        $value->quantity = $pdt_count;
                        $value->price = $value->unit_price * $value->quantity;
                    }
                }

                  for ($k = 0; $k < count($dc); $k++) {
                        $saledc = SaleorderAgainstDc::find()->where(['id' => $dc[$k]])->andWhere(['saleorder_id' => $id])->one();
                        $a[] = $saledc->dc_id;
                    }

                $challan_List = implode(', ', $a);
            }



            if ($from == 'saleorder') {
                $statuscheck = Invoice::find()->where(['sale_order_id' => $id, 'is_deleted' => 0])->one();
                // if($statuscheck)
                // {
                //     Yii::$app->getSession()->setFlash('success', 'Invoice for this Sale Order already exist.');
                //     return $this->redirect(['sale-order/index']);
                // }
                // else
                // {
                $saledata = SaleOrder::find()->where(['id' => $id])->one();
                // $customer = Customer::find()->where(['id'=>$saledata->customer_id])->one();
                // $model->customer_name = $customer->business_name;
                $model->customer_name = $saledata->customer_id;
                if ($saledata->executive_id != '') {
                    $executive = LeadExecutive::find()->where(['id' => $saledata->executive_id])->one();
                    $model->executive = $executive->name;
                }
                $model->receiver_gstn = $saledata->receiver;
                $model->sales_type = $saledata->sale_type;
                $model->sypply_type = $saledata->supply_type;
                $model->supply_reverse_change = $saledata->reverse_charge;
                $model->price_list = $saledata->price_list;
                $model->po_number = $saledata->po_no;
                $model->po_date = $saledata->po_date;
                $model->tax_status = $saledata->is_invoice_paid_provisional;
                $model->point_of_supply = $saledata->point_of_supply;
                $model->terms_of_payment = $saledata->terms_of_payment;
                $model->due_date = $saledata->due_date;
                $model->notes = $saledata->note;
                $model->status = $saledata->order_status;
                $model->income_terms = $saledata->terms;
                // $model->is_tcs = $saledata->is_tcs;
                // $model->round_off = $saleorder_data->round_off;
                if ($saledata->advance_payment == 'Advance payment for this Sales Order') {
                    $model->payment_details = 'Add Receipt';
                } else if ($saledata->advance_payment == 'Matched Receipt') {
                    $model->payment_details = 'Match Receipt';
                } else {
                    $model->payment_details = 'None';
                }
                $model->receipt_setting_type = $saledata->receipt_setting_type;
                $model->receipt_total_amount = $saledata->receipt_total_amount;
                $model->receipt_bank = $saledata->receipt_bank;
                $model->receipt_cheque_no = $saledata->receipt_cheque_no;
                $model->receipt_cheque_date = $saledata->receipt_cheque_date;
                $model->advance_note = $saledata->advance_note;
                $model->sale_order_id = $id;
                $model->receipt_id = $saledata->receipt_id;
                $invoiceproducts = SaleOrderProduct::find()->where(['sale_order_no' => $id])->all();

                foreach ($invoiceproducts as $key => $value) {

                    $finddelivered = ProductDelivered::find()->where(['form_saleorder' => $saledata->id])->andWhere(['is_invoiced' => 0])->all();
                    $pdt_count = 0;
                    foreach ($finddelivered as $key => $val) {
                        $delvproduct = DeliveredProductList::find()->where(['delivered_id' => $val->id])->andWhere(['product_id' => $value->product_id])->one();
                        if ($delvproduct) {
                            $pdt_count = $pdt_count + $delvproduct->qty;
                        } else {
                            $pdt_count = $pdt_count;
                        }

                        # code...
                    }
                    $value->quantity = $pdt_count;
                    $value->price = $value->unit_price * $value->quantity;
                }
            }
            if ($from == 'proformainvoice') {

                $proinvoice = ProformaInvoice::find()->where(['id' => $id])->one();
                if ($proinvoice->sale_order_id != '') {
                    $statuscheck = Invoice::find()->where(['is_deleted' => 0])
                        ->andWhere(['or', ['proforma_invoice_id' => $id], ['sale_order_id' => $proinvoice->sale_order_id]])->one();
                } else {
                    $statuscheck = Invoice::find()->where(['is_deleted' => 0])
                        ->andWhere(['proforma_invoice_id' => $id])->one();
                }


                if ($statuscheck) {
                    Yii::$app->getSession()->setFlash('success', 'Invoice for this ProformaInvoice already exist.');
                    return $this->redirect(['proforma-invoice/index']);
                } else {
                    $proforma_data = ProformaInvoice::find()->where(['id' => $id])->one()->attributes;
                    $model->setAttributes($proforma_data);
                    $customer = Customer::find()->where(['business_name' => $proinvoice->customer_name])->one();
                    $model->customer_name = $customer->id;
                    if ($proinvoice->executive != '') {
                        $executive = LeadExecutive::find()->where(['id' => $proinvoice->executive])->one();
                        $model->executive = $executive->name;
                    }
                    $model->sypply_type = $proinvoice->supply_type;
                    $model->reminder_repeat = $proinvoice->reminder_repeat_on;
                    $model->suppliers_ref = $proinvoice->suppliers_reference;
                    $model->proforma_invoice_id = $id;
                    $model->sale_order_id = $proinvoice->sale_order_id;
                    $model->status = $proinvoice->status;
                    $invoiceproducts = ProformaInvoiceProduct::find()->where(['proforma_invoice_no' => $id])->all();
                }
            }
        }
        $data = Yii::$app->request->post();
        //$last_entry = Invoice::find()->count();
        $selected_date=date('Y-m-d');
         $year=date("Y"); 
         $dynamic_date=$year.'-'.'03'.'-'.'31';
         $dynamic_date_last = ($year - 1) . '-' . '03' . '-' . '31';
             if( strtotime($selected_date) <= strtotime($dynamic_date))
             {
                 $last_entry=Invoice::find()->where(['<=', 'date', $dynamic_date])->andWhere(['>', 'date', $dynamic_date_last])->count();
             }
             elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                 $last_entry=Invoice::find()->where(['>', 'date', $dynamic_date])->count();
             }
             else{
                 $last_entry=0;
             }

        if (Invoice::find()->count() > 0) {
            $total = Invoice::find()->orderBy(['id' => SORT_DESC])->one();
            $count = $total->id;
        } else {
            $count = 0;
        }
        $receipt = new ReceiptDetails();
        if ($model->load(Yii::$app->request->post()) && $document->load(Yii::$app->request->post())) {

            $loged_by = Yii::$app->user->identity->id;
            $user_type = AuthAssignment::find()->where(['user_id' => $loged_by])->one();

            if ($user_type->item_name != 'Admin') {
                $check_customer = UserClient::find()->where(['user_id' => $loged_by])->andWhere(['client_id' => $model->customer_name])->one();
                if ($check_customer == '') {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['invoice/index']);
                }
            }

            $model->created_at = date('Y-m-d H:i:s');
            $model->updated_at = date('Y-m-d H:i:s');
            $model->created_by = Yii::$app->user->identity->id;
            $model->from_delivered = $challan_List;
            $invoice = $count + 1;

            $model->invoice_id = $model->prefix . '' . $model->invoice_no . '' . $model->suffix;

            if (Yii::$app->request->post('reminder'))
                $model->reminder = 'Yes';
            else
                $model->reminder = 'No';
            if (Yii::$app->request->post('delivery_details'))
                $model->add_delivery_details = 'Yes';
            else
                $model->add_delivery_details = 'No';
            if (Yii::$app->request->post('buyer_details'))
                $model->buyer_details = 'Yes';
            else
                $model->buyer_details = 'No';
            if (Yii::$app->request->post('despatch_details'))
                $model->dispatch_details = 'Yes';
            else
                $model->dispatch_details = 'No';
            if (Yii::$app->request->post('deliver_to'))
                $model->deliver_to = 'Yes';
            else
                $model->deliver_to = 'No';
            if (Yii::$app->request->post('recurring'))
                $model->recurring = 'Yes';
            else
                $model->recurring = 'No';
            if (Yii::$app->request->post('packing_details'))
                $model->packing_details = 'Yes';
            else
                $model->packing_details = 'No';
            if ($model->reminder_through == 1 || $model->reminder_through == 'Yes') {
                $model->reminder_through = 'Yes';
            } else {
                $model->reminder_through = 'No';
            }
            if ($model->payment_details == 'Add Receipt') {
                $model->credit_note_id = '';
                $model->receipt_id = '';
            }
            if ($model->payment_details == 'Match Receipt') {
                $model->credit_note_id = '';
                $model->receipt_setting_type = '';
                $model->receipt_total_amount = '';
                $model->receipt_bank = '';
                $model->receipt_cheque_no = '';
                $model->receipt_cheque_date = '';
                $model->advance_note = '';
            }
            if ($model->payment_details == 'Match Credit Note') {
                $model->receipt_id = '';
                $model->receipt_setting_type = '';
                $model->receipt_total_amount = '';
                $model->receipt_bank = '';
                $model->receipt_cheque_no = '';
                $model->receipt_cheque_date = '';
                $model->advance_note = '';
            }
            if ($model->payment_details == 'None') {
                $model->receipt_id = '';
                $model->credit_note_id = '';
                $model->receipt_setting_type = '';
                $model->receipt_total_amount = '';
                $model->receipt_bank = '';
                $model->receipt_cheque_no = '';
                $model->receipt_cheque_date = '';
                $model->advance_note = '';
            }
            if ($model->reminder == 'No') {
                $model->reminder_for = '';
                $model->reminder_through = 'No';
                $model->reminder_content = '';
                $model->reminder_emails = '';
                $model->reminder_repeat = '';
                $model->reminder_from_date = '';
                $model->reminder_to_date = '';
            }
            if ($model->add_delivery_details == 'No') {
                $model->delivery_note = '';
                $model->suppliers_ref = '';
                $model->other_reference = '';
            }
            if ($model->buyer_details == 'No') {
                $model->buyer_order = '';
                $model->buyer_order_date = '';
                $model->buyer = '';
            }
            if ($model->dispatch_details == 'No') {
                $model->dispatch_document_no = '';
                $model->dispatch_date = '';
                $model->dispatched_through = '';
                $model->terms_of_delivery = '';
                $model->destination = '';
            }
            if ($model->packing_details == 'No') {
                $model->net_weight = '';
                $model->gross_weight = '';
                $model->dimension_for_primary = '';
                $model->dimention_for_master = '';
                $model->dimention_for_pallet = '';
                $model->no_of_pallets = '';
            }
            if ($model->recurring == 'No') {
                $model->recurring_frequency = '';
                $model->recurring_until = '';
                $model->recurring_until_date = '';
            }
            if ($model->recurring_until == 'Forever') {
                $model->recurring_until_date = '';
            }
            if ($model->deliver_to == 'No') {
                $model->customer_address = '';
                $model->delivery_receiver_name = '';
                $model->deliver_to_address_1 = '';
                $model->deliver_to_address_2 = '';
                $model->deliver_to_city = '';
                $model->deliver_to_zipcode = '';
                $model->deliver_to_state = '';
                $model->deliver_state_code = '';
                $model->deliver_to_country = '';
            }
            if ($model->point_of_supply == 21) {
                $model->igst_amount = 0;
            }
            if ($model->point_of_supply != 21) {
                $model->cgst_amount = 0;
                $model->sgst_amount = 0;
            }
            // if($model->sale_order_id=='' && $model->proforma_invoice_id=='')
            // {
            //    $model->status = "Pending";
            // }
            // if($model->sale_order_id!='')
            // {
            //    $paidreceipts = ReceiptDetails::find()->where(['sale_order_no'=>$model->sale_order_id])->andWhere(['payment_type'=>'Advance against invoice'])->all();
            //    $padireceiptamount = 0;
            //    foreach ($paidreceipts as $key => $value) {
            //     $padireceiptamount = $padireceiptamount + $value->amount;
            //    }
            //    if($model->total_price>$padireceiptamount && $padireceiptamount== 0)
            //    {
            //       $model->status = "Pending";
            //    }
            //    else if($model->total_price>$padireceiptamount && $padireceiptamount!= 0)
            //    {
            //         $model->status = "Partially Paid";
            //    }
            //    else
            //    {
            //        $model->status = "Paid";
            //    }
            // }
            // if($model->sale_order_id!='')
            // {
            //    $paidreceipts = ReceiptDetails::find()->where(['sale_order_no'=>$model->sale_order_id])->andWhere(['payment_type'=>'Advance against invoice'])->all();
            //    $padireceiptamount = 0;
            //    foreach ($paidreceipts as $key => $value) {
            //     $padireceiptamount = $padireceiptamount + $value->amount;
            //    }
            //    $model->pending_amount = $model->total_price-$padireceiptamount;
            // }
            // else{
            //    $model->pending_amount = $model->total_price;
            // }
            $model->status = "Pending";
            $model->pending_amount = $model->total_price;
            $model->save(false);
            if ($from == 'saleorder' || $from == 'against_dc') {
                $totalsaleorderproductqty = SaleOrderProduct::find()->where(['sale_order_no' => $saledata->id])->all();
                $finddeliveredlist = Invoice::find()->where(['sale_order_id' => $saledata->id])->count();
                if ($finddelivered) {
                    $deliveredlist = Invoice::find()->where(['sale_order_id' => $saledata->id])->all();
                    $dvl_count = 0;
                    foreach ($deliveredlist as $key => $val) {
                        $deliveredlistproduct = InvoiceProduct::find()->where(['invoice_id' => $val->id])->all();
                        foreach ($deliveredlistproduct as $key => $dvl) {
                            $dvl_count = $dvl_count + $dvl->quantity;
                        }
                    }
                    $count = 0;
                    foreach ($totalsaleorderproductqty as $key => $value) {
                        $count = $count + $value->quantity;
                    }
                    $product_count = 0;
                    if (isset($data['productdyn'])) {
                        foreach ($data['productdyn'] as $value) {
                            if ($value['price'] != '') {
                                $product_count = $product_count + $value['quantity'];
                            }
                        }
                    }
                    if (isset($data['productdynupdate'])) {
                        foreach ($data['productdynupdate'] as $value) {
                            if ($value['price'] != '') {
                                $product_count = $product_count + $value['quantity'];
                            }
                        }
                    }

                    $total_pro = $product_count + $dvl_count;
                    if ($total_pro < $count) {
                        $saledata->converted_to = 'Invoice';
                        $saledata->save(false);
                    } else {
                        $saledata->converted_to = 'Invoice';
                        $saledata->save(false);
                    }
                } else {
                    $count = 0;
                    foreach ($totalsaleorderproductqty as $key => $value) {
                        $count = $count + $value->quantity;
                    }
                    $product_count = 0;
                    $product_count = 0;
                    if (isset($data['productdyn'])) {
                        foreach ($data['productdyn'] as $value) {
                            if ($value['price'] != '') {
                                $product_count = $product_count + $value['quantity'];
                            }
                        }
                    }
                    if (isset($data['productdynupdate'])) {
                        foreach ($data['productdynupdate'] as $value) {
                            if ($value['price'] != '') {
                                $product_count = $product_count + $value['quantity'];
                            }
                        }
                    }
                    if ($product_count < $count) {
                        $saledata->converted_to = 'Invoice';
                        $saledata->save(false);
                    } else {
                        $saledata->converted_to = 'Invoice';
                        $saledata->save(false);
                    }
                }
                // if($from=='saleorder')
                // {
                //   // $saledata->converted_to = 'Invoice';
                //   // $saledata->save(false);
                //    $finddelivered = ProductDelivered::find()->where(['form_saleorder'=>$saledata->id])->andWhere(['is_invoiced'=>0])->all();
                //    foreach ($finddelivered as $key => $value) {
                //     $value->is_invoiced = 1;
                //     $value->invoice_no = $model->id;
                //     $value->save();
                //      # code...
                //    }
                // }
                // $finddelivered = ProductDelivered::find()->where(['form_saleorder'=>$saledata->id])->andWhere(['is_invoiced'=>0])->all();
                // foreach ($finddelivered as $key => $value) {
                //  $value->is_invoiced = 1;
                //  $value->invoice_no = $model->id;
                //  $value->save();
                //   # code...
                // }
            }
            if ($from == 'saleorder') {
                // $saledata->converted_to = 'Invoice';
                // $saledata->save(false);
                $finddelivered = ProductDelivered::find()->where(['form_saleorder' => $saledata->id])->andWhere(['is_invoiced' => 0])->all();
                foreach ($finddelivered as $key => $value) {
                    $value->is_invoiced = 1;
                    $value->invoice_no = $model->id;
                    $value->save(false);

                    $saleorder_dc = SaleorderAgainstDc::find()->where(['saleorder_id' => $saledata->id])->all();
                    foreach ($saleorder_dc as $key => $value) {
                        $value->invoice_no = $model->id;
                        $value->convert_to = "Receipt";
                        $value->save(false);
                    }
                }
            }

            if ($from == 'against_dc') {
                for ($i = 0; $i < count($dc); $i++) {
                    $saleorder_dc = SaleorderAgainstDc::find()->where(['id' => $dc[$i]])->andWhere(['saleorder_id' => $id])->one();
                    $saleorder_dc->invoice_no = $model->id;
                    $saleorder_dc->convert_to = "Receipt";
                    $saleorder_dc->save(false);

                    $finddelivered = ProductDelivered::find()->where(['id' => $saleorder_dc->dc_id])->andWhere(['is_invoiced' => 0])->one();
                    $finddelivered->is_invoiced = 1;
                    $finddelivered->invoice_no = $model->id;
                    $finddelivered->save(false);
                    # code...
                }
            }
            $demo = new AccountingDetails();
            $cgst = $model->cgst_amount;
            $igst = $model->igst_amount;
            $sgst = $model->sgst_amount;
            $roundoff = $model->round_off_amount;
            $totalamt = $model->total_price;
            $amt = $model->sub_total_price;
            $gsttype = $model->point_of_supply;
            $tan_id = $model->invoice_id;
            $tan_date = $model->date;
            $customer_name = Customer::find()->where(['id' => $model->customer_name])->one();
            $amtfrom = $customer_name->business_name;
            // $amtfrom = $model->customer_name;
            $tcs = $model->tcs_amount;
            $is_tcs = $model->is_tcs;
            $demo->leadgerentryinvoice($cgst, $sgst, $igst, $roundoff, $totalamt, $gsttype, $tan_id, $amtfrom, $amt, $tcs, $is_tcs, $tan_date);
            if (isset($data['productdyn'])) {
                foreach ($data['productdyn'] as $value) {
                    if ($value['price'] != '') {
                        $product = new InvoiceProduct();
                        $product->product_id = $value['product'];
                        $product->description = $value['desc'];
                        $product->quantity = $value['quantity'];
                        $product->units = $value['units'];
                        $product->price = $value['price'];
                        $product->unit_price = $value['unitprice'];
                        $product->discount = $value['discount'];
                        $product->tax = $value['tax'];
                        $product->discount_type = $value['discounttype'];
                        $product->tax_included = $value['tax_included'];
                        $product->amount = $value['amount'];
                        $product->invoice_id = $model->id;
                        $product->created_at = date('Y-m-d H:i:s');
                        $product->updated_at = date('Y-m-d H:i:s');
                        $product->save(false);
                    }
                }
            }
            if (isset($data['productdynupdate'])) {
                foreach ($data['productdynupdate'] as $value) {
                    if ($value['price'] != '') {
                        $productinv = new InvoiceProduct();
                        $productinv->product_id = $value['product'];
                        $productinv->description = $value['desc'];
                        $productinv->quantity = $value['quantity'];
                        $productinv->units = $value['units'];
                        $productinv->price = $value['price'];
                        $productinv->unit_price = $value['unitprice'];
                        $productinv->discount = $value['discount'];
                        $productinv->tax = $value['tax'];
                        $productinv->discount_type = $value['discounttype'];
                        $productinv->tax_included = $value['tax_included'];
                        $productinv->amount = $value['amount'];
                        $productinv->invoice_id = $model->id;
                        $productinv->created_at = date('Y-m-d H:i:s');
                        $productinv->updated_at = date('Y-m-d H:i:s');
                        $productinv->save(false);
                    }
                }
            }
            if (($model->receipt_total_amount != '' && $model->receipt_setting_type != '' && $model->payment_details == 'Add Receipt') || $model->payment_details == 'Match Receipt') {
                $check_receipt = ReceiptDetails::find()->where(['sale_order_no' => $model->sale_order_id])->one();
                if ($check_receipt == null) {
                    if (ReceiptDetails::find()->count() > 0) {
                        $total = ReceiptDetails::find()->orderBy(['id' => SORT_DESC])->one();
                        $count = $total->id;
                    } else {
                        $count = 0;
                    }
                    $receipt->payment_type = 'Advance Against Invoice';
                    $receipt->receipt_no = $count + 1;
                    $receipt->prefix = 'SR';
                    $receipt->suffix = '';
                    $receipt->receipt_id = $receipt->prefix . '' . $receipt->receipt_no . '' . $receipt->suffix;
                    $name = Customer::find()->where(['id' => $model->customer_name])->one();
                    $receipt->customer_name = $name->business_name;
                    $type = Customer::find()->where(['business_name' => $receipt->customer_name])->one();
                    $receipt->setting_type = $model->receipt_setting_type;
                    $receipt->amount = $model->receipt_total_amount;
                    $receipt->total_amount = $model->receipt_total_amount;
                    $receipt->bank_name = $model->receipt_bank;
                    $receipt->customer_type = $type->customer_type;
                    $receipt->payment_mode = 'Cheque';
                    $receipt->cheque_no = $model->receipt_cheque_no;
                    $receipt->cheque_date = $model->receipt_cheque_date;
                    $receipt->tds_amount = 0;
                    $receipt->invoice_no = $model->invoice_id;
                    $receipt->sale_order_no = $id;
                    $receipt->notes = $model->advance_note;
                    $receipt->receipt_date = date('Y-m-d H:i:s');
                    $receipt->created_at = date('Y-m-d H:i:s');
                    $receipt->updated_at = date('Y-m-d H:i:s');
                    $receipt->save(false);
                } else {
                    $check_receipt->invoice_no = $model->invoice_id;
                    $check_receipt->save(false);
                }
            }
            if ($document->validate()) {
                $names = UploadedFile::getInstances($document, 'document_name');
                foreach ($names as $name) {
                    $path = 'invoicedocuments/invoice-documents/' . $name->baseName . '.' . $name->extension;
                    if ($name->saveAs($path)) {
                        $filename = $name->baseName . '.' . $name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('invoice_document', ['document_name' => $filename, 'invoice_id' => $model->id])->execute();
                    }
                }
            }

            if ($from == '' || $from == 'invoice') {
                //Automatically generating saleorder for direct invoice
                $auto_saleorder = new SaleOrder();
                $auto_saleorder->customer_id = $model->customer_name;
                $auto_saleorder->sale_type = $model->sales_type;
                $auto_saleorder->note = $model->notes;
                $auto_saleorder->supply_type = $model->sypply_type;
                $auto_saleorder->receiver = $model->receiver_gstn;
                $auto_saleorder->reverse_charge = $model->supply_reverse_change;
                $auto_saleorder->price_list = $model->price_list;
                $auto_saleorder->point_of_supply = $model->point_of_supply;
                $auto_saleorder->due_date = $model->due_date;
                $auto_saleorder->terms_of_payment = $model->terms_of_payment;
                $auto_saleorder->sub_total_amount = $model->sub_total_price;
                $auto_saleorder->total_amount = $model->total_price;
                $auto_saleorder->igst_amount = $model->igst_amount;
                $auto_saleorder->cgst_amount = $model->cgst_amount;
                $auto_saleorder->sgst_amount = $model->sgst_amount;
                $auto_saleorder->tcs_amount = $model->tcs_amount;
                $auto_saleorder->round_off = $model->round_off_amount;
                $auto_saleorder->is_tcs = $model->is_tcs;
                $auto_saleorder->converted_to = 'Invoice';
                $auto_saleorder->setting_type = '11';
                $auto_saleorder->saleorder_source = 'Outgoing Shipment';
                $auto_saleorder->date = $model->date;
                $auto_saleorder->terms = $model->income_terms;
                $auto_saleorder->sale_from = 'Invoice';
                $auto_saleorder->paid_amount = 0;
                $auto_saleorder->prefix = "SO";
                $auto_saleorder->created_by = Yii::$app->user->identity->id;

                // $last_entry = SaleOrder::find()->count();
                // if (SaleOrder::find()->count() > 0) {
                //     $total = SaleOrder::find()->orderBy(['id' => SORT_DESC])->one();
                //     $count = $total->id;
                // } else {
                //     $count = 0;
                // }
                // $sale_id = $count + 1;
                // $auto_saleorder->sale_order = $sale_id;
                // $auto_saleorder->sale_order_id = 'SO' . '' . $sale_id . '' . '';
                    // if(date("m",strtotime($model->date))>=4)
                    // {
                    //     $dt = (date('Y', strtotime('+0 year'))).'-'.(date('y', strtotime('+1 year')));
                    // }
                    // else
                    // {
                    //     $dt = (date('Y', strtotime('-1 year'))).'-'.(date('y', strtotime('+0 year')));
                    // }
                    $selected_date=$model->date;
                    $year=date("Y"); 
                    $dynamic_date=$year.'-'.'03'.'-'.'31';
                        if(strtotime($selected_date) <= strtotime($dynamic_date))
                        {
                            $last_entry=SaleOrder::find()->where(['<=', 'date', $dynamic_date])->count();
                            $auto_saleorder->sale_order=$last_entry+1;
                            $dt = (date('Y', strtotime('-1 year'))).'-'.(date('y', strtotime('+0 year')));
                        }
                            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                            $last_entry=SaleOrder::find()->where(['>', 'date', $dynamic_date])->count();
                            $auto_saleorder->sale_order=$last_entry+1;
                            $dt = (date('Y', strtotime('+0 year'))).'-'.(date('y', strtotime('+1 year')));
                        }
                        else{
                            $auto_saleorder->sale_order=1;
                        }
                    $auto_saleorder->sale_order_id = 'SO' . '' .  $auto_saleorder->sale_order . '/'. $dt. '';
                    $auto_saleorder->suffix = '/'.$dt;
                    $auto_saleorder->save(false);

                //fatching product form invoice for saleorder

                $invoice_products = InvoiceProduct::find()->where(['invoice_id' => $model->id])->all();
                foreach ($invoice_products as $key => $value) {
                    $product = new SaleOrderProduct();
                    $product->product_id = $value->product_id;
                    $product->description = $value->description;
                    $product->quantity = $value->quantity;
                    $product->units = $value->units;
                    $product->price = $value->price;
                    $product->unit_price = $value->unit_price;
                    $product->discount = $value->discount;
                    $product->tax = $value->tax;
                    $product->discount_type = $value->discount_type;
                    $product->tax_included = $value->tax_included;
                    $product->amount = $value->amount;
                    $product->sale_order_no = $auto_saleorder->id;
                    $product->created_at = date('Y-m-d H:i:s');
                    $product->updated_at = date('Y-m-d H:i:s');

                    //Checking for product added in saleorder are avilable or not in inventory

                    $avilableproduct = Product::find()->where(['id' => $product->product_id])->one();
                    $avlunits = $avilableproduct->stock_unit;
                    $total_quantity = $total_quantity + $product->quantity;
                    if ($avilableproduct->stock_unit >= $product->quantity) {
                        $avl_amount = $avl_amount + $product->quantity;
                    } else if ($avilableproduct->stock_unit <= 0) {
                        $avl_amount = $avl_amount + 0;
                    } else if ($avilableproduct->stock_unit < $product->quantity && $avilableproduct->stock_unit > 0) {
                        $avl_amount = $avl_amount + $avilableproduct->stock_unit;
                    }
                    if ($avilableproduct->stock_unit < $product->quantity) {
                        $last_purchase_indent = PurchaseOrderIndent::find()->orderby(['id' => SORT_DESC])->one();
                        $indentmodel = new PurchaseOrderIndent();
                        $product_name = Product::find()->where(['id' => $product->product_id])->one();
                        $indentmodel->subject = $product_name->product_name . "(" . $product->description . ")";
                        $indentmodel->date = date('Y-m-d H:i:s');
                        $indentmodel->source = 'SaleOrder';
                        $indentmodel->sub_total_amount = 0;
                        $indentmodel->save(false);
                        $purchase_order_product = new PurchaseOrderIndentProduct();
                        $purchase_order_product->product_id = $product->product_id;
                        $purchase_order_product->description = $product->description;
                        $purchase_order_product->quantity = 0;
                        $purchase_order_product->units = $product->units;
                        $purchase_order_product->unit_price = $avilableproduct->bying_price;
                        $purchase_order_product->price = $avilableproduct->bying_price;
                        $purchase_order_product->amount = 0;
                        $purchase_order_product->tax = $product->tax;
                        $purchase_order_product->purchase_order_indent_id = $indentmodel->id;
                        $purchase_order_product->save(false);
                        $indentmodel->total_amount = 0;
                        $indentmodel->save(false);
                    }
                    $avilableproduct->stock_unit = $avilableproduct->stock_unit - $product->quantity;
                    $avilableproduct->save(false);
                    $product->save(false);
                }
                if ($total_quantity == $avl_amount) {
                    $auto_saleorder->avl_status = "Available";
                    $auto_saleorder->save(false);
                } else if ($total_quantity > $avl_amount && $avl_amount > 0) {
                    $auto_saleorder->avl_status = "Partially Avail.";
                    $auto_saleorder->save(false);
                } else if ($avl_amount <= 0) {
                    $auto_saleorder->avl_status = "Not Avilable";
                    $auto_saleorder->save(false);
                }
                $model->sale_order_id = $auto_saleorder->id;
                $model->save(false);
            }
            if (Yii::$app->request->post('save') == 0) {
                Yii::$app->getSession()->setFlash('success', 'Successfully created the Invoice');
                return $this->redirect(['invoice/index']);
            }

            if (Yii::$app->request->post('save') == 1) {
                Yii::$app->getSession()->setFlash('success', 'Successfully created the Invoice');
                return $this->redirect(['invoice/create']);
            }
        }

        return $this->render('create', [
            'model' => $model,
            'sales_types' => ProformaInvoiceController::$sales_types,
            'supply_types' => ProformaInvoiceController::$supply_types,
            'qty_units' => ProformaInvoiceController::$qty_units,
            'banks_name' => InvoiceController::$banks_name,
            'last_entry' => $last_entry,
            'country' => InvoiceController::$country,
            'state' => InvoiceController::$state,
            'invoiceproducts' => $invoiceproducts,
            'document' => $document,
            'from' => $from,
            'invproduct' => $invproduct,
        ]);
    }

    /**
     * Updates an existing Invoice model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
	ini_set('max_input_vars', '1000000');
        Yii::$app->view->params['active'] = 32;

        $loged_by = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id' => $loged_by])->one();

        if ($user_type->item_name != 'Admin') {
            $check_for_inv = Invoice::find()->where(['id' => $id])->one();
            $check_customer = UserClient::find()->where(['user_id' => $loged_by])->andWhere(['client_id' => $check_for_inv->customer_name])->one();
            if ($check_customer == '') {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['invoice/index']);
            }
        }

        $model = $this->findModel($id);
        $prv_amt = $model->total_price;
        $salesproduct = SalesProduct::find()->where(['invoice_no' => $model->invoice_no])->one();
        $last_entry = Invoice::find()->count();
        $data = Yii::$app->request->post();
        $document = new InvoiceDocument();
        $invproducts = new InvoiceProduct();
        $invoice_products = InvoiceProduct::find()->where(['invoice_id' => $id])->all();

        $receipt = new ReceiptDetails();
        if ($model->load(Yii::$app->request->post())) {
            $model->updated_at = date('Y-m-d H:i:s');
            if (Yii::$app->request->post('reminder'))
                $model->reminder = 'Yes';
            else
                $model->reminder = 'No';
            if (Yii::$app->request->post('delivery_details'))
                $model->add_delivery_details = 'Yes';
            else
                $model->add_delivery_details = 'No';
            if (Yii::$app->request->post('buyer_details'))
                $model->buyer_details = 'Yes';
            else
                $model->buyer_details = 'No';
            if (Yii::$app->request->post('despatch_details'))
                $model->dispatch_details = 'Yes';
            else
                $model->dispatch_details = 'No';
            if (Yii::$app->request->post('deliver_to'))
                $model->deliver_to = 'Yes';
            else
                $model->deliver_to = 'No';
            if (Yii::$app->request->post('recurring'))
                $model->recurring = 'Yes';
            else
                $model->recurring = 'No';
            if (Yii::$app->request->post('packing_details'))
                $model->packing_details = 'Yes';
            else
                $model->packing_details = 'No';
            if ($model->reminder_through == 1 || $model->reminder_through == 'Yes') {
                $model->reminder_through = 'Yes';
            } else {
                $model->reminder_through = 'No';
            }
            if ($model->payment_details == 'Add Receipt') {
                $model->credit_note_id = '';
                $model->receipt_id = '';
            }
            if ($model->reminder == 'No') {
                $model->reminder_for = '';
                $model->reminder_through = 'No';
                $model->reminder_content = '';
                $model->reminder_emails = '';
                $model->reminder_repeat = '';
                $model->reminder_from_date = '';
                $model->reminder_to_date = '';
            }
            if ($model->reminder_through == 'No') {
                $model->reminder_content = '';
                $model->reminder_emails = '';
                $model->reminder_repeat = '';
                $model->reminder_from_date = '';
                $model->reminder_to_date = '';
            }

            if ($model->payment_details == 'Match Receipt') {
                $model->credit_note_id = '';
                $model->receipt_setting_type = '';
                $model->receipt_total_amount = '';
                $model->receipt_bank = '';
                $model->receipt_cheque_no = '';
                $model->receipt_cheque_date = '';
                $model->advance_note = '';
            }
            if ($model->payment_details == 'Match Credit Note') {
                $model->receipt_id = '';
                $model->receipt_setting_type = '';
                $model->receipt_total_amount = '';
                $model->receipt_bank = '';
                $model->receipt_cheque_no = '';
                $model->receipt_cheque_date = '';
                $model->advance_note = '';
            }
            if ($model->payment_details == 'None') {
                $model->receipt_id = '';
                $model->credit_note_id = '';
                $model->receipt_setting_type = '';
                $model->receipt_total_amount = '';
                $model->receipt_bank = '';
                $model->receipt_cheque_no = '';
                $model->receipt_cheque_date = '';
                $model->advance_note = '';
            }
            if ($model->add_delivery_details == 'No') {
                $model->delivery_note = '';
                $model->suppliers_ref = '';
                $model->other_reference = '';
            }
            if ($model->buyer_details == 'No') {
                $model->buyer_order = '';
                $model->buyer_order_date = '';
                $model->buyer = '';
            }
            if ($model->dispatch_details == 'No') {
                $model->dispatch_document_no = '';
                $model->dispatch_date = '';
                $model->dispatched_through = '';
                $model->terms_of_delivery = '';
                $model->destination = '';
            }
            if ($model->packing_details == 'No') {
                $model->net_weight = '';
                $model->gross_weight = '';
                $model->dimension_for_primary = '';
                $model->dimention_for_master = '';
                $model->dimention_for_pallet = '';
                $model->no_of_pallets = '';
            }
            if ($model->recurring == 'No') {
                $model->recurring_frequency = '';
                $model->recurring_until = '';
                $model->recurring_until_date = '';
            }
            if ($model->recurring_until == 'Forever') {
                $model->recurring_until_date = '';
            }
            if ($model->deliver_to == 'No') {
                $model->customer_address = '';
                $model->delivery_receiver_name = '';
                $model->deliver_to_address_1 = '';
                $model->deliver_to_address_2 = '';
                $model->deliver_to_city = '';
                $model->deliver_to_zipcode = '';
                $model->deliver_to_state = '';
                $model->deliver_state_code = '';
                $model->deliver_to_country = '';
            }
            if ($model->point_of_supply == 21) {
                $model->igst_amount = 0;
            }
            if ($model->point_of_supply != 21) {
                $model->cgst_amount = 0;
                $model->sgst_amount = 0;
            }
            if ($model->sale_order_id != '') {
                $paidreceipts = ReceiptDetails::find()->where(['invoice_no' => $model->invoice_id])->all();
                $padireceiptamount = 0;
                foreach ($paidreceipts as $key => $value) {
                    $padireceiptamount = $padireceiptamount + $value->amount;
                }
                if ($model->total_price > $padireceiptamount && $padireceiptamount == 0) {
                    $model->status = "Pending";
                } else if ($model->total_price > $padireceiptamount && $padireceiptamount != 0) {
                    $model->status = "Partially Paid";
                } else {
                    $model->status = "Paid";
                }
            } else {
                $agenestreceipt = ReceiptDetails::find()->where(['invoice_no' => $model->invoice_id])->all();
                $amtagenestinvoice = 0;
                foreach ($agenestreceipt as $key => $value) {
                    $amtagenestinvoice = $amtagenestinvoice + $value->amount;
                }
                if ($model->total_price <= $amtagenestinvoice && $amtagenestinvoice != 0) {
                    $model->status = 'Paid';
                } else if ($amtagenestinvoice == 0) {
                    $model->status = 'Pending';
                } else {
                    $model->status = 'Partially Paid';
                }
            }
            $model->pending_amount = $model->total_price;
            $model->save(false);
            // print_r($prv_amt);
            // die();
            $purchase_order_product_delete = InvoiceProduct::deleteAll(['invoice_id' => $id]);

	    if (isset($data['productdynupdate'])) {

                foreach ($data['productdynupdate'] as $value) {
                    if ($value['price'] != '') {
                        $productinv = new InvoiceProduct();
                        $productinv->product_id = $value['product'];
                        $productinv->description = $value['desc'];
                        $productinv->quantity = $value['quantity'];
                        $productinv->units = $value['units'];
                        $productinv->price = $value['price'];
                        $productinv->unit_price = $value['unitprice'];
                        $productinv->discount = $value['discount'];
                        $productinv->tax = $value['tax'];
                        $productinv->discount_type = $value['discounttype'];
                        $productinv->tax_included = $value['tax_included'];
                        $productinv->amount = $value['amount'];
                        $productinv->invoice_id = $model->id;
                        $productinv->created_at = date('Y-m-d H:i:s');
                        $productinv->updated_at = date('Y-m-d H:i:s');
                        $productinv->save(false);
                    }
                }
            }


            if (isset($data['productdyn'])) {
                foreach ($data['productdyn'] as $value) {
                    if ($value['price'] != '') {
                        $product = new InvoiceProduct();
                        $product->product_id = $value['product'];
                        $product->description = $value['desc'];
                        $product->quantity = $value['quantity'];
                        $product->units = $value['units'];
                        $product->price = $value['price'];
                        $product->unit_price = $value['unitprice'];
                        $product->discount = $value['discount'];
                        $product->tax = $value['tax'];
                        $product->discount_type = $value['discounttype'];
                        $product->tax_included = $value['tax_included'];
                        $product->amount = $value['amount'];
                        $product->invoice_id = $model->id;
                        $product->created_at = date('Y-m-d H:i:s');
                        $product->updated_at = date('Y-m-d H:i:s');
                        $product->save(false);
                    }
                }
            }

            if (($model->receipt_total_amount != '' && $model->receipt_setting_type != '' && $model->payment_details == 'Add Receipt') || $model->payment_details == 'Match Receipt') {
                $check_receipt = ReceiptDetails::find()->where(['invoice_no' => $model->invoice_id])->one();
                if ($check_receipt == null) {
                    if (ReceiptDetails::find()->count() > 0) {
                        $total = ReceiptDetails::find()->orderBy(['id' => SORT_DESC])->one();
                        $count = $total->id;
                    } else {
                        $count = 0;
                    }
                    $receipt->payment_type = 'Advance Against Invoice';
                    $receipt->receipt_no = $count + 1;
                    $receipt->prefix = 'SR';
                    $receipt->suffix = '';
                    $receipt->receipt_id = $receipt->prefix . '' . $receipt->receipt_no . '' . $receipt->suffix;
                    $name = Customer::find()->where(['id' => $model->customer_name])->one();
                    $receipt->customer_name = $name->business_name;
                    $type = Customer::find()->where(['business_name' => $receipt->customer_name])->one();
                    $receipt->setting_type = $model->receipt_setting_type;
                    $receipt->amount = $model->receipt_total_amount;
                    $receipt->total_amount = $model->receipt_total_amount;
                    $receipt->bank_name = $model->receipt_bank;
                    $receipt->customer_type = $type->customer_type;
                    $receipt->payment_mode = 'Cheque';
                    $receipt->cheque_no = $model->receipt_cheque_no;
                    $receipt->cheque_date = $model->receipt_cheque_date;
                    $receipt->tds_amount = 0;
                    $receipt->invoice_no = $model->invoice_id;
                    $receipt->sale_order_no = 0;
                    $receipt->notes = $model->advance_note;
                    $receipt->receipt_date = date('Y-m-d H:i:s');
                    $receipt->created_at = date('Y-m-d H:i:s');
                    $receipt->updated_at = date('Y-m-d H:i:s');
                    $receipt->save(false);
                } else {
                    // $check_receipt->setting_type=$model->receipt_setting_type;
                    // $check_receipt->amount=$model->receipt_total_amount;
                    // $check_receipt->total_amount=$model->receipt_total_amount;
                    // $receipt->bank_name=$model->receipt_bank;
                    // $check_receipt->payment_mode='Cheque';
                    // $check_receipt->cheque_no=$model->receipt_cheque_no;
                    // $check_receipt->cheque_date=$model->receipt_cheque_date; 
                    // $check_receipt->tds_amount=0;
                    // $check_receipt->invoice_no=$model->id;
                    // $check_receipt->sale_order_no=0;
                    // $check_receipt->notes=$model->advance_note;
                    // $check_receipt->receipt_date=date('Y-m-d H:i:s');
                    // $check_receipt->updated_at=date('Y-m-d H:i:s');
                    // $check_receipt->save(false);
                    $check_receipt->invoice_no = $model->invoice_id;
                    $check_receipt->save(false);
                }
            }
            if ($document->validate()) {
                $names = UploadedFile::getInstances($document, 'document_name');
                foreach ($names as $name) {
                    $path = 'invoicedocuments/invoice-documents/' . $name->baseName . '.' . $name->extension;
                    if ($name->saveAs($path)) {
                        $filename = $name->baseName . '.' . $name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('invoice_document', ['document_name' => $filename, 'invoice_id' => $model->id])->execute();
                    }
                }
            }
            if ($model->total_price != $prv_amt) {
                $find_doubleentries = AccountingDetails::find()->where(['transaction_type' => 'Invoice'])->andWhere(['transaction_id' => $model->invoice_id])->all();
                foreach ($find_doubleentries as $key => $value) {

                    $ledger = new AccountingDetails();
                    $ledger->ledgerhead_id = $value->ledgerhead_id;
                    $ledger->transaction_type = $value->transaction_type;
                    $ledger->transaction_id = $value->transaction_id;
                    $ledger->inc_exp = $value->inc_exp;
                    if ($value->accounting_type == 'Credit') {
                        $ledger->accounting_type = "Debit";
                    } elseif ($value->accounting_type == 'Debit') {
                        $ledger->accounting_type = "Credit";
                    }
                    $ledger->amount = $value->amount;
                    $ledger->date = $value->date;
                    $ledger->edit_status = 1;
                    $ledger->save(false);
                    $value->edit_status = 1;
                    $value->save(false);
                }
                $demo = new AccountingDetails();
                $cgst = $model->cgst_amount;
                $igst = $model->igst_amount;
                $sgst = $model->sgst_amount;
                $roundoff = $model->round_off_amount;
                $totalamt = $model->total_price;
                $amt = $model->sub_total_price;
                $gsttype = $model->point_of_supply;
                $tan_id = $model->invoice_id;
                $tan_date = $model->date;
                $customer_name = Customer::find()->where(['id' => $model->customer_name])->one();
                $amtfrom = $customer_name->business_name;
                // $amtfrom = $model->customer_name;
                $tcs = $model->tcs_amount;
                $is_tcs = $model->is_tcs;
                $demo->leadgerentryinvoice($cgst, $sgst, $igst, $roundoff, $totalamt, $gsttype, $tan_id, $amtfrom, $amt, $tcs, $is_tcs, $tan_date);
            }
            if (Yii::$app->request->post('save') == 0) {
                Yii::$app->getSession()->setFlash('success', 'Data Updated Successfully');
                return $this->redirect(['invoice/index']);
            }

            if (Yii::$app->request->post('save') == 1) {
                Yii::$app->getSession()->setFlash('success', 'Data Updated Successfully');
                return $this->redirect(['invoice/create']);
            }
        }


        return $this->render('update', [
            'model' => $model,
            'salesproduct' => $salesproduct,
            'last_entry' => $last_entry + 1,
            'document' => $document,
            'invproducts' => $invproducts,
            'invoice_products' => $invoice_products,
            'banks_name' => InvoiceController::$banks_name,
            'country' => InvoiceController::$country,
            'state' => InvoiceController::$state,
            'sales_types' => ProformaInvoiceController::$sales_types,
            'supply_types' => ProformaInvoiceController::$supply_types,
            'qty_units' => ProformaInvoiceController::$qty_units,
        ]);
    }

    /**
     * Deletes an existing Invoice model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDeliveryChallanTemplate($id)
    {
        $model = $this->findModel($id);
        $product_count = 0;
        if ($model->sale_order_id != '') {
            $count = SaleOrderProduct::find()->where(['sale_order_no' => $model->sale_order_id])->count();
            $products = SaleOrderProduct::find()->where(['sale_order_no' => $model->sale_order_id])->all();
            foreach ($products as $key => $value) {
                $product_count = $product_count + $value->quantity;
                # code...
            }
            if ($model->sale_order_id != '') {
                $sale = SaleOrder::find()->where(['id' => $model->sale_order_id])->one();
            }
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->SetFooter('<br>');
            $mpdf->WriteHTML($this->renderPartial('/invoice/delivery-challan-template', [
                'model' => $model,
                'count' => $count,
                'sale' => $sale,
                'product_count' => $product_count,

            ]));

            $mpdf->Output('delivery-challan.pdf', 'I');
        } else {
            Yii::$app->getSession()->setFlash('success', 'No SaleOrder found for this invoice.');
            return $this->redirect(['invoice/index']);
        }
    }

    public function actionFindinvoiceproduct($productid)
    {
        $productdetails = Product::find()->where(['id' => $productid])->one();
        echo Json::encode($productdetails);
    }
    public function actionFindinvoiceaddress($name)
    {
        $addresstdetails = Customer::find()->where(['id' => $name])->one();
        echo Json::encode($addresstdetails);
    }
    public function actionFindpreviousaddress($id)
    {
        $address = Invoice::find()->where(['id' => $id])->one();
        echo Json::encode($address);
    }
    public function actionProductdetails($searchTerm = null)
    {
        if (!$searchTerm)
            $product = Product::find()->limit(10)->all();
        else
            $product = Product::find()->where(["like", "product_name", $searchTerm])->limit(10)->all();

        $productlist = ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }
    public function actionFinddetails()
    {
        $taxdetails = Accountingtax::find()->select(['tax_name', 'accounting_tax_id'])->where(['is_deleted' => 0])
            ->andWhere(['tax_sub_type' => 'Output'])
            ->andWhere(['status' => 1])
            ->andWhere(['or', ['tax_class' => 'IGST'], ['tax_class' => 'TCS']])->all();
        $taxlist = ArrayHelper::map($taxdetails, 'accounting_tax_id', 'tax_name');
        return Json::encode($taxlist);
    }
    public function actionTaxdetails($item)
    {
        $taxdetails = AccountingTax::find()->where(['accounting_tax_id' => $item])->one();
        echo Json::encode($taxdetails);
    }
    public function actionCustomerdetails($searchTerm = null)
    {
        if (!$searchTerm)
            $customer = Customer::find()->limit(10)->all();
        else
            $customer = Customer::find()->where(["like", "business_name", $searchTerm])->limit(10)->all();

        $customerlist = ArrayHelper::map($customer, 'id', 'business_name');
        return json_encode($customerlist);
    }
    public function actionCustomer($searchTerm = null)
    {
        if (!$searchTerm)
            $customer = Customer::find()->limit(10)->all();
        else
            $customer = Customer::find()->where(["like", "business_name", $searchTerm])->limit(10)->all();

        $customerlist = ArrayHelper::map($customer, 'business_name', 'business_name');
        return json_encode($customerlist);
    }

    public function actionDelete($id = null)
    {
        if ($id == null) {
            $ids = Yii::$app->request->post('data');
            if ($ids) {
                foreach ($ids as $id) {
                    $document = InvoiceDocument::find()->where(['invoice_id' => $id])->all();
                    foreach ($document as $value) {
                        $value->is_deleted = 1;
                        $value->save(false);
                    }
                    $products = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
                    foreach ($products as $products) {
                        $products->is_deleted = 1;
                        $products->save(false);
                    }
                    $data = $this->findModel($id);
                    $data->is_deleted = 1;
                    $data->save(false);

		    $accounting = AccountingDetails::find()->where(['transaction_id'=>$data->invoice_id])->all();
                    foreach ($accounting as $account) {
                        $account->edit_status = 1;
                        $account->save(false);
                    }

                }
            }
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted selected items');
            return $this->redirect(['invoice/index']);
        } else {
            $data = $this->findModel($id);
            $data->is_deleted = 1;
            $data->save(false);
            $document = InvoiceDocument::find()->where(['invoice_id' => $id])->all();
            foreach ($document as $value) {
                $value->is_deleted = 1;
                $value->save(false);
            }
            $products = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
            foreach ($products as $products) {
                $products->is_deleted = 1;
                $products->save(false);
            }

	    $accounting = AccountingDetails::find()->where(['transaction_id'=>$data->invoice_id])->all();
            foreach ($accounting as $account) {
                $account->edit_status = 1;
                $account->save(false);
            }

            Yii::$app->getSession()->setFlash('success', 'Successfully deleted');
            return $this->redirect(['invoice/index']);
        }
    }
    public function actionFindattachments($id)
    {
        $find = InvoiceDocument::find()->select(['document_name', 'id'])->where(['invoice_id' => $id])->asArray()->all();
        echo Json::encode($find);
    }
    public function actionDelattachment($id)
    {
        $file = InvoiceDocument::find()->where(['id' => $id])->one();
        $file->delete();
        // return $exporter->send($find);
        // return $find;
    }
    public function actionExcelExport($dataProvider=null,$detail=null)
    {

        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id' => $check_id])->one();
        $accessed_id[] = $user_type->item_name;
        if ($user_type->item_name == 'Admin') {
            $query = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC]);
        } else {
            // print_r($check_id);die();
            $all = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC])->all();
            $exe_array = [];
            $i = 0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['name' => $val['executive']])->one();
                if ($executivedetails != '') {
                    if ($executivedetails->type == $accessed_id[0])
                        $exe_array[$i] = $executivedetails->name;
                    $i++;
                }
            }
            $exe_array = array_unique($exe_array);

            $customers = UserClient::find()->where(['user_id' => $check_id])->andWhere(['client_type' => 'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach ($customers as $data) {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = Invoice::find()->where(['is_deleted' => 0])->andWhere(['in', 'customer_name', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
        }

         if($dataProvider==null)
         {
            $dataProvider = new ActiveDataProvider([
            'query' => $query,
            ]);
         } 

        if ($detail) {
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    'settings_id',
                    'prefix',
                    'invoice_id',
                    'suffix',
                    'invoice_no',
                    [
                        'label' => 'Customer Name',
                        'attribute' => 'customer_name',
                        'value' => function ($data) {
                            $name = Customer::find()->where(['id' => $data->customer_name])->one();
                            return $name->business_name;
                        },
                    ],
                    'executive',
                    'receiver_gstn',
                    'customer_referance',
                    'sales_type',
                    'notes',
                    'sypply_type',
                    'supply_reverse_change',
                    'po_number',
                    'po_date:date',
                    'price_list',
                    'point_of_supply',
                    'income_terms',
                    'tax_status',
                    'date:date',
                    'due_date:date',
                    'terms_of_payment',
                    'sub_total_price',
                    'total_price',
                    'payment_details',
                    'receipt_setting_type',
                    'receipt_total_amount',
                    'receipt_bank',
                    'receipt_cheque_no',
                    'receipt_cheque_date:date',
                    'advance_note',
                    'credit_note_id',
                    'receipt_id',
                    'time_of_preparation:date',
                    'time_o_removal:date',
                    'reminder',
                    'reminder_for',
                    'reminder_through',
                    'reminder_emails',
                    'reminder_content',
                    'reminder_repeat',
                    'reminder_from_date:date',
                    'reminder_to_date:date',
                    'add_delivery_details',
                    'delivery_note',
                    'suppliers_ref',
                    'other_reference',
                    'buyer_details',
                    'buyer_order',
                    'buyer_order_date:date',
                    'buyer',
                    'dispatch_details',
                    'dispatch_document_no',
                    'dispatch_date:date',
                    'dispatched_through',
                    'destination',
                    'terms_of_delivery',
                    'deliver_to',
                    'delivery_receiver_name',
                    'deliver_to_address_1',
                    'deliver_to_address_2',
                    'deliver_to_city',
                    'deliver_to_zipcode',
                    'deliver_to_state',
                    'deliver_state_code',
                    'deliver_to_country',
                    'recurring',
                    'recurring_frequency',
                    'recurring_until',
                    'recurring_until_date:date',
                    'packing_details',
                    'net_weight',
                    'gross_weight',
                    'dimension_for_primary',
                    'dimention_for_master',
                    'dimention_for_pallet',
                    'no_of_pallets',
                    [

                        'label' => 'Status',
                        'value' => function ($data) {
                            if ($data['status']) {
                                // return $data['status'];
                                // if($data['status']=='Paid')
                                if (($data->pending_amount) == 0) {
                                    return 'PAID';
                                }
                                // else if($data['status']=='Pending')
                                else if ($data->total_price == ($data->pending_amount)) {
                                    return 'PENDING';
                                }
                                // else if ($data['status']=='Partially Paid')
                                else if (($data->total_price - ($data->pending_amount)) > 0) {
                                    return 'PARTIAL';
                                } else {
                                    return $data->status;
                                }
                            }



                            if (!($data->pending_amount - $data->tds_amount)) {
                                return 'PAID';
                            }
                            //    else if($total<$data->total && $total!=0)
                            else if ($data->total - ($data->pending_amount - $data->tds_amount)) {
                                return 'PARTIAL';
                            }
                            //    else if($total==0)
                            else if ($data->total = ($data->pending_amount)) {
                                return 'PENDING';
                            }
                        },
                    ],
                    [

                        'label' => ' Shipment Status',
                        'value' => function ($data) {
                            if ($data['shipment_status']) {
                                // return $data['status'];
                                if ($data['shipment_status'] == 'DELIVERED') {
                                    return 'DELIVERED';
                                } else if ($data['shipment_status'] == 'PARTIAL') {
                                    return 'PARTIAL';
                                } else if ($data['shipment_status'] == 'NOT DELIVERED') {
                                    return 'PENDING';
                                } else {
                                    return $data->shipment_status;
                                }
                            }
                        },
                    ],
                    'sale_order_id',
                    'proforma_invoice_id',
                    [
                        'label' => 'Created At',
                        'attribute' => 'created_at',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y H:i:s", strtotime($data['created_at']));
                            return $newDate;
                        },
                    ],
                    [
                        'label' => 'Updated At',
                        'attribute' => 'updated_at',
                        'value' => function ($data) {
                            $newDate = date("d-m-Y H:i:s", strtotime($data['updated_at']));
                            return $newDate;
                        },
                    ],
                    [
                        'label' => 'Documents',
                        'format'    => 'raw',
                        // 'attribute' => 'customer_name',
                        'value' => function ($data) {
                            $user = InvoiceDocument::find()->select(['document_name'])->where(['invoice_id' => $data['id']])->asArray()->column();
                            $documents = implode(" <br> ", $user);
                            return $documents;
                        },
                    ],
                ],
            ]);
        } else {
            // print_r("xxxxx");
            // exit();
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    'invoice_id',
                    [
                        'label' => 'Customer Name',
                        'attribute' => 'customer_name',
                        'value' => function ($data) {
                            $name = Customer::find()->where(['id' => $data->customer_name])->one();
                            return $name->business_name;
                        },
                    ],
                    'date',
                    'total_price',
                    'executive'
                ],
            ]);
        }

        return $exporter->send('Invoice-details.xlsx');
    }

    public function actionInvoicePdf($dataProvider=null,$from=null,$id=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id' => $check_id])->one();
        $accessed_id[] = $user_type->item_name;
        if ($user_type->item_name == 'Admin') {
            $query = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC]);
        } else {
            // print_r($check_id);die();
            $all = Invoice::find()->where(['is_deleted' => 0])->orderBy(['id' => SORT_DESC])->all();
            $exe_array = [];
            $i = 0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['name' => $val['executive']])->one();
                if ($executivedetails != '') {
                    if ($executivedetails->type == $accessed_id[0])
                        $exe_array[$i] = $executivedetails->name;
                    $i++;
                }
            }
            $exe_array = array_unique($exe_array);

            $customers = UserClient::find()->where(['user_id' => $check_id])->andWhere(['client_type' => 'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach ($customers as $data) {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = Invoice::find()->where(['is_deleted' => 0])->andWhere(['in', 'customer_name', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
        }

        if ($from == 'all') {
            if($dataProvider==null)
             {
                $dataProvider = new ActiveDataProvider([
                'query' => $query,
                ]);
             }
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/invoice/export-pdf', [
                'dataProvider' => $dataProvider,

            ]));
            $mpdf->Output('Invoice-details.pdf', 'I');
        } else {
            $loged_by = Yii::$app->user->identity->id;
            $user_type = AuthAssignment::find()->where(['user_id' => $loged_by])->one();

            if ($user_type->item_name != 'Admin') {
                $check_for_inv = Invoice::find()->where(['id' => $id])->one();
                $check_customer = UserClient::find()->where(['user_id' => $loged_by])->andWhere(['client_id' => $check_for_inv->customer_name])->one();
                if ($check_customer == '') {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['invoice/index']);
                }
            }
            $model = Invoice::find()->where(['id' => $id])->one();
            $products = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
            $find = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
            $count = InvoiceProduct::find()->where(['invoice_id' => $id])->count();
            $total_product = 0;
            foreach ($find as $find) {
                $total_product = $total_product + $find->quantity;
            }
            $tax_amount = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
            $taxable_amount = 0;
            foreach ($tax_amount as $tax_amount) {
                if ($tax_amount->discount_type == "FLAT") {
                    $taxable_amount = $taxable_amount + ($tax_amount->price - $tax_amount->discount);
                }
                if ($tax_amount->discount_type == "%") {
                    $taxable_amount = $taxable_amount + ($tax_amount->price - (($tax_amount->price * $tax_amount->discount) / 100));
                }
                if ($tax_amount->discount_type == "") {
                    $taxable_amount = $taxable_amount + $tax_amount->price;
                }
            }

            $tax_tot = InvoiceProduct::find()->where(['invoice_id' => $id])->all();
            $total_tax = 0;
            foreach ($tax_tot as $tax_tot) {
                if ($tax_tot->tax_included == 1) {
                    if ($tax_tot->discount_type == "FLAT") {
                        $total_tax = $total_tax + ((($tax_tot->price - $tax_tot->discount) * (($tax_tot->tax) / 2)) / 100);
                    }
                    if ($tax_tot->discount_type == "%") {
                        // $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100))

                        $total_tax = $total_tax + ((($tax_tot->price - (($tax_tot->price * $tax_tot->discount) / 100)) * (($tax_tot->tax) / 2)) / 100);
                    }
                    if ($tax_tot->discount_type == "") {
                        $total_tax = $total_tax + (($tax_tot->price * (($tax_tot->tax) / 2)) / 100);
                    }
                }
            }
            $receipt = ReceiptDetails::find()->where(['receipt_id' => $model->receipt_id])->one();
            $dataProvider = new ActiveDataProvider([
                'query' => Invoice::find()->where(['id' => $id]),
            ]);
            $dataProvider->pagination = false;
            $mpdf = new mPDF;
            $mpdf->showImageErrors = true;
            $mpdf->WriteHTML($this->renderPartial('/invoice/invoice-pdf', [
                'dataProvider' => $dataProvider,
                'products' => $products,
                'model' => $model,
                'total_product' => $total_product,
                'taxable_amount' => $taxable_amount,
                'total_tax' => $total_tax,
                'receipt' => $receipt,
                'count' => $count,
            ]));
            $find = Invoice::findOne($id);
            $invoice_id = $find->invoice_id;
            if ($from == 'print') {
                $mpdf->Output($invoice_id . '-Invoice.pdf', 'I');
            } else {
                $mpdf->Output($invoice_id . '-Invoice.pdf', 'D');
            }
        }
    }

    public function actionExcelInvoice($id)
    {

        $loged_by = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id' => $loged_by])->one();

        if ($user_type->item_name != 'Admin') {
            $check_for_inv = Invoice::find()->where(['id' => $id])->one();
            $check_customer = UserClient::find()->where(['user_id' => $loged_by])->andWhere(['client_id' => $check_for_inv->customer_name])->one();
            if ($check_customer == '') {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['invoice/index']);
            }
        }

        $dataProvider = new ActiveDataProvider([
            'query' => Invoice::find()->where(['id' => $id]),
        ]);
        $exporter = new Spreadsheet([
            'dataProvider' => $dataProvider,
            'columns' => [
                'settings_id',
                'prefix',
                'invoice_id',
                'suffix',
                'invoice_no',
                [
                    'label' => 'Customer Name',
                    'attribute' => 'customer_name',
                    'value' => function ($data) {
                        $name = Customer::find()->where(['id' => $data->customer_name])->one();
                        return $name->business_name;
                    },
                ],
                'executive',
                'receiver_gstn',
                'customer_referance',
                'sales_type',
                'notes',
                'sypply_type',
                'supply_reverse_change',
                'po_number',
                'po_date:date',
                'price_list',
                'point_of_supply',
                'income_terms',
                'tax_status',
                'date:date',
                'due_date:date',
                'terms_of_payment',
                'sub_total_price',
                'total_price',
                'payment_details',
                'receipt_setting_type',
                'receipt_total_amount',
                'receipt_bank',
                'receipt_cheque_no',
                'receipt_cheque_date:date',
                'advance_note',
                'credit_note_id',
                'receipt_id',
                'time_of_preparation:date',
                'time_o_removal:date',
                'reminder',
                'reminder_for',
                'reminder_through',
                'reminder_emails',
                'reminder_content',
                'reminder_repeat',
                'reminder_from_date:date',
                'reminder_to_date:date',
                'add_delivery_details',
                'delivery_note',
                'suppliers_ref',
                'other_reference',
                'buyer_details',
                'buyer_order',
                'buyer_order_date:date',
                'buyer',
                'dispatch_details',
                'dispatch_document_no',
                'dispatch_date:date',
                'dispatched_through',
                'destination',
                'terms_of_delivery',
                'deliver_to',
                'delivery_receiver_name',
                'deliver_to_address_1',
                'deliver_to_address_2',
                'deliver_to_city',
                'deliver_to_zipcode',
                'deliver_to_state',
                'deliver_state_code',
                'deliver_to_country',
                'recurring',
                'recurring_frequency',
                'recurring_until',
                'recurring_until_date:date',
                'packing_details',
                'net_weight',
                'gross_weight',
                'dimension_for_primary',
                'dimention_for_master',
                'dimention_for_pallet',
                'no_of_pallets',
                'status',
                'shipment_status',
                'sale_order_id',
                'proforma_invoice_id',
                [
                    'label' => 'Created At',
                    'attribute' => 'created_at',
                    'value' => function ($data) {
                        $newDate = date("d-m-Y H:i:s", strtotime($data['created_at']));
                        return $newDate;
                    },
                ],
                [
                    'label' => 'Updated At',
                    'attribute' => 'updated_at',
                    'value' => function ($data) {
                        $newDate = date("d-m-Y H:i:s", strtotime($data['updated_at']));
                        return $newDate;
                    },
                ],
                [
                    'label' => 'Documents',
                    'format'    => 'raw',
                    // 'attribute' => 'customer_name',
                    'value' => function ($data) {
                        $user = InvoiceDocument::find()->select(['document_name'])->where(['invoice_id' => $data['id']])->asArray()->column();
                        $documents = implode(" <br> ", $user);
                        return $documents;
                    },
                ],
            ],
        ]);
        $find = Invoice::findOne($id);
        $invoice_id = $find->invoice_id;
        return $exporter->send($invoice_id . '-Invoice.xlsx');
    }

    public function actionDownload($id)
    {
        $model = InvoiceDocument::find()->where(['id' => $id])->one();
        if ($model->document_name != null) {
            $local = yii::getAlias('@webroot/invoicedocuments/invoice-documents/');
            $name = $model->document_name;
            $find = $local . $name;
            if (file_exists($find)) {
                return yii::$app->response->sendFile($find);
            }
        }
    }

    public function actionDuplicate($id)
    {
        $model = new Invoice();
        $data = $this->findModel($id)->attributes;
        $model->setAttributes($data);
        $last_entry = Invoice::find()->count();
        $model->invoice_no = $last_entry + 1;
        $total = Invoice::find()->orderBy(['id' => SORT_DESC])->one();
        $no = $total->id;
        $count = $no + 1;
        $model->invoice_id = $model->prefix . '' . $count . '' . $model->suffix;
        $model->save(false);
        $document = InvoiceDocument::find()->where(['invoice_id' => $id])->all();
        foreach ($document as $value) {
            $doc = new InvoiceDocument();
            $data = $value->attributes;
            $doc->setAttributes($data);
            $doc->invoice_id = $model->id;
            $doc->save(false);
        }
        $products = InvoiceProduct::find()->where(['invoice_id' => $id])->all();

        foreach ($products as $product) {
            $pdt = new InvoiceProduct();
            $data = $product->attributes;
            $pdt->setAttributes($data);
            $pdt->invoice_id = $model->id;
            $pdt->save(false);
        }
        Yii::$app->getSession()->setFlash('success', 'Duplicate Created Successfully');
        return $this->redirect(['invoice/index']);
    }

    public function actionFindcustomerdetails($customerid)
    {
        $customerdetails = Customer::find()->where(['id' => $customerid])->one();
        echo Json::encode($customerdetails);
    }
    public function actionFindexecutivedetails($executivedata)
    {
        $executivedetails = LeadExecutive::find()->where(['name' => $executivedata])->one();
        echo Json::encode($executivedetails);
    }

    public function actionCheckreceipt($receiptid, $customer)
    {
        $customer_detail = Customer::find()->where(['id' => $customer])->one();
        $query = ReceiptDetails::find()->where(['receipt_id' => $receiptid])
            ->andWhere(['customer_name' => $customer_detail->business_name])->one();

        if (Count($query) > 0) {
            echo 'true';
        } else {
            echo 'false';
        }
    }
    public function actionCheckdetails($val)
    {
        $inv_detail = Invoice::find()->where(['invoice_no' => $val])->one();


        if ($inv_detail) {
            echo 'true';
        } else {
            echo 'false';
        }
    }

    public function actionDeleteadjust($id)
    {

        $inv = Invoice::find()->where(['id' => $id])->one();
        $adj_amount_check = InovicesAdjustedAmounts::find()->where(['invoice_id' => $id])->count();
        if ($adj_amount_check) {
            $adj_check = InovicesAdjustedAmounts::find()->where(['invoice_id' => $id])->all();

            foreach ($adj_check as $key => $value) {

                $inv->pending_amount = $inv->pending_amount + $value->amount;
                $inv->save(false);

                $ledgerdetails = AccountingLedger::find()->where(['accounting_ledger_id' => $value->account])->one();

                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = $ledgerdetails->ledger_id;
                $ledger->transaction_type = "Adjusted";
                $ledger->transaction_id = $value->id;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $value->amount;
                $ledger->date = $inv->date;
                $ledger->save(false);

                $findcustomer = Customer::find()->where(['id' => $inv->customer_name])->one();
                $ledger_details = AccountingLedger::find()->where(['ledger_id' => $findcustomer->business_name])->one();
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = $ledger_details->ledger_id;
                $ledger->transaction_type = "Adjusted";
                $ledger->transaction_id = $value->id;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $value->amount;
                $ledger->date = $inv->date;
                $ledger->save(false);
            }

            $adj_delete = InovicesAdjustedAmounts::deleteAll(['invoice_id' => $id]);
        }


        return $this->redirect(['invoice/index']);
    }

    public function actionFindinvoicealldetails($id)
    {
        $all = Invoice::find()->where(['id' => $id])->one();
        echo Json::encode($all);
    }
    public function actionCreateUrl($id)
    {
	ini_set('max_input_vars', '1000000');
        // $ids=Yii::$app->request->post('data');
        $url = Url::to(['printall', 'id' => $id], 'https');
        echo Json::encode($url);
        // print_r($url);

    }
    public function actionFinduseralldetails($id)
    {
        $all = Invoice::find()->where(['id' => $id])->one();
        $userdetails = Customer::find()->where(['id' => $all->customer_name])->one();
        echo Json::encode($userdetails);
    }

    public function actionInvoicesettingsid($setting = null, $template = null)
    {
        //print_r(1);die();
        $find = GenericTemplate::find()->where(['template_for'=>'Invoice'])->andWhere(['gt_id'=>$setting])->count();
        echo Json::encode($find);
    }

    public function actionSelectdate($selected_date=null)
    {   $selected_date=$_GET['selected_date']; 
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
        $dynamic_date_last = ($year - 1) . '-' . '03' . '-' . '31';
        $count_before_year=Invoice::find()->where(['<=', 'date', $dynamic_date])->andWhere(['>', 'date', $dynamic_date_last])->count();
        $count_after_year=Invoice::find()->where(['>', 'date', $dynamic_date])->count();

        if(strtotime($selected_date) <= strtotime($dynamic_date)) { 
            $last_entry=$count_before_year+1;
        }
        else if(strtotime($selected_date) > strtotime($dynamic_date)){
            $last_entry=$count_after_year+1;
        } 
        else{
            $last_entry=0;
        }
        echo $last_entry;
    }



    /**
     * Finds the Invoice model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Invoice the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Invoice::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
