<?php

namespace backend\modules\users\controllers;

use Yii;
use backend\modules\users\models\SaleOrderDocument;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\SaleOrder;
use backend\modules\users\models\SaleOrderSearch;
use backend\modules\master\models\LeadExecutive;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Product;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\users\models\Invoice;
use backend\modules\users\models\InvoiceProduct;
use backend\modules\users\models\LeadsQuotes;
use backend\modules\users\models\LeadsQuotesProduct;
use backend\modules\master\models\PurchaseOrderIndent;
use backend\modules\master\models\PurchaseOrderIndentProduct;
use backend\modules\users\models\ReceivedProductList;
use backend\modules\master\models\AccountingTax;
use backend\modules\master\models\LeadsEnquiry;
// use yii\filters\AccessControl;
use backend\models\UserClient;
use backend\modules\users\models\ProductDelivered;
use backend\modules\users\models\SaleorderAgainstDc;
use common\models\User;
use backend\models\AuthAssignment;
use yii\web\Controller;
use yii\helpers\ArrayHelper;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use Mpdf\Mpdf;
use yii\data\ActiveDataProvider;
use yii2tech\spreadsheet\Spreadsheet;
use yii\web\UploadedFile;
use yii\helpers\Json;
use mdm\admin\components\AccessControl;
use yii\helpers\Url;
/**
 * SaleOrderController implements the CRUD actions for SaleOrder model.
 */
class SaleOrderController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    public static $sales_type=["B2B"=>"B2B",
    "B2C"=>"B2C",
    "EXPORT"=>"EXPORT",
    "ADV PAYMENT" =>"ADV PAYMENT",
    ]
    ;
     public static $supply_types=["Inter-State"=>"Inter-State",
    "Intra-State"=>"Intra-State",
    "Export"=>"Export",
    "Exempted" =>"Exempted",
    ]
    ;
    public static $payment_mode=["Cash"=>"Cash",
    "Cheque"=>"Cheque",
    "Card"=>"Card",
    "Mobile Payments"=>"Mobile Payments",
    ]
    ;
    public static $settings_type=["Invoice Receipt"=>"Invoice Receipt"
    ]
    ;
    public static $banks_name=["Punjab National Bank"=>"Punjab National Bank",
    "Bank of India"=>"Bank of India",
    "State Bank of India"=>"State Bank of India"        
    ]
    ;
    /**
     * Lists all SaleOrder models.
     * @return mixed
     */
    public function actionIndex($id=0)
    {
        Yii::$app->view->params['active']=21;
        $model = new SaleOrder();
        $check_id = Yii::$app->user->identity->id;
        $searchModel = new SaleOrderSearch();
        $product=Product::find()->all();
        $allproduct=ArrayHelper::map($product, 'id', 'product_name');
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        }
        else
        {
            $accessed=LeadExecutive::find()->where(['user_id'=>$check_id])->one();
            if($accessed!='')
            {
              $accessed_id[] = $accessed['type'];
            }
            else
            {
                $loged_user = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
                $accessed_id[] = $loged_user['item_name'];
            }
            $dataProvider = $searchModel->search(Yii::$app->request->queryParams,$accessed_id);
        }
        if($model->load(Yii::$app->request->post())){

                if($model->findid!='')
                {
                  $cancelsaleorder = SaleOrder::find()->where(['id'=>$model->findid])->one();
                  if($cancelsaleorder->order_status=='Pending' && $cancelsaleorder->converted_to=='SaleOrder')
                  {
                        if($model->cancel_reason!='')
                        {
                            $cancelsaleorder->cancel_reason = $model->cancel_reason;
                        }
                        else
                        {
                            $cancelsaleorder->cancel_reason = "No Reason Mentioned";
                        }
                        $cancelsaleorder->is_cancel = 1;
                        $cancelsaleorder->save(false);
                        Yii::$app->getSession()->setFlash('success', 'Successfully Canceled SaleOrder');
                        return $this->redirect(['sale-order/index']);
                  }
                  else
                  {
                        Yii::$app->getSession()->setFlash('error', 'Can not Cancel,Saleorder is already processed');
                        return $this->redirect(['sale-order/index']);
                  }
                }
                elseif ($model->mail_id!='') {
                    if($model->send_email!='')
                    {
			$model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                        $file=$model->email_attachment->baseName;
                        $model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                        $model->email_attachment=$file.'.'.$model->email_attachment->extension;
			
                        $message = Yii::$app->mailer->compose()
                       ->setFrom([trim('mohasyn.bbsr@gmail.com')=>"Mohapatra scientific"])
                       ->setTo(trim($model->send_email))
                       ->setSubject($model->email_subject)
                       ->setHtmlBody(nl2br($model->email_message))
                       ->attach(Yii::getAlias('@backend').'/web/email-assets/'.$model->email_attachment);
                         if(!empty($model->cc_to_email!="")){
                            $message->setBcc(trim($model->bcc_to_email));
                           }   
                         if(!empty($model->bcc_to_email!="")){
                            $message->setBcc(trim($model->bcc_to_email));
                           }      
                         Yii::$app->mailer->send($message); 
			 unlink(Yii::$app->basePath . '/web/email-assets/' . $model->email_attachment);
                         Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                             return $this->redirect(['sale-order/index']);
                    }
                    else
                    {
                        Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                         return $this->redirect(['sale-order/index']);
                    } 
                }
                else
                {
                  if($user_type->item_name == 'Admin')
                    {
                        $query=SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
                    }
                    else
                    {   
                        $all = SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all(); 
                        $exe_array= [];
                         $i=0;
                        foreach ($all as $key => $val) {
                            $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive_id']])->one();
                            if($executivedetails!='')
                            {
                               if($executivedetails->type == $accessed_id[0]) 
                                  $exe_array[$i] = $executivedetails->id;
                                $i++;

                            }
                        }
                        $exe_array = array_unique($exe_array);
                        $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
                        $customer_ids = [];
                        $j = 0;
                        foreach($customers as $data)
                        {
                            $customer_ids[$j] = $data->client_id;
                            $j++;
                        }
                        $query = SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_id', $customer_ids])->andWhere(['in', 'executive_id', $exe_array])->orderBy(['id' => SORT_DESC]);

                    }
                  $query->andFilterWhere(['in', 'sale_order', $model->sale_order])
                   ->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])
                   ->andFilterWhere(['in', 'customer_id', $model->customer])
                   ->andFilterWhere(['in', 'executive_id', $model->executives_name])
                   ->andFilterWhere(['in', 'total_amount', $model->sale_total_amount])
                   ->andFilterWhere(['like', 'delivery_date', $model->delv_date])
                   ->andFilterWhere(['in', 'order_status', $model->saleorder_status]);
                   if($model->searchproduct){
                      $productlists=SaleOrderProduct::find()->where(['product_id'=>$model->searchproduct,'is_deleted'=>0])->groupBy(['sale_order_no'])->all();
                      $productid=ArrayHelper::map($productlists, 'sale_order_no','sale_order_no');
                      $query->andFilterWhere(['in', 'id', $productid]) ; 
                   }
                   $dataProvider = new ActiveDataProvider(['query' => $query]);
                }
          }


	//GET function


	if($model->load(Yii::$app->request->get())){

                if($model->findid!='')
                {
                  $cancelsaleorder = SaleOrder::find()->where(['id'=>$model->findid])->one();
                  if($cancelsaleorder->order_status=='Pending' && $cancelsaleorder->converted_to=='SaleOrder')
                  {
                        if($model->cancel_reason!='')
                        {
                            $cancelsaleorder->cancel_reason = $model->cancel_reason;
                        }
                        else
                        {
                            $cancelsaleorder->cancel_reason = "No Reason Mentioned";
                        }
                        $cancelsaleorder->is_cancel = 1;
                        $cancelsaleorder->save(false);
                        Yii::$app->getSession()->setFlash('success', 'Successfully Canceled SaleOrder');
                        return $this->redirect(['sale-order/index']);
                  }
                  else
                  {
                        Yii::$app->getSession()->setFlash('error', 'Can not Cancel,Saleorder is already processed');
                        return $this->redirect(['sale-order/index']);
                  }
                }
                elseif ($model->mail_id!='') {
                    if($model->send_email!='')
                    {
			$model->email_attachment=UploadedFile::getInstance($model,'email_attachment');
                        $file=$model->email_attachment->baseName;
                        $model->email_attachment->saveAs('email-assets/'.$file.'.'.$model->email_attachment->extension);
                        $model->email_attachment=$file.'.'.$model->email_attachment->extension;
			
                        $message = Yii::$app->mailer->compose()
                       ->setFrom([trim('mohasyn.bbsr@gmail.com')=>"Mohapatra scientific"])
                       ->setTo(trim($model->send_email))
                       ->setSubject($model->email_subject)
                       ->setHtmlBody(nl2br($model->email_message))
                       ->attach(Yii::getAlias('@backend').'/web/email-assets/'.$model->email_attachment);
                         if(!empty($model->cc_to_email!="")){
                            $message->setBcc(trim($model->bcc_to_email));
                           }   
                         if(!empty($model->bcc_to_email!="")){
                            $message->setBcc(trim($model->bcc_to_email));
                           }      
                         Yii::$app->mailer->send($message); 
			 unlink(Yii::$app->basePath . '/web/email-assets/' . $model->email_attachment);
                         Yii::$app->getSession()->setFlash('success', 'Mail send Successfully.');
                             return $this->redirect(['sale-order/index']);
                    }
                    else
                    {
                        Yii::$app->getSession()->setFlash('error', 'Mail To can not be blank.');
                         return $this->redirect(['sale-order/index']);
                    } 
                }
                else
                {
                  if($user_type->item_name == 'Admin')
                    {
                        $query=SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
                    }
                    else
                    {   
                        $all = SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all(); 
                        $exe_array= [];
                         $i=0;
                        foreach ($all as $key => $val) {
                            $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive_id']])->one();
                            if($executivedetails!='')
                            {
                               if($executivedetails->type == $accessed_id[0]) 
                                  $exe_array[$i] = $executivedetails->id;
                                $i++;

                            }
                        }
                        $exe_array = array_unique($exe_array);
                        $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
                        $customer_ids = [];
                        $j = 0;
                        foreach($customers as $data)
                        {
                            $customer_ids[$j] = $data->client_id;
                            $j++;
                        }
                        $query = SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_id', $customer_ids])->andWhere(['in', 'executive_id', $exe_array])->orderBy(['id' => SORT_DESC]);

                    }
                  $query->andFilterWhere(['in', 'sale_order', $model->sale_order])
                   ->andFilterWhere(['between', 'date', $model->from_date,$model->to_date])
                   ->andFilterWhere(['in', 'customer_id', $model->customer])
                   ->andFilterWhere(['in', 'executive_id', $model->executives_name])
                   ->andFilterWhere(['in', 'total_amount', $model->sale_total_amount])
                   ->andFilterWhere(['like', 'delivery_date', $model->delv_date])
                   ->andFilterWhere(['in', 'order_status', $model->saleorder_status]);
                   if($model->searchproduct){
                      $productlists=SaleOrderProduct::find()->where(['product_id'=>$model->searchproduct,'is_deleted'=>0])->groupBy(['sale_order_no'])->all();
                      $productid=ArrayHelper::map($productlists, 'sale_order_no','sale_order_no');
                      $query->andFilterWhere(['in', 'id', $productid]) ; 
                   }
                   $dataProvider = new ActiveDataProvider(['query' => $query]);
                }
          }



        return $this->render('index', [
            'model' => $model,  
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'allproduct' => $allproduct,
        ]);
    }

    /**
     * Displays a single SaleOrder model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id,$from=null)
    {
        Yii::$app->view->params['active']=21;


        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = SaleOrder::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_id])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['sale-order/index']);
            }
        }

        
        $sale = SaleOrder::find()->where(['id'=>$id])->one();
        $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        $find = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        $tax_amount= SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        
        $taxable_amount = 0;
        foreach ($tax_amount as $tax_amount) {
          if($tax_amount->discount_type=="FLAT")
          {
              $taxable_amount = $taxable_amount+($tax_amount->price - $tax_amount->discount);
          }
          if($tax_amount->discount_type=="%")
          {
              $taxable_amount = $taxable_amount+($tax_amount->price - (($tax_amount->price * $tax_amount->discount)/100));
          }
          if($tax_amount->discount_type=="")
          {
             $taxable_amount = $taxable_amount+$tax_amount->price;
          }
         }
         $tax_tot = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
         $total_tax = 0;

         foreach ($tax_tot as $tax_tot) {
          if($tax_tot->tax_included==1)
          {
              if($tax_tot->discount_type=="FLAT")
              {
                //    $total_tax = $total_tax+((($tax_tot->price - $tax_tot->discount)*$tax_tot->tax)/100);
              }
              if($tax_tot->discount_type=="%")
              {
                   // $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100))

                //    $total_tax = $total_tax+(($tax_tot->price - (($tax_tot->price * $tax_tot->discount)/100))*$tax_tot->tax)/100;
              }
              if($tax_tot->discount_type=="")
              {
                //    $total_tax = $total_tax+(($tax_tot->price*$tax_tot->tax)/100);
              }
          }
          
         }

         $tax_rate = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
         $inter_state_tax = 0;
         foreach ($tax_rate as $tax_rate) {
          if($tax_rate->tax_included==1)
          {
              if($tax_rate->discount_type=="FLAT")
              {
                //    $inter_state_tax = $inter_state_tax+((($tax_rate->price - $tax_rate->discount)*(($tax_rate->tax)/2))/100);
              }
              if($tax_rate->discount_type=="%")
              {
                //    $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100));

                //    $inter_state_tax = $inter_state_tax+((($tax_rate->price - (($tax_rate->price * $tax_rate->discount)/100))*(($tax_rate->tax)/2))/100);
              }
              if($tax_rate->discount_type=="")
              {
                //    $inter_state_tax = $inter_state_tax+(($tax_rate->price*(($tax_rate->tax)/2))/100);
              }
          }
         }
         $receipt=ReceiptDetails::find()->where(['receipt_id'=>$sale->receipt_id])->one();
        $total_product = 0;
        foreach ($find as $find) {
          $total_product = $total_product+ $find->quantity;
          # code...
        }
        return $this->render('view', [
            'model' => $this->findModel($id),
            'products'=>$products,
            'total_product' => $total_product,
            'taxable_amount' => $taxable_amount,
            'total_tax' =>$total_tax,
            'receipt' =>$receipt,
            'inter_state_tax' => $inter_state_tax,
            'from'=>$from,
        ]);
    }

    /**
     * Creates a new SaleOrder model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate($id=null,$from=null)
    {
        Yii::$app->view->params['active']=21;
        $model = new SaleOrder();
        $product = new Product();
        // $indenttotalamount =0;
        // $indentsubtotalamount =0;
        $avl_amount = 0;
        $saleorderdocument = new SaleOrderDocument();
        $saleorderproduct = new SaleOrderProduct();
        $saleproduct = new SaleOrderProduct();
        $total_quantity =0;
        $avl_amount = 0;

        if($id)
        {
          if($from=='leads-quotes')
          {
            $statuscheck = SaleOrder::find()->where(['lead_quote_id'=>$id,'is_deleted'=>0])->one();
            if($statuscheck)
            {
                Yii::$app->getSession()->setFlash('success', 'SaleOrder for this Lead Quote already exist.');
                return $this->redirect(['leads-quotes/index']);
            }
            else
            {
                $leadsdata= LeadsQuotes::find()->where(['id' =>$id])->one(); 
                // $model->setAttributes($leadsdata->attributes);
                $model->customer_id= $leadsdata->customer;
                $model->executive_id= $leadsdata->executive;
                $model->sale_type = $leadsdata->sales_type;
                $model->note = $leadsdata->notes;
                $model->supply_type = $leadsdata->supply_type;
                $model->receiver = $leadsdata->receiver_gstn;
                $model->reverse_charge = $leadsdata->supply_attracts_rcharge;
                $model->price_list =$leadsdata->pricelist;
                $model->point_of_supply= $leadsdata->pointof_supply;
                $model->is_invoice_paid_provisional =$leadsdata->Is_tax_paid;
                $model->sub_total_amount = $leadsdata->sub_total_amount;
                $model->total_amount = $leadsdata->total_amount;
                $model->note = $leadsdata->notes;
                $model->terms = $leadsdata->terms;
                $model->lead_quote_id=$id;
                $model->is_tcs = $leadsdata->is_tcs;
                $payment_mode = Customer::find()->where(['id' =>$leadsdata->customer])->one();
                if($payment_mode->credit_terms!='')
                {
                    $model->terms_of_payment = $payment_mode->credit_terms;
                }
                $saleorderproduct = LeadsQuotesProduct::find()->where(['leads_quotes_id'=>$id])->all();
            }
              
          } 
          if($from=='saleorder')
          {
            $data = $this->findModel($id)->attributes;
            $model->setAttributes($data);
            $saleorderproduct = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
          }

          if($from == 'leads-enquiry')
          {
             $enquiry_details = LeadsEnquiry::find()->where(['id'=>$id])->one();
             $find_cunstomer = Customer::find()->where(['business_name'=>$enquiry_details->name])->one();
             if($find_cunstomer=='')
             {
                Yii::$app->getSession()->setFlash('error', 'First create a customer then try again.');
                return $this->redirect(['/master/leads-enquiry/index']);
             }
             else
             {
                $model->customer_id = $find_cunstomer->id;
                $saleorderproduct = Array();
             }
          }
        }

        $data=Yii::$app->request->post(); 
       
        $selected_date=date('Y-m-d');
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
            if(strtotime($selected_date) <= strtotime($dynamic_date))
            {
                $last_entry=SaleOrder::find()->where(['<=', 'date', $dynamic_date])->count();
              
               
            }
            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                $last_entry=SaleOrder::find()->where(['>=', 'date', $dynamic_date])->count();
                
            }
            else{
                $last_entry=0;
            }


            // if(SaleOrder::find()->count() > 0) { 
            //     $total=SaleOrder::find()->orderBy(['id' => SORT_DESC])->one();
            //     $count=$total->id;  
            // }
            // else{
            //     $count=0;
            // } 
      

        $receipt= new ReceiptDetails();
        if ($model->load(Yii::$app->request->post()) && $saleorderdocument->load(Yii::$app->request->post()) ) {
            $model->sale_order_id = $model->prefix.''.$model->sale_order.''.$model->suffix;
           
        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$model->customer_id])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['sale-order/index']);
            }
        }


         $model->round_off=Yii::$app->request->post('roundoffval');

          $model->created_by=Yii::$app->user->identity->id;
          
          $model->created_at=date('Y-m-d H:i:s');
          $model->updated_at=date('Y-m-d H:i:s');

          if($from=='leads-quotes')
          {
            $leadsdata->converted_to = 'Sales Order';
            $leadsdata->status = 'Processing Quotes';
            $leadsdata->save(false);
          }
          if($from =='leads-enquiry')
          {
            $enquiry = LeadsEnquiry::find()->where(['id'=>$id])->one();
            $enquiry->converted_to = "Sale Order";
            $enquiry->save(false);
          }
            $model->created_by = Yii::$app->user->identity->id;
            //  $sale_id= $last_entry+1;
            //  $model->sale_order_id = $model->prefix.''.$sale_id.''.$model->suffix;

              $model->converted_to = 'SaleOrder';
              if($model->advance_payment == 'Advance payment for this Sales Order' || $model->advance_payment == 'Matched Receipt'){
                    if($model->total_amount == $model->receipt_total_amount && $model->advance_payment == 'Advance payment for this Sales Order')
                    {
                      $model->order_status = "Paid";
                    } 
                    else if($model->advance_payment == 'Advance payment for this Sales Order')
                    {
                      $model->order_status = "Partially Paid";
                    }
                    else if ($model->advance_payment == 'Matched Receipt' )
                    {
                      $receipt_data = ReceiptDetails::find()->where(['receipt_id'=>$model->receipt_id])->one();
                      if($model->total_amount == $receipt_data->total_amount)
                      {
                         $model->order_status = 'Paid';
                      }
                      else
                      {
                          $model->order_status = "Partially Paid";
                      }
                    }
              }
              else{$model->order_status = 'Pending';} 
              $model->saleorder_source ='Created Manually';
              if($model->advance_payment=='Advance payment for this Sales Order')
              {
                $model->receipt_id = '';
              }
              if($model->point_of_supply==21)
              {
                $model->igst_amount = 0;
              }
              if($model->point_of_supply!=21)
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
              }
              if($model->point_of_supply=='')
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
                $model->igst_amount=0;
              }
              if($model->advance_payment=='Matched Receipt')
              {
                $model->receipt_setting_type='';
                $model->receipt_total_amount='';
                $model->receipt_bank='';
                $model->receipt_cheque_no='';
                $model->receipt_cheque_date='';
                $model->advance_note='';
              }
              if($model->advance_payment=='None')
              {
                $model->receipt_setting_type='';
                $model->receipt_total_amount='';
                $model->receipt_bank='';
                $model->receipt_cheque_no='';
                $model->receipt_cheque_date='';
                $model->advance_note='';
                $model->receipt_id = '';
              }
              $model->paid_amount = 0;
              $model->dc_status = 0;
              $model->save(false);
              if(isset($data['productdyn'])){
                foreach ($data['productdyn'] as $value) {
                if($value['price']!='')
                {
                    $product = new SaleOrderProduct();
                    $product->product_id = $value['product'];
                    $product->description = $value['desc'];
                    $product->quantity = $value['quantity'];
                    $product->units = $value['units'];
                    $product->price = $value['price'];
                    $product->unit_price = $value['unitprice'];
                    $product->discount = $value['discount'];
                    $product->tax=$value['tax'];
                    $product->discount_type=$value['discounttype'];
                    $product->tax_included = $value['tax_included'];
                    $product->amount = $value['amount'];
                    $product->sale_order_no = $model->id;
                    $product->created_at=date('Y-m-d H:i:s');
                    $product->updated_at=date('Y-m-d H:i:s');

                    $avilableproduct = Product::find()->where(['id'=>$product->product_id])->one();
                      $avlunits = $avilableproduct->stock_unit;

                      $total_quantity = $total_quantity + $product->quantity;
                      if($avilableproduct->stock_unit >= $product->quantity)
                      {
                        
                        $avl_amount = $avl_amount + $product->quantity;
                      }
                      else if($avilableproduct->stock_unit <= 0)
                      {
                        

                        $avl_amount = $avl_amount + 0;
                      }
                      else if($avilableproduct->stock_unit < $product->quantity && $avilableproduct->stock_unit>0)
                      {
                        
                        $avl_amount = $avl_amount + $avilableproduct->stock_unit;
                      }


                      if($avilableproduct->stock_unit < $product->quantity)
                      {
                          $last_purchase_indent=PurchaseOrderIndent::find()->orderby(['id' => SORT_DESC])->one();
                          $indentmodel = new PurchaseOrderIndent();
                          $product_name = Product::find()->where(['id'=>$product->product_id])->one();
                          // $purchaseindentproduct = new PurchaseOrderIndentProduct();
                          $indentmodel->subject = $product_name->product_name."(".$product->description.")";
                          $indentmodel->date = date('Y-m-d H:i:s');
                          $indentmodel->source='SaleOrder';
                          
                          $indentmodel->sub_total_amount = 0;
                          $indentmodel->save(false);

                          $purchase_order_product = new PurchaseOrderIndentProduct();
                          $purchase_order_product->product_id = $product->product_id;
                          $purchase_order_product->description = $product->description;
                          $purchase_order_product->quantity = 0;
                          // if($avilableproduct->stock_unit<0)
                          // {
                          //   $purchase_order_product->quantity =  $product->quantity;
                          // }
                          // else
                          // {
                          //   $purchase_order_product->quantity =$avilableproduct->stock_unit - $product->quantity; 
                          // } 
                          // if($purchase_order_product->quantity<0)
                          // {
                          //   $purchase_order_product->quantity = abs($purchase_order_product->quantity);
                          // }
                          
                          $purchase_order_product->units = $product->units;
                          $purchase_order_product->unit_price = $avilableproduct->bying_price;
                          $purchase_order_product->price = $avilableproduct->bying_price;
                          $purchase_order_product->amount = 0;
                          $purchase_order_product->tax = $product->tax;
                          $purchase_order_product->purchase_order_indent_id = $indentmodel->id;
                          $purchase_order_product->save(false);
                          $indentmodel->total_amount = 0;
                          $indentmodel->save(false);
                      }
                      $avilableproduct->stock_unit = $avilableproduct->stock_unit - $product->quantity;
                      $avilableproduct->save(false);
                    $product->save(false);
                    }
                }
                
            }


                if(isset($data['productdynupdate'])){
                foreach ($data['productdynupdate'] as $value) {
                    if($value['price']!='')
                    {
                        $purchase_order = new SaleOrderProduct();
                        $purchase_order->product_id = $value['product'];
                        $purchase_order->description = $value['desc'];
                        $purchase_order->quantity = $value['quantity'];
                        $purchase_order->units = $value['units'];
                        $purchase_order->price = $value['price'];
                        $purchase_order->unit_price = $value['unitprice'];
                        $purchase_order->discount = $value['discount'];
                        $purchase_order->tax=$value['tax'];
                        $purchase_order->discount_type=$value['discounttype'];
                        $purchase_order->tax_included = $value['tax_included'];
                        $purchase_order->amount = $value['amount'];
                        $purchase_order->sale_order_no = $model->id;
                        $purchase_order->created_at=date('Y-m-d H:i:s');
                        $purchase_order->updated_at=date('Y-m-d H:i:s');
                        $purchase_order->save(false);
                    }
                  }
                }

                if($from=='saleorder')
            {
                $sale_pro = SaleOrderProduct::find()->where(['sale_order_no'=>$model->id])->all();
                foreach ($sale_pro as  $product) {

                      $avilableproduct = Product::find()->where(['id'=>$product->product_id])->one();
                      $avlunits = $avilableproduct->stock_unit;
                      $total_quantity = $total_quantity + $product->quantity;
                      if($avilableproduct->stock_unit >= $product->quantity)
                      {
                        
                        $avl_amount = $avl_amount + $product->quantity;
                      }
                      else if($avilableproduct->stock_unit <= 0)
                      {
                        

                        $avl_amount = $avl_amount + 0;
                      }
                      else if($avilableproduct->stock_unit < $product->quantity && $avilableproduct->stock_unit>0)
                      {
                        
                        $avl_amount = $avl_amount + $avilableproduct->stock_unit;
                      }
            

                      if($avilableproduct->stock_unit < $product->quantity)
                      {
                          $last_purchase_indent=PurchaseOrderIndent::find()->orderby(['id' => SORT_DESC])->one();
                          $indentmodel = new PurchaseOrderIndent();
                          $product_name = Product::find()->where(['id'=>$product->product_id])->one();
                          // $purchaseindentproduct = new PurchaseOrderIndentProduct();
                          $indentmodel->subject = $product_name->product_name."(".$product->description.")";
                          $indentmodel->date = date('Y-m-d H:i:s');
                          $indentmodel->source='SaleOrder';
                          
                          $indentmodel->sub_total_amount = 0;
                          $indentmodel->save(false);

                          $purchase_order_product = new PurchaseOrderIndentProduct();
                          $purchase_order_product->product_id = $product->product_id;
                          $purchase_order_product->description = $product->description;
                          $purchase_order_product->quantity = 0;
                          // if($avilableproduct->stock_unit<0)
                          // {
                          //   $purchase_order_product->quantity =  $product->quantity;
                          // }
                          // else
                          // {
                          //   $purchase_order_product->quantity =$avilableproduct->stock_unit - $product->quantity; 
                          // } 
                          // if($purchase_order_product->quantity<0)
                          // {
                          //   $purchase_order_product->quantity = abs($purchase_order_product->quantity);
                          // }
                          
                          $purchase_order_product->units = $product->units;
                          $purchase_order_product->unit_price = $avilableproduct->bying_price;
                          $purchase_order_product->price = $avilableproduct->bying_price;
                          $purchase_order_product->amount = 0;
                          $purchase_order_product->tax = $product->tax;
                          $purchase_order_product->purchase_order_indent_id = $indentmodel->id;
                          $purchase_order_product->save(false);
                          $indentmodel->total_amount = 0;
                          $indentmodel->save(false);
                      }
                      $avilableproduct->stock_unit = $avilableproduct->stock_unit - $product->quantity;
                      $avilableproduct->save(false);
                    // code...
                }
            }

             if($total_quantity == $avl_amount)
            {
                print_r('1');
                $model->avl_status = "Available";
                $model->save(false);
            }
            else if($total_quantity > $avl_amount && $avl_amount>0)
            {
                print_r('2');
                $model->avl_status = "Partially Avail.";
                $model->save(false);
            }
            else if($avl_amount<=0)
            {
                print_r('3');
                $model->avl_status = "Not Avilable";
                $model->save(false);
            }

              if($model->receipt_total_amount!='' && $model->receipt_setting_type!='' && $model->advance_payment='Advance payment for this Sales Order') 
              {
                    //  if(ReceiptDetails::find()->count() > 0) { 
                    // $total=ReceiptDetails::find()->orderBy(['id' => SORT_DESC])->one();
                    // $count=$total->id;  
                    // }
                    // else{
                    //     $count=0;
                    // }
                    // $receipt->receipt_no=$count+1;
                    $receipt->prefix='SR';

                    $selected_date=$model->receipt_cheque_date;
                    $year=date("Y"); 
                    $dynamic_date=$year.'-'.'03'.'-'.'31';
                        if(strtotime($selected_date) <= strtotime($dynamic_date))
                        {
                            $last_entry=ReceiptDetails::find()->where(['<=', 'receipt_date', $dynamic_date])->count();
                            $receipt->receipt_no=$last_entry+1;
                            $dt = (date('Y', strtotime('-1 year'))).'-'.(date('y', strtotime('+0 year')));
                        }
                            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                            $last_entry=ReceiptDetails::find()->where(['>=', 'receipt_date', $dynamic_date])->count();
                            $receipt->receipt_no=$last_entry+1;
                            $dt = (date('Y', strtotime('+0 year'))).'-'.(date('y', strtotime('+1 year')));
                        }
                        else{
                            $receipt->receipt_no=1;
                        }
                    $receipt->receipt_id = 'SR' . '' .  $receipt->receipt_no . '/'. $dt. '';
                    $receipt->suffix = '/'.$dt;




                    // $receipt->receipt_id = $receipt->prefix.''.$receipt->receipt_no.''.$receipt->suffix;
                   //$name=Customer::find()->where(['id'=>$model->customer_id])->one();
                    $receipt->customer_name = $model->customer_id;
                    $type=Customer::find()->where(['id'=>$receipt->customer_name])->one();
                    $type->opening_as_on = ($type->opening_as_on) + ($model->receipt_total_amount);
                    $type->save(false);
                    $receipt->setting_type=$model->receipt_setting_type;
                    $receipt->amount=$model->receipt_total_amount;
                    $receipt->total_amount=$model->receipt_total_amount;
                    $receipt->bank_name=$model->receipt_bank;
                    $receipt->customer_type=$type->customer_type;
                    $receipt->payment_mode='Cheque';
                    $receipt->payment_type='Advance against invoice';
                    $receipt->cheque_no=$model->receipt_cheque_no;
                    $receipt->cheque_date=$model->receipt_cheque_date; 
                    $receipt->tds_amount=0;
                    $receipt->invoice_no=0;
                    $receipt->sale_order_no = $model->id;
                    $receipt->notes=$model->advance_note;
                    $receipt->receipt_date=date('Y-m-d H:i:s');
                    $receipt->created_at=date('Y-m-d H:i:s');
                    $receipt->updated_at=date('Y-m-d H:i:s');
                    $receipt->save(false);
              }   
                 if($saleorderdocument->validate())
                 {
                    $names=UploadedFile::getInstances($saleorderdocument,'document_name');
                    foreach ($names as $name) {
                        // $document->document_name->saveAs('setting/product_documents_images/' .$nameimage.'.'.$document->document_name->extension);
                        $path='saleorder_documents/'.$name->baseName.'.'.$name->extension;
                        if($name->saveAs($path))
                        {
                            $filename = $name->baseName.'.'.$name->extension;
                            $filepath = $path;
                            yii::$app->db->createCommand()->insert('sale_order_document',['document_name'=>$filename,'sale_order_id'=>$model->id])->execute();
                        }
                        
                    }

                 }
                 if (Yii::$app->request->post('save') == 0) {
                         Yii::$app->getSession()->setFlash('success', 'Successfully Created New SaleOrder');
                         return $this->redirect(['sale-order/index']);
                  }

                if (Yii::$app->request->post('save') == 1) {
                       Yii::$app->getSession()->setFlash('success', 'Successfully Created New SaleOrder');
                return $this->redirect(['sale-order/create']);
                  }
                               
        }
        return $this->render('create', [
            'model' => $model,
            'sales_type' => SaleOrderController::$sales_type,
            'supply_types' => SaleOrderController::$supply_types,
            //'count' => $count,
            'product' => $product,
            'saleorderdocument' => $saleorderdocument,
            'saleorderproduct' => $saleorderproduct,
            'payment_mode'=> SaleOrderController::$payment_mode,
            'settings_type'=> SaleOrderController::$settings_type,
            'banks_name'=> SaleOrderController::$banks_name,
            'receipt' => $receipt,
            'last_entry'=>$last_entry+1,
            'from' => $from,
            'saleproduct' => $saleproduct,

        ]);
    }

    public function actionFindproduct($productid)
    {
        $productdetails= Product::find()->where(['id' =>$productid])->one();
        echo Json::encode($productdetails);
    }
   public function actionProductdetails($searchTerm=null)
    {   
        if(!$searchTerm)
        $product=Product::find()->limit(10)->all();
        else
        $product=Product::find()->where(["like","product_name",$searchTerm])->limit(10)->all();

        $productlist=ArrayHelper::map($product, 'id', 'product_name');
        return json_encode($productlist);
    }
     public function actionCustomerdetails($searchTerm=null)
    {   
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        if($user_type->item_name == 'Admin')
        {
            if(!$searchTerm)
            $customer=Customer::find()->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist);
        }
        else
        {
            $customer_ids = [];
            $i =0;

            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            foreach($customers as $data)
            {
                $customer_ids[$i] = $data->client_id;
                $i++;
            }
            if(!$searchTerm)
            $customer=Customer::find()->where(['in','id',$customer_ids])->limit(10)->all();
            else
            $customer=Customer::find()->where(["like","business_name",$searchTerm])->andWhere(['in','id',$customer_ids])->limit(10)->all();

            $customerlist=ArrayHelper::map($customer, 'id', 'business_name');
            return json_encode($customerlist); 
        }
        
    }
    public function actionFinddetails()
    { 
        $taxdetails= Accountingtax::find()->select(['tax_name','accounting_tax_id'])->where(['is_deleted'=>0])
              ->andWhere(['tax_sub_type'=>'Output'])
              ->andWhere(['status'=>1])
              ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])->all();      
        $taxlist=ArrayHelper::map($taxdetails, 'accounting_tax_id','tax_name');
        return Json::encode($taxlist);
    }
    /**
     * Updates an existing SaleOrder model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {

//	ini_set('post_max_size', '10000M');
	ini_set('max_input_vars', '1000000');
/*	$inipath = php_ini_loaded_file();

if ($inipath) {
    echo 'Loaded php.ini: ' . $inipath;
} else {
    echo 'A php.ini file is not loaded';
}die(); */
        Yii::$app->view->params['active']=21;
        $checkinvoice = Invoice::find()->where(['sale_order_id'=>$id])->count();
        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        $data=Yii::$app->request->post(); 
        $selected_date=date('Y-m-d');
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
            if(strtotime($selected_date) <= strtotime($dynamic_date))
            {
                $last_entry=SaleOrder::find()->where(['<=', 'date', $dynamic_date])->count();
            }
            elseif(strtotime($selected_date) > strtotime($dynamic_date)){
                $last_entry=SaleOrder::find()->where(['>=', 'date', $dynamic_date])->count();
            }
            else{
                $last_entry=0;
            }

            // if(SaleOrder::find()->count() > 0) { 
            //     $total=SaleOrder::find()->orderBy(['id' => SORT_DESC])->one();
            //     $count=$total->id;  
            // }
            // else{
            //     $count=0;
            // } 


        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = SaleOrder::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_id])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['sale-order/index']);
            }
        }

        if($checkinvoice)
        {
            Yii::$app->getSession()->setFlash('success', 'Can not edit,Invoice already exist for this Sale order');
            return $this->redirect(['sale-order/index']);
        }
        $data=Yii::$app->request->post();
        $model = $this->findModel($id);
        $product = new Product();
        $saleorderdocument = new SaleOrderDocument();
        $saleorderproduct = new SaleOrderProduct();
        $receipt= new ReceiptDetails();
        $last_entry=SaleOrder::find()->count();
        $saleproducts =SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        $number = count($saleproducts);
        if ($model->load(Yii::$app->request->post()) || $saleorderdocument->load(Yii::$app->request->post())) {
	//echo '<pre>';
	//print_r($data['productdynupdate']);
	//die();	
            $model->round_off=Yii::$app->request->post('roundoffval');
            $model->created_by = Yii::$app->user->identity->id;

            if($model->advance_payment == 'Advance payment for this Sales Order' || $model->advance_payment == 'Matched Receipt'){
                    if($model->total_amount == $model->receipt_total_amount && $model->advance_payment == 'Advance payment for this Sales Order')
                    {
                      $model->order_status = "Paid";
                    } 
                    else if($model->advance_payment == 'Advance payment for this Sales Order')
                    {
                      $model->order_status = "Partially Paid";
                    }
                    else if ($model->advance_payment == 'Matched Receipt' )
                    {
                      $receipt_data = ReceiptDetails::find()->where(['receipt_id'=>$model->receipt_id])->one();
                      if($model->total_amount == $receipt_data->total_amount)
                      {
                         $model->order_status = 'Paid';
                      }
                      else
                      {
                          $model->order_status = "Partially Paid";
                      }
                    }
              }
              else{$model->order_status = 'Pending';}  
              if($model->advance_payment=='Advance payment for this Sales Order')
              {
                $model->receipt_id = '';
              }
              if($model->point_of_supply==21)
              {
                $model->igst_amount = 0;
              }
              if($model->point_of_supply!=21)
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
              }
              if($model->point_of_supply=='')
              {
                $model->cgst_amount=0;
                $model->sgst_amount=0;
                $model->igst_amount=0;
              }
              if($model->advance_payment=='Matched Receipt')
              {
                $model->receipt_setting_type='';
                $model->receipt_total_amount='';
                $model->receipt_bank='';
                $model->receipt_cheque_no='';
                $model->receipt_cheque_date='';
                $model->advance_note='';
              }
              if($model->advance_payment=='None')
              {
                $model->receipt_setting_type='';
                $model->receipt_total_amount='';
                $model->receipt_bank='';
                $model->receipt_cheque_no='';
                $model->receipt_cheque_date='';
                $model->advance_note='';
                $model->receipt_id = '';
              }
           $model->save(false);
          $purchase_order_product_delete=SaleOrderProduct::deleteAll(['sale_order_no'=>$id]);


	if(isset($data['productdynupdate'])){
          
            foreach ($data['productdynupdate'] as $value) {
                if($value['price']!='')
                {
                    $purchase_order = new SaleOrderProduct();
                    $purchase_order->product_id = $value['product'];
                    $purchase_order->description = $value['desc'];
                    $purchase_order->quantity = $value['quantity'];
                    $purchase_order->units = $value['units'];
                    $purchase_order->price = $value['price'];
                    $purchase_order->unit_price = $value['unitprice'];
                    $purchase_order->discount = $value['discount'];
                    $purchase_order->tax=$value['tax'];
                    $purchase_order->discount_type=$value['discounttype'];
                    $purchase_order->tax_included = $value['tax_included'];
                    $purchase_order->amount = $value['amount'];
                    $purchase_order->sale_order_no = $model->id;
                    $purchase_order->created_at=date('Y-m-d H:i:s');
                    $purchase_order->updated_at=date('Y-m-d H:i:s');

                    $purchase_order->save(false);
                }
            }
        }


            if(isset($data['productdyn'])){
            foreach ($data['productdyn'] as $value) {
                if($value['price']!='')
                {
                        $product = new SaleOrderProduct();
                        $product->product_id = $value['product'];
                        $product->description = $value['desc'];
                        $product->quantity = $value['quantity'];
                        $product->units = $value['units'];
                        $product->price = $value['price'];
                        $product->unit_price = $value['unitprice'];
                        $product->discount = $value['discount'];
                        $product->tax=$value['tax'];
                        $product->discount_type=$value['discounttype'];
                        $product->tax_included = $value['tax_included'];
                        $product->amount = $value['amount'];
                        $product->sale_order_no = $model->id;
                        $product->created_at=date('Y-m-d H:i:s');
                        $product->updated_at=date('Y-m-d H:i:s');
                        $product->save(false);
                }
            }
         }

              if($model->receipt_total_amount!='' && $model->receipt_setting_type!='' && $model->advance_payment='Advance payment for this Sales Order') 
              {
                $check_receipt=ReceiptDetails::find()->where(['sale_order_no'=>$model->id])->one();
                if($check_receipt==null)
                {
                    if(ReceiptDetails::find()->count() > 0) { 
                    $total=ReceiptDetails::find()->orderBy(['id' => SORT_DESC])->one();
                    $count=$total->id;  
                    }
                    else{
                        $count=0;
                    }
                    $receipt->receipt_no=$count+1;
                    $receipt->prefix='SR';
                    $receipt->suffix='';
                    $receipt->receipt_id = $receipt->prefix.''.$receipt->receipt_no.''.$receipt->suffix;
                    $name=Customer::find()->where(['id'=>$model->customer_id])->one();
                    $receipt->customer_name = $name->business_name;
                    $type=Customer::find()->where(['business_name'=>$receipt->customer_name])->one();
                    // print_r($type->customer_type);
                    // exit();
                    $receipt->setting_type=$model->receipt_setting_type;
                    $receipt->amount=$model->receipt_total_amount;
                    $receipt->total_amount=$model->receipt_total_amount;
                    $receipt->bank_name=$model->receipt_bank;
                    $receipt->customer_type=$type->customer_type;
                    $receipt->payment_mode='Cheque';
                    $receipt->cheque_no=$model->receipt_cheque_no;
                    $receipt->cheque_date=$model->receipt_cheque_date; 
                    $receipt->tds_amount=0;
                    $receipt->invoice_no=0;
                    $receipt->sale_order_no = $model->id;
                    $receipt->notes=$model->advance_note;
                    $receipt->receipt_date=date('Y-m-d H:i:s');
                    $receipt->created_at=date('Y-m-d H:i:s');
                    $receipt->updated_at=date('Y-m-d H:i:s');
                    $receipt->save(false);
                    }
                    else
                    {
                        $check_receipt->setting_type=$model->receipt_setting_type;
                        $check_receipt->amount=$model->receipt_total_amount;
                        $check_receipt->total_amount=$model->receipt_total_amount;
                        $receipt->bank_name=$model->receipt_bank;
                        $check_receipt->payment_mode='Cheque';
                        $check_receipt->cheque_no=$model->receipt_cheque_no;
                        $check_receipt->cheque_date=$model->receipt_cheque_date; 
                        $check_receipt->tds_amount=0;
                        $check_receipt->invoice_no=0;
                        $check_receipt->sale_order_no = $model->id;
                        $check_receipt->notes=$model->advance_note;
                        $check_receipt->receipt_date=date('Y-m-d H:i:s');
                        $check_receipt->updated_at=date('Y-m-d H:i:s');
                        $check_receipt->save(false);
                    }
              }           

            if($saleorderdocument->validate())
             {
                $names=UploadedFile::getInstances($saleorderdocument,'document_name');
                foreach ($names as $name) {
                    // $document->document_name->saveAs('setting/product_documents_images/' .$nameimage.'.'.$document->document_name->extension);
                    $path='saleorder_documents/'.$name->baseName.'.'.$name->extension;
                    if($name->saveAs($path))
                    {
                        $filename = $name->baseName.'.'.$name->extension;
                        $filepath = $path;
                        yii::$app->db->createCommand()->insert('sale_order_document',['document_name'=>$filename,'sale_order_id'=>$model->id])->execute();
                    }
                    
                }

             }
             if (Yii::$app->request->post('save') == 0) {
                         Yii::$app->getSession()->setFlash('success', 'Successfully Updated SaleOrder');
                         return $this->redirect(['sale-order/index']);
                  }

                if (Yii::$app->request->post('save') == 1) {
                       Yii::$app->getSession()->setFlash('success', 'Successfully Updated SaleOrder');
                         return $this->redirect(['sale-order/create']);
                  }
            
        }
        return $this->render('update', [
            'model' => $model,
            'sales_type' => SaleOrderController::$sales_type,
            'supply_types' => SaleOrderController::$supply_types,
            'product' => $product,
            'saleorderdocument' => $saleorderdocument,
            'saleorderproduct' => $saleorderproduct,
            'payment_mode'=> SaleOrderController::$payment_mode,
            'settings_type'=> SaleOrderController::$settings_type,
            'banks_name'=> SaleOrderController::$banks_name,
            'saleproducts'=>$saleproducts,
            'number'=>$number,
            'last_entry'=>$last_entry+1,

           
        ]);
    }


    public function actionSaleorderPending()
    {
        Yii::$app->view->params['active']=30;
        $model = new SaleOrder();
        $searchModel = new SaleOrderSearch();
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        $accessed_user=LeadExecutive::find()->where(['user_id'=>$check_id])->one();
        $access_id = $accessed_user['id'];
        $sale_ids = SaleOrder::find()->where(['executive_id'=>$access_id])->select(['id'])->all();
        // print_r($sale_ids);
        // die();


        if($user_type->item_name == 'Admin')
        {
            $query = SaleorderAgainstDc::find()->where(['is_deleted'=>0])->andWhere(['or',['convert_to'=>'Invoice'],['convert_to'=>'Receipt']])->orderBy(['id' => SORT_DESC]);
        }
        else
        {   
            $check_id = Yii::$app->user->identity->id;
            $accessed=LeadExecutive::find()->where(['user_id'=>$check_id])->one();
            if($accessed!='')
            {
              $accessed_id[] = $accessed['type'];
            }
            else
            {
                $loged_user = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
                $accessed_id[] = $loged_user['item_name'];
            }
            $all = SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all(); 
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive_id']])->one();
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed_id[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;

                }
            }
            $exe_array = array_unique($exe_array);
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $sale_order_ids = [];
            $k = 0;
            $assigned_saleorders = SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_id', $customer_ids])->andWhere(['in', 'executive_id', $exe_array])->all();
            foreach($assigned_saleorders as $key => $assigned_orders)
            {
                $sale_order_ids[$k] = $assigned_orders->id;
                $k++;
            }
             $query = SaleorderAgainstDc::find()->where(['is_deleted'=>0])->andWhere(['or',['convert_to'=>'Invoice'],['convert_to'=>'Receipt']])->andWhere(['in','saleorder_id',$sale_order_ids])->orderBy(['id' => SORT_DESC]);
        }


        
        // if($user_type->item_name == 'Admin')
        // {
        //     $query = SaleorderAgainstDc::find()->where(['is_deleted'=>0])->andWhere(['or',['convert_to'=>'Invoice'],['convert_to'=>'Receipt']])->orderBy(['id' => SORT_DESC]);
        // }
        // else
        // {
        //      $query = SaleorderAgainstDc::find()->where(['is_deleted'=>0])->andWhere(['or',['convert_to'=>'Invoice'],['convert_to'=>'Receipt']])->andWhere(['saleorder_id'=>$sale_ids])->orderBy(['id' => SORT_DESC]);
        // }
        if($model->load(Yii::$app->request->get()))
        {
                $customer=Customer::find()->where(['business_name'=>$model->commonsearch])->select(['id'])->one();
                if($customer)
                {
                    $query->andFilterWhere(['like', 'customer_id',$customer['id'] ]);
                }
                else
                {
                    if($model->commonsearch!=null)
                    {
                        $query->andFilterWhere(['like', 'customer_id','xxx' ]);
                    }
                    
                $query->andFilterWhere(['between', 'saleorder_date', $model->from_date,$model->to_date])
               ->andFilterWhere(['like', 'Convert_to', $model->converted_to])
               ->andFilterWhere(['like', 'source', $model->saleorder_source]);
                   
                }
               
            }   
        
            $dataProvider = new ActiveDataProvider(['query' => $query]);
             // $dataProvider = new ActiveDataProvider(['query' => $query]); 
        return $this->render('saleorder-pending', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
            'model' => $model,
            // 'sales_types'=> SaleOrderController::$sales_types,
        ]);
    }


    /**
     * Deletes an existing SaleOrder model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id=null)
    {

        $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();
        if($id==null)
        {
            $ids=Yii::$app->request->post('data');
            if($ids){
            foreach($ids as $id){
                 $document=SaleOrderDocument::find()->where(['sale_order_id'=>$id])->all();
                 foreach($document as $value){$value->is_deleted=1;$value->save(false);}
                 $saleorderproducts = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                 foreach($saleorderproducts as $saleorderproducts)
                  {
                    $saleorderproducts->is_deleted=1;
                    $saleorderproducts->save(false);
                  }
                  $data=$this->findModel($id);
                  $data->is_deleted=1;$data->save(false);
            }
           } 
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted selected items');
            return $this->redirect(['sale-order/index']);
        }
        else
        {
            $loged_by = Yii::$app->user->identity->id; 
            $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_for_inv = SaleOrder::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_id])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['sale-order/index']);
                }
            }
            $data=$this->findModel($id);
            $data->is_deleted=1;$data->save(false);
            $document=SaleOrderDocument::find()->where(['sale_order_id'=>$id])->all();
            foreach($document as $value){$value->is_deleted=1;$value->save();}
            $saleorderproducts = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
             foreach($saleorderproducts as $saleorderproducts)
              {
                $saleorderproducts->is_deleted=1;
                $saleorderproducts->save(false);
              }
            Yii::$app->getSession()->setFlash('success', 'Successfully deleted');
            return $this->redirect(['index']);
        }
        
    }
     public function actionPendingDelete($id)
    {
        $data = SaleorderAgainstDc::find()->where(['id'=>$id])->one();
        $data->is_deleted = 1;
        $data->save();
        Yii::$app->getSession()->setFlash('success', 'Successfully deleted');
        return $this->redirect(['sale-order/saleorder-pending']);
    }


    public function actionSaleorderPdf($id=null,$from=null)
    {
        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        $accessed_id[] = $user_type->item_name;
        if($user_type->item_name == 'Admin')
        {
            $query=SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {   
            $all = SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all(); 
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive_id']])->one();
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed_id[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;

                }
            }
            $exe_array = array_unique($exe_array);
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_id', $customer_ids])->andWhere(['in', 'executive_id', $exe_array])->orderBy(['id' => SORT_DESC]);
        }

        if($from=='all')
        {
                $dataProvider = new ActiveDataProvider([
                  'query' => $query,
                ]);
                $dataProvider->pagination = false;
                $mpdf = new mPDF;
                $mpdf->showImageErrors = true;
                $mpdf->WriteHTML($this->renderPartial('/sale-order/export-pdf', [
                    'dataProvider' => $dataProvider,

                ]));
                $mpdf->Output('SalesOrder-details.pdf', 'I');
        }
        else
        {


             $loged_by = Yii::$app->user->identity->id; 
             $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

            if($user_type->item_name != 'Admin')
            {
                $check_for_inv = SaleOrder::find()->where(['id'=>$id])->one();
                $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_id])->one(); 
                if($check_customer == '')
                {
                    Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                    return $this->redirect(['sale-order/index']);
                }
            }
                $model = SaleOrder::find()->where(['id'=>$id])->one();
                $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                $count=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->count();
                // print_r($count);die();
                $find = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                $total_product = 0;
                foreach ($find as $find) {
                  $total_product = $total_product+ $find->quantity;
                  # code...
                }
                $tax_amount= SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                $taxable_amount = 0;
                foreach ($tax_amount as $tax_amount) {
                  if($tax_amount->discount_type=="FLAT")
                  {
                      $taxable_amount = $taxable_amount+($tax_amount->price - $tax_amount->discount);
                  }
                  if($tax_amount->discount_type=="%")
                  {
                      $taxable_amount = $taxable_amount+($tax_amount->price - (($tax_amount->price * $tax_amount->discount)/100));
                  }
                  if($tax_amount->discount_type=="")
                  {
                     $taxable_amount = $taxable_amount+$tax_amount->price;
                  }
                 }
                 $tax_tot = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                 $total_tax = 0;

                 foreach ($tax_tot as $tax_tot) {
                  if($tax_tot->tax_included==1)
                  {
                      if($tax_tot->discount_type=="FLAT")
                      {
                        //    $total_tax = $total_tax+((($tax_tot->price - $tax_tot->discount)*$tax_tot->tax)/100);
                      }
                      if($tax_tot->discount_type=="%")
                      {
                           // $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100))

                        //    $total_tax = $total_tax+(($tax_tot->price - (($tax_tot->price * $tax_tot->discount)/100))*$tax_tot->tax)/100;
                      }
                      if($tax_tot->discount_type=="")
                      {
                           $total_tax = $total_tax+(($tax_tot->price*$tax_tot->tax)/100);
                      }
                  }
                 }
                 $tax_rate = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                 $inter_state_tax = 0;
                 foreach ($tax_rate as $tax_rate) {
                  if($tax_rate->tax_included==1)
                  {
                      if($tax_rate->discount_type=="FLAT")
                      {
                        //    $inter_state_tax = $inter_state_tax+((($tax_rate->price - $tax_rate->discount)*(($tax_rate->tax)/2))/100);
                      }
                      if($tax_rate->discount_type=="%")
                      {
                           // $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100))

                        //    $inter_state_tax = $inter_state_tax+((($tax_rate->price - (($tax_rate->price * $tax_rate->discount)/100))*(($tax_rate->tax)/2))/100);
                      }
                      if($tax_rate->discount_type=="")
                      {
                           $inter_state_tax = $inter_state_tax+(($tax_rate->price*(($tax_rate->tax)/2))/100);
                      }
                  }}
                   $receipt=ReceiptDetails::find()->where(['receipt_id'=>$model->receipt_id])->one();
                $dataProvider = new ActiveDataProvider([
                    'query' => SaleOrder::find()->where(['id'=>$id])
                ]);
                $dataProvider->pagination = false;
                $mpdf = new mPDF(['orientation' => 'L']);
                $mpdf->showImageErrors = true;
                $mpdf->WriteHTML($this->renderPartial('/sale-order/saleorder-pdf', [
                    'dataProvider' => $dataProvider,
                    'products' => $products,
                    'count' =>$count,
                    'model' => $model,
                    'total_product' => $total_product,
                    'taxable_amount' => $taxable_amount,
                    'total_tax' =>$total_tax,
                    'receipt' =>$receipt,
                    'inter_state_tax'=>$inter_state_tax,
                ]));
                $find=SaleOrder::findOne($id);
                $sale_order_id=$find->sale_order_id;
                if($from=='print')
                {
                    $mpdf->Output($sale_order_id.'-SaleOrder.pdf', 'I');
                }
                else
                {
                    $mpdf->Output($sale_order_id.'-SaleOrder.pdf', 'I');
                }
        }    
    }
    public function actionExcelSaleorder($id=null,$detail=null)
    {  

        $check_id = Yii::$app->user->identity->id;
        $user_type = AuthAssignment::find()->where(['user_id'=>$check_id])->one();
        $accessed_id[] = $user_type->item_name;
        if($user_type->item_name == 'Admin')
        {
            $query=SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {   
            $all = SaleOrder::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all(); 
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {
                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive_id']])->one();
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed_id[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;

                }
            }
            $exe_array = array_unique($exe_array);
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }
            $query = SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer_id', $customer_ids])->andWhere(['in', 'executive_id', $exe_array])->orderBy(['id' => SORT_DESC]);
        }

        if($id==null)
        {
            $dataProvider = new ActiveDataProvider([
            'query' =>$query,
                ]);

                if($detail){
                 $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    [
                        'label' => 'Customer',
                        
                        'value' => function ($data) {
                         $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                         return $user['business_name'];
                     },
                     ],
                     [
                        'label' => 'Executive',
                        
                        'value' => function ($data) {
                          if($data['executive_id']!='')
                            {
                                $user= LeadExecutive::find()->where(['id' =>$data['executive_id']])->one();
                                return $user['name'];
                            }
                     },
                     ],
                    'note:ntext',
                    'receiver',
                    'sale_type',
                    'supply_type',
                    'reverse_charge',
                    'priority',
                    'price_list',
                    'po_no',
                    'po_details',
                    'point_of_supply',
                    'is_invoice_paid_provisional',
                    'po_date',
                    'po_exp_date',
                    'sale_order_id',
                    'date',
                    'delivery_date',
                    'due_date',
                    'terms_of_payment',
                    'advance_payment',
                    'receipt_id',
                    'receipt_setting_type',
                    'receipt_total_amount',
                    'receipt_bank',
                    'receipt_cheque_no',
                    'receipt_cheque_date',
                    'advance_note',
                    'sub_total_amount',
                    'total_amount',
                    'converted_to',
                    'saleorder_source',
                    'order_status',
                    'other_note:ntext',
                    'terms:ntext',
                    [
                        'label' => 'Documents',
                        'format'    => 'raw',
                        // 'attribute' => 'customer_name',
                        'value' => function ($data) {
                            $user= SaleOrderDocument::find()->select(['document_name'])->where(['sale_order_id' =>$data['id']])->asArray()->column();
                            $documents = implode(" , ", $user);
                            return $documents;

                            
                    },
                    ],
                    'created_at',
                    'updated_at',
                ],
            ]);
                }else{
                    $exporter = new Spreadsheet([
                        'dataProvider' => $dataProvider,
                        'columns' => [
                           'sale_order_id',
                                            [
                                                'label' => 'Customer',
                                                'attribute' => 'customer_id',
                                                'value' => function ($data) {
                                                    $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                                                    return $user['business_name'];
                                            },
                                            ],
                                            [
                                                'label' => 'PO Details',
                                                'format'=>'raw',
                                                'attribute' => 'po_no',
                                                'value' => function ($data) {
                                                    return 'PO-Number:'.$data->po_no."</br>".'PO-Date:'.$data->po_date;
                                            },
                                            ],

                                           [
                                                'label' => 'Date',
                                                
                                                'format' => ['date', 'php:d-m-Y'],
                                                'attribute' => 'date',
                                                'value' => function ($data) {
                                                    return $data->date;
                                            },
                                            ],
                                            
                                            [
                                                'label' => 'Delivery Date',
                                                
                                                'format' => ['date', 'php:d-m-Y'],
                                                'attribute' => 'delivery_date',
                                                'value' => function ($data) {
                                                    return $data->delivery_date;
                                            },
                                            ],
                                            [
                                                'label' => 'Days Left',
                                                'value' => function ($data) {                                          
                                                    $today= time();
                                                    $date = strtotime($data->delivery_date);
                                                    $diff= $date-$today;
                                                    return floor($diff/(60*60*24)).' Days';
                                            },
                                            ],
                        ],
                    ]);
                }
               
            return $exporter->send('SalesOrder-details.xlsx');
        }
        else
        {
                $dataProvider = new ActiveDataProvider([
                   'query' => SaleOrder::find()->where(['id'=>$id]),
                ]);
              $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                    [
                        'label' => 'Customer',
                        
                        'value' => function ($data) {
                         $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                         return $user['business_name'];
                     },
                     ],
                     [
                        'label' => 'Executive',
                        
                        'value' => function ($data) {
                         $user= LeadExecutive::find()->where(['id' =>$data['executive_id']])->one();
                        if($user)
                         return $user['name'];
                     },
                     ],
                    'note:ntext',
                    'receiver',
                    'sale_type',
                    'supply_type',
                    'reverse_charge',
                    'priority',
                    'price_list',
                    'po_no',
                    'po_details',
                    'point_of_supply',
                    'is_invoice_paid_provisional',
                    'po_date',
                    'po_exp_date',
                    'sale_order_id',
                    'date',
                    'delivery_date',
                    'due_date',
                    'terms_of_payment',
                    'advance_payment',
                    'receipt_id',
                    'receipt_setting_type',
                    'receipt_total_amount',
                    'receipt_bank',
                    'receipt_cheque_no',
                    'receipt_cheque_date',
                    'advance_note',
                    'sub_total_amount',
                    'total_amount',
                    'converted_to',
                    'saleorder_source',
                    'order_status',
                    'other_note:ntext',
                    'terms:ntext',
                    'lead_quote_id',
                    [
                        'label' => 'Documents',
                        'format'    => 'raw',
                        // 'attribute' => 'customer_name',
                        'value' => function ($data) {
                            $user= SaleOrderDocument::find()->select(['document_name'])->where(['sale_order_id' =>$data['id']])->asArray()->column();
                            $documents = implode(" , ", $user);
                            return $documents;

                            
                    },
                    ],
                    'created_at',
                    'updated_at',
                ],
            ]);
               $find=SaleOrder::findOne($id);
                $sale_order_id=$find->sale_order_id; 
            return $exporter->send($sale_order_id.'-SaleOrder.xlsx');
        }  
    }


    public function actionPendingExcelExport($detail=null)
    {
        
        $dataProvider = new ActiveDataProvider([
            // 'query' =>SaleOrder::find()->where(['is_deleted'=>0,'order_status'=>'Pending']),
            'query'=> SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['or',['dc_status'=>1],['dc_status'=>3]])->orderBy(['id' => SORT_DESC]),
            
        ]);

        if($detail){
         $exporter = new Spreadsheet([
        'dataProvider' => $dataProvider,
        'columns' => [
            [
                'label' => 'Customer',
                
                'value' => function ($data) {
                 $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                 return $user['business_name'];
             },
             ],
             [
                'label' => 'Executive',
                
                'value' => function ($data) {
                 $user= LeadExecutive::find()->where(['id' =>$data['executive_id']])->one();
                 return $user['name'];
             },
             ],
            'note:ntext',
            'receiver',
            'sale_type',
            'supply_type',
            'reverse_charge',
            'priority',
            'price_list',
            'po_no',
            'po_details',
            'point_of_supply',
            'is_invoice_paid_provisional',
            'po_date',
            'po_exp_date',
            'sale_order_id',
            'date',
            'delivery_date',
            'due_date',
            'terms_of_payment',
            'advance_payment',
            'receipt_id',
            'receipt_setting_type',
            'receipt_total_amount',
            'receipt_bank',
            'receipt_cheque_no',
            'receipt_cheque_date',
            'advance_note',
            'sub_total_amount',
            'total_amount',
            'converted_to',
            'saleorder_source',
            'order_status',
            'other_note:ntext',
            'terms:ntext',
            'lead_quote_id',
            [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= SaleOrderDocument::find()->select(['document_name'])->where(['sale_order_id' =>$data['id']])->asArray()->column();
                    $documents = implode(" , ", $user);
                    return $documents;

                    
            },
            ],
            'created_at',
            'updated_at',
        ],
    ]);
        }else{
            $exporter = new Spreadsheet([
                'dataProvider' => $dataProvider,
                'columns' => [
                                    [
                                        'label' => 'Description',
                                        'format'=>'raw',
                                        'attribute' => 'po_no',
                                        'value' => function ($data) {
                                            $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                                            return 'No.#-'. $data->sale_order.",".'Name-'.$user['business_name'].",".'Remark-'.$data->other_note;
                                    },
                                    ],
                                    [
                                    'label' => 'Amount',
                                    // 'attribute' => 'total_amount',
                                    'value' => function ($data) {
                                        return $data->total_amount;
                                    },
                                    ],
                                   [
                                        'label' => 'Date',
                                        
                                        'format' => ['date', 'php:d-m-Y'],
                                        'attribute' => 'date',
                                        'value' => function ($data) {
                                            return $data->date;
                                    },
                                    ],
                                   'converted_to',
                                   'saleorder_source',
                ],
            ]);
        }
       
    return $exporter->send('PendingSalesOrder-details.xlsx');
    }

    public function actionPendingPdf()
    {
        $dataProvider = new ActiveDataProvider([
            // 'query' => SaleOrder::find()->where(['is_deleted'=>0,'order_status'=>'Pending']),
          'query'=> SaleOrder::find()->where(['is_deleted'=>0])->andWhere(['or',['dc_status'=>1],['dc_status'=>3]])->orderBy(['id' => SORT_DESC]),
        ]);
        $dataProvider->pagination = false;
        $mpdf = new mPDF;
        $mpdf->showImageErrors = true;
        $mpdf->WriteHTML($this->renderPartial('/sale-order/pending-pdf', [
            'dataProvider' => $dataProvider,

        ]));
        $mpdf->Output('PendingSalesOrder-details.pdf', 'D');
    }

    public function actionDuplicate($id)
    {
        // Yii::$app->view->params['active']=7;
        $model=new SaleOrder();
        $data = $this->findModel($id)->attributes;
        $model->setAttributes($data);
        $last_entry=SaleOrder::find()->count();
        $model->sale_order=$last_entry+1;    
        $total=SaleOrder::find()->orderBy(['id' => SORT_DESC])->one();
        $no=$total->id;
        $count=$no+1;

        $model->sale_order_id = $model->prefix.''.$count.''.$model->suffix;    
        $model->save(false);
        $document=SaleOrderDocument::find()->where(['sale_order_id'=>$id])->all();
        foreach($document as $value){
            $doc=new SaleOrderDocument();
            $data = $value->attributes;
            $doc->setAttributes($data);
            $doc->sale_order_id=$model->id;
            $doc->save(false);  
        }
        $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();

        foreach($products as $product){
            $pdt=new SaleOrderProduct();
            $data = $product->attributes;
            $pdt->setAttributes($data);
            $pdt->sale_order_no=$model->id;
            $pdt->save(false);  
        }
        Yii::$app->getSession()->setFlash('success', 'Duplicate Created Successfully');
        return $this->redirect(['sale-order/index']);
    }

    

    public function actionExcelExport($detail=null)
    {
        
        
    }

    public function actionDeletePendingSaleorder()
    {
        $ids=Yii::$app->request->post('data');

        if($ids){
        foreach($ids as $id){

             $saleorderagainstdc = SaleorderAgainstDc::find()->where(['id'=>$id])->one();
             $saleorderagainstdc->is_deleted = 1;
             $saleorderagainstdc->save();
             // $document=SaleOrderDocument::find()->where(['sale_order_id'=>$id])->all();
             // foreach($document as $value){$value->is_deleted=1;$value->save(false);}
             // $saleorderproducts = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
             // foreach($saleorderproducts as $saleorderproducts)
             //  {
             //    $saleorderproducts->is_deleted=1;
             //    $saleorderproducts->save(false);
             //  }
             //  $data=$this->findModel($id);
             //  $data->is_deleted=1;$data->save(false);
        }
       } 
        Yii::$app->getSession()->setFlash('success', 'Successfully deleted selected items');
        return $this->redirect(['sale-order/saleorder-pending']);
    }

    public function actionConvertInvoice($id)
    {
        $model = $this->findModel($id);
        $invoice = new Invoice();
        $find = Invoice::find()->where(['sale_order_id' => $id])->one();
        if($find)
        {
            $model->converted_to='Invoice';
            $model->save(false);
            Yii::$app->getSession()->setFlash('success', 'Invoice already exist for this Saleorder');
                    return $this->redirect(['sale-order/saleorder-pending']);
        }
        else
        {
            if(Invoice::find()->count() > 0) { 
                    $total=Invoice::find()->orderBy(['id' => SORT_DESC])->one();
                    $count=$total->id;  
                    }
                    else{
                        $count=0;
                    }
                    $last_entry=Invoice::find()->count();
                    $invoice->invoice_no=$last_entry+1;
                    $invoice->settings_id='Tax Invoice(GOODS)2020-21';
                    $invoice->prefix='INV';
                    $invoice->suffix='';
                    $num=$count+1;
                    $invoice->invoice_id = $invoice->prefix.''.$num.''.$invoice->suffix;
                    $name=Customer::find()->where(['id'=>$model->customer_id])->one();
                    $invoice->customer_name = $name->business_name;
                    $name=LeadExecutive::find()->where(['id'=>$model->executive_id])->one();
                    $invoice->executive = $name->name;
                    $invoice->receiver_gstn= $model->receiver;
                    $invoice->sales_type = $model->sale_type;
                    $invoice->sypply_type = $model->supply_type;
                    $invoice->supply_reverse_change=$model->reverse_charge;
                    $invoice->po_number= $model->po_no;
                    $invoice->po_date = $model->po_date;
                    $invoice->price_list = $model->price_list;
                    $invoice->point_of_supply = $model->point_of_supply;
                    $invoice->due_date = $model->due_date;
                    $invoice->terms_of_payment=$model->terms_of_payment;
                    $invoice->tax_status=$model->is_invoice_paid_provisional;
                    $invoice->sub_total_price=$model->sub_total_amount;
                    $invoice->total_price = $model->total_amount;
                    $invoice->notes = $model->note;
                    $invoice->status = $model->order_status;
                    $invoice->sale_order_id = $id;
                    if($model->advance_payment=='Matched Receipt' || $model->advance_payment=='Advance payment for this Sales Order')
                    {
                       $invoice->shipment_status = 'PAID';  
                    }
                    else
                    {
                        $invoice->shipment_status = 'UNPAID';
                    }
                    $invoice->date=date('Y-m-d H:i:s');
                    $invoice->created_at=date('Y-m-d H:i:s');
                    $invoice->updated_at=date('Y-m-d H:i:s');
                    $invoice->save(false);
                    $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
                    foreach($products as $products)
                      {
                          $invoiceproduct = new InvoiceProduct();
                          $invoiceproduct->invoice_id = $invoice->id;
                          $invoiceproduct->product_id = $products->product_id;
                          $invoiceproduct->description = $products->description; 
                          $invoiceproduct->quantity = $products->quantity; 
                          $invoiceproduct->units = $products->units; 
                          $invoiceproduct->price = $products->price; 
                          $invoiceproduct->discount = $products->discount; 
                          $invoiceproduct->tax = $products->tax; 
                          $invoiceproduct->discount_type = $products->discount_type; 
                          $invoiceproduct->tax_included = $products->tax_included;
                          $invoiceproduct->amount = $products->amount;
                          $invoiceproduct->created_at=date('Y-m-d H:i:s');
                          $invoiceproduct->updated_at=date('Y-m-d H:i:s');
                          $invoiceproduct->save(false);
                      }
                    $model->converted_to='Invoice';
                    $model->save(false);
                    Yii::$app->getSession()->setFlash('success', 'Successfully Generated Invoice');
                    return $this->redirect(['sale-order/saleorder-pending']);
        }
        
    }
    public function actionConvertReceipt($id)
    {
        $model = $this->findModel($id);
        $invoice = new Invoice();
        $find = Invoice::find()->where(['sale_order_id' => $id])->one();
        return $this->redirect(['receipt-details/create', 'invoice' => $find->id,'sale'=>$id]);
    }
     public function actionFindattachments($id)
    {
        $find=SaleOrderDocument::find()->select(['document_name','id'])->where(['sale_order_id'=>$id])->asArray ()->all();
        echo Json::encode($find);
        // return $exporter->send($find);
        // return $find;
    }
 public function actionDelattachment($id)
    {
        $file=SaleOrderDocument::find()->where(['id'=>$id])->one();
         $file->delete();
        // return $exporter->send($find);
        // return $find;
    }
    public function actionFindcustomerdetails($customerid)
    {
       $customerdetails= Customer::find()->where(['id' =>$customerid])->one();
        echo Json::encode($customerdetails);
    }
     public function actionFindexecutivedetails($executivedata)
    {
       $executivedetails= LeadExecutive::find()->where(['name' =>$executivedata])->one();
        echo Json::encode($executivedetails);
    }
    public function actionCheckreceipt($receiptid,$customer)
    { 
        $customer_name = Customer::find()->select('business_name')->where(['id'=>$customer])->one();
        $query= ReceiptDetails::find()->where(['receipt_id' =>$receiptid])
                                      ->andWhere(['customer_name'=>$customer_name])->one();
                                      
        if( Count($query) > 0 ){
            echo 'true';
        }
        else{
            echo 'false';
        }
       
    }
    public function actionDownload($id) 
    {
        $model=SaleOrderDocument::find()->where(['id'=>$id])->one();
        if($model->document_name!=null)
        {
            $local=yii::getAlias('@webroot/saleorder_documents/');
            $name=$model->document_name;

            $find=$local.$name;
            if(file_exists($find))
            {
               return yii::$app->response->sendFile($find);
            }
        }
    }
    public function actionTaxdetails($item)
    {
       $taxdetails= AccountingTax::find()->where(['accounting_tax_id' =>$item])->one();
        echo Json::encode($taxdetails);
    }


    public function actionFindsalealldetails($id)
    {
        $all= SaleOrder::find()->where(['id' =>$id])->one();
        echo Json::encode($all);
    } 
    public function actionCreateUrl($id)
    {
        $url = Url::to(['saleorder-pdf', 'id' => $id],'https');
        echo Json::encode($url);
    } 

    public function actionFinduseralldetails($id)
    {
        $all= Saleorder::find()->where(['id' =>$id])->one();
        $userdetails = Customer::find()->where(['id'=>$all->customer_id])->one();
        echo Json::encode($userdetails);
    }

    

    public function actionCheckSaleorder()
    {                     
        $ids=Yii::$app->request->post('data');
        $s_id = SaleorderAgainstDc::find()->select('saleorder_id')->where(['id'=>$ids[0]])->one();
        // print_r($s_id);
        // die();
        $count =0;
        for($i=0; $i<count($ids); $i++)
        {
        
          $sale= SaleorderAgainstDc::find()->where(['id'=>$ids[$i]])->one();
          $sale_id= SaleorderAgainstDc::find()->select('saleorder_id')->where(['id'=>$ids[$i]])->one();
          if($s_id!=$sale_id)
          {
             $count = $count + 1;
          }
          else
          {
            if($sale->invoice_no!=null)
            {
                 $count = $count + 1;
            }
          }
        }                             
        if($count == 0 ){
            echo 'true';
        }
        else{
            echo 'false';
        }
       
    }

     public function actionFromSaleorder()
    {       
                    // $ids = [2,3];
        $ids=Yii::$app->request->post('data');
        $s_id = SaleorderAgainstDc::find()->where(['id'=>$ids[0]])->one();
       
        $this->redirect(['invoice/create','id'=>$s_id->saleorder_id,'from' => 'against_dc','dc'=>$ids]);
    }

    public function actionSelectdate($selected_date=null)
    {   $selected_date=$_GET['selected_date']; 
        $year=date("Y"); 
        $dynamic_date=$year.'-'.'03'.'-'.'31';
        $count_before_year=SaleOrder::find()->where(['<=', 'date', $dynamic_date])->count();
        $count_after_year=SaleOrder::find()->where(['>=', 'date', $dynamic_date])->count();

        if(strtotime($selected_date) <= strtotime($dynamic_date)) { 
            $last_entry=$count_before_year+1;
        }
        else if(strtotime($selected_date) > strtotime($dynamic_date)){
            $last_entry=$count_after_year+1;
        } 
        else{
            $last_entry=0;
        }
        echo $last_entry;
    }

    public function actionPrintall($id,$from=null,$title=null)
    {
         $loged_by = Yii::$app->user->identity->id; 
        $user_type = AuthAssignment::find()->where(['user_id'=>$loged_by])->one();

        if($user_type->item_name != 'Admin')
        {
            $check_for_inv = SaleOrder::find()->where(['id'=>$id])->one();
            $check_customer = UserClient::find()->where(['user_id'=>$loged_by])->andWhere(['client_id'=>$check_for_inv->customer_id])->one(); 
            if($check_customer == '')
            {
                Yii::$app->getSession()->setFlash('error', 'Access Denied.');
                return $this->redirect(['sale-order/index']);
            }
        }

        
        $sale = SaleOrder::find()->where(['id'=>$id])->one();
        $products=SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        $find = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        $tax_amount= SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
        
        $taxable_amount = 0;
        foreach ($tax_amount as $tax_amount) {
          if($tax_amount->discount_type=="FLAT")
          {
              $taxable_amount = $taxable_amount+($tax_amount->price - $tax_amount->discount);
          }
          if($tax_amount->discount_type=="%")
          {
              $taxable_amount = $taxable_amount+($tax_amount->price - (($tax_amount->price * $tax_amount->discount)/100));
          }
          if($tax_amount->discount_type=="")
          {
             $taxable_amount = $taxable_amount+$tax_amount->price;
          }
         }
         $tax_tot = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
         $total_tax = 0;

         foreach ($tax_tot as $tax_tot) {
          if($tax_tot->tax_included==1)
          {
              if($tax_tot->discount_type=="FLAT")
              {
                //    $total_tax = $total_tax+((($tax_tot->price - $tax_tot->discount)*$tax_tot->tax)/100);
              }
              if($tax_tot->discount_type=="%")
              {
                   // $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100))

                //    $total_tax = $total_tax+(($tax_tot->price - (($tax_tot->price * $tax_tot->discount)/100))*$tax_tot->tax)/100;
              }
              if($tax_tot->discount_type=="")
              {
                //    $total_tax = $total_tax+(($tax_tot->price*$tax_tot->tax)/100);
              }
          }
          
         }

         $tax_rate = SaleOrderProduct::find()->where(['sale_order_no'=>$id])->all();
         $inter_state_tax = 0;
         foreach ($tax_rate as $tax_rate) {
          if($tax_rate->tax_included==1)
          {
              if($tax_rate->discount_type=="FLAT")
              {
                //    $inter_state_tax = $inter_state_tax+((($tax_rate->price - $tax_rate->discount)*(($tax_rate->tax)/2))/100);
              }
              if($tax_rate->discount_type=="%")
              {
                //    $total_tax = $total_tax+($tax_tot->price - (((($tax_tot->price * $tax_tot->discount)/100)*$tax_tot->tax)/100));

                //    $inter_state_tax = $inter_state_tax+((($tax_rate->price - (($tax_rate->price * $tax_rate->discount)/100))*(($tax_rate->tax)/2))/100);
              }
              if($tax_rate->discount_type=="")
              {
                //    $inter_state_tax = $inter_state_tax+(($tax_rate->price*(($tax_rate->tax)/2))/100);
              }
          }
         }
         $receipt=ReceiptDetails::find()->where(['receipt_id'=>$sale->receipt_id])->one();
        $total_product = 0;
        foreach ($find as $find) {
          $total_product = $total_product+ $find->quantity;
          # code...
        }
        return $this->renderPartial('printall', [
	    'title' => $title,
            'model' => $this->findModel($id),
            'products'=>$products,
            'total_product' => $total_product,
            'taxable_amount' => $taxable_amount,
            'total_tax' =>$total_tax,
            'receipt' =>$receipt,
            'inter_state_tax' => $inter_state_tax,
            'from'=>$from,
        ]);
        
    }

    /**
     * Finds the SaleOrder model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return SaleOrder the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = SaleOrder::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}
