<?php

namespace backend\modules\users\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\users\models\AccountingContra;

/**
 * AccountingContraSearch represents the model behind the search form of `backend\modules\users\models\AccountingContra`.
 */
class AccountingContraSearch extends AccountingContra
{
    /**
     * {@inheritdoc}
     */
    public $from_date;
    public $to_date;
    public $user;
    public $bank;
    public $with1;
    public $with2;
    public $op1;
    public $op2;
    public function rules()
    {
        return [
            [['contra_id'], 'integer'],
            [['contra_type','op2', 'op1','date','bank', 'voucher_no', 'prefix','user', 'suffix', 'notes', 'source_bank', 'destination_bank', 'ceated_at','from_date','to_date','with2','with1','contra_no'], 'safe'],
            [['amount'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params)
    {
        $query = AccountingContra::find();

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'contra_id' => $this->contra_id,
            'date' => $this->date,
            'contra_no' => $this->contra_no,
            'amount' => $this->amount,
            'ceated_at' => $this->ceated_at,
            'update_at' => $this->update_at,
        ]);

        $query->andFilterWhere(['like', 'contra_type', $this->contra_type])
            ->andFilterWhere(['like', 'voucher_no', $this->voucher_no])
            ->andFilterWhere(['like', 'prefix', $this->prefix])
            ->andFilterWhere(['like', 'suffix', $this->suffix])
            ->andFilterWhere(['like', 'notes', $this->notes])
            ->andFilterWhere(['like', 'user', $this->user])
            ->andFilterWhere(['like', 'contra_no', $this->contra_no])
            // ->andFilterWhere(['like', 'source_bank', $this->source_bank])
            //->andFilterWhere(['like', 'destination_bank', $this->destination_bank])
            ->andFilterWhere(['between', 'date', $this->from_date,$this->to_date])
            ->orFilterWhere(['like', 'source_bank', $this->bank])
            ->orFilterWhere(['like', 'destination_bank', $this->bank]);
            // ->andFilterWhere(['between', 'amount', $this->with1,$this->with2]);



        return $dataProvider;
    }
}
