<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "accounting_details".
 *
 * @property int $id
 * @property string|null $ledgerhead_id
 * @property string|null $transaction_type
 * @property string|null $transaction_id
 * @property string|null $inc_exp
 * @property string|null $accounting_type
 * @property float|null $amount
 * @property string $created_at
 * @property string $updated_at
 */
class AccountingDetails extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'accounting_details';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['amount'], 'number'],
            [['created_at', 'updated_at','date'], 'safe'],
            [['ledgerhead_id', 'transaction_type', 'transaction_id', 'inc_exp', 'accounting_type'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'ledgerhead_id' => 'Ledgerhead ID',
            'transaction_type' => 'Transaction Type',
            'transaction_id' => 'Transaction ID',
            'inc_exp' => 'Inc Exp',
            'accounting_type' => 'Accounting Type',
            'amount' => 'Amount',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }

    public static function leadgerentryinvoice($cgst=null,$sgst=null,$igst=null,$roundoff=null,$totalamt=null,$gsttype=null,$tan_id=null,$amtfrom=null,$amt=null,$tcs=null,$is_tcs=null,$tan_date=null)
    {
        // print_r($tan_id);
        // die();
        if($gsttype!='' && $gsttype==21)
        {
            if($cgst!='')
            {

                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "CGST Payable";
                $ledger->transaction_type = "Invoice";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $cgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            if($sgst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "SGST Payable";
                $ledger->transaction_type = "Invoice";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $sgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            
        }
        else if($gsttype!='' && $gsttype!=21)
        {
            if($igst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "IGST Payable";
                $ledger->transaction_type = "Invoice";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $igst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
        }
       if($roundoff!='' && $roundoff>=0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Invoice";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $roundoff;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       else if($roundoff!='' && $roundoff<0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Invoice";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Debit";
            $ledger->amount = abs($roundoff);
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       if($totalamt!='')
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Sales-Taxable";
            $ledger->transaction_type = "Invoice";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $amt;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       if($is_tcs==1)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "TCS Payable";
            $ledger->transaction_type = "Invoice";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $tcs;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $amtfrom;
            $ledger->transaction_type = "Invoice";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $totalamt;
            $ledger->date = $tan_date;
            $ledger->save(false);
        
    }
    public static function leadgerentryreceipt($amt=null,$tds_amount=null,$final_amt=null,$tan_id=null,$amtfrom=null,$payment_mode=null,$bank_name=null,$tan_date=null)
    {
        // print_r($payment_mode);
        // exit();
        if($payment_mode=='Cash')
        {
            // print_r('xx');
            // exit();
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $payment_mode;
            $ledger->transaction_type = "Receipt";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $final_amt;
            $ledger->date = $tan_date;
            $ledger->save(false);
        }
        else
        {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $bank_name;
            $ledger->transaction_type = "Receipt";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $final_amt;
            $ledger->date = $tan_date;
            $ledger->save(false);   
        }
        if($tds_amount>0)
        {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "TDS Amount";
            $ledger->transaction_type = "Receipt";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $tds_amount;
            $ledger->date = $tan_date;
            $ledger->save(false);
        }
        if($amtfrom!='')
        {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $amtfrom;
            $ledger->transaction_type = "Receipt";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $amt;
            $ledger->date = $tan_date;
            $ledger->save(false);
        }
        if($amtfrom==null)
        {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = 'W/I';
            $ledger->transaction_type = "Receipt";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $amt;
            $ledger->date = $tan_date;
            $ledger->save(false);
        }
        
    }
     public static function leadgerentrybill($cgst=null,$sgst=null,$igst=null,$roundoff=null,$totalamt=null,$gsttype=null,$tan_id=null,$amtto=null,$amt=null,$tcs=null,$tan_date=null)
     {


        if($gsttype!='' && $gsttype==21)
        {
            if($cgst!='')
            {

                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "CGST Payable";
                $ledger->transaction_type = "Bill";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Expense";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $cgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            if($sgst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "SGST Payable";
                $ledger->transaction_type = "Bill";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Expense";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $sgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            
        }
        else if($gsttype!='' && $gsttype!=21)
        {
            if($igst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "IGST Payable";
                $ledger->transaction_type = "Bill";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Expense";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $igst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
        }
       if($roundoff!='' && $roundoff>0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Bill";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $roundoff;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       else if($roundoff!='' && $roundoff<0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Bill";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Credit";
            $ledger->amount = abs($roundoff);
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       if($totalamt!='')
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Purchases - Registered Dealer";
            $ledger->transaction_type = "Bill";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $amt;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "TCS Payable";
            $ledger->transaction_type = "Bill";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $tcs;
            $ledger->date = $tan_date;
            $ledger->save(false);

       $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $amtto;
            $ledger->transaction_type = "Bill";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $totalamt;
            $ledger->date = $tan_date;
            $ledger->save(false);

     }

    public static function leadgerentrypayment($amt=null,$tds_amount=null,$final_amt=null,$tan_id=null,$amtto=null,$payment_mode=null,$tan_date=null)
    {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $payment_mode;
            $ledger->transaction_type = "Payment";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Credit";
            $ledger->date = $tan_date;
            $ledger->amount = $amt;
            $ledger->save(false);
       
        $ledger = new AccountingDetails();
        $ledger->ledgerhead_id = $amtto;
        $ledger->transaction_type = "Payment";
        $ledger->transaction_id =$tan_id ;
        $ledger->inc_exp = "Expense";
        $ledger->accounting_type = "Debit";
        $ledger->date = $tan_date;
        $ledger->amount = $amt;
        $ledger->save(false);



        if($tds_amount>0)
        {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "TDS Amount";
            $ledger->transaction_type = "Payment";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $tds_amount;
            $ledger->date = $tan_date;
            $ledger->save(false);
        }
    }

    public static function leadgerentrydebit($cgst=null,$sgst=null,$igst=null,$roundoff=null,$totalamt=null,$gsttype=null,$tan_id=null,$amtto=null,$amt=null,$tcs=null,$tan_date=null)
    {
        if($gsttype!='' && $gsttype==21)
        {
            if($cgst!='')
            {

                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "CGST Payable";
                $ledger->transaction_type = "Debit Note";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Expense";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $cgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            if($sgst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "SGST Payable";
                $ledger->transaction_type = "Debit Note";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Expense";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $sgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            
        }
        else if($gsttype!='' && $gsttype!=21)
        {
            if($igst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "IGST Payable";
                $ledger->transaction_type = "Debit Note";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Expense";
                $ledger->accounting_type = "Debit";
                $ledger->amount = $igst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
        }
       if($roundoff!='' && $roundoff>=0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Debit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $roundoff;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       else if($roundoff!='' && $roundoff<0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Debit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Credit";
            $ledger->amount = abs($roundoff);
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       if($totalamt!='')
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Purchases - Registered Dealer";
            $ledger->transaction_type = "Debit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $amt;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "TCS Payable";
            $ledger->transaction_type = "Debit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $tcs;
            $ledger->date = $tan_date;
            $ledger->save(false);

       $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $amtto;
            $ledger->transaction_type = "Debit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Expense";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $totalamt;
            $ledger->date = $tan_date;
            $ledger->save(false);

    }
    public static function leadgerentrycredit($cgst=null,$sgst=null,$igst=null,$roundoff=null,$totalamt=null,$gsttype=null,$tan_id=null,$amtfrom=null,$amt=null,$tcs=null,$is_tcs=null,$tan_date=null)
    {
        // print_r($tan_id);
        // die();
        if($gsttype!='' && $gsttype==21)
        {
            if($cgst!='')
            {

                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "CGST Payable";
                $ledger->transaction_type = "Credit Note";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $cgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            if($sgst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "SGST Payable";
                $ledger->transaction_type = "Credit Note";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $sgst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
            
        }
        else if($gsttype!='' && $gsttype!=21)
        {
            if($igst!='')
            {
                $ledger = new AccountingDetails();
                $ledger->ledgerhead_id = "IGST Payable";
                $ledger->transaction_type = "Credit Note";
                $ledger->transaction_id =$tan_id ;
                $ledger->inc_exp = "Income";
                $ledger->accounting_type = "Credit";
                $ledger->amount = $igst;
                $ledger->date = $tan_date;
                $ledger->save(false);
            }
        }
       if($roundoff!='' && $roundoff>=0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Credit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $roundoff;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       else if($roundoff!='' && $roundoff<0)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Round-off";
            $ledger->transaction_type = "Credit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Debit";
            $ledger->amount = abs($roundoff);
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       if($totalamt!='')
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "Sales-Taxable";
            $ledger->transaction_type = "Credit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $amt;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       if($is_tcs==1)
       {
            $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = "TCS Payable";
            $ledger->transaction_type = "Credit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Credit";
            $ledger->amount = $tcs;
            $ledger->date = $tan_date;
            $ledger->save(false);
       }
       $ledger = new AccountingDetails();
            $ledger->ledgerhead_id = $amtfrom;
            $ledger->transaction_type = "Credit Note";
            $ledger->transaction_id =$tan_id ;
            $ledger->inc_exp = "Income";
            $ledger->accounting_type = "Debit";
            $ledger->amount = $totalamt;
            $ledger->date = $tan_date;
            $ledger->save(false);
        
    }
    public static function leadgerentrycontra($amt=null,$source=null,$destination=null,$tran_id=null,$tan_date=null)
    {
        $ledger = new AccountingDetails();
        $ledger->ledgerhead_id = $source;
        $ledger->transaction_type = "Contra";
        $ledger->transaction_id =$tran_id ;
        $ledger->inc_exp = "";
        $ledger->accounting_type = "Debit";
        $ledger->amount = $amt;
        $ledger->date = $tan_date;
        $ledger->save(false);
        
        $ledger = new AccountingDetails();
        $ledger->ledgerhead_id = $destination;
        $ledger->transaction_type = "Contra";
        $ledger->transaction_id =$tran_id;
        $ledger->inc_exp = "";
        $ledger->accounting_type = "Credit";
        $ledger->amount = $amt;
        $ledger->date = $tan_date;
        $ledger->save(false);
    }
    public static function leadgerentryjournal($amt=null,$account=null,$tran_id=null,$is_debit=null,$tan_date=null)
    {
        $ledger = new AccountingDetails();
        $ledger->ledgerhead_id = $account;
        $ledger->transaction_type = "Journal";
        $ledger->transaction_id ='J'.$tran_id ;
        $ledger->inc_exp = "";
        if($is_debit==1){
            $ledger->accounting_type ="Debit";
        }else{
            $ledger->accounting_type ="Credit";
        }
        $ledger->date = $tan_date;
        $ledger->amount = $amt;
        $ledger->save(false);
    }
}

