<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "credit_note_product".
 *
 * @property int $id
 * @property string $credit_note_id
 * @property string $product_id
 * @property string $description
 * @property string $quantity
 * @property string $units
 * @property float $unit_price
 * @property float $price
 * @property string $discount
 * @property string $tax
 * @property string $discount_type
 * @property string $tax_included
 * @property float $amount
 * @property int $is_deleted
 * @property string $created_at
 * @property string $updated_at
 */
class CreditNoteProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'credit_note_product';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            // [['credit_note_id', 'product_id', 'description', 'quantity', 'units', 'unit_price', 'price', 'discount', 'tax', 'discount_type', 'tax_included', 'amount', 'created_at', 'updated_at'], 'required'],
            [['unit_price', 'price', 'amount'], 'number'],
            [['is_deleted'], 'integer'],
            [['created_at', 'updated_at','tax'], 'safe'],
            [['credit_note_id', 'product_id', 'description', 'units', 'discount', 'discount_type', 'tax_included'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'credit_note_id' => 'Credit Note ID',
            'product_id' => 'Product ID',
            'description' => 'Description',
            'quantity' => 'Quantity',
            'units' => 'Units',
            'unit_price' => 'Unit Price',
            'price' => 'Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'discount_type' => 'Discount Type',
            'tax_included' => 'Tax Included',
            'amount' => 'Amount',
            'is_deleted' => 'Is Deleted',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
