<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "debit_note".
 *
 * @property int $id
 * @property string $setting_type
 * @property int $party_id
 * @property string|null $sender_gst
 * @property string $bill_type
 * @property string|null $notes
 * @property string|null $supply_type
 * @property string|null $supply_attracts
 * @property string|null $pricelist
 * @property string|null $point_of_supply
 * @property string|null $ineligible_itc
 * @property string|null $prefix
 * @property string|null $po
 * @property string|null $suffix
 * @property string|null $date
 * @property string|null $bill_no
 * @property string|null $bill_date
 * @property string|null $product_code
 * @property float $sub_total
 * @property float $total
 * @property int $match_bill
 * @property int $show_to_store_keeper
 * @property int $full_order
 * @property int $product_wise
 * @property string|null $debit_notes
 * @property string $created_at
 * @property string $updated_at
 */
class DebitNote extends \yii\db\ActiveRecord
{
    public $from_date;
    public $to_date;
    public $partytype;
    public $party;
    public $setting;
    public $amount;
    public $image;
    public $product;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'debit_note';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['setting_type', 'party_id','party_type', 'bill_type', 'sub_total', 'total'], 'required'],
            [['party_id', 'match_bill', 'show_to_store_keeper', 'product_wise','is_tcs'], 'integer'],
            [['sender_gst', 'notes', 'product_code', 'debit_notes','full_debit_id'], 'string'],
            [['sub_total', 'total'], 'number'],
            [['from_date','to_date','partytype','party','setting','amount','product','full_order','image','created_at', 'updated_at','tcs'], 'safe'],
            [['setting_type', 'point_of_supply'], 'string', 'max' => 56],
            [['bill_type', 'ineligible_itc', 'prefix', 'po', 'suffix', 'date', 'bill_date'], 'string', 'max' => 32],
            [['supply_type', 'supply_attracts', 'pricelist', 'bill_no'], 'string', 'max' => 128],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'setting_type' => 'Setting Type',
            'party_id' => 'Party ID',
            'sender_gst' => 'Sender Gst',
            'bill_type' => 'Bill Type',
            'notes' => 'Notes',
            'supply_type' => 'Supply Type',
            'supply_attracts' => 'Supply Attracts',
            'pricelist' => 'Pricelist',
            'point_of_supply' => 'Point Of Supply',
            'ineligible_itc' => 'Ineligible Itc',
            'prefix' => 'Prefix',
            'po' => 'Po',
            'suffix' => 'Suffix',
            'date' => 'Date',
            'bill_no' => 'Bill No',
            'bill_date' => 'Bill Date',
            'product_code' => 'Product Code',
            'sub_total' => 'Sub Total',
            'total' => 'Total',
            'match_bill' => 'Match Bill',
            'show_to_store_keeper' => 'Show To Store Keeper',
            'full_order' => 'Full Order',
            'product_wise' => 'Product Wise',
            'debit_notes' => 'Debit Notes',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
