<?php

namespace backend\modules\users\models;

use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\users\models\DebitNote;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Customer;
use backend\models\UserClient;
use yii\db\Query;
/**
 * DebitNoteSearch represents the model behind the search form of `backend\modules\users\models\DebitNote`.
 */
class DebitNoteSearch extends DebitNote
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'match_bill', 'show_to_store_keeper', 'full_order', 'product_wise'], 'integer'],
            [['party_id','setting_type', 'sender_gst', 'bill_type', 'notes', 'supply_type', 'supply_attracts', 'pricelist', 'point_of_supply', 'ineligible_itc', 'prefix', 'po', 'suffix', 'date', 'bill_no', 'bill_date', 'product_code', 'debit_notes', 'created_at', 'updated_at'], 'safe'],
            [['sub_total', 'total'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params,array $accessed=null)
    {

        // print_r($accessed);
        // die();
        if($accessed == null)
        {
            $query = DebitNote::find()->where(['is_deleted'=>0])->orderBy(['id'=>SORT_DESC]);
        }
        else
        {
            $vendors = UserClient::find()->where(['user_id'=>$accessed])->all();
            // $customers = UserClient::find()->where(['user_id'=>$accessed])->andWhere(['client_type'=>'Customer'])->all();
            // $customer_ids = [];
            $vendor_ids= [];
            $i = 0;
            // $j = 0;
            foreach($vendors as $data)
            {
                $vendor_ids[$i] = $data->client_id;
                $i++;
            }

            // foreach($customers as $data)
            // {
            //     $customer_ids[$j] = $data->client_id;
            //     $j++;
            // }
            // print_r($vendor_ids);
            // print_r('-------------');

            // print_r($customer_ids);
            // die();
            $query = DebitNote::find()->orderBy(['id' => SORT_DESC])->where(['in', 'party_id', $vendor_ids])->andWhere(['is_deleted' =>0]);
            // $subquery = DebitNote::find()->orderBy(['id' => SORT_DESC])->where(['in', 'party_id', $customer_ids])->andWhere(['party_type'=>'customer'])->andWhere(['is_deleted' =>0]);

            // $query->union($subquery, true);
        }

        

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
            // 'sort'=> ['defaultOrder' => ['id' => SORT_ASC]],
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'sub_total' => $this->sub_total,
            'total' => $this->total,
            'match_bill' => $this->match_bill,
            'show_to_store_keeper' => $this->show_to_store_keeper,
            'full_order' => $this->full_order,
            'product_wise' => $this->product_wise,
            'created_at' => $this->created_at,
            'updated_at' => $this->updated_at,
        ]);

        $query->andFilterWhere(['like', 'setting_type', $this->setting_type])
            ->andFilterWhere(['like', 'sender_gst', $this->sender_gst])
            ->andFilterWhere(['like', 'bill_type', $this->bill_type])
            ->andFilterWhere(['like', 'notes', $this->notes])
            ->andFilterWhere(['like', 'supply_type', $this->supply_type])
            ->andFilterWhere(['like', 'supply_attracts', $this->supply_attracts])
            ->andFilterWhere(['like', 'pricelist', $this->pricelist])
            ->andFilterWhere(['like', 'point_of_supply', $this->point_of_supply])
            ->andFilterWhere(['like', 'ineligible_itc', $this->ineligible_itc])
            ->andFilterWhere(['like', 'prefix', $this->prefix])
            ->andFilterWhere(['like', 'po', $this->po])
            ->andFilterWhere(['like', 'suffix', $this->suffix])
            ->andFilterWhere(['like', 'date', $this->date])
            ->andFilterWhere(['like', 'bill_no', $this->bill_no])
            ->andFilterWhere(['like', 'bill_date', $this->bill_date])
            ->andFilterWhere(['like', 'product_code', $this->product_code])
            ->andFilterWhere(['like', 'debit_notes', $this->debit_notes]);
            if($this->party_id){
                $vendor=Vendor::find()->select('id')->where(['like','business_name',$this->party_id])->column();
                $customer=Customer::find()->select('id')->where(['like','business_name',$this->party_id])->column();
                $query->andFilterWhere([
                    'or',['in', 'party_id', $vendor],
                    ['in', 'party_id', $customer]
                ]);
                if(!$vendor&&!$customer){
                    $query->andFilterWhere([ 'party_id'=> 0]);
                }
            }

        return $dataProvider;
    }
}
