<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "inventory_pending_view".
 *
 * @property string|null $name
 * @property string $created_date
 * @property string $type
 * @property string|null $executive_name
 * @property string|null $note
 * @property string $latest_date
 * @property int $id
 * @property string|null $po
 * @property string|null $po_date
 * @property string|null $last_date
 * @property string|null $order_id
 * @property string|null $status
 * @property string $gr_status
 */
class InventoryPendingView extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'inventory_pending_view';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['created_date', 'latest_date'], 'required'],
            [['created_date', 'latest_date'], 'safe'],
            [['note'], 'string'],
            [['id'], 'integer'],
            [['name', 'status'], 'string', 'max' => 254],
            [['type'], 'string', 'max' => 13],
            [['executive_name'], 'string', 'max' => 20],
            [['po'], 'string', 'max' => 128],
            [['po_date'], 'string', 'max' => 10],
            [['last_date'], 'string', 'max' => 32],
            [['order_id'], 'string', 'max' => 255],
            [['gr_status'], 'string', 'max' => 11],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'name' => 'Name',
            'created_date' => 'Created Date',
            'type' => 'Type',
            'executive_name' => 'Executive Name',
            'note' => 'Note',
            'latest_date' => 'Latest Date',
            'id' => 'ID',
            'po' => 'Po',
            'po_date' => 'Po Date',
            'last_date' => 'Last Date',
            'order_id' => 'Order ID',
            'status' => 'Status',
            'gr_status' => 'Gr Status',
        ];
    }
}
