<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "invoice".
 *
 * @property int $id
 * @property string $settings_id
 * @property string $customer_name
 * @property string $executive
 * @property string $receiver_gstn
 * @property string $customer_referance
 * @property string $sales_type
 * @property string $notes
 * @property string $sypply_type
 * @property string $supply_reverse_change
 * @property string $po_number
 * @property string $po_date
 * @property string $price_list
 * @property string $point_of_supply
 * @property string $income_terms
 * @property string $tax_status
 * @property string $invoice_no
 * @property string $date
 * @property string $due_date
 * @property string $terms_of_payment
 * @property string $sub_total_price
 * @property string $round_up_price
 * @property string $total_price
 * @property string $time_of_preparation
 * @property string $time_o_removal
 * @property string $reminder
 * @property string $add_delivery_details
 * @property string $byers_details
 * @property string $dispatch_details
 * @property string $deliver_to
 * @property string $recurring
 * @property string $packing_details
 * @property string $invoice_documents
 * @property string $created_at
 * @property string $updated_at
 */
class Invoice extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'invoice';
    }
    public $invoice_search;
	
    public $email_attachment;
    public $from_date;
    public $to_date;
    public $customer;
    public $setting;
    public $total_amount;
    public $shipment;
    public $executives_name;
    public $bill_type;
    public $search_supply;
    public $po_no;
    public $po_searchdate;
    public $find_product;
    public $c_code;
    public $c_mobile;
    public $findid;
    public $text_send;
    public $send_email;
    public $bcc_to_email;
    public $cc_to_email;
    public $email_subject;
    public $email_message;
    public $so_number;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['customer_name','date','settings_id'], 'required'],

            [['notes', 'income_terms', 'invoice_documents','terms_of_delivery','reminder_emails','reminder_content','text_send','email_subject','email_message','findid','email_attachment','so_number','po_no'], 'string'],
            [['po_date', 'date', 'due_date', 'time_of_preparation', 'time_o_removal', 'created_at', 'updated_at','from_date','to_date','po_searchdate','dispatch_date','recurring_until_date','reminder_from_date','reminder_to_date','buyer_order_date','receipt_cheque_date'], 'safe'],
            [['settings_id', 'customer_name', 'executive', 'receiver_gstn', 'customer_referance', 'sales_type', 'sypply_type', 'supply_reverse_change', 'price_list', 'point_of_supply', 'tax_status', 'invoice_no', 'terms_of_payment','shipment_status','status','payment_details','invoice_search','customer','setting','shipment','executives_name','bill_type','search_supply','buyer_details','dispatch_document_no','dispatched_through','destination','recurring_frequency','recurring_until','net_weight','gross_weight','dimension_for_primary','dimention_for_master','dimention_for_pallet','no_of_pallets','delivery_receiver_name','deliver_to_address_1','deliver_to_address_2','deliver_to_city','deliver_to_state','deliver_state_code','deliver_to_country','reminder_for','reminder_through','reminder_repeat','delivery_note','suppliers_ref','other_reference','buyer_order','buyer','receipt_setting_type','receipt_total_amount','receipt_bank','receipt_cheque_no','advance_note','credit_note_id','receipt_id','customer_address','find_product','invoice_id','from_delivered'], 'string', 'max' => 254],
            [['po_number', 'sub_total_price', 'round_up_price', 'total_price','total_amount', 'reminder', 'add_delivery_details', 'buyer_details', 'dispatch_details', 'deliver_to', 'recurring', 'packing_details','prefix','suffix','igst_amount','cgst_amount','sgst_amount','tcs_amount','is_tcs'
            ,'round_off_amount','pending_amount','created_by','c_code','c_mobile'], 'string', 'max' => 100],
             // [['po_number','po_no'], 'string','min'=>10, 'max' => 10],
             // [['po_number','po_no'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'PO Number Can Contain only numeric characters.'],
            ['send_email','email','message'=> 'Enter a valid Email'],
            ['bcc_to_email','email','message'=> 'Enter a valid Email'],
            ['cc_to_email','email','message'=> 'Enter a valid Email'],
             [['receiver_gstn'], 'string','min'=>15, 'max' => 15],
             [['receiver_gstn'], 'match' ,'pattern'=>'/^([0-9]){2}([A-Z]){4}([0-9A-Z]){1}([0-9]){4}([A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}([0-9A-Z]){1}?$/', 'message'=> 'GSTN Format should be like  12ABCDE1234Z1Z1.'],
             ['due_date', 'compare', 'compareAttribute' => 'date', 'operator' => '>='],
             ['reminder_emails','email'],
             [['reminder_from_date'], 'compare' ,'compareValue'=>date("Y-m-d"),'operator'=>'>=', 'message'=> 'Due Date must be equal/greater than todays date'],
             ['reminder_to_date', 'compare', 'compareAttribute' => 'reminder_from_date', 'operator' => '>'],
             [['deliver_to_zipcode'], 'string','min'=>6, 'max' =>6],
		[['receipt_cheque_no'], 'string','max' =>6],
             [['deliver_to_zipcode'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Zip Code Can Contain only numeric characters.'],
             [['to_date'], 'compare' ,'compareAttribute' => 'from_date','operator'=>'>=', 'message'=> 'To Date must be equal/greater than From date'],
             ['to_date', 'required', 'when' => function($model) {
                return $model->from_date;
            },'whenClient' => "function (attribute, value) {
                return $('#invoice-from_date').val();
            }"],
            ['from_date', 'required', 'when' => function($model) {
                return $model->to_date;
            },'whenClient' => "function (attribute, value) {
                return $('#invoice-to_date').val();
            }"],



        ];  
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'settings_id' => 'Settings ID',
            'customer_name' => 'Customer Name',
            'executive' => 'Executive',
            'receiver_gstn' => 'Receiver Gstn',
            'customer_referance' => 'Customer Referance',
            'sales_type' => 'Sales Type',
            'notes' => 'Notes',
            'sypply_type' => 'Sypply Type',
            'supply_reverse_change' => 'Supply Reverse Change',
            'po_number' => 'Po Number',
            'po_date' => 'Po Date',
            'price_list' => 'Price List',
            'point_of_supply' => 'Point Of Supply',
            'income_terms' => 'Income Terms',
            'tax_status' => 'Tax Status',
            'invoice_no' => 'Invoice No',
            'date' => 'Date',
            'due_date' => 'Due Date',
            'terms_of_payment' => 'Terms Of Payment',
            'sub_total_price' => 'Sub Total Price',
            'round_up_price' => 'Round Up Price',
            'total_price' => 'Total Price',
            'time_of_preparation' => 'Time Of Preparation',
            'time_o_removal' => 'Time O Removal',
            'reminder' => 'Reminder',
            'add_delivery_details' => 'Add Delivery Details',
            'byers_details' => 'Byers Details',
            'dispatch_details' => 'Dispatch Details',
            'deliver_to' => 'Deliver To',
            'recurring' => 'Recurring',
            'packing_details' => 'Packing Details',
            'invoice_documents' => 'Invoice Documents',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
