<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "invoice_product".
 *
 * @property int $id
 * @property string $invoice_id
 * @property string $product_id
 * @property string $description
 * @property string $quantity
 * @property string $units
 * @property float $price
 * @property string $discount
 * @property string $tax
 * @property string $discount_type
 * @property string $tax_included
 * @property float $amount
 * @property int $is_deleted
 * @property string $created_at
 * @property string $updated_at
 */
class InvoiceProduct extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'invoice_product';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['created_at', 'updated_at','tax'], 'safe'],
            [['invoice_no', 'product_id', 'description', 'units', 'discount', 'discount_type', 'tax_included','unit_price'], 'string', 'max' => 254],
            [['quantity'], 'string', 'max' => 30],
            [['price', 'amount','unit_price'], 'number'],
            // ['discount_type', 'required', 'when' => function($model) {
            //     return $model->discount != '';
            // },'whenClient' => "function (attribute, value) {
            //     return $('#includediscount').val() != '';
            // }"],

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'invoice_id' => 'Invoice ID',
            'product_id' => 'Product ID',
            'description' => 'Description',
            'quantity' => 'Quantity',
            'units' => 'Units',
            'price' => 'Price',
            'discount' => 'Discount',
            'tax' => 'Tax',
            'discount_type' => 'Discount Type',
            'tax_included' => 'Tax Included',
            'amount' => 'Amount',
            'is_deleted' => 'Is Deleted',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
