<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "journal_debit_credit".
 *
 * @property int $id
 * @property int $account_id
 * @property float $debit_amount
 * @property float $credit_amount
 * @property string|null $remarks
 * @property int $is_deleted
 * @property string $created_at
 * @property string $updated_at
 */
class JournalDebitCredit extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'journal_debit_credit';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['account_id'], 'required'],
            [['account_id', 'is_deleted'], 'integer'],
            [['debit_amount', 'credit_amount'], 'number'],
            [['remarks'], 'string'],
            [['created_at', 'updated_at'], 'safe'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'account_id' => 'Account ID',
            'debit_amount' => 'Debit Amount',
            'credit_amount' => 'Credit Amount',
            'remarks' => 'Remarks',
            'is_deleted' => 'Is Deleted',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
