<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "journal_invoicesbills".
 *
 * @property int $id
 * @property int $journal_id
 * @property int $journal_debit_credit_id
 * @property string $invoice_id
 * @property float $invoice_amount
 * @property string $invoice_date
 * @property float $invoice_pay_amount
 * @property float $invoice_tds_amount
 * @property string $invoice_notes
 * @property string $bill_type
 */
class JournalInvoicesbills extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'journal_invoicesbills';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['journal_id', 'journal_debit_credit_id', 'invoice_id', 'invoice_amount', 'invoice_date', 'invoice_pay_amount', 'invoice_tds_amount', 'invoice_notes', 'bill_type'], 'required'],
            [['journal_id', 'journal_debit_credit_id'], 'integer'],
            [['invoice_amount', 'invoice_pay_amount', 'invoice_tds_amount'], 'number'],
            [['invoice_date'], 'safe'],
            [['invoice_notes'], 'string'],
            [['invoice_id', 'bill_type'], 'string', 'max' => 256],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'journal_id' => 'Journal ID',
            'journal_debit_credit_id' => 'Journal Debit Credit ID',
            'invoice_id' => 'Invoice ID',
            'invoice_amount' => 'Invoice Amount',
            'invoice_date' => 'Invoice Date',
            'invoice_pay_amount' => 'Invoice Pay Amount',
            'invoice_tds_amount' => 'Invoice Tds Amount',
            'invoice_notes' => 'Invoice Notes',
            'bill_type' => 'Bill Type',
        ];
    }
}
