<?php

namespace backend\modules\users\models;

use Yii;
use yii\base\Model;
use yii\data\ActiveDataProvider;
use backend\modules\users\models\LeadsQuotes;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use backend\models\UserClient;

/**
 * LeadsQuotesSearch represents the model behind the search form of `backend\modules\users\models\LeadsQuotes`.
 */
class LeadsQuotesSearch extends LeadsQuotes
{
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id', 'is_deleted','closure_property'], 'integer'],
            [['supply_attracts', 'customer', 'executive', 'notes', 'receiver_gstn', 'sales_type', 'supply_type', 'supply_attracts_rcharge', 'pointof_supply', 'pricelist', 'terms', 'Is_tax_paid', 'prefix', 'quotes_no', 'suffix', 'quotes_id', 'set_reminder', 'add_delivery_details', 'packing_details', 'date', 'created_date', 'updated_date','converted_to','status'], 'safe'],
            [['sub_total_amount', 'total_amount'], 'number'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function scenarios()
    {
        // bypass scenarios() implementation in the parent class
        return Model::scenarios();
    }

    /**
     * Creates data provider instance with search query applied
     *
     * @param array $params
     *
     * @return ActiveDataProvider
     */
    public function search($params,array $accessed=null)
    {
        if($accessed == null)
        {
            $query=LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC]);
        }
        else
        {
            $check_id = Yii::$app->user->identity->id;
            $all = LeadsQuotes::find()->where(['is_deleted'=>0])->orderBy(['id' => SORT_DESC])->all();
            $exe_array= [];
             $i=0;
            foreach ($all as $key => $val) {

                $executivedetails = LeadExecutive::find()->where(['id'=>$val['executive']])->one();
                // print_r( $executivedetails);
                
                if($executivedetails!='')
                {
                   if($executivedetails->type == $accessed[0]) 
                      $exe_array[$i] = $executivedetails->id;
                    $i++;
                }
            }
            // die();
            $exe_array = array_unique($exe_array);
            $customers = UserClient::find()->where(['user_id'=>$check_id])->andWhere(['client_type'=>'Customer'])->all();
            $customer_ids = [];
            $j = 0;
            foreach($customers as $data)
            {
                $customer_ids[$j] = $data->client_id;
                $j++;
            }

            $query = LeadsQuotes::find()->where(['is_deleted'=>0])->andWhere(['in', 'customer', $customer_ids])->andWhere(['in', 'executive', $exe_array])->orderBy(['id' => SORT_DESC]);
        }

        // add conditions that should always apply here

        $dataProvider = new ActiveDataProvider([
            'query' => $query,
        ]);

        $this->load($params);

        if (!$this->validate()) {
            // uncomment the following line if you do not want to return any records when validation fails
            // $query->where('0=1');
            return $dataProvider;
        }

        // grid filtering conditions
        $query->andFilterWhere([
            'id' => $this->id,
            'sub_total_amount' => $this->sub_total_amount,
            'total_amount' => $this->total_amount,
            'date' => $this->date,
            'is_deleted' => $this->is_deleted,
            'created_date' => $this->created_date,
            'updated_date' => $this->updated_date,
            'closure_property' => $this->closure_property,
        ]);

        $query->andFilterWhere(['like', 'supply_attracts', $this->supply_attracts])
            ->andFilterWhere(['like', 'notes', $this->notes])
            ->andFilterWhere(['like', 'receiver_gstn', $this->receiver_gstn])
            ->andFilterWhere(['like', 'sales_type', $this->sales_type])
            ->andFilterWhere(['like', 'supply_type', $this->supply_type])
            ->andFilterWhere(['like', 'supply_attracts_rcharge', $this->supply_attracts_rcharge])
            ->andFilterWhere(['like', 'pointof_supply', $this->pointof_supply])
            ->andFilterWhere(['like', 'pricelist', $this->pricelist])
            ->andFilterWhere(['like', 'terms', $this->terms])
            ->andFilterWhere(['like', 'Is_tax_paid', $this->Is_tax_paid])
            ->andFilterWhere(['like', 'prefix', $this->prefix])
            ->andFilterWhere(['like', 'quotes_no', $this->quotes_no])
            ->andFilterWhere(['like', 'suffix', $this->suffix])
            ->andFilterWhere(['like', 'quotes_id', $this->quotes_id])
            ->andFilterWhere(['like', 'set_reminder', $this->set_reminder])
            ->andFilterWhere(['like', 'status', $this->status])
            ->andFilterWhere(['like', 'add_delivery_details', $this->add_delivery_details])
            ->andFilterWhere(['like', 'packing_details', $this->packing_details]);
            if($this->customer){
                $customer=Customer::find()->select('id')->where(['like','business_name',$this->customer])->column();
               $query->andFilterWhere(['in', 'customer', $customer]);}
            if($this->executive){
                $customer=LeadExecutive::find()->select('id')->where(['like','name',$this->executive])->column();
               $query->andFilterWhere(['in', 'executive', $customer]);}  
            if($this->converted_to){
                $find=LeadsQuotes::find()->select('converted_to')->where(['converted_to'=>$this->converted_to])->column();
               $query->andFilterWhere(['in', 'converted_to', $find]);}    

        return $dataProvider;
    }
}
