<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "product_delivered".
 *
 * @property int $id
 * @property string $setting_id
 * @property int $customer_id
 * @property string $date
 * @property string|null $remarks
 * @property string $prefix
 * @property string $dc_no
 * @property string $suffix
 * @property string|null $notes
 * @property string|null $terms
 * @property string|null $product_code
 * @property int $dispatch_details
 * @property string|null $dispatch_doc_no
 * @property string|null $dispatch_date
 * @property string|null $dispatched_through
 * @property string|null $destination
 * @property string|null $terms_of_delivery
 * @property int $deliver_to
 * @property string|null $company
 * @property string|null $name
 * @property string|null $address_1
 * @property string|null $address_2
 * @property string|null $city
 * @property string|null $state
 * @property string|null $zip_code
 * @property int $request_invoice
 * @property string $created_at
 * @property string $updated_at
 */
class ProductDelivered extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'product_delivered';
    }
    public $from_date;
    public $to_date;
    public $refno;
    public $customer;
    public $image;

    public $mail_id;
    public $send_email;
    public $bcc_to_email;
    public $cc_to_email;
    public $email_subject;
    public $email_message;
    public $so_number;
    public $email_attachment;
    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['setting_id', 'customer_id', 'date', 'dc_no', 'suffix'], 'required'],
            [[ 'dispatch_details', 'deliver_to', 'request_invoice','is_invoiced'], 'integer'],
            [['image','remarks', 'notes', 'terms', 'product_code', 'destination', 'terms_of_delivery', 'name', 'address_1', 'address_2','send_email','bcc_to_email','cc_to_email','email_subject','email_message','so_number','mail_id'], 'string'],
            [['from_date','to_date','refno','customer','created_at', 'updated_at'], 'safe'],
            [['email_attachment'], 'file', 'skipOnEmpty' => true, 'extensions' => 'pdf, jpg, png'],
            [['setting_id'], 'string', 'max' => 16],
            [['date', 'prefix', 'suffix', 'dispatch_date'], 'string', 'max' => 32],
            [['dispatch_doc_no', 'dispatched_through', 'company', 'city', 'state'], 'string', 'max' => 128],
            [['form_saleorder','invoice_no'], 'string', 'max' => 254],
            [['zip_code'], 'string', 'max' => 9],
            [['zip_code'], 'match' ,'pattern'=>'/^[0-9]+$/u', 'message'=> 'Zip Code Can Contain only numeric character'], 

        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'setting_id' => 'Setting ID',
            'customer_id' => 'Customer',
            'date' => 'DC Date',
            'remarks' => 'Remarks',
            'prefix' => 'Prefix',
            'dc_no' => 'Dc No',
            'suffix' => 'Suffix',
            'notes' => 'Notes',
            'terms' => 'Terms',
            'product_code' => 'Product Code',
            'dispatch_details' => 'Dispatch Details',
            'dispatch_doc_no' => 'Dispatch Doc No',
            'dispatch_date' => 'Dispatch Date',
            'dispatched_through' => 'Dispatched Through',
            'destination' => 'Destination',
            'terms_of_delivery' => 'Terms Of Delivery',
            'deliver_to' => 'Deliver To',
            'company' => 'Company',
            'name' => 'Name',
            'address_1' => 'Address 1',
            'address_2' => 'Address 2',
            'city' => 'City',
            'state' => 'State',
            'zip_code' => 'Zip Code',
            'request_invoice' => 'Request Invoice',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
