<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "product_received".
 *
 * @property int $id
 * @property string $setting_id
 * @property int $vendor_id
 * @property string|null $date
 * @property string $prefix
 * @property string $shippment_no
 * @property string|null $suffix
 * @property string $notes
 * @property string $income_terms
 * @property string $product_code
 * @property string $created_at
 * @property string $updated_at
 */
class ProductReceived extends \yii\db\ActiveRecord
{
    public $from_date;
    public $to_date;
    public $shippment;
    public $vendor;
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'product_received';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['setting_id', 'vendor_id', 'prefix', 'shippment_no','date'], 'required'],
            [['vendor_id','is_billed'], 'integer'],
            [['notes', 'income_terms','product_code'], 'string'],
            [['shippment','vendor','from_date','to_date','created_at', 'updated_at'], 'safe'],
            [['setting_id', 'prefix', 'suffix'], 'string', 'max' => 8],
            [['date'], 'string', 'max' => 32],
            [['purchase_order_id','bill_order_id'], 'string', 'max' => 254],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'setting_id' => 'Setting ID',
            'vendor_id' => 'Vendor',
            'date' => 'Date',
            'prefix' => 'Prefix',
            'shippment_no' => 'Shipment No',
            'suffix' => 'Suffix',
            'notes' => 'Notes',
            'income_terms' => 'Income Terms',
            'product_code' => 'Product Code',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
