<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "purchase_bill".
 *
 * @property int $id
 * @property string $setting_type
 * @property int $vendor_id
 * @property string|null $vendor_bill_no
 * @property string|null $bill_date
 * @property string|null $sender_gst_id
 * @property string|null $notes
 * @property string|null $bill_type
 * @property string $supply_type
 * @property int|null $supply_attracts
 * @property int|null $is_ineligible_itc
 * @property string|null $point_of_supply
 * @property string|null $pricelist
 * @property string|null $prefix
 * @property string|null $bill_no
 * @property string|null $suffix
 * @property string $date
 * @property string $due_date
 * @property string|null $bill_notes
 * @property string|null $terms_of_payment
 * @property string|null $product_code
 * @property float $subtotal
 * @property float $total
 * @property float|null $tcs
 * @property int|null $round_off
 * @property int|null $payment
 * @property int|null $set_reminder
 * @property int $show_to_store_keeper
 * @property int $order_type
 * @property string|null $terms
 * @property string $created_at
 * @property string $updated_at
 */
class PurchaseBill extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'purchase_bill';
    }
    public $from_date;
    public $to_date;
    public $vendor;
    public $setting;
    public $amount;
    public $image;
    public $product;
    public $transaction;
    public $account;
    public $supplier_bill;
    public $po;
    public $description;
    public $shipment;
    public $grn;


    public $c_code;
     public $c_mobile;
     public $findid;
     public $text_send;

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['setting_type', 'vendor_id', 'date', 'due_date'], 'required'],
            [['advance_setting_type','amount','bank','advance_note','cheque_no','cheque_date', 'supply_attracts', 'is_ineligible_itc', 'round_off', 'payment', 'set_reminder', 'show_to_store_keeper', 'order_type'], 'safe'],
            [['vendor_bill_no', 'sender_gst_id', 'notes', 'bill_no', 'bill_notes', 'product_code', 'terms','findid','text_send'], 'string'],
            [['amount','subtotal', 'tcs'], 'number'],
            [['total','from_date','to_date','vendor','setting','amount','product','transaction','account','supplier_bill','po','description','shipment','grn','image','created_at', 'updated_at','is_tcs'], 'safe'],
            [['setting_type', 'bill_date', 'bill_type', 'date', 'due_date'], 'string', 'max' => 32],
            [['supply_type', 'point_of_supply', 'pricelist', 'prefix', 'suffix','full_bill_name', 'terms_of_payment','c_code','c_mobile'], 'string', 'max' => 64],
            ['amount', 'compare', 'compareValue' => 0.1, 'operator' => '>='],
            // ['total', 'compare', 'compareValue' => 0.1, 'operator' => '>='],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'setting_type' => 'Setting Type',
            'vendor_id' => 'Vendor ID',
            'vendor_bill_no' => 'Vendor Bill No',
            'bill_date' => 'Bill Date',
            'sender_gst_id' => 'Sender Gst ID',
            'notes' => 'Notes',
            'bill_type' => 'Bill Type',
            'supply_type' => 'Supply Type',
            'supply_attracts' => 'Supply Attracts',
            'is_ineligible_itc' => 'Is Ineligible Itc',
            'point_of_supply' => 'Point Of Supply',
            'pricelist' => 'Pricelist',
            'prefix' => 'Prefix',
            'bill_no' => 'Bill No',
            'suffix' => 'Suffix',
            'date' => 'Date',
            'due_date' => 'Due Date',
            'bill_notes' => 'Bill Notes',
            'terms_of_payment' => 'Terms Of Payment',
            'product_code' => 'Product Code',
            'subtotal' => 'Subtotal',
            'total' => 'Total',
            'tcs' => 'Tcs',
            'round_off' => 'Round Off',
            'payment' => 'Payment',
            'set_reminder' => 'Set Reminder',
            'show_to_store_keeper' => 'Show To Store Keeper',
            'order_type' => 'Order Type',
            'terms' => 'Terms',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
