<?php

namespace backend\modules\users\models;

use Yii;

/**
 * This is the model class for table "saleorder_against_dc".
 *
 * @property int $id
 * @property int|null $saleorder_id
 * @property int|null $dc_id
 * @property int|null $customer_id
 * @property float|null $total_amount
 * @property float|null $delivered_amount
 * @property string|null $saleorder_date
 * @property string|null $source
 * @property int|null $dc_status
 * @property int|null $invoice_no
 * @property string $created_at
 * @property string $updated_at
 */
class SaleorderAgainstDc extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'saleorder_against_dc';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'required'],
            [['id', 'saleorder_id', 'dc_id', 'customer_id', 'dc_status', 'invoice_no','is_deleted'], 'integer'],
            [['total_amount'], 'number'],
            [['saleorder_date', 'created_at', 'updated_at'], 'safe'],
            [['source','convert_to'], 'string'],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'saleorder_id' => 'Saleorder ID',
            'dc_id' => 'Dc ID',
            'customer_id' => 'Customer ID',
            'total_amount' => 'Total Amount',
            'delivered_amount' => 'Delivered Amount',
            'saleorder_date' => 'Saleorder Date',
            'source' => 'Source',
            'dc_status' => 'Dc Status',
            'invoice_no' => 'Invoice No',
            'created_at' => 'Created At',
            'updated_at' => 'Updated At',
        ];
    }
}
