<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use yii\helpers\Url;
use backend\modules\users\models\AccountingContra;
use backend\modules\master\models\AccountingLedger;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\AccountingContraSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
$query = new yii\db\Query();
$data = $query->select(['user'])
    ->from('accounting_contra')
    ->distinct()
    ->all();
$listData=ArrayHelper::map($data,'user','user');

$rows = (new \yii\db\Query())
->select('ledger_id')
->from('accounting_ledger')
->where(['account_type_id' => 2])
// ->limit(10)
->all();

// if ($data) {
//     foreach ($data as $row) {
//         echo ': ' . $row['user'] . '<br>';
//     }
// }
// print_r($data);die();
$this->title = 'Accounting Contra';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
                    <?php endif; ?>
                    <div class="app-main__inner">
                    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                                <div class="card">
                                    <div class="no-gutters row">
                                        <div class="col-md-12 col-lg-12">
                                            <ul class="list-group list-group-flush">
                                                <li class="bg-transparent list-group-item">
                                                    <div class="widget-content p-0">
                                                        <div class="widget-content-outer">
                                                            <div class="widget-content-wrapper">
                                                                <div class="widget-content-left">
                                                                    <div class="widget-numbers dj-text-success">Accounting Contra</div>
                                                                </div>
                                                                <div class="widget-content-right">
                                                                <a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Contra</a>

                                                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/create'])->one()!=''){?>
                                                                <a href="<?=Url::base()?>/users/accounting-contra/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Contra</a>
                                                               <?php }else {?>

                                                               <?php } ?>
                                                                    
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </li>
                                            
                                            </ul>
                                        </div>
                                    
                                        
                                    </div>
                                </div>
                            </div>
                            <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['action' => ['index'],'method' => 'get'],['options' => ['class'=>"dj-sale-form collapse"]]); ?>
						   <div class="row dj-adv-search-row">
						   <div class="col-md-5">
                               <div class="position-relative form-group">
                               <?= $form->field($searchModel, 'contra_no')->textInput(['maxlength' => true,'class'=>"form-control",'placeholder'=>"Contra No"])->label(false) ?>
                              </div>
                            </div>
							<div class="col-md-2">
                            <button class="btn btn-rounded search_field_buttons"><i class="fa fa-search"></i> Search</button>

							</div>
                            <?php ActiveForm::end(); ?>
							<div class="col-md-4">
							<a id='advance-search' class="btn btn-rounded search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>

                            <a style="margin-left: 49px" class="vendorrefresh search_field_buttons"  href="<?=Url::base()?>/users/accounting-contra/index" role="button" ><i class="fa fa-refresh" aria-hidden="true"></i></a>

							</div>
                            
						   </div>
                        <?php $form = ActiveForm::begin(['method' => 'get','options' => ['class'=>"dj-sale-form collapse"]]); ?>

                                        <div class="form-row">
										
                                        <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>

                                                   <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                                                   <?= $form->field($searchModel, 'from_date')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                   <!-- <input name="amount" id="amount" type="date" class="form-control"> -->
                                                   <?= $form->field($searchModel, 'to_date')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Setting Type</label>
                                                    <?= $form->field($searchModel, 'contra_type')->dropdownList(['contra'=>'Contra'],['prompt'=>'-Select-','maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                     <!-- <select class="multiselect-dropdown form-control">
														<option value="1">-Select Setting Type-</option>
                                                    </select> -->
                                                </div>
                                            </div>
    											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">User</label>
                                               <?= $form->field( $searchModel, 'user')->dropDownList($listData,[ 'prompt' => '-Select User-' ])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Bank</label>
                                                    <?= $form->field($searchModel, 'bank')->dropDownList( ArrayHelper::map($rows, 'ledger_id', 'ledger_id'),['prompt'=>'-Select Bank-'])->label(false)?>
                                                     <!-- <select class="multiselect-dropdown form-control">
														<option value="1">-Select a Bank-</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Notes</label>
                                                    <?= $form->field($searchModel, 'notes')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                   <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount From</label>
                                                    <!-- <?= $form->field($searchModel, 'op1')->dropdownList(['='=>'=','<'=>'<','<='=>'<=','>'=>'>','>='=>'>='],['prompt'=>'-Select-','maxlength' => true,'class'=>"form-control"])->label(false) ?> -->
                                                    <?=$form->field($searchModel, 'op1')->dropDownList(['>'=>'>','>='=>'>='], ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>
                                                   <!-- <select class="multiselect-dropdown form-control">
														<option value="=">=</option>
														<option value="<">&lt;</option>
														<option value="<=">&lt;=</option>
														<option value=">">&gt;</option>
														<option value=">=">&gt;=</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">with</label>
                                                    <?= $form->field($searchModel, 'with1')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                   <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount to</label>
                                                    <!-- <?= $form->field($searchModel, 'op2')->dropdownList(['='=>'=','<'=>'<','<='=>'<=','>'=>'>','>='=>'>='],['prompt'=>'-Select-','maxlength' => true,'class'=>"form-control"])->label(false) ?> -->
                                                    <?=$form->field($searchModel, 'op2')->dropDownList(['<'=>'<','<='=>'<='], ['prompt' => '--Select--', 'class' => "multiselect form-control", 'maxlength' => true])->label(false)?>
                                                   <!-- <select class="multiselect-dropdown form-control">
														<option value="=">=</option>
														<option value="<">&lt;</option>
														<option value="<=">&lt;=</option>
														<option value=">">&gt;</option>
														<option value=">=">&gt;=</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">with</label>
                                                    <?= $form->field($searchModel, 'with2')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                   <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                                                </div>
                                            </div>
											<div class="col-md-4 dj-btn-align">
											<button class="btn btn-info btn-rounded dj-search"><i class="fa fa-search"></i> Search</button>
											</div>
                                        </div>
                                        <?php ActiveForm::end(); ?> 
                                    
                                </div>
                        </div>
						  <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						<div class="col-md-6">

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/delete'])->one()!=''){?>
                            <button id='delete' class='mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn'><i class="fa fa-trash"></i> Delete</button>
                           <?php }else {?>

                           <?php } ?>
                        

							</div>
							<div class="col-md-6">
						<div class="djsec-text-right dj-print-sec">

                         <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/excel-export'])->one()!=''){?>
                            <a href="<?=Url::base();?>/users/accounting-contra/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                            
                             <a href="<?=Url::base();?>/users/accounting-contra/excel-export" data-method="post">   <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                           <?php }else {?>

                           <?php } ?> 

                           <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/contra-template'])->one()!=''){?>
                            <a href="<?=Url::base();?>/users/accounting-contra/contra-template?from=all" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                           <?php }else {?>

                           <?php } ?>   

                           
							
											
                                     </div>
							 </div>
							 </div>
                             <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
            'contra_no',
            [
                'label'=>'Amount',
                'contentOptions'=>[ 'style'=>'text-align:right'],
                'headerOptions'=>[ 'style'=>'text-align:right'],
               'attribute' => 'amount',
               'value' => function ($data) {
                $finalamount = number_format((float)$data->amount, 2, '.', '');
                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$finalamount);
                return $num;   
                //return number_format($data->amount,2);
               }
            ],
            //'contra_id',
            //'contra_type',
            // 'date:date',
            [
                'header'=> 'Date',
                'value'=> function($data){
                    if($data->date!=''){
                    return date(("\ F j  Y"), strtotime($data->date));
                    }else{

                    }
                } 
            ],
            [
                'label'=>'From',
               'attribute' => 'source_bank',
               'value' => function ($data) {
                $value=AccountingContra::find()->where(['contra_id'=>$data->contra_id])->one();
                return $value?$value->source_bank:'';
               }
            ],
            // 'destination_bank',
            [
                'label'=>'To',
               'attribute' => 'destination_bank',
               'value' => function ($data) {
                $value=AccountingContra::find()->where(['contra_id'=>$data->contra_id])->one();
                return $value?$value->destination_bank:'';
               }
            ],
            'notes',
            //'voucher_no',
            //'prefix',
            //'contra_no',
            //'suffix',
            //'ceated_at',
            //'update_at',
            // ['class' => 'yii\grid\ActionColumn'],
            [
                'label' => 'Action',
                'contentOptions'=>['style'=>'width:35px'],
                'format'=>'raw',
                'value' => function ($data) use ($assign) {


                    $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';  


                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/contra-template'])->one()!='')
                    {
                            $printstring = '<li class="nav-item">
                            <a class="nav-link" target="_blank" href='.Url::base().'/users/accounting-contra/contra-template?id='.$data->contra_id.' data-method=post>
                               <i class="fa fa-print"></i>
                                <span class="dj-icon-gap"> Print</span>
                            </a>
                        </li>';
                    }
                    else
                    {
                        $printstring = '';
                    }


                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/accounting-contra/view?id='.$data->contra_id.' , data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap"> View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/accounting-contra/update?id='.$data->contra_id.'>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-contra/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/accounting-contra/delete?id='.$data->contra_id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                    return $topstring.''.$printstring.''.$viewstring.''.$editstring.''.$deletestring.''.$downstring;
                },
            ],
        ],
    ]); ?>
                        </div>
                    </div>
                </div>

                <?php ob_start();?>
 <script type="text/javascript">
$(function() {
    $('#datepicker').datepicker({
            uiLibrary: 'bootstrap4'
        });
//     var $operations2 = $('#accountingcontrasearch-op2');
//     var operations1 = {
//         '=':  [],
//         '<':  ['>','>='],
//         '<=': ['>','>='],
//         '>':  ['<','<='],
//         '>=': ['<','<='],
//     }
// var op1 = $('#accountingcontrasearch-op1').val(), lcns = operations1[op1] || [];
// if(op1==='='){
//     $("#accountingcontrasearch-with2").prop('disabled', true);
// }
// //   console.log(op1);
// var html = $.map(lcns, function(lcn){
//         return '<option value="' + lcn + '">' + lcn + '</option>'
//     }).join('');
//     $operations2.html(html);

$('#accountingcontrasearch-from_date').attr('type','date');
$('#accountingcontrasearch-to_date').attr('type','date');
$('input[name="AccountingContraSearch[date]"]').attr('type','date');
$('#delete').click(function(){
var ids = $('#w2').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})
$('#w1').hide();
$('#advance-search').click(function(){
    $('#w1').toggle();
});

$('#accountingcontrasearch-op1').change(function(){
    var op1 = $(this).val(), lcns = operations1[op1] || [];
    if(op1==='='){
        // $("#accountingcontrasearch-with2").val('1');
        $("#accountingcontrasearch-with2").prop('disabled', true);
        }else{
            $("#accountingcontrasearch-with2").prop('disabled', false);

        }
    
    var html = $.map(lcns, function(lcn){
            return '<option value="' + lcn + '">' + lcn + '</option>'
        }).join('');
        $operations2.html(html)
    
        });

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
