<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use backend\modules\users\models\AccountingJournal;
use backend\modules\master\models\AccountingLedger;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id' => $id])->one();

$vendorledgername = AccountingLedger::find()->where(['group_name_id' => 29])->andWhere(['account_type_id' => 3])->all();
$customerledgername = AccountingLedger::find()->where(['group_name_id' => 28])->andWhere(['account_type_id' => 4])->all();
$otherledgername = AccountingLedger::find()->where(['and', ['!=', 'group_name_id', 28], ['!=', 'group_name_id', 29]])->all();
$Customersname = '';
foreach ($customerledgername as $value) {
    $Customersname .= "<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}
$vendorsname = '';
foreach ($vendorledgername as $value) {
    $vendorsname .= "<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}

$otherssname = '';
foreach ($otherledgername as $value) {
    $otherssname .= "<option value=$value->accounting_ledger_id>$value->ledger_id</option>";
}
?>
<style>
    .custDispTbl2 th {
        background: url(../../../images/tblHdrBg.gif) repeat-x scroll left top #0E91BE;
        border: 1px solid #FFF;
        color: #FFFFFF;
        font-size: 0.9em;
        font-weight: bold;
        text-align: center;
        height: 30px;
        vertical-align: middle;
    }

    input[type="text"],
    [type="number"] {
        background-color: #ffffff;
        background-image: none;
        border: 1px solid #e5e6e7;
        border-radius: 1px;
        color: inherit;
        display: block;
        font-size: 14px;
        padding: 6px;
        transition: border-color 0.15s ease-in-out 0s, box-shadow 0.15s ease-in-out 0s;
        width: 100%;
    }

    input::-webkit-outer-spin-button,
    input::-webkit-inner-spin-button {
        -webkit-appearance: none;
        margin: 0;
    }

    span.select2.select2-container.select2-container--default {
        width: 242.406px !important;
    }

    body {
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }

    .form-control {
        transition: all .2s;
        font-family: Arial, Helvetica, sans-serif;
        font-size: 13px;
    }
</style>
<div class="app-main__inner">
    <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
        <div class="card">
            <div class="no-gutters row">
                <div class="col-md-12 col-lg-12">
                    <ul class="list-group list-group-flush">
                        <li class="bg-transparent list-group-item">
                            <div class="widget-content p-0">
                                <div class="widget-content-outer">
                                    <div class="widget-content-wrapper">
                                        <div class="widget-content-left">
                                            <div class="widget-numbers dj-text-success"><?= !$update ? "Add" : "Update" ?> a Journal</div>
                                        </div>
                                        <div class="widget-content-right">
                                            <a href="<?= Url::base() . '/users/accounting-journal/index' ?>" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </li>

                    </ul>
                </div>


            </div>
        </div>
    </div>
    <div class="main-card mb-3 card">
        <div class="card-body">
            <?php $form = ActiveForm::begin(); ?>
            <div class="form-row">
                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="setting Id">Journal Type<span class="dj-red">*</span></label>
                        <?= $form->field($model, 'journal_type')->dropDownList(['Journal' => 'Journal'], ['class' => "multiselect-dropdown form-control", 'maxlength' => true])->label(false) ?>

                    </div>
                </div>

                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="date">Date <span class="dj-red">*</span></label>
                        <?= $form->field($model, 'date')->textInput(['maxlength' => true, 'class' => "form-control", 'value' => date('Y-m-d', time())])->label(false) ?>
                    </div>
                </div>


                <div class="col-md-6">
                    <div class="position-relative form-group">

                        <div class="form-row">

                            <div class="col-md-4">
                                <label for="JV-no">Prefix</label>

                                <?= $form->field($model, 'prefix')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true, 'value' => 'J'])->label(false) ?>
                            </div>
                            <div class="col-md-4">
                                <label for="salesorder" class="">Jv No#<?= $update ? $model->jv_no - 1 : $count ?></label>
                                <?php if ($update) { ?>
                                    <?= $form->field($model, 'jv_no')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true])->label(false) ?>
                                <?php } else { ?>
                                    <?= $form->field($model, 'jv_no')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true, 'value' => $count + 1])->label(false) ?>
                                <?php } ?>
                            </div>
                            <div class="col-md-4">
                                <label for="JV-no">Suffix</label>

                                <?= $form->field($model, 'suffix')->textInput(['maxlength' => true, 'class' => "form-control", 'readonly' => true])->label(false) ?>
                            </div>
                        </div>
                        <div>
                            <div class="position-relative form-group">
                                <label for="Roll.No">Ref No. </label>
                                <?= $form->field($model, 'ref_no')->textInput(['maxlength' => true, 'class' => "form-control"])->label(false) ?>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="position-relative form-group">
                        <label for="Note">Notes</label>
                        <?= $form->field($model, 'notes')->textarea(['class' => "form-control", 'rows' => '4'])->label(false) ?>
                    </div>
                </div>

            </div>
            <hr class="dj-hr">
            <div class="form-row">

                <?php if ($update) {
                    if ($datalist) {
                        foreach ($datalist as $index => $value) { ?>
                            <table class="mb-0 table table-bordered dj-table-form">
                                <thead>
                                    <tr>

                                        <th colspan="3" width=30%>Account</th>
                                        <th>Debit</th>
                                        <th>Credit</th>
                                        <th>Remark</th>

                                    </tr>
                                </thead>

                                <tbody id="dj-table-body">
                                    <tr class='firstrow'>
                                        <?php if ($index == 0 || $index == 1) { ?>
                                            <td colspan=2 class="text-center"><i class="refreshind fa fa-refresh" aria-hidden="true" style="color: blue;"></i></td>
                                        <?php } else { ?>
                                            <td class="text-center"><i class="refreshind fa fa-refresh" aria-hidden="true" style="color: blue;"></i></td>
                                            <td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td>
                                        <?php } ?>
                                        <td><select required name="account<?= $index + 1 ?>" id="account<?= $index + 1 ?>" class="accountind form-control">
                                                <option value="<?= $value->account_id ?>"><?= $value->id ?></option>
                                            </select></td>
                                        <!-- multiselect-dropdown -->
                                        <td><input required min=0.1 step="0.01" name="debit<?= $index + 1 ?>" id="debit<?= $index + 1 ?>" type="number" class="form-control debitind" value=<?= $value['debit_amount'] ?>></td>
                                        <td><input required min=0.1 step="0.01" name="credit<?= $index + 1 ?>" id="credit<?= $index + 1 ?>" type="number" class="form-control creditind" value=<?= $value['credit_amount'] ?>></td>
                                        <td><input name="remark<?= $index + 1 ?>" id="remark<?= $index + 1 ?>" type="text" class="form-control remarkind" value=<?= $value['remarks'] ?>></td>

                                    </tr>
                                </tbody>





                            </table>
                            <!-- <tr>
                                            <td><label class="dj-total-amt">Total</label></td>
                                            <td  class="text-right"><label class="dj-total-amt">0.00</label></td>
                                            <td  class="text-right"><label class="dj-total-amt">0.00</label></td>
                                          </tr> -->
                        <?php }
                    } else { ?>
                        <!-- UPDATE TIME -->



                        <table class="mb-0 table table-bordered dj-table-form">
                            <thead>
                                <tr>
                                    <th colspan="3" width=30%>Account</th>
                                    <th>Debit</th>
                                    <th>Credit</th>
                                    <th>Remark</th>
                                </tr>
                            </thead>
                            <tbody id="dj-table-body">
                                <tr class='firstrow'>
                                    <td colspan=2 class="text-center"><i class="refreshind fa fa-refresh" aria-hidden="true" style="color: blue;"></i></td>
                                    <!-- <td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td> -->
                                    <td><select class="form-control select_class required select2-offscreen accountind" data-errorrequired="Select Account"  tabindex="-1" id="account1" name="account1">
                                            <option value="">Select an Account</option>
                                            <optgroup label="Customers"><?= $Customersname ?></optgroup>
                                            <optgroup label="Vendors"><?= $vendorsname ?></optgroup>
                                            <optgroup label="Others"><?= $otherssname ?></optgroup>
                                        </select></td>
                                    <!-- multiselect-dropdown -->
                                    <td><input required min=0.1 step="0.01" name="debit1" id="debit1" type="number" class="form-control debitind"></td>
                                    <td><input required min=0.1 step="0.01" name="credit1" id="credit1" type="number" class="form-control creditind"></td>
                                    <td><input name="remark1" id="remark1" type="text" class="form-control remarkind"></td>
                                </tr>
                            </tbody>
                        </table>

                        <!-- <tr>
                                            <td><label class="dj-total-amt">Total</label></td>
                                            <td  class="text-right"><label class="dj-total-amt">0.00</label></td>
                                            <td  class="text-right"><label class="dj-total-amt">0.00</label></td>
                                          </tr> -->

                        <div class="col-md-12 form-group" style="">
                            <div class="invoice-table" style="display:none;">
                                <h3 style="background: none repeat scroll 0 0 #61A3CB;color: #FFFFFF; padding: 5px;" id="myHeader"></h3>
                                <div class="col-md-12 form-group" id="showreceipt" style="">
                                    <table class="custDispTbl2" style="width: 100%;">
                                        <thead>
                                            <tr>
                                                <th>Entry Type </th>
                                                <th>Entry No # </th>
                                                <th>Amount</th>
                                                <th>Date</th>
                                                <th>Pending</th>
                                                <th>Pay Amount</th>
                                                <th>TDS Amount</th>
                                                <th>Notes</th>
                                                <th>Amount</th>
                                            </tr>
                                        </thead>
                                        <tbody id="embeded">

                                        </tbody>
                                        <tr>
                                            <td colspan="8" style="text-align:right;"><b id="matchedHeader"></b></td>
                                            <td style="text-align:right; width:130px;"><input type="text" id="MtotalAmt" name="MtotalAmt" style="text-align:right;" alt="1" readonly="readonly" value=<?= 0 ?>></td>
                                        </tr>
                                        <tr bgcolor="#E3F0F7">

                                            <td colspan="8" style="text-align:right;"><b id="amountHeader"></b></td>
                                            <td style="text-align:right; width:130px"><input type="text" id="balanceAmt" name="balanceAmt" value="<?= 0 ?>" style="text-align:right;" alt="1" readonly="readonly"></td>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                        </div>


                        <table class="mt-3 table table-bordered dj-table-form">
                            <tbody id="dj-table-body">
                                <tr class='firstrow'>
                                    <td colspan=2 class="text-center"><i class="refreshind fa fa-refresh" aria-hidden="true" style="color: blue;"></i></td>
                                    <!-- <td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td> -->
                                    <td><select class="form-control select_class required select2-offscreen accountind" data-errorrequired="Select Account" tabindex="-1" id="account1" name="account1">
                                            <option value="">Select an Account</option>
                                            <optgroup label="Customers"><?= $Customersname ?></optgroup>
                                            <optgroup label="Vendors"><?= $vendorsname ?></optgroup>
                                            <optgroup label="Others"><?= $otherssname ?></optgroup>
                                        </select></td>
                                    <!-- multiselect-dropdown -->
                                    <td><input required min=0.1 step="0.01" name="debit2" id="debit2" type="number" class="form-control debitind"></td>
                                    <td><input required min=0.1 step="0.01" name="credit2" id="credit2" type="number" class="form-control creditind"></td>
                                    <td><input name="remark2" id="remark2" type="text" class="form-control remarkind"></td>
                                </tr>
                            </tbody>
                        </table>


                        <div class="col-md-12 form-group" style="">
                            <div class="bill-table" style="display:none;">
                                <h3 style="background: none repeat scroll 0 0 #61A3CB;color: #FFFFFF; padding: 5px;" id="myHeader2"></h3>
                                <div class="col-md-12 form-group" id="showreceipt1" style="">
                                    <table class="custDispTbl2" style="width: 100%;">
                                        <thead>
                                            <tr>
                                                <th>Entry Type </th>
                                                <th>Entry No # </th>
                                                <th>Amount</th>
                                                <th>Date</th>
                                                <th>Pending</th>
                                                <th>Pay Amount</th>
                                                <th>TDS Amount</th>
                                                <th>Notes</th>
                                                <th>Amount</th>
                                            </tr>
                                        </thead>
                                        <tbody id="embeded2">
                                        </tbody>

                                        <tr>
                                            <td colspan="8" style="text-align:right;"><b id="matchedHeader1"></b></td>
                                            <td style="text-align:right;"><input type="text" id="MtotalAmt1" name="MtotalAmt" style="width:70px; text-align:right;" alt="1" readonly="readonly" value=<?= 0 ?>></td>
                                        </tr>
                                        <tr bgcolor="#E3F0F7">

                                            <td colspan="8" style="text-align:right;"><b id="amountHeader1"></b></td>
                                            <td style="text-align:right;"><input type="text" id="balanceAmt1" name="balanceAmt" value="<?= 0 ?>" style="width:70px; text-align:right;" alt="1" readonly="readonly"></td>
                                        </tr>
                                        <!-- <tr>
                                              <td colspan="7"></td>
                                              <td style="float:right; font-weight: 900;">Total</td>
                                              <td><input type="text" id="second_row_total_amount"></td>
                                            </tr> -->
                                    </table>
                                </div>
                            </div>
                        </div>





                    <?php  }
                } else { ?>
                    <table class="mb-0 table table-bordered dj-table-form">
                        <thead>
                            <tr>
                                <th colspan="3" width=30%>Account</th>
                                <th>Debit</th>
                                <th>Credit</th>
                                <th>Remark</th>
                            </tr>
                        </thead>
                        <tbody id="dj-table-body">
                            <tr class='firstrow'>
                                <td colspan=2 class="text-center" style="width: 5px;"><i class="refreshind fa fa-refresh" aria-hidden="true" style="color: blue;"></i></td>
                                <td>
                                    <select class="form-control select_class required select2-offscreen accountind" data-errorrequired="Select Account" name="account1" tabindex="-1" id="account1" name="account1">
                                        <option value="">Select an Account</option>
                                        <optgroup label="Customers"><?= $Customersname ?></optgroup>
                                        <optgroup label="Vendors"><?= $vendorsname ?></optgroup>
                                        <optgroup label="Others"><?= $otherssname ?></optgroup>
                                    </select>
                                </td>

                                <!-- <select required name="account1" id="account1" class="accountind form-control multiselect-dropdow"><option value="">Select an Account</option></select> -->
                                <td><input required min=0.1 step="0.01" name="debit1" id="debit1" type="number" class="form-control debitind"></td>
                                <td><input required min=0.1 step="0.01" name="credit1" id="credit1" type="number" class="form-control creditind"></td>
                                <td><input name="remark1" id="remark1" type="text" class="form-control remarkind"></td>
                            </tr>
                        </tbody>
                    </table>

                    <br>
                    <div class="col-md-12 form-group">
                        <div class="invoice-table" style="display:none;">
                            <h3 style="background: none repeat scroll 0 0 #61A3CB;color: #FFFFFF; padding: 5px;" id="myHeader"></h3>
                            <div class="col-md-12 form-group" id="showreceipt" style="">
                                <table class="custDispTbl2" style="width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>Entry Type </th>
                                            <th>Entry No # </th>
                                            <th>Amount</th>
                                            <th>Date</th>
                                            <th>Pending</th>
                                            <th>Pay Amount</th>
                                            <th>TDS Amount</th>
                                            <th>Notes</th>
                                            <th>Amount</th>
                                        </tr>
                                    </thead>
                                    <tbody id="embeded">

                                    </tbody>
                                    <tr>
                                        <td colspan="8" style="text-align:right;"><b id="matchedHeader"></b></td>
                                        <td style="text-align:right; width:130px"><input type="text" id="MtotalAmt" name="MtotalAmt" style="text-align:right;" alt="1" readonly="readonly" value=<?= 0 ?>></td>
                                    </tr>
                                    <tr bgcolor="#E3F0F7">

                                        <td colspan="8" style="text-align:right;"><b id="amountHeader"></b></td>
                                        <td style="text-align:right; width:130px;"><input type="text" id="balanceAmt" name="balanceAmt" value="<?= 0 ?>" style="text-align:right;" alt="1" readonly="readonly"></td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>

                    <table class="mb-0 table table-bordered dj-table-form">
                        <thead style="display:none">
                            <tr>
                                <th colspan="3" width=30%>Account</th>
                                <th>Debit</th>
                                <th>Credit</th>
                                <th>Remark</th>
                            </tr>
                        </thead>
                        <tbody id="dj-table-body">
                            <tr class='firstrow'>
                                <td colspan=2 class="text-center"><i class="refreshind fa fa-refresh" aria-hidden="true" style="color: blue;"></i></td>
                                <!-- <td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td> -->
                                <td style="max-width: 228px;">
                                    <select class="form-control select_class required select2-offscreen accountind" data-errorrequired="Select Account" name="account2" tabindex="-1" id="account2" name="account2">
                                        <option value="">Select an Account</option>
                                        <optgroup label="Customers"><?= $Customersname ?></optgroup>
                                        <optgroup label="Vendors"><?= $vendorsname ?></optgroup>
                                        <optgroup label="Others"><?= $otherssname ?></optgroup>
                                    </select>
                                </td>

                                <!-- multiselect-dropdown -->
                                <td><input required min=0.1 step="0.01" name="debit2" id="debit2" type="number" class="form-control debitind"></td>
                                <td><input required min=0.1 step="0.01" name="credit2" id="credit2" type="number" class="form-control creditind"></td>
                                <td><input name="remark2" id="remark2" type="text" class="form-control remarkind"></td>
                            </tr>
                        </tbody>
                    </table>


                    <div class="col-md-12 form-group" style="">
                        <div class="bill-table" style="display:none;">
                            <h3 style="background: none repeat scroll 0 0 #61A3CB;color: #FFFFFF; padding: 5px;" id="myHeader2"></h3>
                            <div class="col-md-12 form-group" id="showreceipt1" style="">
                                <table class="custDispTbl2" style="width: 100%;">
                                    <thead>
                                        <tr>
                                            <th>Entry Type </th>
                                            <th>Entry No # </th>
                                            <th>Amount</th>
                                            <th>Date</th>
                                            <th>Pending</th>
                                            <th>Pay Amount</th>
                                            <th>TDS Amount</th>
                                            <th>Notes</th>
                                            <th>Amount</th>
                                        </tr>
                                    </thead>
                                    <tbody id="embeded2">
                                    </tbody>

                                    <tr>
                                        <td colspan="8" style="text-align:right;"><b id="matchedHeader1"></b></td>
                                        <td style="text-align:right;"><input type="text" id="MtotalAmt1" name="MtotalAmt" style="width:70px; text-align:right;" alt="1" readonly="readonly" value=<?= 0 ?>></td>
                                    </tr>
                                    <tr bgcolor="#E3F0F7">

                                        <td colspan="8" style="text-align:right;"><b id="amountHeader1"></b></td>
                                        <td style="text-align:right;"><input type="text" id="balanceAmt1" name="balanceAmt" value="<?= 0 ?>" style="width:70px; text-align:right;" alt="1" readonly="readonly"></td>
                                    </tr>
                                    <!-- <tr>
                                              <td colspan="7"></td>
                                              <td style="float:right; font-weight: 900;">Total</td>
                                              <td><input type="text" id="second_row_total_amount"></td>
                                            </tr> -->
                                </table>
                            </div>
                        </div>
                    </div>




                <?php } ?>


                <!-- <a href="javascript:void(0);" class="mt-4 dynamicadd dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Line </a>&nbsp; -->


                <!-- <?php if (AuthItemChild::find()->where(['parent' => $assign->item_name, 'child' => '/master/accounting-ledger/create'])->one() != '') { ?>
                                    <a target="_blank" href="<?= Url::base() . '/master/accounting-ledger/create' ?>" class="mt-4 dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add an Account</a>
                                   <?php } else { ?>

                                   <?php } ?> -->


            </div>
            <div class="form-row">
                <?php if ($update && $model->document_name) { ?>
                    <div class="col-md-4">
                    <?php } else { ?>
                        <div class="col-md-6">
                        <?php } ?>
                        <div class="position-relative form-group">
                            <label for="exampleFile" class="">Attach Documents</label>
                            <?= $form->field($model, 'document_name')->fileInput(['maxlength' => true, 'class' => "form-control"])->label(false) ?>
                            <span class="form-text text-muted">Allowed File Formats *.jpg,*.png,*.gif,*.txt,*.xls,*.doc,*.xlsx (Allowed Size 2M)</span>

                        </div>
                        </div>
                        <?php if ($update && $model->document_name) { ?>
                            <div class="col-md-2">
                                <img style="margin-top:30px" width="90" height="40" src="<?= Url::base() ?>/usersdocument/accounting_journal/<?= $model->document_name ?>">
                            </div>
                        <?php } ?>

                        <div class="col-md-6">
                            <div class="position-relative form-group">
                                <table class="mb-0 table table-bordered">
                                    <tr>
                                        <td width="25%"><label class="total-cr">Total Credit</label><?= $form->field($model, 'total_credit')->hiddenInput(['maxlength' => true, 'class' => "form-control totalcredit"])->label(false) ?></td>
                                        <td width="25%" class="text-right"><label class="total-cr totalcredit">0.00</label></td>
                                    </tr>
                                    <tr>
                                        <td width="25%"><label class="total-db">Total Debit</label><?= $form->field($model, 'total_debit')->hiddenInput(['maxlength' => true, 'class' => "form-control totaldebit"])->label(false) ?></td>
                                        <td width="25%" class="text-right"><label class="total-db totaldebit">0.00</label></td>
                                    </tr>
                                    </tr>
                                    <tr>
                                        <td width="25%"><label class="totallabel">Total</label><?= $form->field($model, 'totalamt')->hiddenInput(['maxlength' => true, 'class' => "form-control totalamt"])->label(false) ?></td>
                                        <td width="25%" class="text-right"><label class="totals totalamt">0.00</label></td>
                                    </tr>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>


                    <div class="djsec-text-right">
                        <button class="submit-btn print-btn mb-2 mr-2 btn-icon btn dj-danger-btn"><i class="fa fa-print" aria-hidden="true"></i> <?= $update ? "Update" : "Save" ?> and Print</button>
                        <button class="submit-btn mb-2 mr-2 btn-icon btn dj-danger-btn"><i class="fa fa-check-square-o" aria-hidden="true"></i> <?= $update ? "Update" : "Save" ?></button>
                        <button type="reset" onclick="location.href='<?= Url::base() ?>/users/accounting-journal/index';" class="mb-2 mr-2 btn-icon btn btn-danger dj-le-btn"><i class="fa fa-ban" aria-hidden="true"></i> Cancel</button>

                    </div>

                    <?php ActiveForm::end(); ?>
            </div>
        </div>

    </div>

    <?php ob_start(); ?>
    <script type="text/javascript">
        $(function() {

            // $('.select_class').select2();
            var debitamt = 0;
            var creditamt = 0;
            $(".debitind").each(function() {
                if ($(this).val()) {
                    debitamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                    $(this).parent().siblings().children('.creditind').attr('readonly', true)
                }
            })
            $(".creditind").each(function() {
                if ($(this).val()) {
                    creditamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                    $(this).parent().siblings().children('.debitind').attr('readonly', true)
                }
            })
            $('.totaldebit').val(debitamt.toFixed(2)).text(debitamt.toFixed(2))
            $('.totalcredit').val(creditamt.toFixed(2)).text(creditamt.toFixed(2))
            $('.totalamt').text(creditamt - debitamt.toFixed(2)).val(creditamt - debitamt.toFixed(2))

            $('#accountingjournal-date').attr('type', 'date');
            $(".select option").val(function(idx, val) {
                $(this).siblings('[value="' + val + '"]').remove();
            });
            $('.accountind').select2();

            // $('.accountind').select2({
            //         ajax: { 
            //         url: "findledger",
            //         type: "get",
            //         dataType: 'json',
            //         delay: 250,
            //         data: function (params) {
            //             return {
            //             searchTerm: params.term // search term
            //             };
            //         },
            //         processResults: function (response) {

            //             return {
            //                 results: $.map(response, function (i,item) {

            //                 return {
            //                     text: i,
            //                     slug: "",
            //                     id: item
            //                 }
            //             })
            //         };


            //         },
            //         cache: true
            //         }
            //     });

            // if(!<?= $update ?>){
            // $.post( 'get-account', function( data ) {

            //     $('.accountind').empty();
            //     $('.accountind').append('<option value="">Select Account</option>');
            //     $.each(JSON.parse(data), function(i, item) {
            //     $('.accountind').append('<optgroup label=\"'+i+'\"></optgroup>');
            //     $.each(item, function(index, itemval) {
            //     $('.accountind').append($('<option value=\"'+index+'\">'+itemval+'</option>'));
            // });
            //     });
            //     })
            // }else{
            //     $.post( 'get-account', function( data ) {
            //         $.each(JSON.parse(data), function(i, item) {
            //     $('.accountind').append('<optgroup label=\"'+i+'\"></optgroup>');
            //     $.each(item, function(index, itemval) {
            //     $('.accountind').append($('<option value=\"'+index+'\">'+itemval+'</option>'));
            // });
            //     });
            //     $(".accountind option").val(function(idx, val) {
            //     $(this).siblings('[value='+ val +']').remove();
            //     return val;
            //     });
            //     })
            // }
            $('.dynamicadd').click(function() {
                count = $('#dj-table-body tr').length + 1;
                $('#dj-table-body').append('<tr><td class="text-center"><i class=" fa fa-refresh refreshind" aria-hidden="true" style="color: blue;"></i></td><td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td><td><select required name=\"account' + count + '\" id=\"account' + count + '\" class="accountind form-control"><option value="">Select an Account</option></select></td><td><input required min=0.1 step="0.01" name=\"debit' + count + '\" id=\"debit' + count + '\" type="number" class="form-control debitind"></td><td><input required min=0.1 step="0.01" name=\"credit' + count + '\" id=\"credit' + count + '\" type="number" class="form-control creditind"></td><td><input name="remark1" id="remark1" type="text" class="form-control remarkind"></td></tr>')
                $('#account' + count).empty();
                $('#account' + count).append('<option value="">Select Account</option>');
                //     $.post( 'get-account', function( data ) {
                //       $.each(JSON.parse(data), function(i, item) {
                //     $('#account'+count).append('<optgroup label=\"'+i+'\"></optgroup>');
                //     $.each(item, function(index, itemval) {
                //     $('#account'+count).append($('<option value=\"'+index+'\">'+itemval+'</option>'));
                // });
                //     });
                // $('#account'+count).select2();
                $('#account' + count).select2({
                    ajax: {
                        url: "findledger",
                        type: "get",
                        dataType: 'json',
                        delay: 250,
                        data: function(params) {
                            return {
                                searchTerm: params.term // search term
                            };
                        },
                        processResults: function(response) {

                            return {
                                results: $.map(response, function(i, item) {

                                    return {
                                        text: i,
                                        slug: "Names",
                                        id: item
                                    }
                                })
                            };


                        },
                        cache: true
                    }
                });

            })
            $(document).on('change', ".accountind", function() {
                var sample = $(this);
                // $.post( 'get-description',{data: $(this).val()}, function( data ) {
                // sample.parent().siblings().children('.debitind').val(JSON.parse(data).des);
                // sample.parent().siblings().children('.creditind').val(JSON.parse(data).unit);
                // sample.parent().siblings().children('.remarkind').val(JSON.parse(data).price);
                var debitamt = 0;
                var creditamt = 0;
                $(".debitind").each(function() {
                    if ($(this).val())
                        debitamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $(".creditind").each(function() {
                    if ($(this).val())
                        creditamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $('.totaldebit').val(debitamt.toFixed(2)).text(debitamt.toFixed(2))
                $('.totalcredit').val(creditamt.toFixed(2)).text(creditamt.toFixed(2))
                $('.totalamt').text(creditamt - debitamt.toFixed(2)).val(creditamt - debitamt.toFixed(2))

            })
            $(document).on('change', ".debitind", function() {
                var sample = $(this);
                var debitamt = 0;
                var creditamt = 0;
                $(".debitind").each(function() {
                    if ($(this).val())
                        debitamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $(".creditind").each(function() {
                    if ($(this).val())
                        creditamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $('.totaldebit').val(debitamt.toFixed(2)).text(debitamt.toFixed(2))
                $('.totalcredit').val(creditamt.toFixed(2)).text(creditamt.toFixed(2))
                $('.totalamt').text((creditamt - debitamt).toFixed(2)).val((creditamt - debitamt).toFixed(2))
            })
            $(document).on('change', ".creditind", function() {
                var debitamt = 0;
                var creditamt = 0;
                $(".debitind").each(function() {
                    if ($(this).val())
                        debitamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $(".creditind").each(function() {
                    if ($(this).val())
                        creditamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $('.totaldebit').val(debitamt.toFixed(2)).text(debitamt.toFixed(2))
                $('.totalcredit').val(creditamt.toFixed(2)).text(creditamt.toFixed(2))
                $('.totalamt').text((creditamt - debitamt).toFixed(2)).val((creditamt - debitamt).toFixed(2))
            })
            $(document).on('click', ".removeind", function() {
                $(this).parent().parent().remove();
                $("#dj-table-body").find('.accountind').each(function(index) {
                    $(this).attr('id', 'account' + (index + 1));
                    $(this).attr('name', 'account' + (index + 1));
                })
                $("#dj-table-body").find('.debitind').each(function(index) {
                    $(this).attr('id', 'debit' + (index + 1));
                    $(this).attr('name', 'debit' + (index + 1));
                })
                $("#dj-table-body").find('.creditind').each(function(index) {
                    $(this).attr('id', 'credit' + (index + 1));
                    $(this).attr('name', 'credit' + (index + 1));
                })
                $("#dj-table-body").find('.remarkind').each(function(index) {
                    $(this).attr('id', 'remark' + (index + 1));
                    $(this).attr('name', 'remark' + (index + 1));
                })
                var debitamt = 0;
                var creditamt = 0;
                $(".debitind").each(function() {
                    if ($(this).val())
                        debitamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $(".creditind").each(function() {
                    if ($(this).val())
                        creditamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                })
                $('.totaldebit').val(debitamt.toFixed(2)).text(debitamt.toFixed(2))
                $('.totalcredit').val(creditamt.toFixed(2)).text(creditamt.toFixed(2))
                $('.totalamt').text((creditamt - debitamt).toFixed(2)).val((creditamt - debitamt).toFixed(2))
            })
            $(document).on('click', ".refreshind", function() {
                var sample = $(this);
                sample.parent().siblings().children('.accountind').empty();
                sample.parent().siblings().children('.accountind').append('<option value="">Select Account</option>');
                sample.parent().siblings().children('input').val('');
                $.post('get-account', function(data) {
                    $.each(JSON.parse(data), function(i, item) {
                        sample.parent().siblings().children('.accountind').append('<optgroup label=\"' + i + '\"></optgroup>');
                        $.each(item, function(index, itemval) {
                            sample.parent().siblings().children('.accountind').append($('<option value=\"' + index + '\">' + itemval + '</option>'));
                        });
                    });
                    // $.each(JSON.parse(data), function(i, item) {
                    // sample.parent().siblings().children('.accountind').append($('<option value=\"'+i+'\">'+item+'</option>'));
                    // });
                })
                var debitamt = 0;
                var creditamt = 0;
                $(".debitind").each(function() {
                    if ($(this).val()) {
                        debitamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                    }
                })
                $(".creditind").each(function() {
                    if ($(this).val()) {
                        creditamt += parseFloat(isNaN($(this).val()) ? 0 : $(this).val());
                    }
                })
                $('.totaldebit').val(debitamt.toFixed(2)).text(debitamt.toFixed(2))
                $('.totalcredit').val(creditamt.toFixed(2)).text(creditamt.toFixed(2))
                $('.totalamt').text((creditamt - debitamt).toFixed(2)).val((creditamt - debitamt).toFixed(2))
                sample.parent().siblings().children('.creditind').removeAttr('readonly')
                sample.parent().siblings().children('.debitind').removeAttr('readonly')
            })
            $('.print-btn').click(function() {
                $('form').append('<input type="hidden" name="print" value="print">')
            })
            $(document).on('change', ".debitind", function() {
                if ($(this).val())
                    $(this).parent().siblings().children('.creditind').attr('readonly', true)
                else
                    $(this).parent().siblings().children('.creditind').removeAttr('readonly')
            })
            $(document).on('change', ".creditind", function() {
                if ($(this).val())
                    $(this).parent().siblings().children('.debitind').attr('readonly', true)
                else
                    $(this).parent().siblings().children('.debitind').removeAttr('readonly')
            })
            $('form').submit(function(e) {
                $('.submit-btn').prop('disabled', 'true');
                setTimeout(function() {
                    if (!$('.has-error').length) {
                        $('.submit-btn').prop('disabled', 'true');
                        $('.submit-btn').text('Please Wait..');
                    } else
                        $('.submit-btn').removeAttr('disabled');
                }, 200);
                $('form').append('<input type="hidden" name="accountcount" value=\"' + $('#dj-table-body tr').length + '\">')
            })
            $(document).on("keydown", 'input[type=number]', function(e) {
                var invalidChars = ["-", "+", "e"];
                if (invalidChars.includes(e.key)) {
                    e.preventDefault();
                }
            });
            let total_debit_value = 0;
            let total_value = 0;
            let total = 0;
            let second_row_value = 0;
            let second_total = 0;
            let total_credit_value = 0;
            let credit_total_value = 0;
            let credit_total = 0;
            let credit_second_row_value = 0;
            let credit_second_total = 0;
            $(document).on("change", "#account1", function() {
                total_value = 0;
                $('#total_amount').val(total_value.toFixed(2)).text(total_value.toFixed(2))
                var selected = $(':selected', this);
                if (selected.closest('optgroup').attr('label') == "Customers") {

                    $(this).parent().siblings().children('.creditind').val('')
                    $('.creditind').trigger('change');
                    // $("#myHeader").text("Pending Accounts");
                } else {
                    // $("#myHeader").text("Credit Accounts");
                    $(this).parent().siblings().children('.debitind').val('')
                    $('.debitind').trigger('change');
                }
                var user_id = $(this).val();
                form = '';
                $.get("finduser", {
                    user_id: user_id
                }, function(data) {
                    var data = $.parseJSON(data);
                    // alert(data.group_name_id);
                    if (data.group_name_id == 28) {
                        $("#myHeader").text("Pending Invoices for the customer [" + data.ledger_id + " ]");
                        $("#amountHeader").text("Amount to Customer");
                        $("#matchedHeader").text("Amount matched with Invoice");
                        $('.debit1').trigger('change');
                        form = 'customer';
                    } else {
                        $("#myHeader").text("Pending Bills for the vendor [" + data.ledger_id + " ]");
                        $("#amountHeader").text("Amount to Vendor");
                        $("#matchedHeader").text("Amount matched with Bill");
                        $('.credit1').trigger('change');
                        form = 'vendor';
                    }
                    // alert(data.ledger_id);
                });
                $.get("findbill", {
                    user_id: user_id
                }, function(data) {
                    var res = JSON.parse(JSON.stringify(data));
                    if (!res == null) {} else {
                        $('.invoice-table').show();
                        var table_data = '';
                        $('#embeded').empty();
                        let x = 1;
                        $.each(JSON.parse(data), function(key, value) {
                            // console.log(value.id);
                            table_data = $('<tr class="newrw"><td><input type="checkbox" name="myCheckboxes[]" class="myCheckboxes" id="mycheck' + x + '" value=' + value.total_price + ' > (' + value.id + ')</td><td>' + value.invoice_id + '<input type="text" name="Bill[' + x + '][bill_id]" id="bill_id-' + x + '" value=' + value.invoice_id + ' hidden=true class="checkPa" alt="0"></td><td>' + value.total_price + '<input type="text" name="Bill[' + x + '][from]" id="from-' + x + '" value="' + form + '" hidden="true" class="check" alt="0"></td><td>' + value.due_date + '</td><td>' + value.pending_amount + '</td><td style="width:130px;"><input type="text" name="Bill[' + x + '][amount]" id="total' + x + '" class="total" min=0 step=.01 placeholder=0.00  style="text-align:right;"  alt="0" pattern="[-0-9.]*"></td><td style="width:130px"><input type="text" min=0 step=.01 placeholder=0.00 name="Bill[' + x + '][tdsamount]" style="text-align:right;" class="total_tds" alt="0" pattern="[-0-9.]*"></td><td><input type="text" name="Bill[' + x + '][notes]"></td><td style="width:130px"><input  type="text" min=0 step=.01 placeholder=0.00 class="final_amt" name="Bill[' + x + '][finalamount]"  style="text-align:right;"  alt="0" pattern="[-0-9.]*"></td></tr>');
                            $('#embeded').append(table_data);
                            x++;
                        });

                    }
                });
            });
            $(document).on("change", "#account2", function() {
                second_row_value = 0;
                $('#second_row_total_amount').val(second_row_value.toFixed(2)).text(second_row_value.toFixed(2))
                var selected = $(':selected', this);
                if (selected.closest('optgroup').attr('label') == "Customers") {
                    $(this).parent().siblings().children('.creditind').val('')
                    // $('.creditind').trigger('change');
                    // $("#myHeader2").text("Pending Accounts");
                } else {
                    $(this).parent().siblings().children('.debitind').val('')
                    $('.debitind').trigger('change');
                    // $("#myHeader2").text("Credit Accounts");
                }
                var user_id = $(this).val();

                $.get("finduser", {
                    user_id: user_id
                }, function(data) {
                    var data = $.parseJSON(data);
                    var from = '';
                    if (data.group_name_id == 28)
                        $("#myHeader2").text("Pending Invoices for the customer [" + data.ledger_id + " ]");
                    else
                        $("#myHeader2").text("Pending Bills for the vendor [" + data.ledger_id + " ]");


                    if (data.group_name_id == 28) {
                        $("#myHeader2").text("Pending Invoices for the customer [" + data.ledger_id + " ]");
                        $("#amountHeader1").text("Amount to Customer");
                        $("#matchedHeader1").text("Amount matched with Invoice");
                        $('.debit2').trigger('change');
                        form = 'customer';
                    } else {
                        $("#myHeader2").text("Pending Bills for the vendor [" + data.ledger_id + " ]");
                        $("#amountHeader1").text("Amount to Vendor");
                        $("#matchedHeader1").text("Amount matched with Bill");
                        $('.credit2').trigger('change');
                        form = 'vendor';
                    }
                    // alert(data.ledger_id);
                });
                $.get("findbill", {
                    user_id: user_id
                }, function(data) {
                    var res = JSON.parse(JSON.stringify(data));
                    if (!res == null) {} else {
                        $('.bill-table').show();
                        var table_data = '';
                        $('#embeded2').empty();
                        let x = 1;
                        $.each(JSON.parse(data), function(key, value) {

                            table_data = $('<tr class="newrw"><td><input type="checkbox" name="myCheckboxes2[]" class="myCheckboxes2" id="mycheckbox' + x + '" value=' + value.total_price + ' > (' + value.id + ')</td><td>' + value.invoice_id + '<input type="text" name="Bill1[' + x + '][bill_id]" id="bill_id-' + x + '" value="' + value.invoice_id + '" hidden=true class="checkPa" alt="0"></td><td>' + value.total_price + '<input type="text" name="Bill1[' + x + '][from]" id="from-' + x + '" value="' + form + '" hidden=true class="check" alt="0"></td><td>' + value.due_date + '</td><td>' + value.pending_amount + '</td><td style="width:130px;"><input type="text" name="Bill1[' + x + '][amount]" id="second_total' + x + '" class="second_total" min=0 step=.01 placeholder=0.00  style="text-align:right;"  alt="0" pattern="[-0-9.]*"></td><td style="width:130px;"><input type="text" min=0 step=.01 placeholder=0.00  style="text-align:right;" name="Bill1[' + x + '][tdsamount]" class="second_tds" alt="0" pattern="[-0-9.]*"></td><td><input name="Bill1[' + x + '][notes]" type="text"></td><td style="width:130px;"><input  type="text" class="final_amt" name="Bill1[' + x + '][finalamount]" min=0 step=.01 placeholder=0.00  style="text-align:right;"  alt="0" pattern="[-0-9.]*"></td></tr>');
                            $('#embeded2').append(table_data);
                            x++;
                        });

                    }
                });
            });

            // $(document).on("change",".myCheckboxes",function() {

            // alert();
            //             // $('.totaldebit').val(total_value.toFixed(2)).text(total_value.toFixed(2))
            //             // $('.totalamt').text(creditamt-debit_value.toFixed(2)).val(creditamt-debit_value.toFixed(2))

            //         let isChecked = $(this).closest('.myCheckboxes').is(':checked');
            //     $('.total_amount').empty();
            //     if(isChecked == true){

            //             total = parseInt($(this).val());
            //             $(this).closest('tr').find('.total').val(total);
            //             total_value = total_value + total;
            //     }
            //      else{
            //             total =0;
            //             total_value =  total_value - parseInt($(this).val())
            //             $(this).closest('tr').find('.total').val(total);

            //     }

            //             $('#total_amount').val(total_value.toFixed(2)).text(total_value.toFixed(2))
            //         // total_debit_value = total_value + second_row_value;
            //         // $('.totaldebit').val(total_debit_value.toFixed(2)).text(total_debit_value.toFixed(2))




            //  });
            // $('.total_tds')
            $(document).on("change", ".total_tds", function() {
                $amount_matched = 0;
                $('.total').each(function() {
                    if ($(this).val() > 0) {
                        $tdsamt = $(this).parent().siblings().children('.total_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));

                        $(this).parent().siblings().children('.myCheckboxes').prop('checked', true);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));
                    } else if ($(this).val() == "") {
                        $tdsamt = $(this).parent().siblings().children('.total_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat(0) + parseFloat($tdsamt));
                        // alert($(this).val());
                        // alert($tdsamt);
                        // alert(2);
                    } else {
                        $tdsamt = $(this).parent().siblings().children('.total_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));
                        // alert(3);
                    }
                })
                
                $('#MtotalAmt').val(parseFloat($amount_matched));
                if ($('#debit1').val() > 0) {
                    $('#debit1').trigger('change');
                } else if ($('#credit1').val() > 0) {
                    $('#credit1').trigger('change');
                } else {
                    $('#balanceAmt').val(parseFloat($amount_matched));
                }
            })
            $(document).on("change", ".second_tds", function() {
                $amount_matched = 0;
                $('.second_total').each(function() {
                    // alert();
                    if ($(this).val() > 0) {

                        $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));

                        $(this).parent().siblings().children('.myCheckboxes2').prop('checked', true);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));

                    } else if ($(this).val() == "") {
                        $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes2').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat(0) + parseFloat($tdsamt));
                    } else {
                        $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes2').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));
                    }
                })


                $('#MtotalAmt1').val(parseFloat($amount_matched));
                if ($('#debit2').val() > 0) {
                    $('#debit2').trigger('change');
                } else if ($('#credit2').val() > 0) {
                    $('#credit2').trigger('change');
                } else {
                    $('#balanceAmt1').val(parseFloat($amount_matched));
                }
            })



            

            $(document).on("change", ".total", function() {
                // if ($(this).val() > 0)
                $amount_matched = 0;
                $('.total').each(function() {
                    if ($(this).val() > 0) {
                        $tdsamt = $(this).parent().siblings().children('.total_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));

                        $(this).parent().siblings().children('.myCheckboxes').prop('checked', true);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));
                    } else if ($(this).val() == "") {
                        $tdsamt = $(this).parent().siblings().children('.total_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat(0) + parseFloat($tdsamt));
                        // alert($(this).val());
                    } else {
                        $tdsamt = $(this).parent().siblings().children('.total_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));
                        // alert(3);
                    }
                })
                $('#MtotalAmt').val(parseFloat($amount_matched));
                if ($('#debit1').val() > 0) {
                    $('#debit1').trigger('change');
                } else if ($('#credit1').val() > 0) {
                    $('#credit1').trigger('change');
                } else {
                    $('#balanceAmt').val(parseFloat($amount_matched));
                }
            })

            $(document).on("change", "#debit1", function() {
                $amount_matched = 0;
                $('.total').each(function() {

                    $tdsamt = $(this).parent().siblings().children('.total_tds').val();

                    if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                        $tdsamt = parseFloat(0);
                    }
                    if ($(this).val() > 0) {
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));
                    } else if ($(this).val() == "") {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    } else {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    }
                })
                if ($("#debit1").val() == '') {
                    $('#balanceAmt').val(parseFloat(0) - parseFloat($amount_matched));
                } else {
                    $('#balanceAmt').val(parseFloat($("#debit1").val()) - parseFloat($amount_matched));
                }
            })

            $(document).on("change", "#credit1", function() {
                $amount_matched = 0;
                $('.total').each(function() {

                    $tdsamt = $(this).parent().siblings().children('.total_tds').val();
                    if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                        $tdsamt = parseFloat(0);
                    }

                    if ($(this).val() > 0) {
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));
                    } else if ($(this).val() == "") {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    } else {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    }
                })
                if ($("#credit1").val() == '') {
                    $('#balanceAmt').val(parseFloat(0) - parseFloat($amount_matched));
                } else {
                    $('#balanceAmt').val(parseFloat($("#credit1").val()) - parseFloat($amount_matched));
                }

            })



            $(document).on("change", ".second_total", function() {
                // if ($(this).val() > 0)

                    $amount_matched = 0;
                $('.second_total').each(function() {
                    // alert();
                    if ($(this).val() > 0) {

                        $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));

                        $(this).parent().siblings().children('.myCheckboxes2').prop('checked', true);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));

                    } else if ($(this).val() == "") {
                        $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes2').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat(0) + parseFloat($tdsamt));
                    } else {
                        $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                        if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                            $tdsamt = parseFloat(0);
                        }
                        $amount_matched = $amount_matched + parseFloat(0);
                        $(this).parent().siblings().children('.myCheckboxes2').prop('checked', false);
                        $(this).parent().siblings().children('.final_amt').val(parseFloat($(this).val()) + parseFloat($tdsamt));
                    }
                })

                $('#MtotalAmt1').val(parseFloat($amount_matched));
                if ($('#debit2').val() > 0) {
                    $('#debit2').trigger('change');
                } else if ($('#credit2').val() > 0) {
                    $('#credit2').trigger('change');
                } else {
                    $('#balanceAmt1').val(parseFloat($amount_matched));
                }

            })


            $(document).on("change", "#debit2", function() {
                $amount_matched = 0;
                $('.second_total').each(function() {
                    $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                    if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                        $tdsamt = parseFloat(0);
                    }
                    if ($(this).val() > 0) {
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));
                    } else if ($(this).val() == "") {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    } else {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    }
                })

                if ($("#debit2").val() == '') {
                    $('#balanceAmt1').val(parseFloat(0) - parseFloat($amount_matched));
                } else {
                    $('#balanceAmt1').val(parseFloat($("#debit2").val()) - parseFloat($amount_matched));
                }
                // $('.credit1').trigger('change');
            })

            $(document).on("change", "#credit2", function() {

                $amount_matched = 0;
                $('.second_total').each(function() {


                    $tdsamt = $(this).parent().siblings().children('.second_tds').val();
                    if ($tdsamt == '' || $tdsamt < 0 || $tdsamt == undefined) {
                        $tdsamt = parseFloat(0);
                    }

                    if ($(this).val() > 0) {
                        $amount_matched = $amount_matched + parseFloat(parseFloat($(this).val()) + parseFloat($tdsamt));
                    } else if ($(this).val() == "") {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    } else {
                        $amount_matched = $amount_matched + parseFloat(parseFloat(0) + parseFloat($tdsamt));
                    }
                })
                if ($("#credit2").val() == '') {
                    $('#balanceAmt1').val(parseFloat(0) - parseFloat($amount_matched));
                } else {
                    $('#balanceAmt1').val(parseFloat($("#credit2").val()) - parseFloat($amount_matched));
                }
            })




            $(document).on("change", ".myCheckboxes2", function() {

                let isChecked = $(this).closest('.myCheckboxes2').is(':checked');
                $('.total_amount').empty();
                if (isChecked == true) {

                    second_total = parseInt($(this).val());
                    $(this).closest('tr').find('.second_total').val(second_total);
                    second_row_value = second_row_value + second_total;
                } else {
                    second_total = 0;
                    second_row_value = second_row_value - parseInt($(this).val())
                    $(this).closest('tr').find('.second_total').val(second_total);

                }

                $('#second_row_total_amount').val(second_row_value.toFixed(2)).text(second_row_value.toFixed(2))

                // total_debit_value = total_value + second_row_value;
                // $('.totaldebit').val(total_debit_value.toFixed(2)).text(total_debit_value.toFixed(2))


                // $('.totaldebit').val(second_row_value.toFixed(2)).text(second_row_value.toFixed(2))
                // $('.totalamt').text(creditamt-debit_value.toFixed(2)).val(creditamt-debit_value.toFixed(2))


            });


        });
    </script>
    <?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean())) ?>