<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\AccountingLedger;
use backend\modules\users\models\JournalDebitCredit;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\AccountingJournalSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Accounting Journals';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
<?php endif; ?>
<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Accounting Journal</div>
                                                            </div>
															<div class="widget-content-right">

                                                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/create'])->one()!=''){?>
                                                                <a href="<?=Url::base().'/users/accounting-journal/create'?>" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Journal</a>
                                                               <?php }else {?>

                                                               <?php } ?>    

                                                                <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-creditnote" role="button" aria-expanded="false" aria-controls="search-creditnote">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>

                                                                 <a  class="search_field_buttons"  href="<?=Url::base().'/users/accounting-journal/index'?>" role="button" aria-expanded="false" aria-controls="search-look"><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card collapse" id="search-creditnote">
                           <div class="card-body">
						   <h5 class="card-title">Journal No</h5>
                           <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                        <div class="form-row">
										
										<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                <?= $form->field($model, 'prefix')->textInput(['maxlength' => true,'class'=>'form-control','placeholder'=>"Prefix"])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                <?= $form->field($model, 'journal')->textInput(['maxlength' => true,'class'=>'form-control','placeholder'=>"Journal #"])->label(false) ?>

                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">

                                                    <?= $form->field($model, 'suffix')->textInput(['maxlength' => true,'class'=>'form-control','placeholder'=>"Suffix"])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-2">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Account</label>
                                                    <?=$form->field($model, 'account')->dropDownList($account, ['prompt' => '--Select--', 'class' => " form-control", 'maxlength' => true])->label(false)?>

                                                     <!-- <select class="multiselect-dropdown form-control">
														<option value="1">-Select an Account-</option>
                                                    </select> -->
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Journal Type</label>
                                                    <?=$form->field($model, 'journaltype')->dropDownList(['Journal'=>'Journal'], ['prompt' => '--Select--', 'class' => " form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">User</label>
                                                    <?=$form->field($model, 'user_name')->dropDownList($username, ['prompt' => '--Select--', 'class' => " form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Notes</label>
                                                    <?= $form->field($model, 'notes')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4 dj-btn-align" style="padding-top: 5px">
                                            <button class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search"></i>Search</button>
											</div>
                                        </div>
                                        <?php ActiveForm::end(); ?> 
                                    
                                </div>
                        </div>
						  <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						<div class="col-md-6">

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/delete'])->one()!=''){?>
                                                               <button id="delete" class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                                               <?php }else {?>

                                                               <?php } ?>
                       
							</div>
							<div class="col-md-6">
						<div class="djsec-text-right dj-print-sec">
                        <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/excel-export'])->one()!=''){?>
                            <a href="<?=Url::base();?>/users/accounting-journal/excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details  Excel</button></a>
                            <a href="<?=Url::base();?>/users/accounting-journal/excel-export" data-method="post">   <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                           <?php }else {?>

                           <?php } ?>

                           <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/journal-template'])->one()!=''){?>
                            <a href="<?=Url::base();?>/users/accounting-journal/journal-template?from=all" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                           <?php }else {?>

                           <?php } ?>
							
											
                                     </div>
							 </div>
							 </div>
                             <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
            [
                'label'=>'Journal #',
               'attribute' => 'jv_no',
               'value' => function ($data) {
                return $data->jv_no;
               }
            ],
            'date:date',
            [
                'header'=> 'Date',
                'headerOptions' => ['style' => 'color:#495057'],
                'value'=> function($data){
                    if($data->date!='')
                    return date(("\ F j Y"), strtotime($data->date));
                } 
            ],
            [
                'label'=>'Debit From',
            //    'attribute' => 'total_credit',
               'value' => function ($data) {
                   $debit = JournalDebitCredit::find()->where(['journal_id'=>$data->id])->andWhere(['!=','debit_amount',''])->one();
                   $name = AccountingLedger::find()->where(['accounting_ledger_id'=>$debit->account_id])->one();
                   return $name->ledger_id;
                // return number_format($data->total_credit,2);

               }
            ],
            [
                'label'=>'Debit Account',
                'contentOptions'=>[ 'style'=>'text-align:right'],
                'headerOptions'=>[ 'style'=>'text-align:right'],
               'attribute' => 'total_debit',
               'value' => function ($data) {
                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->total_debit);
                return $num; 
                // return number_format($data->total_debit,2);
               }
            ],
            [
                'label'=>'Credit To',
            //    'attribute' => 'total_credit',
               'value' => function ($data) {
                $credit = JournalDebitCredit::find()->where(['journal_id'=>$data->id])->andWhere(['!=','credit_amount',''])->one();
                $name = AccountingLedger::find()->where(['accounting_ledger_id'=>$credit->account_id])->one();
                return $name->ledger_id;
                // return number_format($data->total_credit,2);

               }
            ],
            [
                'label'=>'Credit Account',
                'contentOptions'=>[ 'style'=>'text-align:right'],
                'headerOptions'=>[ 'style'=>'text-align:right'],
               'attribute' => 'total_credit',
               'value' => function ($data) {
                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->total_credit);
                return $num; 
                // return number_format($data->total_credit,2);

               }
            ],
            [
                'label' => 'Action',
                'contentOptions'=>['style'=>'width:35px'],
                'headerOptions' => ['class'=>'action-header','style'=>'color:#495057;'],
                'format'=>'raw',
                'value' => function ($data) use ($assign) {

                    $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/journal-template'])->one()!='')
                    {
                        $printstring = '<li class="nav-item">
                            <a class="nav-link" target="_blank" href='.Url::base().'/users/accounting-journal/journal-template?id='.$data->id.' data-method=post>
                               <i class="fa fa-print"></i>
                                <span class="dj-icon-gap"> Print</span>
                            </a>
                        </li>';
                    }
                    else
                    {
                        $printstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/accounting-journal/view?id='.$data->id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/accounting-journal/update?id='.$data->id.' data-method=post>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/accounting-journal/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/accounting-journal/delete?id='.$data->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                    return $topstring.''.$printstring.''.$viewstring.''.$editstring.''.$deletestring.''.$downstring;    
                },
            ],
        ],
    ]); ?>
                            <!-- <table class="mb-0 table table-bordered">
                                        <thead>
                                            <tr>
                                                <th class="text-center"><input type="checkbox"></th>
                                                <th>Journal #</th>
                                                <th>Date </th>
                                                <th>Amount</th>
                                                <th>Credit Account</th>
                                                <th>Debit Account</th>
												<th>Description</th>
												<th>Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
										<tr>
										<td class="text-center"><input type="checkbox"></td>
										 <td>J 21</td>
										 <td>September 12, 2020</td>
										 <td>34811</td>
										 <td></td>
										  <td></td>
										   <td></td>
										 <td><div class="d-inline-block dropdown">
                                    <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                    <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                        <ul class="nav flex-column">
                                            <li class="nav-item">
                                                <a class="nav-link">
                                                    <i class="fa fa-pencil-square"></i>
                                                    <span class="dj-icon-gap"> Edit</span>
                                                </a>
                                            </li>
                                            <li class="nav-item">
                                                <a class="nav-link">
                                                   <i class="fa fa-trash"></i>
                                                    <span class="dj-icon-gap">  Delete</span>
                                                </a>
                                            </li>
                                        </ul>
                                    </div>
                                </div></td>
										</tr>
										
                                        </tbody>
                                    </table> -->
                        </div>
                    </div>
                </div>

                <?php ob_start();?>
 <script type="text/javascript">
$(function() {
$('#accountingjournal-from_date').attr('type','date');
$('#accountingjournal-to_date').attr('type','date');
$('#delete').click(function(){
var ids = $('#w1').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})
$('#search-creditnote').hide();
$('#advance-search').click(function(){
    $('#search-creditnote').toggle();
})
$('input[name="AccountingJournalSearch[date]"]').attr('type','date');
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
