<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\CustomerType;
use backend\modules\users\models\Invoice;
use backend\modules\master\models\Product;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\master\models\SalesTemplates;
use backend\modules\master\models\GenericTemplate;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

$settingtypes = GenericTemplate::find()->where(['template_for'=>'Credit Note'])->all();
$prosettinglist=ArrayHelper::map($settingtypes, 'gt_id', 'template_name');
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\CreditNoteSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Credit Notes';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.select2-container .select2-selection--single {
    height: 39px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.rendered .select2-selection__rendered {
    width: 220px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>


<div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Credit Note</div>
                                                            </div>
                                                            <div class="widget-content-right">

                                                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/create'])->one()!=''){?>
                                                              <a href="create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Credit Note</a>
                                                               <?php }else {?>

                                                               <?php } ?>
                                                                
                                                                <a id='advance-search' class="search_field_buttons" data-toggle="collapse" href="#search-creditnote" role="button" aria-expanded="false" aria-controls="search-creditnote">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                                                                
                                                                <a  class="search_field_buttons"  href="<?=Url::base().'/users/credit-note/index'?>" role="button" aria-expanded="false" aria-controls="search-look" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                        <div class="main-card mb-3 card collapse" id="search-creditnote">
                           <div class="card-body">
                            
                                    <form class="dj-sale-form " >
                                        <div class="form-row">
                                        
                                        <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                   <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                   <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Customer/Receiver</label>
                                                     <?=$form->field($model, 'type_of_customer')->dropDownList(['customer'=>'Customer','vendor'=>'Vendor'], ['prompt' => '--Select--', 'class' => "select_class form-control", 'maxlength' => true])->label(false)?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group rendered">
                                                    <label for="date">User</label>





                                                    <?php if($model->type_of_customer=='vendor'){?>

                                                                <?php if($model->customer!=''){?>

                                                                <?php $customer=Vendor::find()->where(['id'=>$model->customer])->one()?>
                                                               <?=$form->field($model, 'customer')->dropDownList([$model->customer=>$customer->business_name], ['options' => [$model->customer => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "select_class addcustomer form-control", 'maxlength' => true])->label(false)?>

                                                               <?php }else {?>
                                                                          
                                                                <?=$form->field($model, 'customer')->dropDownList([], ['prompt' => '--Select--', 'class' => "addcustomer form-control", 'maxlength' => true])->label(false)?>           
                                                               <?php } ?>

                                                   <?php }else if($model->type_of_customer=='customer') {?>
                                                              
                                                                <?php if($model->customer!=''){?>

                                                                <?php $customer=Customer::find()->where(['id'=>$model->customer])->one()?>
                                                               <?=$form->field($model, 'customer')->dropDownList([$model->customer=>$customer->business_name], ['options' => [$model->customer => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "select_class addcustomer form-control", 'maxlength' => true])->label(false)?>

                                                               <?php }else {?>
                                                                          
                                                                <?=$form->field($model, 'customer')->dropDownList([], ['prompt' => '--Select--', 'class' => "addcustomer form-control", 'maxlength' => true])->label(false)?>         
                                                               <?php } ?>

                                                   <?php }else{?> 

                                                     <?=$form->field($model, 'customer')->dropDownList([], ['prompt' => '--Select--', 'class' => "addcustomer form-control", 'maxlength' => true])->label(false)?>

                                                   <?php } ?>

                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Setting Type</label>
                                                     <?= $form->field($model, 'setting')->dropDownList($prosettinglist,['prompt'=>'--Select--','class'=>'select_class form-control'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount</label>
                                                    <?= $form->field($model, 'amount')->textInput(['maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                            
                                            <div class="col-md-3">
                                                <div class="position-relative form-group rendered">
                                                    <label for="date">Product</label>



                                                     <?php if($model->product!=''){?>

                                                    <?php $product=Product::find()->where(['id'=>$model->product])->one()?>
                                                   <?=$form->field($model, 'product')->dropDownList([$model->product=>$product->product_name], ['options' => [$model->product => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "product form-control", 'maxlength' => true])->label(false)?>

                                                   <?php }else {?>
                                                              
                                                    <?=$form->field($model, 'product')->dropDownList([], ['prompt' => '--Select--', 'class' => "product form-control", 'maxlength' => true])->label(false)?>           
                                                   <?php } ?>

                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3 dj-btn-align" style="padding-top: 5px">
                                            <button class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search"></i>Search</button>
                                            
                                            </div>
                                            

                                        </div>
                                      </form>
                                        
                                    
                                </div>
                        </div>
                        <?php ActiveForm::end(); ?>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                        <div class="row">

                            <div class="col-sm-6">
                                <div class="djsec-text-left dj-print-sec">

                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/delete'])->one()!=''){?>
                                  <button id='bulkdelete' class='mb-2 mr-2 btn-icon btn btn-danger '><i class="fa fa-trash"></i> Delete</button> 
                                   <?php }else {?>

                                <?php } ?>          
                               </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="djsec-text-right dj-print-sec">
                                        
                                        <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/creditnote-pdf'])->one()!=''){?>
                                          <a href="<?=Url::base();?>/users/credit-note/creditnote-pdf?from=all" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-pdf-o"></i> Pdf</button></a>
                                           <?php }else {?>

                                        <?php } ?>


                                        <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/excel-export'])->one()!=''){?>
                                          <a href="<?=Url::base();?>/users/credit-note/excel-export?detail=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details Excel</button></a>
                                          <a href="<?=Url::base();?>/users/credit-note/excel-export" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                                           <?php }else {?>

                                        <?php } ?>
 
                                </div>
                            </div>
                        
                             </div>
                            
                             <?= GridView::widget([
                                    'dataProvider' => $dataProvider,
                                    "id" => "grid",
                                    'columns' => [
                                        ['class' => 'yii\grid\CheckboxColumn'],
                                        ['class' => 'yii\grid\SerialColumn',
                                         
                                         ],
                                        'credit_note_id',
                                        [
                                            'label' => 'Credit Note #',
                                            'attribute' => 'setting_type',
                                            'value' => function ($data) {
                                                $settings = GenericTemplate::find()->where(['gt_id'=>$data->setting_type])->one();
                                                if($settings)
                                                   return $settings->template_name;
                                               else 
                                                   return $data->setting_type;
                                        },
                                        ],
                                        [
                                            'label' => 'Amount',
                                            'attribute' => 'total_amount',
                                            'value' => function ($data) {
                                            $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data->total_amount);
                                            return $num; 
                                                
                                        },
                                        ],
                                         [
                                            'label'=>'Customer',
                                            'contentOptions'=>['style'=>'font-weight:bold'],
                                           'attribute' => 'customer_name',
                                           'value' => function ($data) {
                                            if($data->customer_type=='customer')
                                            {
                                                $val=Customer::find()->where(['id'=>$data->customer_name])->one();
                                                return $val->business_name;
                                            }
                                            else
                                            {
                                                $val=Vendor::find()->where(['id'=>$data->customer_name])->one();
                                                return $val->business_name;
                                            }
                                            
                                           }
                                        ],
                                        [
                                            'label' => 'Date',
                                            'attribute' => 'date',
                                            'value' => function ($data) {
                                                return date('F j Y', strtotime($data->date));
                                        },
                                        ],
                                        [
                                        'label' => 'Paid',
                                        'contentOptions'=>[ 'style'=>'text-align:right'],

                                        'value' => function ($data) {
                                            if($data->invoice_no!='')
                                            {
                                                $receipt_no = Invoice::find()->select(['receipt_id'])->where(['invoice_id'=>$data->invoice_no])->asArray()->one();
                                                $amount_paid = Invoice::find()->select(['receipt_total_amount'])->where(['invoice_id'=>$data->invoice_no])->one();

                                                if($receipt_no!='' && $receipt_no!='')
                                                {
                                                    $price= ReceiptDetails::find()->select(['total_amount'])->where(['receipt_id' =>$receipt_no])->asArray()->one();
                                                    if($price!='')
                                                      $amount_given=$price['total_amount'];
                                                    else $amount_given =0;

                                                }
                                                else if($amount_paid!=0)
                                                {
                                                    $amount_given = $amount_paid['receipt_total_amount'];
                                                }
                                                else
                                                {
                                                    $amount_given = 0;
                                                }
                                                $amt=$data->total_amount-$amount_given;
                                                $paid_amount=$data->total_amount-$amt;
                                                $finalamount = number_format((float)$paid_amount, 2, '.', '');
                                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                                                return $num;
                                                
                                            }
                                            else{
                                                return 0.00;
                                            }                                            
                                        },
                                        ],
                                        [
                                        'label' => 'Pending',
                                        'contentOptions'=>[ 'style'=>'text-align:right'],

                                        'value' => function ($data) {
                                            if($data->invoice_no!='')
                                            {
                                                $receipt_no = Invoice::find()->select(['receipt_id'])->where(['invoice_id'=>$data->invoice_no])->asArray()->one();
                                                $amount_paid = Invoice::find()->select(['receipt_total_amount'])->where(['invoice_id'=>$data->invoice_no])->one();

                                                if($receipt_no!='')
                                                {
                                                    $price= ReceiptDetails::find()->select(['total_amount'])->where(['receipt_id' =>$receipt_no])->asArray()->one();
                                                    if($price!='')
                                                      $amount_given=$price['total_amount'];
                                                    else $amount_given =0;

                                                }
                                                else if($amount_paid!=0)
                                                {
                                                    $amount_given = $amount_paid['receipt_total_amount'];
                                                }
                                                else
                                                {
                                                    $amount_given = 0;
                                                }
                                                $amt=$data->total_amount-$amount_given;
                                                $finalamount = number_format((float)$amt, 2, '.', '');
                                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                                                return $num;
                                                // return number_format($amt,2);
                                            }
                                            else
                                            {
                                                return 0.00;
                                            }
                                        },
                                        ],
                                        
                                        [
                                        'label' => 'Status',
                                        'format'=>'raw',
                                        'value' => function ($data) {
                                           $status = Invoice::find()->select(['status'])->where(['invoice_id'=>$data->invoice_no])->asArray()->column();
                                           $status = implode($status);
                                           if($status)
                                                {
                                                    // return $data['status'];
                                                    if($status=='Paid')
                                                    {
                                                         return '<span class="label-paid">PAID</span>';
                                                    }
                                                    else{
                                                        return "<span class='label-draft'>$status</span>";
                                                    }
                                                }
                                        },
                                        ],
                                        [
                                        'label' => 'Action',
                                        // 'attribute' => 'username',
                                        'format'=>'raw',
                                        'contentOptions'=>[ 'style'=>'width: 35px'],
                                        'value' => function ($data) use ($assign) {


                                            $topstring = '<div class="d-inline-block dropdown">
                                                                    <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                                    <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                                        <ul class="nav flex-column">';
                                            $downstring =  '</ul></div></div>';

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/view'])->one()!='')
                                            {
                                                $viewstring = '<li class="nav-item">
                                                        <a class="nav-link" href='.Url::base().'/users/credit-note/view?id='.$data->id.' data-method=post>
                                                           <i class="fa fa-eye"></i>
                                                            <span class="dj-icon-gap">  View</span>
                                                        </a>
                                                    </li>';
                                            }
                                            else
                                            {
                                                $viewstring = '';
                                            } 

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/update'])->one()!='')
                                            {
                                                $editstring = '<li class="nav-item">
                                                        <a class="nav-link" href='.Url::base().'/users/credit-note/update?id='.$data->id.'>
                                                            <i class="fa fa-pencil-square"></i>
                                                            <span class="dj-icon-gap"> Edit</span>
                                                        </a>
                                                    </li>';
                                            }
                                            else
                                            {
                                                $editstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/delete'])->one()!='')
                                            {
                                                $deletestring = '<li class="nav-item">
                                                        <a class="nav-link confirmdeletecreditnote" href='.Url::base().'/users/credit-note/delete?id='.$data->id.'  data-method=post>
                                                           <i class="fa fa-trash"></i>
                                                            <span class="dj-icon-gap">  Delete</span>
                                                        </a>
                                                    </li>';
                                            }
                                            else
                                            {
                                                $deletestring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/creditnote-pdf'])->one()!='')
                                            {
                                                $pdfstring = '<li class="nav-item">
                                                        <a class="nav-link" href='.Url::base().'/users/credit-note/creditnote-pdf?id='.$data->id.'  >
                                                           <i class="fa fa-file-pdf-o"></i>
                                                            <span class="dj-icon-gap">  PDF Credit Note</span>
                                                        </a>
                                                    </li>
                                                    <li class="nav-item">
                                                        <a class="nav-link" target="_blank" href='.Url::base().'/users/credit-note/view?id='.$data->id.'&from=print  >
                                                           <i class="fa fa-file-pdf-o"></i>
                                                            <span class="dj-icon-gap">  Print Credit Note</span>
                                                        </a>
                                                    </li>';
                                            }
                                            else
                                            {
                                                $pdfstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/excel-creditnote'])->one()!='')
                                            {
                                                $excelstring = '<li class="nav-item">
                                                        <a class="nav-link" href='.Url::base().'/users/credit-note/excel-creditnote?id='.$data->id.' >
                                                           <i class="fa fa-print"></i>
                                                            <span class="dj-icon-gap">Excel Credit Note</span>
                                                        </a>
                                                    </li>';
                                            }
                                            else
                                            {
                                                $excelstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/findcreditalldetails'])->one()!='')
                                            {
                                                $mailstring = '<li class="nav-item">
                                                        <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                                            <i class="fa fa-envelope-o"></i>
                                                            <span class="dj-icon-gap"> Mail Credit Note</span>
                                                        </a>
                                                    </li>
';
                                            }
                                            else
                                            {
                                                $mailstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/credit-note/findattachments'])->one()!='')
                                            {
                                                $attachemntstring = '<li class="nav-item">
                                                        <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#executive_type" value='.$data->id.'>
                                                           <i class="fa fa-paperclip"></i>
                                                            <span class="dj-icon-gap">  Download Attachments</span>
                                                        </a>
                                                    </li>
';
                                            }
                                            else
                                            {
                                                $attachemntstring = '';
                                            }


                                            return $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$pdfstring.''.$excelstring.''.$mailstring.''.$attachemntstring.''.$downstring;

                                        },
                                    ],
                                    ],
                                ]); ?>


                        </div>
                    </div>
                </div>





<div class="modal fade" id="email">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Email</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mail To </label>   
                 <div class="col-md-12">      
                          <?= $form->field($model, 'send_email')->textInput(['maxlength' => true,'class' => "form-control mail_send"])->label(false) ?>                   
                 </div> 

                 <label for="customer" class="">BCC </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'bcc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_bbc"])->label(false) ?>                                                
                </div>

                <label for="customer" class="">Mail Cc </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'cc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_cc"])->label(false) ?>                            
                </div>

                <label for="customer" class="">Subject </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'email_subject')->textInput(['maxlength' => true,'placeholder'=>'Enter Subject','class' => "form-control mail_subject"])->label(false) ?>
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id"])->label(false) ?> 
                       <!-- </div> -->
                                                
                </div>

                <label for="customer" class="">Message </label>   
                 <div class="col-md-12">

                          <?= $form->field($model, 'email_message')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control message"])->label(false) ?>
                           
                       <!-- </div> -->
                                                
                </div>
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                   <?= Html::submitButton('<i class="fa fa-check-square-o" aria-hidden="true"></i> Send', ['class' => 'btn dj-blue-btn submit-btn']) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>


<div class="modal fade" id="executive_type" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Credit Note Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            
            <table id="dinamic">
                
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>



<?php ob_start();?>
 <script type="text/javascript">
$(function() {
 $('.select_class').select2();

    $('.senddetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     $('.cancel_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('findalldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           $('.c_code').val('91');
           $('.reason').val('');
           jQuery.ajaxSetup({async:false});
           $.get('create-url',{id:id},function(st)
           {
                var st =$.parseJSON(st);
                $('.send_text').text('We have confirmed your Invoice '+(data.invoice_id)+' has been raised for Rs '+data.total_price+'. Thank you! For Download Click this link '+st); 
           })
     });  
})

 $('.sendemail').click(function(){
     var id = $(this).attr('value');
     // $('.reason').val('');
     $('.cancel_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('finduseralldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           $('.send_email').val(data.email);
           $('.mail_bbc').val('');
           
           
           // jQuery.ajaxSetup({async:false});
           $.get('findcreditalldetails',{id:id},function(st)
           {
                var st =$.parseJSON(st);
                var sub= 'Credit Note # '+st.credit_note_id+" Date:"+st.date;
                $('.mail_subject').val(sub);
                $.get('create-url',{id:id},function(link)
                {
                    var link =$.parseJSON(link);
                    // var obj = $('.message').html('Dear '+(data.business_name)+"\n We have confirmed your order for Invoice # MS/389/21-22. The Invoice has been raised for Rs"+ st.total_price+'\n Thank you! \n MOHASYN \n \n Download attached invoice at: \n'+link).wrap('<pre />'); 
                })
                // var obj = $("#example").text('this\n has\n newlines');
               
           })
           

     });
     
})


  $('.product').select2({
        ajax: { 
        url: "<?php echo Url::toRoute('leads-quotes/productdetails'); ?>",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    $('.addcustomer').select2();    
$('#creditnote-type_of_customer').change(function(){
    if($(this).val()=='vendor')
    {
        $('.addcustomer').empty();
        $('.addcustomer').append('<option value="">--Select--</option>');
        $('.addcustomer').select2({
        ajax: { 
        url: "vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
    }
    else if($(this).val()=='customer')
    {
        $('.addcustomer').empty();
        $('.addcustomer').append('<option value="">--Select--</option>');
        $('.addcustomer').select2({
        ajax: { 
        url: "../sale-order/customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    } 
    else
    {
        $('.addcustomer').empty();
        $('.addcustomer').append('<option value="">--Select--</option>');
        $('.addcustomer').select2();
    }    
})    
$('#bulkdelete').click(function(){
    var ids = $('#grid').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure you want to delete selected items?");
        if(x)
        {
            var ids = $('#grid').yiiGridView('getSelectedRows');
            console.log(ids);
            $.post( 'delete',{data: ids}, function( data ) {
               });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some items to delete!");
    }
   
})
$('.confirmdeletecreditnote').click(function(){
var confirm = window.confirm("Are you sure you want to delete selected item?");
if (confirm == true)
return true;
else
return false;
})

var isLoading = false;
$('.attachments').click(function(){
     $("#dinamic").empty();
     isLoading = true;
     var id = $(this).attr('value');
     $.get('findattachments',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           if(data.length==0)
           {
               $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
           }
           for (var i = 0; i < data.length; i++){
                 // $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "</td><tr>");

                $('#dinamic').append("<tr><td  value='" + data[i].id + "'><a href='<?=Url::base();?>/users/credit-note/download?id="+ data[i].id +"'>"+ data[i].document_name +"</a></td><tr>");
               

                  }
         isLoading = false;        

     });
})


$('#search-creditnote').hide();
$('#advance-search').click(function(){
    $('#search-creditnote').toggle();
})
if($('#creditnote-type_of_customer').val()){
$.post( 'find-'+$('#creditnote-type_of_customer').val(), function( data ) {
     $('#creditnote-customer').empty();
    $('#creditnote-customer').append('<option value="">--Select--</option>');
    $.each(JSON.parse(data), function(i, item) {
      $('#creditnote-customer').append($('<option value=\"'+i+'\">'+item+'</option>'));
      });
      $('#creditnote-customer').val(<?=$model->customer?$model->customer:''?>)
    })   
}


if($('.addcustomer').val()!=''){
    if($('#creditnote-type_of_customer').val()=='vendor')
    {
        $('.addcustomer').select2({
        ajax: { 
        url: "vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
    }
    else if($('#creditnote-type_of_customer').val()=='customer')
    {
       
        $('.addcustomer').select2({
        ajax: { 
        url: "../sale-order/customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    } 
    else
    {
        $('.addcustomer').empty();
        $('.addcustomer').append('<option value="">--Select--</option>');
        $('.addcustomer').select2();
    }    
}


});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>

                
