<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\AccountingTax;
use yii\helpers\ArrayHelper;
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\PurchaseTemplates;
use backend\modules\master\models\GenericTemplate;


if(date("m")>=4)
{
    $dt = (date('Y', strtotime('+0 year'))).'-'.(date('y', strtotime('+1 year')));
}
else
{
    $dt = (date('Y', strtotime('-1 year'))).'-'.(date('y', strtotime('+0 year')));
}


$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

$tcs_rate=AccountingTax::findOne(35)->tax_rate;
if($model->party_type=='vendor')
{
    $customer=Vendor::find()->select('business_name')->where(['id'=>$model->party_id])->one();
}
else
{
    $customer=Customer::find()->select('business_name')->where(['id'=>$model->party_id])->one();
}

$debit = GenericTemplate::find()->where(['template_for'=>'Debit Note'])->all();
$debitnote=ArrayHelper::map($debit, 'gt_id', 'template_name');

/* @var $this yii\web\View */
/* @var $model backend\modules\users\models\DebitNote */
/* @var $form yii\widgets\ActiveForm */
?>
<style>
    .select2-container .select2-selection--single {
    height: 39px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
input#debitnote-tcs{
    float: right;
    width: 141px;
    margin-bottom:25px;
}
.error-help
{
    color:red;
    margin-top: -15px;
}
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
                    <?php endif; ?>
<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success"><?=$update?"Update":"Create"?> Debit Note</div>
                                                            </div>
															<div class="widget-content-right">
                                                                <a href="<?=Url::base().'/users/debit-note/index'?>" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(); ?>
                            <?= $form->field($model, 'image')->fileInput(['maxlength' => true,'class'=>"form-control",'style'=>'display:none'])->label(false) ?>
						    <div class="form-row">
							<div class="col-md-6">
							  <div class="position-relative form-group">
                                                    <label for="customer" >Settings Type<span class="dj-red">*</span></label>

                                                    <?php if($model->setting_type=='') { ?>
                                                        <?=$form->field($model, 'setting_type')->dropDownList($debitnote, [ 'class' => "multiselect-dropdow form-control setting_default", 'prompt'=>'--Select--','maxlength' => true])->label(false)?>
                                                    <div class="error-help">This template is already deleted.</div>
                                                    <?php } else { ?>
                                                        <?=$form->field($model, 'setting_type')->dropDownList($debitnote, [ 'class' => "multiselect-dropdow form-control", 'prompt'=>'--Select--','maxlength' => true])->label(false)?>
                                                    <div class="error-help">This template is already deleted.</div>
                                                    <?php } ?>

                                                    
                                                </div>
							</div>
                            <div class="col-md-6">
							  <div class="position-relative form-group">
                                                    <label for="customer" >Party Type <span class="dj-red">*</span></label>
                                                    <?=$form->field($model, 'party_type')->dropDownList(['vendor'=>'Vendor','customer' => 'Customer'], ['prompt'=>'--Select--','class' => "form-control select_class", 'maxlength' => true])->label(false)?>

                                                </div>
							</div>
							 <div class="col-md-2" style="margin:auto;">
						   <div class="text-right">
                           <!-- <a id="partyadd" href="#" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Party</a> -->
									</div>
									</div>
									</div>
									<hr class="dj-hr">
                                    <!-- <form class="dj-sale-form"> -->
									  <div class="form-row">
                                            <div class="col-md-5">
                                                <div class="position-relative form-group">
                                                    <label for="customer" >Party Name <span class="dj-red">*</span></label>
                                                    <?php if($update){?>

                                                     <?= $form->field($model, 'party_id') ->dropDownList([$model->party_id=>$customer->business_name],['options' => [$model->party_id => ['Selected'=>'selected']],'prompt'=>'--Select--','class' => " party_name form-control"])->label(false)?>
                                                    <?php } else{?>
                                                    <?=$form->field($model, 'party_id')->dropDownList([''=>'--Selcet--'], [ 'class' => " party_name form-control", 'maxlength' => true])->label(false)?>
                                                    <?php } ?>
                                                </div></div>
                                                <div class="col-md-1">
                                            <button style='margin-top:30px' type="button"  title='Refresh Vendor'class="vendorrefresh dj-danger-btn"><i class="fa fa-refresh" aria-hidden="true"></i></button>
                                            </div>
                                            <div class="col-md-6">
											<div class="position-relative form-group">
                                                    <label for="gstn">Sender GSTN/ UID</label>
                                                    <?= $form->field($model, 'sender_gst')->textInput(['maxlength' => true,'class'=>"form-control",'readonly'=>true])->label(false) ?>
                                                </div>
                                                </div>
                                             <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="salestype">Bill Type <span class="dj-red">*</span></label>
                                                    <?=$form->field($model, 'bill_type')->dropDownList(['B2B'=>'B2B','B2C'=>'B2C','EXPORT'=>'EXPORT','ADV PAYMENT'=>'ADV PAYMENT'], ['prompt' => '--Select--', 'class' => "multiselect-dropdow form-control", 'maxlength' => true])->label(false)?>
                                                     <!-- <select class="multiselect-dropdow form-control">
														<option value="b2b">B2B</option>
														<option value="b2c">B2C</option>
														<option value="b2c">EXPORT</option>
														<option value="b2c">ADV PAYMENT</option>
                                                    </select> -->
                                                </div>
                                            </div>
                                            <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Notes</label>
                                                    <?= $form->field($model, 'notes')->textarea(['class'=>"form-control",'rows' => '2'])->label(false) ?>
                                                </div>
                                            </div>
                                           
                                        </div>
										<hr class="dj-hr">
										 <div class="form-row">
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Supply Type</label>
                                                    <?=$form->field($model, 'supply_type')->dropDownList(['Inter-State'=>'Inter-State','Intra-State'=>'Intra-State','Export'=>'Export','Exempted'=>'Exempted'], ['prompt' => '--Select--', 'class' => "multiselect-dropdow form-control", 'maxlength' => true])->label(false)?>

                                                    <!-- <select class="multiselect-dropdow form-control">
												   <option value="RK">Select a Supply Type</option>
														<option value="RM">Inter-State</option>
														<option value="RM">Intra-State</option>
														<option value="RM">Export</option>
														<option value="RM">Exempted</option>
                                                    </select> -->
                                                </div>
											</div>
											 <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Supply Attracts Reverse Charge</label>
                                                    <?=$form->field($model, 'supply_attracts')->dropDownList(['1'=>'Yes','0'=>'No'], ['prompt' => '--Select--', 'class' => "multiselect-dropdow form-control", 'maxlength' => true])->label(false)?>

                                                    <!-- <select class="multiselect-dropdow form-control">
														<option value="RM">Yes</option>
														<option value="RM">No</option>
                                                    </select> -->
                                                </div>
											</div>
											  <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Pricelist</label>
                                                    <?=$form->field($model, 'pricelist')->dropDownList(['Default Sale Price'=>'Default Sale Price'], ['prompt' => '--Select--', 'class' => "multiselect-dropdow form-control", 'maxlength' => true])->label(false)?>

                                                   <!-- <select class="multiselect-dropdow form-control">
														<option value="RM">Default Sale Price</option>
                                                    </select> -->
                                                </div>
											 </div>
											 <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Point of Supply (Only if different from location of recipient)</label>
                                                    <?= $form->field($model, 'point_of_supply')->textInput(['maxlength' => true,'class'=>"form-control point_of_supply",'readonly'=>true])->label(false) ?>
                                                </div>
												
											 </div>								 
											 <div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="customer" class="">Is ineligible ITC?</label>
                                                    <?=$form->field($model, 'ineligible_itc')->dropDownList(['1'=>'Yes','0'=>'No'], ['prompt' => '--Select--', 'class' => "multiselect-dropdow form-control", 'maxlength' => true])->label(false)?>
                                                </div>
                                            </div>
									</div>
									<hr class="dj-hr">
											 <h5 class="card-title">Debit Note #</h5>
											 <div class="form-row">
											   <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="prefix" class="">Prefix Ex:RA</label>
                                                    <?= $form->field($model, 'prefix')->textInput(['maxlength' => true,'class'=>"form-control",'readonly'=>true,'value'=>'D'])->label(false) ?>
                                                </div>
											 </div>
											 <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="salesorder" class="do" id="debit_label">DO# Last# <?=$last_entry-1?></label>
                                                    <?php if($update){ ?>
                                                     <?= $form->field($model, 'po')->textInput(['maxlength' => true,'class'=>"form-control",'readonly'=>true,'value'=>$last_entry])->label(false) ?>
                                                     <?php } else{ ?>
                                                     <?= $form->field($model, 'po')->textInput(['maxlength' => true,'class'=>"form-control",'readonly'=>true,'value'=>$last_entry])->label(false) ?>
                                                     <?php } ?>
                                                </div>
											 </div>
											 <div class="col-md-4">
                                                <div class="position-relative form-group">
												 <label for="suffix" class="">Suffix EX: RT</label>
                                                 <?= $form->field($model, 'suffix')->textInput(['maxlength' => true,'class'=>"form-control",'readonly'=>true,'value'=>$dt])->label(false) ?>
                                                </div>
											 </div>
											  <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date" class="">Date <span class="dj-red">*</span></label>
                                                    <?php if(!$update){?>
                                                    <?= $form->field($model, 'date')->textInput(['type'=>'date','maxlength' => true,'class'=>"form-control",'value'=>date('Y-m-d', time())])->label(false) ?>
                                                    <?php } else { ?>
                                                    <?= $form->field($model, 'date')->textInput(['maxlength' => true,'class'=>"form-control tcal"])->label(false) ?>
                                                    <?php } ?>                                                </div>
											 </div>
											 <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date" class="">Bill Number</label>
                                                    <?= $form->field($model, 'bill_no')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                                </div>
											 </div>
											   <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date" class="">Bill Date</label>
                                                    <?= $form->field($model, 'bill_date')->textInput(['maxlength' => true,'class'=>"form-control",'type'=>'date'])->label(false) ?>
                                                </div>
											 </div>
											 </div>
											 <hr class="dj-hr">
											 <div class="form-group row">
                                    <label class="col-form-label col-md-2">Product Code</label>
                                    <div class="col-md-10">
                                    <?= $form->field($model, 'product_code')->textInput(['maxlength' => true,'class'=>"form-control"])->label(false) ?>
                                    </div>
                                    </div>
									<div class="form-row">
									<table class="mb-0 table table-bordered dj-table-form">
                                        <thead>
                                            <tr>
                                                <th colspan="2" width="20%">Product *</th>
                                                <th width="10%">Desc</th>
                                                <th width="10%">Qty</th>
                                                <th width="10%">Units</th>
                                                <th width="10%">Price</th>
                                                <th width="10%">Discount</th>
                                                <th width="10%">Discount Type</th>
                                                <th width="20%">Tax</th>
                                                <th>Incl Tax</th>
                                                <th width="10%">Amount</th>
                                            </tr>
                                        </thead>
                                        <tbody id="dj-table-body">
                                        <?php if($update){ if($datalist){foreach($datalist as $index=>$value){ ?>
                                            <?php 
                                            $product = Product::find()->select('product_name')->where(['id'=>$value->product_id])->one(); ?>
                                            <tr >
                                               <?php if($index==0){ ?>
                                                <td class="text-center"></td>
                                                
                                               <?php } else{?>
                                              
                                                <td class="text-center"></td>
                                               <?php } ?>
                                                <td>
                                                    <select style="width: 200px" name="product<?=$index+1?>" id="product<?=$index+1?>" class="productind form-control">
                                                        <option value="<?=$value->product_id?>"><?=$product->product_name?></option>
                                                    </select>
                                                </td>
                                                    <!-- multiselect-dropdow -->
                                                <td><input name="desc<?=$index+1?>" id="desc<?=$index+1?>" type="text" class="form-control descriptionind" value=<?=$value['description']?>></td>
                                                <td><input min='1' name="quantity<?=$index+1?>" id="quantity<?=$index+1?>" type="number" class="form-control quantityind" value=<?=$value['qty']?> onkeypress="return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"></td>
                                                <td><select disabled name="unit<?=$index+1?>" id="unit<?=$index+1?>" class=" form-control unitind"><option <?=$value['unit']=='Nos'?"selected":''?> value="Nos">Nos</option><option <?=$value['unit']=='Pcs'?"selected":''?> value="Pcs">Pcs</option><option <?=$value['unit']=='Pkt'?"selected":''?> value="Pkt">Pkt</option></select></td>
                                                <td><input step="any" required name="price<?=$index+1?>" id="price<?=$index+1?>" type="number" class="form-control priceind" value=<?=$value['price']?> ></td>
                                                <td><input type="text" name="discount<?=$index+1?>" id="discount<?=$index+1?>" class="form-control discountind" value=<?=$value['discount']?>>
                                                <div class="error-help">Enter the Valid Discount</div>  
                                                </td>
                                                <td><select name="discounttype<?=$index+1?>" id="discounttype<?=$index+1?>" class="form-control discounttypeind"><option value="">--Select---</option><option <?=$value['discount_type']=="%"?"selected":''?> value="%">%</option><option <?=$value['discount_type']=="FLAT"?"selected":''?> value="FLAT">FLAT</option></select>
                                                <div class="error-help">Enter the Valid Discount Type</div>  
</td>
												<td><?php  foreach (explode(',',$value['tax']) as $taxin) {$sel_groups_array[$taxin] = array("selected"=>true);}
                                                  
                                                  ?>

                                                                <?= $form->field($value, 'tax')->dropDownList(ArrayHelper::map(Accountingtax::find()->select(['tax_name','accounting_tax_id'])->asArray()
                                                                ->where(['is_deleted'=>0])
                                                                ->andWhere(['tax_sub_type'=>'Input'])
                                                                ->andWhere(['status'=>1])
                                                                ->andWhere(['or',['tax_class'=>'IGST'],['tax_class'=>'TCS']])
                                                                  ->all(),'accounting_tax_id','tax_name'),['prompt'=>'--Select Tax--','class' => "taxind form-control",'style'=>"width: 200px",'id'=>"tax".($index+1) , 'name'=>"tax".($index+1)])->label(false)?> 

                                                                <?php $sel_groups_array=[]?> 
                                                            </td>	
                                                <td class="text-center"><input name="includetax<?=$index+1?>" id="includetax<?=$index+1?>" class="includetaxind" type="checkbox" value=<?=$value['incl_tax']?> <?=$value['incl_tax']?"checked":1?>></td>
											    <td class="text-right"><input type="text" name="total<?=$index+1?>" id="total<?=$index+1?>" class="totalind form-control" value=<?=$value['amount']?> readonly ></td>	
                                            </tr>
                                        <?php } } else{?>
                                            <tr  class='firstrow'>
                                            <td class="text-center"></td>
                                                <!-- <td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td> -->
                                                <td><select style="width:200px" name="product1" id="product1" class="productind form-control">
                                                        <option value="">Select a Product</option>
                                                    </select></td>
                                                    <!-- multiselect-dropdow -->
                                                <td><input name="desc1" id="desc1" type="text" class="form-control descriptionind"></td>
                                                <td><input min='1' name="quantity1" id="quantity1" type="number" class="form-control quantityind"  onkeypress="return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"></td>
                                                <td><select disabled name="unit1" id="unit1" class=" form-control unitind"><option value="Nos">Nos</option><option value="Pcs">Pcs</option><option value="Pkt">Pkt</option></select></td>
                                                <td><input required step="any" type="number" name="price1" id="price1" class="form-control priceind" ></td>
                                                <td><input type=text name="discount1" id="discount1" class="form-control discountind">
                                                <div class="error-help">Enter the Valid Discount</div>  

                                                </td>
                                                <td><select name="discounttype1" id="discounttype1" class="form-control discounttypeind"><option value="">--Select---</option><option value="%">%</option><option value="FLAT">FLAT</option></select>
                                                <div class="error-help">Enter the Valid Discount Type</div>  
                                                </td>
												<td>
                                                    <div> <select  name="tax1" id="tax1" class="form-control taxind"  style="width: 200px">
                                                  
                                                </select></div>                                     
                                                </td>	
                                                <td class="text-center"><input name="includetax1" id="includetax1" class="includetaxind" type="checkbox" value=1></td>
											    <td class="text-right"><input type=text name="total1" id="total1" class="totalind form-control" readonly ></td>	
                                            </tr>
                                      <?php  } } else{ ?>
                                            <tr  class='firstrow'>
                                            <td class="text-center"></td>
                                                <!-- <td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td> -->
                                                <td><select style="width:200px" name="product1" id="product1" class="productind form-control">
                                                        <option value="">Select a Product</option>
                                                    </select></td>
                                                    <!-- multiselect-dropdow -->
                                                <td><input name="desc1" id="desc1" type="text" class="form-control descriptionind"></td>
                                                <td><input min='1' name="quantity1" id="quantity1" type="number" class="form-control quantityind" onkeypress="return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"></td>
                                                <td><select disabled name="unit1" id="unit1" class="form-control unitind"><option value="Nos">Nos</option><option value="Pcs">Pcs</option><option value="Pkt">Pkt</option></select></td>
                                                <td><input required step="any" name="price1" id="price1" type="number" class="form-control priceind" ></td>
                                                <td><input type=text name="discount1" id="discount1" class="form-control discountind">
                                                <div class="error-help">Enter the Valid Discount</div>  

                                                </td>
                                                <td><select style="width: 90px" name="discounttype1" id="discounttype1" class="form-control discounttypeind"><option value="">--Select---</option><option value="%">%</option><option value="FLAT">FLAT</option></select>
                                                <div class="error-help">Enter the Valid Discount Type</div>  
                                                </td>
												<td><div> <select  name="tax1" id="tax1" class="form-control taxind"  style="width: 200px">
                                                  
                                                </select></div></td>	
                                                <td class="text-center"><input name="includetax1" id="includetax1" class="includetaxind" type="checkbox" value=1></td>
											    <td class="text-right"><input type=text name="total1" id="total1" class="totalind form-control" readonly value='0.00'></td>	
                                          
                                            </tr>
                                        <?php } ?>
                                        </tbody>
                                    </table>
									</div>
									  <div class="form-row">
									<table class="mb-0 table table-bordered">
										  <tr>
											<td width="25%" rowspan="7"><a href="javascript:void(0);" class="dynamicadd dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Line </a></td>
											<td width="25%" rowspan="7" class="text-right">

                                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/master/product/create'])->one()!=''){?>
                                               <a href="<?=Url::base().'/master/product/create'?>" target='_blank' class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a Product</a>
                                               <?php }else {?>

                                               <?php } ?>

                                            </td>
											<td width="25%"><label class="dj-sub-total-amt ">Subtotal:</label></td>
											<td width="25%" class="text-right"><label class="dj-sub-total-amt subtotalamount">0.00</label>
                                            <input type=hidden name=subtotalamount id=subtotalamount value=0></td>
										  </tr>
                                          <tr class='cgst-row' style="display:none">
                                            <td><input type="hidden" class='cgst' id="cgst" name="cgst" value="<?=$model->cgst?$model->cgst:0.00?>"><label class="dj-sub-total-amt">CGST:</label></td>
                                            <td  class="text-right cgst"><label class="dj-sub-total-amt cgst"><?=$model->cgst?$model->cgst:0.00?></label></td>
                                          </tr>
                                          <tr class='sgst-row' style="display:none">
                                            <td><input type="hidden" class='sgst' id="sgst" name="sgst" value="<?=$model->sgst?$model->sgst:0.00?>"><label class="dj-sub-total-amt">SGST:</label></td>
                                            <td  class="text-right sgst"><label class="dj-sub-total-amt sgst"><?=$model->sgst?$model->sgst:0.00?></label></td>
                                          </tr>
                                          <tr class='igst-row' style="display:none">
                                            <td><input type="hidden" class='igst' id="igst" name="igst" value="<?=$model->igst?$model->igst:0.00?>"><label class="dj-sub-total-amt">IGST:</label></td>
                                            <td  class="text-right igst"><label class="dj-sub-total-amt igst"><?=$model->igst?$model->igst:0.00?></label></td>
                                          </tr>
                                          <tr>
                                          
                                          <tr>
                                            <td width="25%"><label class="dj-sub-total-amt"><?= $form->field($model, 'is_tcs')->checkBox(['label' =>'','class'=>'tcs_tax'])->label(false) ?></label>&nbsp;&nbsp;<label class="dj-sub-total-amt">TCS:</label></td>
                                            <td width="25%" class="text-right"><label class="dj-sub-total-amt tcsam" style="padding-top: 10px"></label><?= $form->field($model, 'tcs')->textInput(['maxlength' => true,'class' => "form-control tcs"])->label(false) ?></td>
                                          </tr>
                                          <tr>
                                            <td><input type="checkbox" id="round" type="text" class="">&nbsp;&nbsp;<label class="dj-sub-total-amt">Add: Round Off</label></td>
                                            <td><input readonly name="roundoffval" id="roundoffval" type="text" class="form-control" value=<?=$model->round_off?$model->round_off:''?>></td>
                                          </tr>
										  <tr>
											<td><label class="dj-total-amt">Total(INR):</label></td>
											<td  class="text-right"><label class="totalamount dj-total-amt">0.00</label>
                                            <input type=hidden name=totalamount id=totalamount value=0>
                                            </td>
										  </tr>
                                          
										  <tr>
											<td colspan="2"><div class="form-group">
											<div class="form-check form-check-inline">
                                            <!-- <label class="form-check-label" for="sale_order">Match Bill</label> -->

                                            <?= $form->field($model, 'match_bill')->radioList(['1' => 'match bill'])->label(false) ?>

												<!-- <input class="form-check-input" type="radio" name="sale_order" id="sale_order" value="option1"> -->
											</div>
											</div></td>
										  </tr>
										</table>

										</div>
											<hr class="dj-hr">
											<div class="form-row">
									  <div class="col-md-12" style="margin-bottom:10px;">
                                <div class="text-left mt-3"> </label><?= $form->field($model, "show_to_store_keeper")->checkbox(['label' => "Show to Store Keeper?"]); ?>
                                </div>
                                            <div class="form-check form-check-inline">
                                            <!-- <label class="form-check-label" for="full-order"> Full Order </label>&nbsp&nbsp -->

                                            <?= $form->field($model, 'full_order')->radioList(['full order' => 'full order', 'product wise' => 'product wise'])->label(false) ?>

                                                <!-- <input class="form-check-input" type="radio" name="sale_order" id="sale_order" value="option1"> -->

                                                  <!-- <input class="form-check-input" type="radio" name="sale_order" id="sale_order" value="option1">
                                                <label class="form-check-label" for="product-wise"> Product Wise</label> -->
                                            </div>
										</div>
											<div class="col-md-6">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Notes</label>
                                                    <?= $form->field($model, 'debit_notes')->textarea(['class'=>"form-control",'rows' => '4'])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-6">
													<div class="position-relative form-group attachment">
                                                    <label for="exampleFile" class="">Attach Documents</label>
                                                <?php if($update&&$doc){ foreach($doc as $index=>$value){?>
                                                <?php if($index==0){?>
                                                    <input style="display:none" class="form-control file<?=$index+1?>" type="file" id="file<?=$index+1?>" name="file<?=$index+1?>">
                                                <?php } ?>
                                                        <input style="display:none" class="form-control file<?=$index+2?>" type="file" id="file<?=$index+2?>" name="file<?=$index+2?>">
                                                        <input class="form-control file<?=$index+2?>" type="hidden" value=<?=$value->id?> name="file<?=$index+2?>">
                                                        <br><br><img class="file<?=$index+2?>"width="90" height="40"src="<?=Url::base()?>/usersdocument/debit_note/<?=$value->document_name?>"><button style="margin-left:50px;display:none"type="button" data='file<?=$index+1?>' class=" remove dj-danger-btn file<?=$index+1?>"><i class="fa fa-plus-circle" aria-hidden="true"></i> Remove</button>
                                                        <button style="margin-left:50px"type="button" data="file<?=$index+2?>" class="dj-danger-btn remove file<?=$index+2?>"><i class="fa fa-plus-circle" aria-hidden="true"></i> Remove</button>
                                                <?php } }elseif($update){?>
                                                    <input style="display:none" class="form-control file1" type="file" id="file1" name="file1">
                                                    <input class="form-control file2" type="file" id="file2" name="file2">

                                                    <button style="margin-left:50px;display:none"type="button" class="dj-danger-btn file2"><i class="fa fa-plus-circle" aria-hidden="true"></i> Remove</button>
                                               <?php } else{?>
                                                <input class="form-control file1" type="file" id="file1" name="file1">
                                                    <button style="margin-left:50px;display:none"type="button" class="dj-danger-btn file1"><i class="fa fa-plus-circle" aria-hidden="true"></i> Remove</button>
                                                    <?php } ?>
                                                   <!-- <span class="form-text text-muted">Allowed File Formats *.jpg,*.png,*.gif,*.txt,*.xls,*.doc,*.xlsx (Allowed Size 2M)</span> -->
                                                </div>
                                                <input type='hidden' name='imagecount' id='imagecount' value="<?=$update?count($doc):1?>">
												<button type="button" id="attachment" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add a New</button>
										 </div>
									 </div>
									<div class="djsec-text-right dj-btn-sapce-sec">
                                            <button class="submit-btn mb-2 mr-2 btn-icon btn dj-danger-btn create-new"><i class="fa fa-file-text-o" aria-hidden="true"></i> <?=$update?"Update":"Save"?> and Create New</button>
										    <button class="submit-btn mb-2 mr-2 btn-icon btn dj-danger-btn"><i class="fa fa-commenting" aria-hidden="true"></i> <?=$update?"Update":"Save"?> and SMS</button>
											<button class="submit-btn mb-2 mr-2 btn-icon btn dj-danger-btn"><i class="fa fa-envelope-o" aria-hidden="true"></i> <?=$update?"Update":"Save"?> and Email</button>
											<button class="submit-btn mb-2 mr-2 btn-icon btn dj-danger-btn saveon"><i class="fa fa-check-square-o" aria-hidden="true"></i> <?=$update?"Update":"Save"?></button>
                                            <button type="reset" onclick="location.href='<?=Url::base()?>/users/product-delivered/index';" class="mb-2 mr-2 btn-icon btn btn-danger dj-le-btn"><i class="fa fa-ban" aria-hidden="true"></i> Cancel</button>
											
                                     </div>
                                     <?php ActiveForm::end(); ?>
                                </div>
                        </div>
                </div>
                <?php ob_start();?>
<script type="text/javascript">
$(function() {
    $('.error-help').hide();
     $('.taxind').select2();
    $('.select_class').select2();
     $('.discounttypeind').select2();
     $('.setting_default').find("option[value='23']").attr("selected",true).trigger('change');
  if(!<?=$update?> || <?=count($datalist)?><=0){
    $.get('../purchase-bill/finddetails',function(data)
     {
       $.each(JSON.parse(data), function(i, item) {
         $('.taxind').append($('<option value=\"'+i+'\">'+item+'</option>'));
    });
  });
  }

    var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
        $(".priceind").each(function(){
         var pct=$(this).parent().siblings().children('.discounttypeind').val();
        if($(this).val())
            {
                 if(pct=="%")
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    
                  }
                  else if(pct=="FLAT")
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                     
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                  }
            }
            })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        total();
$('#debitnote-date').attr('type','date');
$('#debitnote-bill_date').attr('type','date');
$('.vendorrefresh.dj-danger-btn').click(function(){
$('.cgst-row').hide();$('.sgst-row').hide();$('.igst-row').hide();
$('.cgst').val(''); $('.sgst').val(''); $('.igst').val('');
$('#debitnote-sender_gst').val('');$('#debitnote-point_of_supply').val('');
if($('#debitnote-party_type').val()){
// $.post( 'get-'+$('#debitnote-party_type').val(), function( data ) {
// $('#debitnote-party_id').empty();
// $('#debitnote-party_id').append('<option value="">--Select--</option>');
// $.each(JSON.parse(data), function(i, item) {
// $('#debitnote-party_id').append($('<option value=\"'+i+'\">'+item+'</option>'));
// });
// })
$('#debitnote-party_id').empty();
$('#debitnote-party_id').append('<option value="">--Select--</option>');
}else{
    alert("Please Select Party Type")
}      
})

if(<?=$update?>){
    $('#debitnote-party_id').each(function(){
    if($('#debitnote-party_type').val()=='vendor')
    {
        $('.party_name').select2({
        ajax: { 
        url: "../credit-note/vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            $('#customersearch').trigger('change');
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
    }
    else if($('#debitnote-party_type').val()=='customer')
    {
        $('.party_name').select2({
        ajax: { 
        url: "../sale-order/customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    }
    });
}
$('#debitnote-party_type').change(function(){
$('.cgst-row').hide();$('.sgst-row').hide();$('.igst-row').hide();
$('.cgst').val(''); $('.sgst').val(''); $('.igst').val('');
$('#debitnote-sender_gst').val('');$('#debitnote-point_of_supply').val('');
$('#partyadd').attr('href','<?=Url::base().'/master/'?>'+$(this).val()+'/create');
$('#partyadd').attr('target','_blank');
    if($(this).val()=='vendor')
    {
         $('.party_name').empty();
         $('.party_name').append('<option value="">--Select--</option>');
        $('.party_name').select2({
        ajax: { 
        url: "../credit-note/vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
    }
    else if($(this).val()=='customer')
    {
         $('.party_name').empty();
         $('.party_name').append('<option value="">--Select--</option>');
        $('.party_name').select2({
        ajax: { 
        url: "../sale-order/customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    }
    else
    {
         $('.party_name').empty();
         $('.party_name').append('<option value="">--Select--</option>');
        $('.party_name').select2();
    }
    // $.post( 'get-'+$(this).val(), function( data ) {
    //  $('#debitnote-party_id').empty();
    // $('#debitnote-party_id').append('<option value="">--Select-- </option>');
    // $.each(JSON.parse(data), function(i, item) {
    //   $('#debitnote-party_id').append($('<option value=\"'+i+'\">'+item+'</option>'));
    //   });
    // })      
})
$(".select option").val(function(idx, val) {
$(this).siblings('[value="'+ val +'"]').remove();
});

$('.dynamicadd').click(function(){
    count=$('#dj-table-body tr').length+1;
   
    $('#dj-table-body').append('<tr><td class="text-center"><i class="fa fa-close removeind" aria-hidden="true" style="color: blue;"></i></td><td><select name=\"product'+count+'\" id=\"product'+count+'\" class="productind form-control"><option value="">Select a Product</option></select></td><td><input name=\"desc'+count+'\" id=\"desc'+count+'\" type="text" class="form-control descriptionind"></td><td><input min=1 name=\"quantity'+count+'\" id=\"quantity'+count+'\" type="number" class="form-control quantityind" onkeypress="return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"></td><td><select disabled name=\"unit'+count+'\" id=\"unit'+count+'\" class=" form-control unitind"><option value="Nos">Nos</option><option value="Pcs">Pcs</option><option value="Pkt">Pkt</option></select></td><td><input step="any" required type=number name=\"price'+count+'\" id=\"price'+count+'\" class="form-control priceind"></td><td><input type=text name=\"discount'+count+'\" id=\"discount'+count+'\" class="form-control discountind"><div class="error-help">Enter the Valid Discount</div></td><td><select name=\"discounttype'+count+'\" id=\"discounttype'+count+'\" class="form-control discounttypeind"><option value="">--Select---</option><option value="%">%</option><option value="FLAT">FLAT</option></select><div class="error-help">Enter the Valid Discount</div></td><td><div><select  name=\"tax'+count+'\" id=\"tax'+count+'\" class="form-control taxind"></select></div></td>	<td class="text-center"><input value=1 name=\"includetax'+count+'\" id=\"includetax'+count+'\" class="includetaxind" type="checkbox"></td><td class="text-right"><input type=text name=\"total'+count+'\" id=\"total'+count+'\" class="totalind form-control" readonly value="0.00"></td></tr>')                                        
$('.error-help').hide();
    $('#product'+count).select2({
            ajax: { 
            url: "../leads-quotes/productdetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                // console.log(response);
                return {
                    results: $.map(response, function (i,item) {
                        // console.log(i,item);
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
                    
               
            },
            cache: true
            }
            })
    $('#discounttype'+count+'').select2();
    $('#tax'+count+'').select2();
      $.get('../purchase-bill/finddetails',function(data)
         {
           $.each(JSON.parse(data), function(i, item) {
             $('#tax'+count+'').append($('<option value=\"'+i+'\">'+item+'</option>'));
        });
      });
})
$(document).on('change', ".productind", function() {
    jQuery.ajaxSetup({async:false});   
if(!$('#debitnote-point_of_supply').val()){
$('.productind').val('').trigger('change.select2');
alert("Please Select Party Name")
return false;
}
var sample=$(this); 
$.post( 'get-description',{data: $(this).val()}, function( data ) {
sample.parent().siblings().children('.descriptionind').val(JSON.parse(data).des);

// if(data.units!='')
//                 {
//                     $this.parent().parent().siblings().children().children('.unitind').val(data.units).trigger('change');
//                 }
//                 else
//                 {
//                     $this.parent().parent().siblings().children().children('.unitind').val('Nos').trigger('change');
//                 }


sample.parent().siblings().children('.unitind').val(JSON.parse(data).unit);
sample.parent().siblings().children('.priceind').val(JSON.parse(data).price);
sample.parent().siblings().children('.quantityind').val(1);
var tax_details = JSON.parse(data).tax;
sample.parent().siblings().children().children('.taxind').find('option').removeAttr("selected");
// tax_details.split(',').forEach(function(item) {
  // sample.parent().siblings().children().children('.taxind').find("option[value='"+item+"']").attr("selected",true);
  sample.parent().siblings().children().children('.taxind').find("option[value='38']").attr("selected",true).trigger('change');
  sample.parent().siblings().children().children('.taxind').trigger('change.select2');
// });
sample.parent().siblings().children('.totalind').val(JSON.parse(data).price);
if(sample.val())
sample.parent().siblings().children('.quantityind').attr('required',true);
else
sample.parent().siblings().children('.quantityind').attr('required',false);
// sample.parent().siblings().children('.includetaxind').prop('checked', false)
sample.parent().siblings().children('.includetaxind').val('1')
sample.parent().siblings().children('.discountind').val('0.00');
sample.parent().siblings().children('.discounttypeind').find("option[value='%']").attr("selected",true).trigger('change');
var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
  //   alert(totalamt);
        $(".priceind").each(function(){
          var pct=$(this).parent().siblings().children('.discounttypeind').val();
            if($(this).val())
            {
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                     
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                       subtotalamt+=s_amt;
                  }
            }
        })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
        $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        $('.totalamount').text(totalamt.toFixed(2))

        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        var totaldiscount=0;
        total();

})
if($(this).val()){
          var tax=$(this).parent().siblings().children().children('.taxind').val();
          if(tax){
            $(this).parent().siblings().children('.includetaxind').prop('checked', true);;   
          taxIncluded($(this).parent().siblings().children('.includetaxind'));
          }
      }
})
$(document).on('click', ".removeind", function() {
    $(this).parent().parent().remove();
    $("#dj-table-body").find('.productind').each(function(index){
              $(this).attr('id','product'+(index+1));
              $(this).attr('name','product'+(index+1));
          })
          $("#dj-table-body").find('.descriptionind').each(function(index){
              $(this).attr('id','desc'+(index+1));
              $(this).attr('name','desc'+(index+1));
          })
          $("#dj-table-body").find('.quantityind').each(function(index){
              $(this).attr('id','quantity'+(index+1));
              $(this).attr('name','quantity'+(index+1));
          })
          $("#dj-table-body").find('.unitind').each(function(index){
              $(this).attr('id','unit'+(index+1));
              $(this).attr('name','unit'+(index+1));
          })
          var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
        
        
        $(".priceind").each(function(){
          var pct=$(this).parent().siblings().children('.discounttypeind').val();
            if($(this).val())
            {
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                     
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                  }
            }
        })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
        // $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        $('.totalamount').text(totalamt.toFixed(2)).val(totalamt.toFixed(2))
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        var totaldiscount=0;
       total();
        // var totaltax=(totaldiscount+totalamt)-subtotalamt;
        // $('.tcs').val((totalamt*0.01).toFixed(2)).text((totalamt*0.01).toFixed(2))
        // if($('#debitnote-point_of_supply').val()==21){
        //     $('.sgst').val((totaltax/2).toFixed(2)).text((totaltax/2).toFixed(2)) 
        //     $('.cgst').val((totaltax/2).toFixed(2)).text((totaltax/2).toFixed(2)) 
        // }else{
        //     $('.igst').val((totaltax).toFixed(2)).text((totaltax).toFixed(2))  
        // }
})

$('#imagecount').val($(".attachment").find('input[type=file]').length);
      $('#attachment').click(function(){
          var count=$(".attachment").find('input[type=file]').length+1;
          $('button.dj-danger-btn.file'+$(".attachment").find('input[type=file]').length).after('<input class="form-control file'+count+'" type="file" id="file'+count+'" name="file'+count+'"><button style="margin-left:50px"type="button" data="file'+count+'" class="dj-danger-btn remove file'+count+'"><i class="fa fa-plus-circle" aria-hidden="true"></i> Remove</button>')
          $(".attachment").find('input[type=file]').each(function(index){
              $(this).attr('id','file'+(index+1));
              $(this).attr('name','file'+(index+1));
          })
          $(".addnew").find('.remove').each(function(index){
              $(this).attr('data','file'+(index+1));
              $(this).attr('class','dj-danger-btn remove file'+(index+1));
          })
        $('#imagecount').val(count);
      })
    $(document).on('click',".remove", function(){
        if($(this).attr('data')!='file1')
        $('.'+$(this).attr('data')).remove();
        $(".attachment").find('input[type=file]').each(function(index){
              $(this).attr('id','file'+(index+1));
              $(this).attr('name','file'+(index+1));
          })
          $(".addnew").find('.remove').each(function(index){
              $(this).attr('data','file'+(index+1));
              $(this).attr('class','dj-danger-btn remove file'+(index+1));
          })
    })
    $(document).on('change',".discountind", function(){
        if($(this).val())
        $(this).parent().siblings().children('.discounttypeind').attr('required',true);
        else
        $(this).parent().siblings().children('.discounttypeind').attr('required',false);
        var val=parseFloat($(this).parent().siblings().children('.priceind').val());
        
        
        var discountind=isNaN(parseFloat($(this).val()))?0:parseFloat($(this).val());
        var qtyind=parseInt($(this).parent().siblings().children('.quantityind').val());
        qtyind=isNaN(qtyind)?0:qtyind;
        val=val*qtyind;
       
        var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
        $(".priceind").each(function(){
          var productamt =0;
          var tax=parseFloat($(this).parent().siblings().children().children('.taxind').val());
        tax=isNaN(tax)?0:tax;
        var includetax=$(this).parent().siblings().children('.includetaxind').is(":checked");
            if($(this).val())
            {
                var pct=$(this).parent().siblings().children('.discounttypeind').val();
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    productamt = s_amt-(s_amt*(dis_amount/100))
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                    productamt =  s_amt-dis_amount;
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                      productamt = s_amt;
                  }
                  if(includetax){
                      var taxg=0;
                      var tot_tax = 0;
                         jQuery.ajaxSetup({async:false});
                         // tax.forEach(function(item) {
                           var item= tax;
                              $.get('../leads-quotes/taxdetails',{item:item},function(data)
                              {  
                                   var data =$.parseJSON(data);
                                   tot_tax= tot_tax +parseFloat(data.tax_rate);
                              }) 
                      taxg=productamt+(productamt*(tot_tax/100));
                      $(this).parent().siblings().children('.totalind').val(taxg);
                  }
                  else{
                    $(this).parent().siblings().children('.totalind').val(productamt);

                  }     
                          }

        })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
        // $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        $('.totalamount').text(totalamt.toFixed(2)).val(totalamt.toFixed(2))
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        var totaldiscount=0;
        total();
       
    })
    $(document).on('change',".discounttypeind", function(){
        var val=parseFloat($(this).parent().siblings().children('.priceind').val());
        
        var discountind=parseFloat($(this).parent().siblings().children('.discountind').val());
        discountind=isNaN(discountind)?0:discountind;
        var qtyind=parseInt($(this).parent().siblings().children('.quantityind').val());
        qtyind=isNaN(qtyind)?0:qtyind;
        // if(discountind){
        // val=val*qtyind;
        // if(pct=="%"){val=val-(val*(discountind/100));}
        // else if(pct=="FLAT"){val=val-discountind;}
        // if(includetax){val=val+(val*(tax/100));}
        // $(this).parent().siblings().children('.totalind').val(val)
        // }
        var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
        $(".priceind").each(function(){
            var pct=$(this).parent().siblings().children('.discounttypeind').val();
            var tax=$(this).parent().siblings().children().children('.taxind').val();
        tax=isNaN(tax)?0:tax;
        var includetax=$(this).parent().siblings().children('.includetaxind').is(":checked");
          var productamt =0;
            if($(this).val())
            {
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    productamt = s_amt-(s_amt*(dis_amount/100))
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                    productamt =  s_amt-dis_amount;
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                      productamt = s_amt;
                  }
                  if(includetax){
                      var taxg=0;
                      var tot_tax = 0;
                         jQuery.ajaxSetup({async:false});
                         // tax.forEach(function(item) {
                           var item= tax;
                              $.get('../leads-quotes/taxdetails',{item:item},function(data)
                              {  
                                   var data =$.parseJSON(data);
                                   tot_tax= tot_tax +parseFloat(data.tax_rate);
                              }) 
                      taxg=productamt+(productamt*(tot_tax/100));
                      $(this).parent().siblings().children('.totalind').val(taxg);
                  }
                  else{
                    $(this).parent().siblings().children('.totalind').val(productamt);

                  } 
                   }

        })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
        // $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        $('.totalamount').text(totalamt.toFixed(2)).val(totalamt.toFixed(2))
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        total();
    })
        $(document).on('change',".priceind", function(){
        var val=$(this).val();
        
        
        var discountind=isNaN(parseFloat($(this).val()))?0:parseFloat($(this).val());
        var qtyind=parseInt($(this).parent().siblings().children('.quantityind').val());
        qtyind=isNaN(qtyind)?0:qtyind;
        // val=val*qtyind;
        // if(pct=="%"){val=val-(val*(discountind/100));}
        // else if(pct=="FLAT"){val=val-discountind;}
        // if(includetax){val=val+(val*(tax/100));}
        // $(this).parent().siblings().children('.totalind').val(val)
        var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
        $(".priceind").each(function(){
            var pct=$(this).parent().siblings().children('.discounttypeind').val();
            var tax=parseFloat($(this).parent().siblings().children().children('.taxind').val());
        tax=isNaN(tax)?0:tax;
        var includetax=$(this).parent().siblings().children('.includetaxind').is(":checked");
          var productamt =0;
            if($(this).val())
            {
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    productamt = s_amt-(s_amt*(dis_amount/100))
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                    productamt =  s_amt-dis_amount;
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                      productamt = s_amt;
                  }
                  if(includetax){
                      var taxg=0;
                      var tot_tax = 0;
                         jQuery.ajaxSetup({async:false});
                         // tax.forEach(function(item) {
                           var item= tax;
                              $.get('../leads-quotes/taxdetails',{item:item},function(data)
                              {  
                                   var data =$.parseJSON(data);
                                   tot_tax= tot_tax +parseFloat(data.tax_rate);
                              }) 
                      taxg=productamt+(productamt*(tot_tax/100));
                      $(this).parent().siblings().children('.totalind').val(taxg);
                  }
                  else{
                    $(this).parent().siblings().children('.totalind').val(productamt);

                  } 
                 }

        })
         
        $('#subtotalamount').val(subtotalamt.toFixed(2))
        // $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        $('.totalamount').text(totalamt.toFixed(2)).val(totalamt.toFixed(2))
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        total();
    })
    $(document).on('change',".quantityind", function(){
        var val=parseFloat($(this).val()*$(this).parent().siblings().children('.priceind').val())
        
        
        var discountind=parseFloat($(this).parent().siblings().children('.discountind').val());
        discountind=isNaN(discountind)?0:discountind;
        // if(pct=="%"){val=val-(val*(discountind/100));}
        // else if(pct=="FLAT"){val=val-discountind;}
        // if(includetax){val=val+(val*(tax/100));}
        $(this).parent().siblings().children('.totalind').val(val)
        var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
         $(".priceind").each(function(){
          var productamt =0;
          var tax=parseFloat($(this).parent().siblings().children().children('.taxind').val());
        tax=isNaN(tax)?0:tax;
        var includetax=$(this).parent().siblings().children('.includetaxind').is(":checked");
          var pct=$(this).parent().siblings().children('.discounttypeind').val();
            if($(this).val())
            {
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    productamt = s_amt-(s_amt*(dis_amount/100))
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                    productamt =  s_amt-dis_amount;
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                      productamt = s_amt;
                  }
                  if(includetax){
                      var taxg=0;
                      var tot_tax = 0;
                         jQuery.ajaxSetup({async:false});
                         // tax.forEach(function(item) {
                           var item= tax;
                              $.get('../leads-quotes/taxdetails',{item:item},function(data)
                              {  
                                   var data =$.parseJSON(data);
                                   tot_tax= tot_tax +parseFloat(data.tax_rate);
                              }) 
                      taxg=productamt+(productamt*(tot_tax/100));
                      $(this).parent().siblings().children('.totalind').val(taxg);
                  }
                  else{
                    $(this).parent().siblings().children('.totalind').val(productamt);

                  }          
                    }

        })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
        // $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        $('.totalamount').text(totalamt.toFixed(2)).val(totalamt.toFixed(2))
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        var totaldiscount=0;
        total();
    })
    $(document).on('change',".includetaxind", function(){  
        taxIncluded($(this))
    })
    function taxIncluded(valueind){
        var quantity=valueind.parent().siblings().children('.quantityind').val();
        var val=parseFloat(valueind.val()*valueind.parent().siblings().children('.priceind').val());
        var discountind=parseFloat(valueind.parent().siblings().children('.discountind').val());
        discountind=isNaN(discountind)?0:discountind;
        // if(pct=="%"){val=val-(val*(discountind/100));}
        // else if(pct=="FLAT"){val=val-discountind;}
        // if(includetax){val=val+(val*(tax/100));}
        // $(this).parent().siblings().children('.totalind').val(val)
        var totalamt=0;
        var subtotalamt=0;
        // $(".totalind").each(function(){
        //     if($(this).val())
        //     totalamt+=parseFloat($(this).val());
        // })
          $(".priceind").each(function(){
            var includetax=$(this).parent().siblings().children('.includetaxind').is(":checked");
            var tax=parseFloat($(this).parent().siblings().children().children('.taxind').val());
            tax=isNaN(tax)?0:tax;
            var pct=$(this).parent().siblings().children('.discounttypeind').val();
            var productamt =0;
            if($(this).val())
            {
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    productamt = s_amt-(s_amt*(dis_amount/100))
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                    productamt =  s_amt-dis_amount;
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                      productamt = s_amt;
                  }
                  if(includetax){
                      var taxg=0;
                      var tot_tax = 0;
                         jQuery.ajaxSetup({async:false});
                         // tax.forEach(function(item) {
                           var item= tax;
                              $.get('../leads-quotes/taxdetails',{item:item},function(data)
                              { 
                                   var data =$.parseJSON(data);
                                   tot_tax= tot_tax +parseFloat(data.tax_rate);
                              }) 
                      taxg=productamt+(productamt*(tot_tax/100));
                      $(this).parent().siblings().children('.totalind').val(taxg);
                  }else{
                    $(this).parent().siblings().children('.totalind').val(productamt);

                  }            
                   }

        })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
         // $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        // $('.totalamount').text(totalamt.toFixed(2)).val(totalamt.toFixed(2))
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        var totaldiscount=0;
        total();
            }
    $(document).on('change',".taxind", function(){  
        var quantity=$(this).parent().siblings().children('.quantityind').val();
        var val=parseFloat($(this).val()*$(this).parent().siblings().children('.priceind').val());
        // alert(includetax);
        var discountind=parseFloat($(this).parent().siblings().children('.discountind').val());
        discountind=isNaN(discountind)?0:discountind;
        // if(pct=="%"){val=val-(val*(discountind/100));}
        // else if(pct=="FLAT"){val=val-discountind;}
        // if(includetax){val=val+(val*(tax/100));}
        // $(this).parent().siblings().children('.totalind').val(val)
        var totalamt=0;
        var subtotalamt=0;
        // $(".totalind").each(function(){
        //     if($(this).val())
        //     totalamt+=parseFloat($(this).val());
        // })
          $(".priceind").each(function(){
            var pct=$(this).parent().siblings().children('.discounttypeind').val();
            var tax=parseFloat($(this).parent().siblings().children().children('.taxind').val());
            tax=isNaN(tax)?0:tax;
            var includetax=$(this).parent().siblings().children('.includetaxind').is(":checked");
            // alert(includetax);
          var productamt =0;
            if($(this).val())
            {
                 if(pct=='%')
                  {
                    var dis_amount =(isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()));

                   var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));

                    subtotalamt+=s_amt-(s_amt*(dis_amount/100));
                    productamt = s_amt-(s_amt*(dis_amount/100))
                  }
                  else if(pct=='FLAT')
                  {
                    var dis_amount =((isNaN(parseFloat($(this).parent().siblings().children('.discountind').val()))?0:parseFloat($(this).parent().siblings().children('.discountind').val()))*(isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val())));
                    var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                    subtotalamt+=s_amt-dis_amount;
                    productamt =  s_amt-dis_amount;
                  }
                  else
                  {
                       var s_amt = (isNaN(parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()))?0:parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val()));
                      subtotalamt+=s_amt;
                      productamt = s_amt;
                  }
                  if(includetax){
                      var taxg=0;
                      var tot_tax = 0;
                         jQuery.ajaxSetup({async:false});
                         // tax.forEach(function(item) {
                           var item= tax;
                              $.get('../leads-quotes/taxdetails',{item:item},function(data)
                              { 
                                   var data =$.parseJSON(data);
                                   tot_tax= tot_tax +parseFloat(data.tax_rate);
                              }) 
                      taxg=productamt+(productamt*(tot_tax/100));
                      $(this).parent().siblings().children('.totalind').val(taxg);
                  }
                  else{
                    $(this).parent().siblings().children('.totalind').val(productamt);

                  }            
                   }

        })
        $('#subtotalamount').val(subtotalamt.toFixed(2))
         // $('#totalamount').val(totalamt.toFixed(2))
        $('.subtotalamount').text(subtotalamt.toFixed(2))
        // $('.totalamount').text(totalamt.toFixed(2)).val(totalamt.toFixed(2))
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        var totaldiscount=0;
        total();
            })

  $(document).on("click",".saveon",function(e)
    {  e.preventDefault();
        var value=false;

       
    //   $(".discountind").each(function()
    //     { 
    //         if($(this).val()!="" && $(this).val()>=0)
    //         {  
    //             var discounttype = $(this).parent().siblings().children('.discounttypeind').val();
    //             if(discounttype == null || discounttype == '' || discounttype == '--Select--')
    //             { 
    //                 value=true;
    //                 $(this).parent().siblings().children('.error-help').show();
    //                 $(this).focus();
    //             }
    //             else      
    //             {
    //                 $(this).parent().siblings().children('.error-help').hide();
    //                 $(this).parent().siblings().children('.error-help').hide();
    //             }
    //         }
    //         else
    //         {  
    //             if($(this).val()!=0 && $(this).val()!="" && $(this).val()<0)
    //             { 
    //                 value=true;
    //                 $(this).siblings('.error-help').show();
    //                 // $(this).parent().siblings('.error-help').show();
    //             }
    //             else
    //             {
    //                 $(this).parent().siblings('.error-help').hide();
    //             }
 
        //         $(this).parent().parent().siblings().children('.error-help').hide();
        //         $(this).parent().parent().siblings().children().children('.error-help').hide();
        //     }
        // });
        $(".discounttypeind").each(function()
        {
            if($(this).val()=='FLAT' || $(this).val()=='%')
            {

                var discount = $(this).parent().siblings().children('.discountind').val();
                if(discount=='')
                { 
                    value=true;
                     $(this).parent().siblings().children('.error-help').show();
                     $(this).parent().siblings().children('.discountind').focus();
                }
                else
                {
                     $(this).parent().siblings().children('.error-help').hide();
                }
            }
        });
        
    $('#debitnote-setting_type').each(function(){
       var setting= $(this).val();
       //alert(setting);
       $.get('fielddebitnotesettingtype',{setting:setting},function(data)
         {
            var data =$.parseJSON(data);
            //alert(data);
                if(data=='0')
                {
                    //alert('ho');
                    $('#debitnote-setting_type').parent().siblings('.error-help').show();
                    $('#debitnote-setting_type').focus();
                   
                    value=true;
                  
                }
                else{ 
                //alert('hide');                   
                $('#debitnote-setting_type').parent().siblings('.error-help').hide();    
                value=false;

                }

         })

   });


        if(value==false)
        {
           // alert(value);
           $(this).attr("disabled", "disabled");
           setTimeout(function() {
           $('.saveon').removeAttr("disabled"); 
           }, 7000);
           $(".saveon").submit();
        }
    })

   



function total()
{ 
  var t_amount = $('#totalamount').val();
  var tax_amount=0;
  var igst=0 ;
  $('.includetaxind').each(function()
  {  

    var includetax=$(this).is(":checked");
    // alert(includetax);
    if(includetax)
        { 

        var val=parseFloat($(this).parent().siblings().children('.priceind').val())
        var pct=$(this).parent().siblings().children('.discounttypeind').val();
        
        var discountind=parseFloat($(this).parent().siblings().children('.discountind').val());
        discountind=isNaN(discountind)?0:discountind;
        var qtyind=parseInt($(this).parent().siblings().children('.quantityind').val());
        var product_amt = $(this).parent().siblings().children('.totalind').val();
        // tax_amount=product_amt-(val*qtyind)
        qtyind=isNaN(qtyind)?0:qtyind;
        
        val=val*qtyind;
        if(pct=='%'){
        val=val-(val*(discountind/100));
        tax_amount=product_amt-val;
        }
        else if(pct=='FLAT'){
            val=val-discountind*qtyind;
            tax_amount=product_amt-val;
        }
        // alert(tax_amount);
          var tax = $(this).parent().siblings().children().children('.taxind').val();
          // var igst = 0;
          var sub_igst =0;
          var tot_tax = 0;
          jQuery.ajaxSetup({async:false});
          // tax.forEach(function(item) {
            var item= tax;
               $.get('../leads-quotes/taxdetails',{item:item},function(data)
               {
                    var data =$.parseJSON(data);
                    tot_tax= tot_tax +parseFloat(data.tax_rate);
               }) 
            // });

        //   sub_igst = parseFloat(tax_amount+((product_amt*tot_tax)/100));
          igst += parseFloat(tax_amount);
        }
       
        var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){ 
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
        // 
        var final_amount = parseFloat(totalamt);
       
        // $('.tcs').val((final_amount*0.01).toFixed(2)).text((final_amount*0.01).toFixed(2));
        var total_final_amount = final_amount + parseFloat($('.tcs').val());
        $('.totalamount').text(total_final_amount.toFixed(2));
        $('#totalamount').val(total_final_amount.toFixed(2));
        t_amount=$('#totalamount').val();
        if($('.tcs_tax').is(":checked"))
        { 
            // if(parseFloat($('#debitnote-tcs').val())>0)
            // tcs_amt=parseFloat($('#debitnote-tcs').val())
            // else
        var tcs_rate=<?=$tcs_rate?>;
        tcs_amt = parseFloat(parseFloat(tcs_rate)*parseFloat(final_amount)/100);
            t_amount = parseFloat(totalamt)+ tcs_amt;
        $('.totalamount').text(t_amount.toFixed(2));
        $('#totalamount').val(t_amount.toFixed(2));

        }
        else
        { 
        $('#debitnote-tcs').val(0)
        if(parseFloat($('#debitnote-tcs').val())>0)
        tcs_amt=parseFloat($('#debitnote-tcs').val())
        else
        tcs_amt = 0;
       
        $('.totalamount').text(totalamt.toFixed(2));
        $('#totalamount').val(totalamt.toFixed(2));
    }
    // $('.tcsamt').text((tcs_amt).toFixed(2));
    $('.tcs').val((tcs_amt).toFixed(2));

        if($('.point_of_supply').val()==21){
           
            $('.sgst').val((igst/2).toFixed(2)).text((igst/2).toFixed(2));
            $('.cgst').val((igst/2).toFixed(2)).text((igst/2).toFixed(2));
        }else{
            
            $('.igst').val((igst).toFixed(2)).text((igst).toFixed(2));
        }
       }  )  

}
$('#debitnote-is_tcs').change(function(){
    total();
  })
  $('#debitnote-tcs').change(function(){
    $('#round').prop('checked',false)
    $('#roundoffval').val('');
    var tcs_amt=parseFloat($('#debitnote-tcs').val());
    var totalamt=$('#totalamount').val();
    if($('.tcs_tax').is(":checked")){
        t_amount = parseFloat(totalamt)+ tcs_amt;
        $('.totalamount').text(t_amount.toFixed(2));
        $('#totalamount').val(t_amount.toFixed(2));
    }
  })
    $('#round').change(function(){
        if($(this).is(":checked")){
           
           var roundval=Math.round($('#totalamount').val()) - $('#totalamount').val();
           // if(roundval < 0){
           // roundval=-1*roundval;
           // }
           $('.totalamount').text(Math.round($('#totalamount').val()));
           $('#roundoffval').val(roundval.toFixed(2));
           $('.totalamount').val(roundval.toFixed(2));
            $('#totalamount').val(Math.round($('#totalamount').val()));
        }
        else{
        total();
        $('#round').prop('checked',false)
        $('#roundoffval').val('')
        }
    })
    if($('#roundoffval').val()!='')
    {
        
        $('#round').prop('checked',true)
    }
    
    if($('#round').is(":checked")){
           var roundval= Math.round($('#totalamount').val()) - $('#totalamount').val();
           
           $('.totalamount').text(Math.round($('#totalamount').val()));
           $('#roundoffval').val(roundval.toFixed(2));
           $('.totalamount').val(roundval.toFixed(2));
           $('#totalamount').val(Math.round($('#totalamount').val()));
    }
    $('.create-new').click(function(){
        $('form').append('<input type="hidden" name="createnew" value="createnew">') 
    })
    $('form').submit(function(e){
        $('.submit-btn').prop('disabled','true');
        setTimeout(function(){
        if(!$('.has-error').length){
        $('.submit-btn').prop('disabled','true');
        $('.submit-btn').text('Please Wait..');
        }else{
        $('.submit-btn').removeAttr("disabled");
        }
        // console.log($('.has-error').length)
    }, 200);
        $('.unitind').removeAttr("disabled");
         $('form').append('<input type="hidden" name="productcount" value=\"'+$('#dj-table-body tr').length+'\">') 
    })
    $('.multiselect-dropdow').select2();
    
     $('.productind').select2({
            ajax: { 
            url: "../leads-quotes/productdetails",
            type: "get",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                searchTerm: params.term // search term
                };
            },
            processResults: function (response) {
                // console.log(response);
                return {
                    results: $.map(response, function (i,item) {
                        // console.log(i,item);
                    return {
                        text: i,
                        slug: "",
                        id: item
                    }
                })
            };
                    
               
            },
            cache: true
            }
            })
$(document).on('change', "#debitnote-party_id", function() {
if(!$('#debitnote-party_type').val()){
alert('Select Party Type')
return false;
}else{
$.post( 'get-'+$('#debitnote-party_type').val()+'-gst',{data: $(this).val()}, function( data ) {
$('#debitnote-sender_gst').val(data);
$('#debitnote-point_of_supply').val($('#debitnote-sender_gst').val().substring(0, 2));
if($('#debitnote-point_of_supply').val()==21){
    $('.cgst-row').show();$('.sgst-row').show();$('.igst-row').hide();
    $('.igst').val('');
}else{
    $('.cgst-row').hide();$('.sgst-row').hide();$('.igst-row').show();
    $('.cgst').val(''); $('.sgst').val('');
}
var totalamt=0;
        var subtotalamt=0;
        $(".totalind").each(function(){
            if($(this).val())
            totalamt+=parseFloat($(this).val());
        })
        // $(".priceind").each(function(){
        //     if($(this).val())
        //     subtotalamt+=parseFloat($(this).parent().siblings().children('.quantityind').val()*$(this).val());
        // })
        var totaldiscount=0;
        total();
         // $('.igst').val((totaltax).toFixed(2)).text((totaltax).toFixed(2))  
})
}
})
if(<?=$update?>){
    if($('#debitnote-point_of_supply').val()==21){
    $('.cgst-row').show();$('.sgst-row').show();$('.igst-row').hide();
    $('.igst').val('');
}else{
    $('.cgst-row').hide();$('.sgst-row').hide();$('.igst-row').show();
    $('.cgst').val(''); $('.sgst').val('');
    }
}

$("#debitnote-date").on("change",function(){
        var selected_date = $(this).val();
        var sel_date = new Date($(this).val());
        $.get('selectdate',{selected_date:selected_date},function(data)
        {  

                var d = new Date();
                var output = d.getFullYear() + '-' +'03'+ '-' +'31';

                if(new Date(selected_date) <= new Date(output))
                {
                    var dt = sel_date.getFullYear().toString().substr(-2);
                    var prv_dt = sel_date.getFullYear()-1;
                    var prefix_date = prv_dt+'-'+dt;
                }
                else
                {
                    var dt = sel_date.getFullYear();
                    var new_dt = (sel_date.getFullYear()+1).toString().substr(-2);
                    var prefix_date = dt+'-'+new_dt;
                }
                


                var data =$.parseJSON(data);
                $('#debitnote-po').val(data).trigger('change');
                $('#debitnote-suffix').val(prefix_date).trigger('change');
                $('#debit_label').empty();
                $('#debit_label').append("DO# Last# "+(data-1));

        })
    });


});
        </script>
        <?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>