<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\LeadExecutive;
use backend\modules\master\models\Customer;
use backend\modules\master\models\Vendor;
use backend\modules\users\models\SaleOrder;
use backend\modules\master\models\Product;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\LeadsQuotesSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Inventory Pendings';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>

<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Pendings</div>
                                                            </div>
															<div class="widget-content-right">
                                                                <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                                                                <a  class="search_field_buttons"  href="<?=Url::base().'/users/inventory-pending/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card collapse" id="search-inventory-pending">
                           <div class="card-body">
									<form class="dj-sale-form " >
                                        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                        <div class="form-row">
										
										<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                  <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                   <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Type</label>
                                                    
                                                    <?= $form->field($model, 'type_inventory')->dropDownList(['To Be Shipped'=>'To Be Shipped','To be Received'=>'To be Received'],['prompt'=>'--Select--','class'=>'select_class form-control'])->label(false) ?>
                                                </div>
												
                                            </div>
                                            <!-- <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Vendor</label>
                                                     <select class="multiselect-dropdown form-control">
														<option value="1">-Select a Vendor-</option>
                                                    </select>
                                                </div>
												
                                            </div> -->
											 
											<div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Customer</label>

                                                    <?php if($model->customer!=''){?>

                                                    <?php $customer=Customer::find()->where(['business_name'=>$model->customer])->one()?>
                                                   <?=$form->field($model, 'customer')->dropDownList([$model->customer=>$customer->business_name], ['options' => [$model->customer => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "customer form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?= $form->field($model, 'customer') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control customer",])->label(false)?>            
                                                   <?php } ?>
                                                     <!-- <select class="multiselect-dropdown form-control">
														<option value="1">-Select a Customer-</option>
                                                    </select> -->
                                                </div>
												
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Vendor</label>



                                                    <?php if($purchasemodel->vendor!=''){?>

                                                    <?php $customer=Vendor::find()->where(['business_name'=>$purchasemodel->vendor])->one()?>
                                                    <?=$form->field($purchasemodel, 'vendor')->dropDownList([$purchasemodel->vendor=>$customer->business_name], ['options' => [$purchasemodel->vendor => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "findvendor form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?=$form->field($purchasemodel, 'vendor')->dropDownList([], ['prompt' => '--Select--', 'class' => "findvendor form-control", 'maxlength' => true])->label(false)?>           
                                                   <?php } ?>


                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Ref #</label>
                                                   <?= $form->field($model, 'ref')->textInput(['maxlength' => true,'type'=>'text','class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											
											<div class="col-md-12 dj-btn-align">
											<?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
											</div>
                                        </div>
                                        <?php ActiveForm::end(); ?> 
                                      </form>  
                                    
                                </div>
                        </div>
						  <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						
							<div class="col-md-12">
						<div class="djsec-text-right dj-print-sec">
                                             <!-- <a href="" data-method="post"> <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i> Details Excel</button></a> -->
                                             <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/inventory-pending/inventory-pdf'])->one()!=''){?>


                                                <?php if(Yii::$app->request->getQueryParams()){?>
                                                        <a href="<?=Url::current()?>&print=true" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i> Print</button></a>
                                                <?php } else{ ?>
                                                    <a href="<?=Url::current()?>?print=true" data-method="post" target="_blank">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print" aria-hidden="true"></i> Print</button></a>
                                                <?php } ?>



                                             <!--  <a href="<?=Url::base();?>/users/inventory-pending/inventory-pdf" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i> Print</button></a> -->
                                               <?php }else {?>

                                               <?php } ?> 
										    
											<!-- <a href="" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a> -->
											
											
                                     </div>
							 </div>
							 </div>
                            
                                    <?= GridView::widget([
        'dataProvider' => $data,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
            [
                'label'=>'Customer/Vendor',
                'contentOptions'=>['style'=>'font-weight:bold'],
               'attribute' => 'name',
               'value' => function ($data) {

                return $data->name;
                
                // if($data->type =='saleorder')
                // {
                //     return $data->name;
                // }
                // else if($data->type=='purchaseorder')
                // {
                //     return $data->name;
                // }
                // else if($data->type=='debit_note' || $data->type=='credit_note')
                // {
                //     if($data->user_type=='vendor')
                //     {
                //         $name = Vendor::find()->where(['id'=>$data->name])->one();
                //         return $name->business_name;
                //     }
                //     else if ($data->user_type=='customer') {
                //         $name = Customer::find()->where(['id'=>$data->name])->one();
                //         return $name->business_name;
                //     }
                    
                // }
                
               }
               
            ],
            [
                'label'=>'Executive/Service Engineer',
               'attribute' => 'executive_name',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    if($data->executive_name!='')
                    {
                        $user= LeadExecutive::find()->where(['id' =>$data->executive_name])->one();
                        if($user)
                        return $user->name;
                    }
                }
               }
            ],
            [
                'label'=>'Date',
               'attribute' => 'latest_date',
                'value' => function ($data) {    
                    return date('F j Y', strtotime($data->date));
               }
            ],
            [
                'label'=>'Product Category',
               'attribute' => 'name',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    return 'SaleOrder';
                }
                else if($data->type=='purchaseorder')
                {
                    return 'Purchase';
                }
                else if($data->type=='debit_note')
                {
                    return 'DebitNote';
                }
                else
                    return "CreditNote";
               }
            ],
            [
                'label'=>'Order Type',
               'attribute' => 'name',
               'value' => function ($data) {
                return 'Full';
               }
            ],
            [
                'label'=>'Type',
               'attribute' => 'name',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    return 'To Be Shipped';
                }
                else if($data->type=='purchaseorder')
                {
                    return 'To Be Received';
                }
                
               }
            ],
            [
                'label'=>'Ref #',
               'attribute' => 'name',
               'format'=>'raw',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    
                     return ''.$data->order_id."</br>".'PO #:'.$data->po."</br>".'Date:'.$data->po_date."</br>".'Exp Date:'.$data->last_date;
                }
                else if($data->type=='purchaseorder')
                {
                    return $data->order_id;
                }
                else if($data->type=='debit_note')
                {
                    return $data->order_id;
                }
                else
                    return $data->order_id;
                 
               }
            ],
            [
                'label'=>'Stock',
               'attribute' => 'type',
               'format'=>'raw',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    // return $data['status'];
                             if($data->status=='Available')
                                {
                                 return '<span class="label-avl"><font color="#0D7077" size = "2" >Available</font></span>';
                             }
                             //    else if($total<$data->total && $total!=0)
                                else if($data->status=='Not Avilable')
                                {   
                                 return '<span class="label-not-avl"><font color="#A71F3A" size = "2" >Not Avilable</font></span>';
                             }
                             //    else if($total==0)
                                else if($data->status=='Partially Avail.')
                                {
                                 return '<span class="label-partial-avl"><font color="#B78617" size = "2" >Partially Avail.</font></span>';
                             }
                }
                if($data->type=='purchaseorder')
                {
                    return "-";
                }
                else
                {
                  return "-";
                }
               
                
               }
            ],
            
            [
                'label'=>'Notes',
               'attribute' => 'note',
               'value' => function ($data) {
                return $data->note;
               }
            ],
            [
                'label' => 'Action',
                // 'attribute' => 'username',
                'format'=>'raw',
                'value' => function ($data) use ($assign) {

                    $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>'; 
                    if($data->type=="saleorder")
                    {

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/inventory-pending/view'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/users/inventory-pending/view?id='.$data->id.' data-method=post>
                                           <i class="fa fa-eye"></i>
                                            <span class="dj-icon-gap">View</span>
                                        </a>
                                    </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/product-delivered/create'])->one()!='')
                        {
                            $dcstring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/users/product-delivered/create?id='.$data->id.'&from=inventory data-method=post>
                                            <i class="fa fa-pencil-square"></i>
                                            <span class="dj-icon-gap"> Convert To DC</span>
                                        </a>
                                    </li>';
                        }
                        else
                        {
                            $dcstring = '';
                        }

                        return $topstring.''.$viewstring.''.$dcstring.''.$downstring;
                       
                    }
                    if($data['type']=='purchaseorder')
                    {


                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/inventory-pending/view-purchase'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/users/inventory-pending/view-purchase?id='.$data->id.' data-method=post>
                                           <i class="fa fa-eye"></i>
                                            <span class="dj-icon-gap">View</span>
                                        </a>
                                    </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/product-delivered/create'])->one()!='')
                        {
                            $grstring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/users/product-received/create?id='.$data->id.'&from=inventory data-method=post>
                                            <i class="fa fa-pencil-square"></i>
                                            <span class="dj-icon-gap"> Convert To GR</span>
                                        </a>
                                    </li>';
                        }
                        else
                        {
                            $grstring = '';
                        }

                        return $topstring.''.$viewstring.''.$grstring.''.$downstring;
                        
                    }
                    if($data['type']=='debit_note')
                    {
                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/inventory-pending/view-debit'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/users/inventory-pending/view-debit?id='.$data->id.' data-method=post>
                                           <i class="fa fa-eye"></i>
                                            <span class="dj-icon-gap">View</span>
                                        </a>
                                    </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        }

                        return $topstring.''.$viewstring.''.$downstring;

                    }
                    if($data['type']=='credit_note')
                    {

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/inventory-pending/view-credit'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                        <a class="nav-link" href='.Url::base().'/users/inventory-pending/view-credit?id='.$data->id.' data-method=post>
                                           <i class="fa fa-eye"></i>
                                            <span class="dj-icon-gap">View</span>
                                        </a>
                                    </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        }

                        return $topstring.''.$viewstring.''.$downstring;
                    }
                },
            ],
           
       
        ],
    ]); ?>
                        </div>
                    </div>
                </div>



<?php ob_start();?>
 <script type="text/javascript">
$(function() {
 $('.select_class').select2();
 $('.customer').select2({
        ajax: { 
        url: "customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            
            $('#customersearch').trigger('change');
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
 $('.findvendor').select2({
        ajax: { 
        url: "vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };        
           
        },
        cache: true
        }
    });
// $('input[name="SaleOrderSearch[date]"]').attr('type','date');
// $('input[name="SaleOrderSearch[date]"]').attr('style','width:75px');
// $('input[name="SaleOrderSearch[delivery_date]"]').attr('type','date');
// $('input[name="SaleOrderSearch[delivery_date]"]').attr('style','width:75px');
$('#search-inventory-pending').hide();
$('#advance-search').click(function(){
    $('#search-inventory-pending').toggle();
})
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>

               