<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use backend\modules\users\models\SaleOrderDocument;
use backend\modules\master\models\Vendor;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Inventory Details';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
     
      <h1 style="text-align:center">Inventory Details</h1>
       <br>
 <br>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
           [
                'label'=>'Customer/Vendor',
                'contentOptions'=>['style'=>'font-weight:bold'],
               'attribute' => 'name',
               'value' => function ($data) {

                return $data->name;
                
                // if($data->type =='saleorder')
                // {
                //     return $data->name;
                // }
                // else if($data->type=='purchaseorder')
                // {
                //     return $data->name;
                // }
                // else if($data->type=='debit_note' || $data->type=='credit_note')
                // {
                //     if($data->user_type=='vendor')
                //     {
                //         $name = Vendor::find()->where(['id'=>$data->name])->one();
                //         return $name->business_name;
                //     }
                //     else if ($data->user_type=='customer') {
                //         $name = Customer::find()->where(['id'=>$data->name])->one();
                //         return $name->business_name;
                //     }
                    
                // }
                
               }
               
            ],
            [
                'label'=>'Executive/Service Engineer',
               'attribute' => 'executive_name',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    if($data->executive_name!='')
                    {
                        $user= LeadExecutive::find()->where(['id' =>$data->executive_name])->one();
                        return $user->name;
                    }
                }
               }
            ],
            [
                'label'=>'Date',
               'attribute' => 'latest_date',
                'value' => function ($data) {    
                    return date('F j Y', strtotime($data->created_date));
               }
            ],
            [
                'label'=>'Product Category',
               'attribute' => 'name',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    return 'SaleOrder';
                }
                else if($data->type=='purchaseorder')
                {
                    return 'Purchase';
                }
                else if($data->type=='debit_note')
                {
                    return 'DebitNote';
                }
                else
                    return "CreditNote";
               }
            ],
            [
                'label'=>'Order Type',
               'attribute' => 'name',
               'value' => function ($data) {
                return 'Full';
               }
            ],
            [
                'label'=>'Type',
               'attribute' => 'name',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    return 'To Be Shipped';
                }
                else if($data->type=='purchaseorder')
                {
                    return 'To Be Received';
                }
                
               }
            ],
            [
                'label'=>'Ref #',
               'attribute' => 'name',
               'format'=>'raw',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    
                     return ''.$data->order_id."</br>".'PO #:'.$data->po."</br>".'Date:'.$data->po_date."</br>".'Exp Date:'.$data->last_date;
                }
                else if($data->type=='purchaseorder')
                {
                    return $data->order_id;
                }
                else if($data->type=='debit_note')
                {
                    return $data->order_id;
                }
                else
                    return $data->order_id;
                 
               }
            ],
            [
                'label'=>'Stock',
               'attribute' => 'type',
               'value' => function ($data) {
                if($data->type=='saleorder')
                {
                    // return $data['status'];
                             if($data->status=='Available')
                                {
                                 return 'Available';
                             }
                             //    else if($total<$data->total && $total!=0)
                                else if($data->status=='Not Avilable')
                                {   
                                 return 'Not Avilable';
                             }
                             //    else if($total==0)
                                else if($data->status=='Partially Avail.')
                                {
                                 return 'Partially Avail';
                             }
                }
                if($data->type=='purchaseorder')
                {
                    return "-";
                }
                else
                {
                  return "-";
                }
               
                
               }
            ],
            
            [
                'label'=>'Notes',
               'attribute' => 'note',
               'value' => function ($data) {
                return $data->note;
               }
            ],
            
           
           
        ],
    ]); ?>
    <br>

 
</div>
</div>
</div>