<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use yii\helpers\Url;
/* @var $this yii\web\View */
use backend\modules\master\models\Customer;
use backend\modules\master\models\Product;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\master\models\LeadExecutive;
use backend\modules\users\models\SaleOrderDocument;
?>

<div class="app-main__inner">
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Inventory Pendings</div>
                                                            </div>
															<div class="widget-content-right">
                                                                <a href="<?=Url::base()?>/users/inventory-pending/index" class="dj-danger-btn"><i class="fa fa-chevron-circle-left" aria-hidden="true"></i> Back</a>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>

    <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            [
                'label' => 'Customer',
                
                'value' => function ($data) {
                 $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                 return $user['business_name'];
             },
             ],
             [
                'label' => 'Executive',
                
                'value' => function ($data) {
                 $user= LeadExecutive::find()->where(['id' =>$data['executive_id']])->one();
                 return $user['name'];
             },
             ],
            'note:ntext',
            'receiver',
            'sale_type',
            'supply_type',
            'reverse_charge',
            'priority',
            'price_list',
            'po_no',
            'po_details',
            'point_of_supply',
            'is_invoice_paid_provisional',
            'po_date',
            'po_exp_date',
            'sale_order_id',
            'date',
            'delivery_date',
            'due_date',
            'terms_of_payment',
            'advance_payment',
            'receipt_id',
            'receipt_setting_type',
            'receipt_total_amount',
            'receipt_bank',
            'receipt_cheque_no',
            'receipt_cheque_date',
            'advance_note',
            'sub_total_amount',
            'igst_amount',
            'sgst_amount',
            'cgst_amount',
            'tcs_amount',
            'total_amount',
            'converted_to',
            'saleorder_source',
            'order_status',
            'other_note:ntext',
            'terms:ntext',
            'lead_quote_id',
            [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= SaleOrderDocument::find()->select(['document_name'])->where(['sale_order_id' =>$data['id']])->asArray()->column();
                    $documents = implode(" , ", $user);
                    return $documents;

                    
            },
            ],
            'created_at',
            'updated_at',
            'cancel_reason',
        ],
    ]) ?>
<br>
    <?php if($products) {?>
<h4>Products</h4>
    <?php } ?>

<table id="w0" class="table table-striped table-bordered detail-view"><tbody>
<?php foreach($products as $value){ ?>
<tr><th>Product</th><td><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></td></tr>
<tr><th>Description</th><td><?=$value->description?></td></tr>
<tr><th>Qty</th><td><?=$value->quantity?></td></tr>
<tr><th>Unit</th><td><?php switch($value->units){
            case 'Nos':  echo "Nos"; break;
            case 'Pcs':  echo "Pcs"; break;
            case 'Pkt':  echo "Pkt"; break;
} ?></td></tr>
<tr><th>Price</th><td><?=$value->unit_price?></td></tr>
<tr><th>Discount</th><td><?=$value->discount?></td></tr>
<tr><th>Discount Type</th><td><?=$value->discount_type?></td></tr>
<tr><th>Tax</th><td><?=$value->tax?></td></tr>
<tr><th>Tax included</th><td><?php switch($value->tax_included){
            case '1':  echo "Yes"; break;
            case '0':  echo "No"; break;
} ?></td></tr>
<tr><th>Total amount</th><td><?=$value->amount?></td></tr>
<tr><th style="background-color: #fff" colspan=2>&nbsp;</th><tr>
<?php } ?>
</tbody></table>
<br> 


</div>
</div>
</div>