<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Vendor;
use backend\modules\master\models\Product;

use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\LeadsQuotesSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Leads Quotes';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.add_product .select2-selection__rendered {
    width: 220px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
#card-stack {
  background: #ddd;
  white-space: pre-wrap;  /* <-- THIS PRESERVES THE LINE BREAKS */
}
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
<div class="alert alert-success alert-dismissable">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('success') ?>
</div>
<?php endif; ?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>
<div class="app-main__inner">
<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
    <div class="card">
        <div class="no-gutters row">
            <div class="col-md-12 col-lg-12">
                <ul class="list-group list-group-flush">
                    <li class="bg-transparent list-group-item">
                        <div class="widget-content p-0">
                            <div class="widget-content-outer">
                                <div class="widget-content-wrapper">
                                    <div class="widget-content-left">
                                        <div class="widget-numbers dj-text-success">Leads Quotes</div>
                                    </div>
                                    <div class="widget-content-right">
                                    <a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Quote</a>
                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/create'])->one()!=''){?>
                                    <a href="<?=Url::base()?>/users/leads-quotes/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Quotes</a>
                                   <?php }else {?>

                                   <?php } ?>
                                        
                                    </div>
                                </div>
                            </div>
                        </div>
                    </li>
                  
                </ul>
            </div>
           
            
        </div>
    </div>
</div>
<div class="main-card mb-3 card">
   <div class="card-body">
    <?php $form = ActiveForm::begin(['method' => 'get']); ?>
    <div class="row dj-adv-search-row">
       <div class="col-md-6">
           <div class="position-relative form-group">
              <?= $form->field($model, 'lead_quote_id')->textInput(['maxlength' => true,'class'=>"form-control floating","placeholder"=>"Quote Id",'id'=>'id_quote'])->label(false) ?>
          </div>
        </div>
        <div class="col-md-2">
            <button type="submit" class="search_field_buttons"><i class="fa fa-search"></i> Search</button>
        </div>
       <?php ActiveForm::end(); ?>
       <div class="col-md-3">
        <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
        </div>
        <div class="col-md-1">
        <a  class="search_field_buttons"  href="<?=Url::base().'/users/leads-quotes/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
        </div>
       </div>

            <?php $form = ActiveForm::begin(['method' => 'get']); ?>              
                <div class="form-row" id="search-look">
                 <div class="col-md-2">
                        <div class="position-relative form-group">
                            <label for="notes">From</label>
                           <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-2">
                        <div class="position-relative form-group">
                            <label for="notes">To</label>
                           <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="date">Customer</label>
                              

                              <?php if($model->customer_name!=''){?>

                            <?php $customer=Customer::find()->where(['id'=>$model->customer_name])->one()?>
                           <?=$form->field($model, 'customer_name')->dropDownList([$model->customer_name=>$customer->business_name], ['options' => [$model->customer_name => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "customer_details form-control", 'maxlength' => true])->label(false)?>
                           <?php }else {?>
                                      
                            <?= $form->field($model, 'customer_name') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control customer_details",])->label(false)?>            
                           <?php } ?>
                        </div>
                    </div>
                    
                    
                    <div class="col-md-2">
                        <div class="position-relative form-group">
                            <label for="notes">Probability Form</label>
                           <?= $form->field($model, 'closure_from')->textInput(['maxlength' => true,'type'=>'number','min'=>1,'max'=>100])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-2">
                        <div class="position-relative form-group">
                            <label for="notes">Closure Probability To</label>
                           <?= $form->field($model, 'closure_to')->textInput(['maxlength' => true,'type'=>'number','min'=>1,'max'=>100])->label(false) ?>
                        </div>
                    </div>
                    <!-- <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="date">Quote Type</label>
                             <select class="multiselect-dropdown form-control">
                                <option value="quotes">All Quotes</option>
                                <option value="sample">Sample Products</option>
                            </select>
                        </div>
                        
                    </div> -->
                       <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="notes">Quote Status</label>
                            <?= $form->field($model, 'quote_status')->dropDownList(['All Quotes'=>'All Quotes', 'Pending Quotes'=>'Pending Quotes','Closed Quotes'=>'Closed Quotes'],['prompt'=>'--Select--','class'=>'form-control quote_status'])->label(false) ?>
                        </div>
                    </div>
                      <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="notes">Convert Status</label>
                            <?= $form->field($model, 'convert_status')->dropDownList(['Pending'=>'Pending', 'Profroma Invoice'=>'Proforma Invoice','Invoice'=>'Invoice','Sales Order'=>'Sales Order'],['prompt'=>'--Select--','class'=>' form-control convert_status'])->label(false) ?>
                        </div>
                    </div>
                      <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="notes">Setting Type</label>
                            <?= $form->field($model, 'setting')->dropDownList(['Quote'=>'Quote',],['prompt'=>'--Select--','class'=>'setting form-control'])->label(false) ?>
                        </div>
                    </div>
                    
                    <div class="col-md-2">
                        <div class="position-relative form-group">
                            <label for="notes">Total Amount</label>
                            <?= $form->field($model, 'amount_compare')->dropDownList(['='=>'=','<'=>'<','<='=>'<=','>'=>'>','>='=>'>='],['prompt'=>'--Select--','class'=>'amount_compare form-control'])->label(false) ?>
                        </div>
                    </div>
                    <div class="col-md-2">
                        <div class="position-relative form-group">
                            <label for="notes">with</label>
                           <?= $form->field($model, 'amount')->textInput(['maxlength' => true,'type'=>'number','min'=>1])->label(false) ?>
                        </div>
                    </div>
                     <div class="col-md-4">
                        <div class="position-relative form-group">
                            <label for="notes">Executives</label>
                            <?= $form->field($model, 'executive_name') ->dropDownList(ArrayHelper::map(LeadExecutive::find()->select(['name','id'])
                            ->orderBy('name')
                            ->asArray ()
                            ->all (),'id','name'),['prompt'=>'--Select--','class' => "form-control executive_name",])->label(false)?>
                        </div>
                    </div>
                     <div class="col-md-4">
                        <div class="position-relative form-group add_product">
                            <label for="notes">Product</label>

                            <?php if($model->find_product!=''){?>

                            <?php $product=Product::find()->where(['id'=>$model->find_product])->one()?>
                           <?=$form->field($model, 'find_product')->dropDownList([$model->find_product=>$product->product_name], ['options' => [$model->find_product => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "find_product form-control", 'maxlength' => true])->label(false)?>
                           <?php }else {?>
                                      
                            <?=$form->field($model, 'find_product')->dropDownList([], ['prompt' => '--Select--', 'class' => "find_product form-control", 'maxlength' => true])->label(false)?>             
                           <?php } ?>
                          
                        </div>
                    </div>
                    <div class="col-md-12 dj-btn-align" style="padding-top: 5px">
                    <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                    </div>
                </div>
              <?php ActiveForm::end(); ?>
            
        </div>
</div>
  <div class="main-card mb-3 card">
<div class="card-body">
<div class="row">
<div class="col-md-6">
        <div class="djsec-text-left dj-print-sec">
            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/delete'])->one()!=''){?>
            <button id='bulkdelete' class='mb-2 mr-2 btn-icon btn btn-danger '><i class="fa fa-trash"></i> Delete</button>
           <?php }else {?>

           <?php } ?>
                       
       </div>
    </div>
    <div class="col-md-6">
        <div class="djsec-text-right dj-print-sec">

            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/pdf-leadsquote'])->one()!=''){?>
             <a href="<?=Url::base();?>/users/leads-quotes/pdf-leadsquote?from=all" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-pdf-o"></i> Pdf</button></a>
           <?php }else {?>

           <?php } ?>

            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/excel-leadsquote'])->one()!=''){?>
             <a href="<?=Url::base();?>/users/leads-quotes/excel-leadsquote?detail=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details Excel</button></a>
             <a href="<?=Url::base();?>/users/leads-quotes/excel-leadsquote" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
           <?php }else {?>

           <?php } ?>
           
        </div>
     </div>
     </div>
   
     <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        "id" => "grid",
        
        'columns' => [
            ['class' => 'yii\grid\SerialColumn',],
            ['class' => 'yii\grid\CheckboxColumn',],
            // 'quotes_id',

            [
                'label'=>'Quotes Id',
               'attribute' => 'quotes_id',
               'value' => function ($data) {
                return $data->prefix.''.$data->quotes_no.''.$data->suffix;
               }
            ],
            
            [
                'contentOptions'=>[ 'style'=>'text-align:right'],

                'label' => 'Total Amount',
                'attribute' => 'total_amount',
                'value' => function ($data) {
                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data->total_amount);
                 return $num;    
            },
            ],

            [
                'label'=>'Customer',
               'attribute' => 'customer',
               'contentOptions' => function ($data) {
                if ($data->customer) {
                    return ['style' => 'font-weight:bold'];  
                }
            },
               'value' => function ($data) {
                    $val=Customer::find()->where(['id'=>$data->customer])->one();
                    // return $data->customer;
                    if($val)
                     return $val->business_name;
               }
            ],
            [
                'label' => 'Executive',
                'attribute' => 'executive',
                'value' => function ($data) {
                $user= Leadexecutive::find()->where(['id' =>$data['executive']])->one();
                if($user)
                 return $user['name'];
                 
            },
            ],
            [
                'label' => 'Date',
                'attribute' => 'date',
                'value' => function ($data) {
                    return date('F j Y', strtotime($data->date));
            },
            ],
            [
                'label' => 'Closure Pr(%)',
                'contentOptions'=>[ 'style'=>'text-align:right'],
                'attribute' => 'closure_property',
                'value' => function ($data) {
                    return $data->closure_property;
            },
            ],
            
              [
                'label' => 'Age of Quote',
                'contentOptions'=>[ 'style'=>'text-align:right'],

                'headerOptions' => ['style' => 'color:#495057'],
                'value' => function ($data) {
                    $today= time();
                    $date = strtotime($data->date);
                    $diff= $date-$today;
                    $age = floor($diff/(60*60*24)).' Days';
                    if($age<0)
                    {
                       

                        $final_age = -1 * (int)$age ;
                        return (int) $final_age;

                    }
                    else
                    {
                        return $age;
                    }
                    
            },
            ],
            [
                'label' => 'Status',
                'attribute' => 'status',
                'format'=>'raw',
                'value' => function ($data) {
                    if($data['status'])
                {
                    // return $data['status'];
                    if($data['status']=='Processing Quotes')
                    {
                         return '<span class="label-partial">PROCESSING</span>';
                    }
                    else if($data['status']=='Pending Quotes')
                    {
                        return '<span class="label-draft">PENDING</span>';
                    }
                    else if ($data['status']=='Closed Quotes') {
                        return '<span class="label-received">CLOSED</span>';
                    }
                    else if ($data['status']=='All Quotes') {
                        return '<span class="label-draft">ALL</span>';
                    }
                    else{
                        $status=$data['status'];
                        return "<span class='label-draft'>$status</span>";
                    }
                }
            },
            ],
            [
                'label' => 'Covt. To',
                'attribute' => 'converted_to',
                'value' => function ($data) {
                    return $data->converted_to;
            },
            ],
            [
            'label' => 'Action',
            // 'attribute' => 'username',
            'format'=>'raw',
            'contentOptions'=>[ 'style'=>'width: 35px'],
            'headerOptions' => ['style' => 'color:#495057'],
            'value' => function ($data) use ($assign) {
                    $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';
                    if($data->status=="Closed Quotes")
                    {


                        $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                        $downstring =  '</ul></div></div>';

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/view'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/view?id='.$data->id.' data-method=post>
                                       <i class="fa fa-eye"></i>
                                        <span class="dj-icon-gap">  View</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        }   

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/delete'])->one()!='')
                        {
                            $deletestring = '<li class="nav-item">
                                    <a class="nav-link deletequotes" href='.Url::base().'/users/leads-quotes/delete?id='.$data->id.' data-method=post>
                                       <i class="fa fa-trash"></i>
                                        <span class="dj-icon-gap">  Delete</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $deletestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/pdf-leadsquote'])->one()!='')
                        {
                            $pdfstring = ' <li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.' >
                                       <i class="fa fa-file-pdf-o"></i>
                                        <span class="dj-icon-gap">  PDF Leads Quote</span>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" target="_blank" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.'&from=print >
                                       <i class="fa fa-print"></i>
                                        <span class="dj-icon-gap">  Print Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $pdfstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/excel-leadsquote'])->one()!='')
                        {
                            $excelstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/excel-leadsquote?id='.$data->id.'  >
                                       <i class="fa fa-file-excel-o"></i>
                                        <span class="dj-icon-gap">  Excel Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $excelstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findattachments'])->one()!='')
                        {
                            $attachmentstring = '<li class="nav-item">
                                    <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                        <i class="fa fa-paperclip"></i>
                                        <span class="dj-icon-gap">Download Attachments</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $attachmentstring = '';
                        }

                        return $topstring.''.$viewstring.''.$deletestring.''.$pdfstring.''.$excelstring.''.$attachmentstring.''.$downstring;
                    }
                    else
                    {
                        if($data->converted_to=='Pending')
                        {


                        $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                        $downstring =  '</ul></div></div>';

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/view'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/view?id='.$data->id.' data-method=post>
                                       <i class="fa fa-eye"></i>
                                        <span class="dj-icon-gap">  View</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/update'])->one()!='')
                        {
                            $editstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/update?id='.$data->id.'>
                                        <i class="fa fa-pencil-square"></i>
                                        <span class="dj-icon-gap"> Edit</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $editstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/closequote'])->one()!='')
                        {
                            $closestring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/closequote?id='.$data->id.' >
                                       <i class="fa fa-times"></i>
                                        <span class="dj-icon-gap">  Close</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $closestring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/delete'])->one()!='')
                        {
                            $deletestring = '<li class="nav-item">
                                    <a class="nav-link deletequotes" href='.Url::base().'/users/leads-quotes/delete?id='.$data->id.' data-method=post>
                                       <i class="fa fa-trash"></i>
                                        <span class="dj-icon-gap">  Delete</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $deletestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/pdf-leadsquote'])->one()!='')
                        {
                            $pdfstring = ' <li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.' >
                                       <i class="fa fa-file-pdf-o"></i>
                                        <span class="dj-icon-gap">  PDF Leads Quote</span>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" target="_blank" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.'&from=print >
                                       <i class="fa fa-print"></i>
                                        <span class="dj-icon-gap">  Print Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $pdfstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/excel-leadsquote'])->one()!='')
                        {
                            $excelstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/excel-leadsquote?id='.$data->id.'  >
                                       <i class="fa fa-file-excel-o"></i>
                                        <span class="dj-icon-gap">  Excel Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $excelstring = '';
                        }


                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/create'])->one()!='')
                        {
                            $salestring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/sale-order/create?id='.$data->id.'&from=leads-quotes  >
                                       <i class="fa fa-retweet"></i>
                                        <span class="dj-icon-gap">  Convert To SaleOrder</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $salestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/create'])->one()!='')
                        {
                            $duplicatestring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/create?id='.$data->id.'&from=leads-quotes  data-method=post>
                                       <i class="fa fa-files-o"></i>
                                        <span class="dj-icon-gap">  Duplicate LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $duplicatestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $mailstring = '<li class="nav-item ">
                                  <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                      <i class="fa fa-envelope-o"></i>
                                      <span class="dj-icon-gap">Mail LeadsQuote</span>
                                  </a>
                              </li>';
                        }
                        else
                        {
                            $mailstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $whatsappstring = '<li class="nav-item">
                                    <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                        <i class="fa fa-whatsapp"></i>
                                        <span class="dj-icon-gap"> Whatsapp LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $whatsappstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findattachments'])->one()!='')
                        {
                            $attachmentstring = '<li class="nav-item">
                                    <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                        <i class="fa fa-paperclip"></i>
                                        <span class="dj-icon-gap">Download Attachments</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $attachmentstring = '';
                        }


                        return $topstring.''.$viewstring.''.$editstring.''.$closestring.''.$deletestring.''.$pdfstring.''.$excelstring.''.$salestring.''.$duplicatestring.''.$mailstring.''.$whatsappstring.''.$attachmentstring.''.$downstring;

                        }
                    else if($data->converted_to=='Sales Order')
                    {

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/view'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/view?id='.$data->id.' data-method=post>
                                       <i class="fa fa-eye"></i>
                                        <span class="dj-icon-gap">  View</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/update'])->one()!='')
                        {
                            $editstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/update?id='.$data->id.'>
                                        <i class="fa fa-pencil-square"></i>
                                        <span class="dj-icon-gap"> Edit</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $editstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/pdf-leadsquote'])->one()!='')
                        {
                            $pdfstring = ' <li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.' >
                                       <i class="fa fa-file-pdf-o"></i>
                                        <span class="dj-icon-gap">  PDF Leads Quote</span>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" target="_blank" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.'&from=print >
                                       <i class="fa fa-print"></i>
                                        <span class="dj-icon-gap">  Print Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $pdfstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/excel-leadsquote'])->one()!='')
                        {
                            $excelstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/excel-leadsquote?id='.$data->id.'  >
                                       <i class="fa fa-file-excel-o"></i>
                                        <span class="dj-icon-gap">  Excel Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $excelstring = '';
                        }


                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/create'])->one()!='')
                        {
                            $proformastring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/proforma-invoice/create?id='.$data->id.'&from=leads-quotes  >
                                       <i class="fa fa-retweet"></i>
                                        <span class="dj-icon-gap">  Convert To proforma-invoice</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $proformastring = '';
                        }

                         if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/invoice/create'])->one()!='')
                        {
                            $invoicestring = '<li class="nav-item">
                                    <a class="nav-link" href=  >
                                       <i class="fa fa-retweet"></i>
                                        <span class="dj-icon-gap">  Convert To Invoice</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $invoicestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/create'])->one()!='')
                        {
                            $duplicatestring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/create?id='.$data->id.'&from=leads-quotes  data-method=post>
                                       <i class="fa fa-files-o"></i>
                                        <span class="dj-icon-gap">  Duplicate LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $duplicatestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $mailstring = '<li class="nav-item ">
                                  <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                      <i class="fa fa-envelope-o"></i>
                                      <span class="dj-icon-gap">Mail LeadsQuote</span>
                                  </a>
                              </li>';
                        }
                        else
                        {
                            $mailstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $whatsappstring = '<li class="nav-item">
                                    <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                        <i class="fa fa-whatsapp"></i>
                                        <span class="dj-icon-gap"> Whatsapp LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $whatsappstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findattachments'])->one()!='')
                        {
                            $attachmentstring = '<li class="nav-item">
                                    <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                        <i class="fa fa-paperclip"></i>
                                        <span class="dj-icon-gap">Download Attachments</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $attachmentstring = '';
                        }



                        return $topstring.''.$viewstring.''.$editstring.''.$pdfstring.''.$excelstring.''.$proformastring.''.$duplicatestring.''.$mailstring.''.$whatsappstring.''.$attachmentstring.''.$downstring;


                        
                    }
                    else if($data->converted_to=='Proforma Invoice')
                    {

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/view'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/view?id='.$data->id.' data-method=post>
                                       <i class="fa fa-eye"></i>
                                        <span class="dj-icon-gap">  View</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/update'])->one()!='')
                        {
                            $editstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/update?id='.$data->id.'>
                                        <i class="fa fa-pencil-square"></i>
                                        <span class="dj-icon-gap"> Edit</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $editstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/pdf-leadsquote'])->one()!='')
                        {
                            $pdfstring = ' <li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.' >
                                       <i class="fa fa-file-pdf-o"></i>
                                        <span class="dj-icon-gap">  PDF Leads Quote</span>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" target="_blank" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.'&from=print >
                                       <i class="fa fa-print"></i>
                                        <span class="dj-icon-gap">  Print Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $pdfstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/excel-leadsquote'])->one()!='')
                        {
                            $excelstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/excel-leadsquote?id='.$data->id.'  >
                                       <i class="fa fa-file-excel-o"></i>
                                        <span class="dj-icon-gap">  Excel Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $excelstring = '';
                        }

                         if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/invoice/create'])->one()!='')
                        {
                            $invoicestring = '<li class="nav-item">
                                    <a class="nav-link" href=  >
                                       <i class="fa fa-retweet"></i>
                                        <span class="dj-icon-gap">  Convert To Invoice</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $invoicestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/create'])->one()!='')
                        {
                            $duplicatestring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/create?id='.$data->id.'&from=leads-quotes  data-method=post>
                                       <i class="fa fa-files-o"></i>
                                        <span class="dj-icon-gap">  Duplicate LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $duplicatestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $mailstring = '<li class="nav-item ">
                                  <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                      <i class="fa fa-envelope-o"></i>
                                      <span class="dj-icon-gap">Mail LeadsQuote</span>
                                  </a>
                              </li>';
                        }
                        else
                        {
                            $mailstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $whatsappstring = '<li class="nav-item">
                                    <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                        <i class="fa fa-whatsapp"></i>
                                        <span class="dj-icon-gap"> Whatsapp LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $whatsappstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findattachments'])->one()!='')
                        {
                            $attachmentstring = '<li class="nav-item">
                                    <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                        <i class="fa fa-paperclip"></i>
                                        <span class="dj-icon-gap">Download Attachments</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $attachmentstring = '';
                        }



                        return $topstring.''.$viewstring.''.$editstring.''.$pdfstring.''.$excelstring.''.$duplicatestring.''.$mailstring.''.$whatsappstring.''.$attachmentstring.''.$downstring;
                    }
                    else if($data->converted_to=='Invoice')
                    {



                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/view'])->one()!='')
                        {
                            $viewstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/view?id='.$data->id.' data-method=post>
                                       <i class="fa fa-eye"></i>
                                        <span class="dj-icon-gap">  View</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $viewstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/update'])->one()!='')
                        {
                            $editstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/update?id='.$data->id.'>
                                        <i class="fa fa-pencil-square"></i>
                                        <span class="dj-icon-gap"> Edit</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $editstring = '';
                        } 

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/pdf-leadsquote'])->one()!='')
                        {
                            $pdfstring = ' <li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.' >
                                       <i class="fa fa-file-pdf-o"></i>
                                        <span class="dj-icon-gap">  PDF Leads Quote</span>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" target="_blank" href='.Url::base().'/users/leads-quotes/pdf-leadsquote?id='.$data->id.'&from=print >
                                       <i class="fa fa-print"></i>
                                        <span class="dj-icon-gap">  Print Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $pdfstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/excel-leadsquote'])->one()!='')
                        {
                            $excelstring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/excel-leadsquote?id='.$data->id.'  >
                                       <i class="fa fa-file-excel-o"></i>
                                        <span class="dj-icon-gap">  Excel Leads Quote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $excelstring = '';
                        }
                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/create'])->one()!='')
                        {
                            $duplicatestring = '<li class="nav-item">
                                    <a class="nav-link" href='.Url::base().'/users/leads-quotes/create?id='.$data->id.'&from=leads-quotes  data-method=post>
                                       <i class="fa fa-files-o"></i>
                                        <span class="dj-icon-gap">  Duplicate LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $duplicatestring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $mailstring = '<li class="nav-item ">
                                  <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                      <i class="fa fa-envelope-o"></i>
                                      <span class="dj-icon-gap">Mail LeadsQuote</span>
                                  </a>
                              </li>';
                        }
                        else
                        {
                            $mailstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findleadsalldetails'])->one()!='')
                        {
                            $whatsappstring = '<li class="nav-item">
                                    <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                        <i class="fa fa-whatsapp"></i>
                                        <span class="dj-icon-gap"> Whatsapp LeadsQuote</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $whatsappstring = '';
                        }

                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/leads-quotes/findattachments'])->one()!='')
                        {
                            $attachmentstring = '<li class="nav-item">
                                    <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                        <i class="fa fa-paperclip"></i>
                                        <span class="dj-icon-gap">Download Attachments</span>
                                    </a>
                                </li>';
                        }
                        else
                        {
                            $attachmentstring = '';
                        }

                        return $topstring.''.$viewstring.''.$editstring.''.$pdfstring.''.$excelstring.''.$duplicatestring.''.$mailstring.''.$whatsappstring.''.$attachmentstring.''.$downstring;

                    }
                       
                    }                
            },
        ],                       
        ],
    ]); ?>

</div>
</div>
</div>

<div class="modal fade" id="whatapp">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Whatsapp Message</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mobile no. </label>   
                 <div class="col-md-12">
                      <!-- <div class="position-relative form-group"> -->
                         <!-- <label for="customer" class="">Reason </label>  -->
                       
                        <div class="col-md-3" style="float: left;" > <?= $form->field($model, 'c_code')->textInput(['maxlength' => true,'class' => "form-control c_code",'placeholder'=>'Country Code'])->label(false) ?></div> 
                          <div class="col-md-9" style="float: right;" > <?= $form->field($model, 'c_mobile')->textInput(['maxlength' => true,'placeholder'=>'Mobile No.','class' => "form-control c_mobile"])->label(false) ?></div>

                         <?= $form->field($model, 'text_send')->textarea(['rows' => 6,'placeholder'=>'text','class' => "form-control send_text"])->label(false) ?>
                           
                       <!-- </div> -->                      
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::Button('<i class="fa fa-check-square-o" aria-hidden="true"></i> Send', ['class' => 'btn dj-blue-btn submit-btn sendwhatapp','target'=>"_blank"]) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
  </div>


  <div class="modal fade" id="email">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Email</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mail To </label>   
                 <div class="col-md-12">      
                          <?= $form->field($model, 'send_email')->textInput(['maxlength' => true,'class' => "form-control mail_send"])->label(false) ?>                   
                 </div> 

                 <label for="customer" class="">BCC </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'bcc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_bbc"])->label(false) ?>                                                
                </div>

                <label for="customer" class="">Mail Cc </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'cc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_cc"])->label(false) ?>                            
                </div>

                <label for="customer" class="">Subject </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'email_subject')->textInput(['maxlength' => true,'placeholder'=>'Enter Subject','class' => "form-control mail_subject"])->label(false) ?>
                            <?= $form->field($model, 'findid')->textInput(['maxlength' => true,'class' => "form-control cancel_id"])->label(false) ?> 
                       <!-- </div> -->
                                                
                </div>

                <label for="customer" class="">Message </label>   
                 <div class="col-md-12">

                          <?= $form->field($model, 'email_message')->textarea(['rows' => 6,'placeholder'=>'text','class' => "form-control message",'style' => 'white-space:pre;'])->label(false) ?>
                           
                       <!-- </div> -->
                                                
                </div>
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                   <?= Html::submitButton('<i class="fa fa-check-square-o" aria-hidden="true"></i> Send', ['class' => 'btn dj-blue-btn submit-btn']) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>




<div class="modal fade" id="document" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Leads Quotes Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            
            <table id="dinamic">
               
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>

<?php ob_start();?>
<script type="text/javascript">
$(function() {

 $('.sendwhatapp').click(function()  {  
    var country_code = $('.c_code').val();
    var mobile = $('.c_mobile').val();
    var mobile_no = country_code.concat(mobile);
    var g_text = $('.send_text').val();
    var url= "https://wa.me/"+mobile_no+"/?text="+g_text;
    window.location.href = url; 
 })

$('.cancel_id').hide();
$('.senddetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     $('.cancel_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('findleadsalldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           $('.c_code').val('91');
           $('.reason').val('');
           jQuery.ajaxSetup({async:false});
           $.get('create-url',{id:id},function(st)
           {
                var st = $.parseJSON(st);
                $('.send_text').text('We have confirmed your Quote '+(data.quotes_id)+' has been raised for Rs '+data.total_amount+'. Thank you! For Download Click this link '+st); 
           })
     });
     
})


$('.sendemail').click(function(){
     var id = $(this).attr('value');
     // $('.reason').val('');
     $('.cancel_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('finduseralldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           $('.send_email').val(data.email);
           $('.mail_bbc').val('');
           
           
           // jQuery.ajaxSetup({async:false});
           $.get('findleadsalldetails',{id:id},function(st)
           {
                var st =$.parseJSON(st);
                var sub= 'Quote # '+st.quotes_id+" Date:"+st.date;
                $('.mail_subject').val(sub);
                $.get('create-url',{id:id},function(link)
                {
                    var link =$.parseJSON(link);
                    var obj = $('.message').html('Dear '+(data.business_name)+"\n We have confirmed your order for Quote "+sub+". The Quote has been raised for Rs"+ st.total_amount+'\n Thank you! \n MOHASYN \n \n Download attached Quote at: \n'+link).wrap('<pre />'); 
                })
                // var obj = $("#example").text('this\n has\n newlines');
               
           })
           

     });
     
})



$('.quote_status').select2();
$('.amount_compare').select2();
$('.executive_name').select2();
$('.setting').select2();
$('.convert_status').select2();

$('.customer_details').select2({
        ajax: { 
        url: "customer",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    $('.find_product').select2({
        ajax: { 
        url: "productdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });


$('#bulkdelete').click(function(){
    var ids = $('#grid').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure want to delete the selected items?");
        if(x)
        {

            var ids = $('#grid').yiiGridView('getSelectedRows');

            console.log(ids);
            $.post( 'delete',{data: ids}, function( data ) {
               });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some item to delete!");
    }
   
})

$('#w1').hide();
$('#advance-search').click(function(){
    $('#w1').toggle();
})

$('.deletequotes').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})

$('input[name="LeadsQuotesSearch[date]"]').attr('type','date');
$('input[name="LeadsQuotesSearch[date]"]').attr('style','width:105px');


var isLoading = false;
$('.attachments').click(function(){
     $("#dinamic").empty();
     isLoading = true;
     var id = $(this).attr('value');
     $.get('findattachments',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           if(data.length==0)
           {
               $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
           }
           for (var i = 0; i < data.length; i++){
                $('#dinamic').append("<tr><td  value='" + data[i].id + "'><a href='<?=Url::base();?>/users/leads-quotes/download?id="+ data[i].id +"'>"+ data[i].document_name +"</a></td><tr>");
               

                  }
         isLoading = false;        

     });
})
});
</script>   
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>