<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use backend\modules\users\models\ReceiptDetails;
use backend\modules\master\models\Customer;
use yii\helpers\ArrayHelper;
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\ProformaInvoiceSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
use backend\models\AuthAssignment;
use backend\models\AuthItemChild;
use backend\modules\master\models\SalesTemplates;
use backend\modules\master\models\GenericTemplate;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

$this->title = 'Proforma Invoices';
$this->params['breadcrumbs'][] = $this->title;

$settingtypes = GenericTemplate::find()->where(['template_for'=>'Proforma Invoice'])->all();
$prosettinglist=ArrayHelper::map($settingtypes, 'gt_id', 'template_name');
?>
<style>
.badge{
    background-color: #899;
    margin: 10px -10px 10px 20px;
}
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
.noHover{
    pointer-events: none;
}


/* .label {
  color: white;
  padding: 8px;
  font-family: Arial;
} */
.label {
  color: white;
  padding: 8px;
  font-family: Arial;
}
.success {background-color: #4CAF50 !important;} /* Green */
.info {background-color: #2196F3;} /* Blue */
.warning {background-color: #ff9800;} /* Orange */
.danger {background-color: #f44336;} /* Red */ 
.other {background-color: #e7e7e7; color: black;} /* Gray */ 

</style>
    <?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
                    <?php endif; ?>
                <div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Proforma Invoice</div>
                                                            </div>
                                                            <div class="widget-content-right">

                                                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/create'])->one()!=''){?>
                                                                <a href="create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Proforma Invoice</a>
                                                               <?php }else {?>

                                                               <?php } ?>

                                                            </div>

                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                            <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                           <div class="row dj-adv-search-row">
                           <div class="col-md-6">
                               <div class="position-relative form-group">
                                  <?= $form->field($model, 'proforma')->textInput(['maxlength' => true,'class'=>"form-control floating","placeholder"=>"Proforma Invoice Id"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-2">
                                <button type="submit" class="search_field_buttons"><i class="fa fa-search"></i> Search</button>
                            </div>
                           <?php ActiveForm::end(); ?>
                           <!-- <div class="col-md-3">
                            <a id="advance-search" class="btn btn-rounded dj-adv-search" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a> -->
                           <div class="col-md-3">
                            <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-1">
                            <a  class="search_field_buttons"  href="<?=Url::base().'/users/proforma-invoice/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
                           </div>

                           <!-- <div class="dj-sale-form collapse" id="search-look"> -->
                                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                    <!-- <form > -->
                                        <div class="form-row">
                                        <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                   <?= $form->field($model, 'from_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                   <?= $form->field($model, 'to_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Customer/Receiver</label>


                                                    <?php if($model->customer!=''){?>

                                                    <?php $customer=Customer::find()->where(['business_name'=>$model->customer])->one()?>
                                                   <?=$form->field($model, 'customer')->dropDownList([$model->customer=>$customer->business_name], ['options' => [$model->customer => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "customer form-control", 'maxlength' => true])->label(false)?>

                                                   <?php }else {?>
                                                              
                                                    <?= $form->field($model, 'customer') ->dropDownList([],['prompt'=>'Select Customer','class' => "form-control customer"])->label(false)?>           
                                                   <?php } ?>

                                                </div>
                                                
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Setting Type</label>
                                                     <?= $form->field($model, 'setting')->dropDownList($prosettinglist,['class'=>'setting','prompt'=>'--select--'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount</label>
                                                   <?= $form->field($model, 'total_amount')->textInput(['maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4 dj-btn-align" style="padding-top: 5px">
                                            <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                                            </div>
                                        </div>
                                      <!-- </form>   -->
                                      <?php ActiveForm::end(); ?>
                                  <!-- </div> -->
                                    
                                </div>
                        </div>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                        <div class="row">

                            <div class="col-sm-6">
                                <div class="djsec-text-left dj-print-sec">

                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/delete'])->one()!=''){?>
                                    <button id='bulkdelete' class='mb-2 mr-2 btn-icon btn btn-danger '><i class="fa fa-trash"></i> Delete</button>
                                   <?php }else {?>

                                   <?php } ?>          
                               </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="djsec-text-right dj-print-sec">

                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/excel-proforma'])->one()!=''){?>
                                        <a href="<?=Url::base();?>/users/proforma-invoice/excel-proforma?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details Excel</button></a>

                                        <a href="<?=Url::base();?>/users/proforma-invoice/excel-proforma" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                                    <?php }else {?>

                                    <?php } ?>

                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/proforma-invoice-pdf'])->one()!=''){?>
                                       <a href="<?=Url::base();?>/users/proforma-invoice/proforma-invoice-pdf?from=all" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                                    <?php }else {?>

                                    <?php } ?> 
                                       
                                        
                                       
                                        
                                       

                                        
                                </div>
                            </div>
                        
                             </div>
                          

                             <?= GridView::widget([
                                'dataProvider' => $dataProvider,
                                // 'filterModel' => $searchModel,
                                 "id" => "grid",
                                
                                'columns' => [
                                   ['class' => 'yii\grid\SerialColumn',],
                                   ['class' => 'yii\grid\CheckboxColumn',],
                                    'proforma_invoice_id',
                                    // 'customer_name',
                                    [
                                        'contentOptions' => ['style' => 'font-weight:bolder'],
                                        'label' => 'Customer Name',
                                        'attribute' => 'customer_name',
                                        'value' => 'customer_name'
                                    ],
                                    // 'date:date',
                                    [
                                        'label' => 'Date',
                                        'attribute' => 'date',
                                        'value' => function ($data) {
                                            return date('F j Y', strtotime($data->date));
                                    },
                                    ],
                                    [
                                        'contentOptions'=>[ 'style'=>'text-align:right'],
                                        'label' => 'Total Price',
                                        'attribute' => 'total_price',
                                        'value' => function ($data) {
                                             $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data->total_price);
                                            return $num;  
                                    },
                                    ],
                                    [
                                        'contentOptions'=>[ 'style'=>'text-align:right'],
                                        'label' => 'Paid',
                                        'headerOptions' => ['style' => 'color:#495057'],
                                        'value' => function ($data) {
                                            $amount= ReceiptDetails::find()->select(['total_amount'])->where(['id' =>$data->receipt_no])->asArray()->one();
                                            $amt=$data->total_price-$amount;
                                            $paid_amount=$data->total_price-$amt;
                                            $pamount = number_format((float)$paid_amount, 2, '.', '');
                                             $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $pamount);
                                            return $num;  

                                    }
                                    ],
                                    [
                                        'contentOptions'=>[ 'style'=>'text-align:right'],
                                        'label' => 'Pending',
                                        'headerOptions' => ['style' => 'color:#495057'],
                                        'value' => function ($data) { 
                                         $amount= ReceiptDetails::find()->select(['total_amount'])->where(['id' =>$data->receipt_no])->asArray()->one();
                                            $amt=$data->total_price-$amount; 
                                            $amount = number_format((float)$amt, 2, '.', '');
                                             $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$amount);
                                            return $num;    
                                    }
                                    ],
                                    [
                                        'label' => 'Status',
                                        'headerOptions'=>['style'=>'text-align: center;'],
                                        'format'=>'raw',
                                       
                                        'value' => function ($data) {                              
                                            if($data['status'])
                                            {
                                                // return $data['status'];
                                                if($data['status']=='Pending')
                                                {
                                                     return '<span class="label-draft">DRAFT</span>';
                                                }
                                                else if($data['status']=='Paid')
                                                {
                                                    return '<span class="label-paid">PAID</span>';
                                                }
                                                else if ($data['status']=='Draft') {
                                                    return '<span class="label-draft">DRAFT</span>';
                                                }
                                            } 
                                    }
                                    ],
                                    // 'status',
                                    'converted_to',
    [
                                        'label' => 'Action',
                                        // 'attribute' => 'username',
                                        'headerOptions' => ['style' => 'color:#495057'],
                                        'format'=>'raw',
                                        'contentOptions'=>[ 'style'=>'width: 35px'],
                                        'value' => function ($data) use ($assign){

                                        $topstring = '<div class="d-inline-block dropdown">
                                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                            <ul class="nav flex-column">';
                                        $downstring =  '</ul></div></div>';   


                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/view'])->one()!='')
                                        {
                                            $viewstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/users/proforma-invoice/view?id='.$data->id.' data-method=post>
                                                   <i class="fa fa-eye"></i>
                                                    <span class="dj-icon-gap">  View</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $viewstring = '';
                                        } 

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/update'])->one()!='')
                                        {
                                            $editstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/users/proforma-invoice/update?id='.$data->id.'>
                                                    <i class="fa fa-pencil-square"></i>
                                                    <span class="dj-icon-gap"> Edit</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $editstring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/delete'])->one()!='')
                                        {
                                            $deletestring = '<li class="nav-item">
                                                <a class="nav-link deleteproforma" href='.Url::base().'/users/proforma-invoice/delete?id='.$data->id.' data-method=post>
                                                   <i class="fa fa-trash"></i>
                                                    <span class="dj-icon-gap"> Delete</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $deletestring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/proforma-invoice-pdf'])->one()!='')
                                        {
                                            $printstring = '<li class="nav-item">
                                                <a class="nav-link " target=_blank href='.Url::base().'/users/proforma-invoice/view?id='.$data->id.'&from=print>
                                                    <i class="fa fa-file-pdf-o"></i>
                                                    <span class="dj-icon-gap">Print Proforma Invoice</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $printstring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/excel-proforma'])->one()!='')
                                        {
                                            $excelstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/users/proforma-invoice/excel-proforma?id='.$data->id.'>
                                                    <i class="fa fa-file-excel-o"></i>
                                                    <span class="dj-icon-gap">Excel Proforma Invoice</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $excelstring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/findproinvoicealldetails'])->one()!='')
                                        {
                                            $mailstring = '<li class="nav-item">
                                                <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                                <i class="fa fa-envelope-o"></i>
                                                <span class="dj-icon-gap">Mail Proforma Invoice</span>
                                            </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $mailstring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/invoice/create'])->one()!='')
                                        {
                                            $invoicestring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/users/invoice/create?id='.$data->id.'&from=proformainvoice data-method=post>
                                                    <i class="fa fa-retweet"></i>
                                                    <span class="dj-icon-gap">Convert to Invoice</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $invoicestring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/create'])->one()!='')
                                        {
                                            $duplicatestring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/users/proforma-invoice/create?id='.$data->id.'&from=proformainvoice data-method=post  >
                                                    <i class="fa fa-files-o"></i>
                                                    <span class="dj-icon-gap">Duplicate Proforma Invoice</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $duplicatestring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/findproinvoicealldetails'])->one()!='')
                                        {
                                            $whatsappstring = '<li class="nav-item">
                                                <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                                <i class="fa fa-whatsapp"></i>
                                                <span class="dj-icon-gap"> Whatsapp Proforma Invoice</span>
                                            </a>

                                            </li>';
                                        }
                                        else
                                        {
                                            $whatsappstring = '';
                                        }

                                        if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/findattachments'])->one()!='')
                                        {
                                            $attachmentstring = '<li class="nav-item">
                                                <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                                    <i class="fa fa-paperclip"></i>
                                                    <span class="dj-icon-gap">Download Attachments</span>
                                                </a>
                                            </li>';
                                        }
                                        else
                                        {
                                            $attachmentstring = '';
                                        }


                                        return $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$printstring.''.$excelstring.''.$mailstring.''.$invoicestring.''.$duplicatestring.''.$whatsappstring.''.$attachmentstring;
                                        },
                                    ],
                                ],
                            ]); ?>


                        </div>
                    </div>
                </div>



<div class="modal fade" id="whatapp">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Whatsapp Message</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mobile no. </label>   
                 <div class="col-md-12">
                      <!-- <div class="position-relative form-group"> -->
                         <!-- <label for="customer" class="">Reason </label>  -->
                       
                        <div class="col-md-3" style="float: left;" > <?= $form->field($model, 'c_code')->textInput(['maxlength' => true,'class' => "form-control c_code",'placeholder'=>'Country Code'])->label(false) ?></div> 
                          <div class="col-md-8" style="float: right;" > <?= $form->field($model, 'c_mobile')->textInput(['maxlength' => true,'placeholder'=>'Mobile No.','class' => "form-control c_mobile"])->label(false) ?></div>

                          <?= $form->field($model, 'text_send')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control send_text"])->label(false) ?>
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id",])->label(false) ?> 
                       <!-- </div> -->
                                                
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::Button('<i class="fa fa-check-square-o" aria-hidden="true"></i> Save', ['class' => 'btn dj-blue-btn submit-btn sendwhatapp','target'=>"_blank"]) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>

<div class="modal fade" id="email">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Email</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mail To </label>   
                 <div class="col-md-12">      
                          <?= $form->field($model, 'send_email')->textInput(['maxlength' => true,'class' => "form-control mail_send"])->label(false) ?>                   
                 </div> 

                 <label for="customer" class="">BCC </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'bcc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_bbc"])->label(false) ?>                                                
                </div>

                <label for="customer" class="">Mail Cc </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'cc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_cc"])->label(false) ?>                            
                </div>

                <label for="customer" class="">Subject </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'email_subject')->textInput(['maxlength' => true,'placeholder'=>'Enter Subject','class' => "form-control mail_subject"])->label(false) ?>
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id"])->label(false) ?> 
                       <!-- </div> -->
                                                
                </div>

                <label for="customer" class="">Message </label>   
                 <div class="col-md-12">

                          <?= $form->field($model, 'email_message')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control message"])->label(false) ?>
                           
                       <!-- </div> -->
                                                
                </div>
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                   <?= Html::submitButton('<i class="fa fa-check-square-o" aria-hidden="true"></i> Send', ['class' => 'btn dj-blue-btn submit-btn']) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>




<div class="modal fade" id="document" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Proforma Invoice Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            
            <table id="dinamic">
               
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>

<?php ob_start();?>
<script type="text/javascript">
$(function() {

    $('.sendwhatapp').click(function()  {  
        var country_code = $('.c_code').val();
        var mobile = $('.c_mobile').val();
        var mobile_no = country_code.concat(mobile);
        var g_text = $('.send_text').val();
        var url= "https://wa.me/"+mobile_no+"/?text="+g_text;
        window.location.href = url; 
})

    $('.senddetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     $('.cancel_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('findproinvoicealldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           $('.c_code').val('91');
           $('.reason').val('');
           jQuery.ajaxSetup({async:false});

           $.get('create-url',{id:id},function(st)
           {
                var st = $.parseJSON(st);
                $('.send_text').text('We have confirmed your Proforma Invoice '+(data.proforma_invoice_id)+' has been raised for Rs '+data.total_price+'. Thank you! For Download Click this link '+st); 
           })
           

     });
     
})

 $('.sendemail').click(function(){
     var id = $(this).attr('value');
     // $('.reason').val('');
     $('.cancel_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('finduseralldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
            // alert(data.email);
           $('.send_email').val(data.email);
           $('.mail_bbc').val('');
           
           
           // jQuery.ajaxSetup({async:false});
           $.get('findproinvoicealldetails',{id:id},function(st)
           {
                var st =$.parseJSON(st);
                var sub= 'Proforma Invoice # '+st.proforma_invoice_no+" Date:"+st.date;
                $('.mail_subject').val(sub);
                $.get('create-url',{id:id},function(link)
                {
                    var link =$.parseJSON(link); 
                    var obj = $('.message').html(link).wrap('<pre />'); 
                })
                // var obj = $("#example").text('this\n has\n newlines');
               
           })
           

     });
     
})


    $('.setting').select2();
$('#bulkdelete').click(function(){
    var ids = $('#grid').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure want to delete the selected items?");
        if(x)
        {

            var ids = $('#grid').yiiGridView('getSelectedRows');

            console.log(ids);
            $.post( 'delete',{data: ids}, function( data ) {
               });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some Proforma Invoice to delete!");
    }
   
})


var isLoading = false;
$('.attachments').click(function(){
     $("#dinamic").empty();
     isLoading = true;
     var id = $(this).attr('value');
     $.get('findattachments',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           if(data.length==0)
           {
               $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
           }
           for (var i = 0; i < data.length; i++){
                $('#dinamic').append("<tr><td  value='" + data[i].id + "'><a href='<?=Url::base();?>/users/proforma-invoice/download?id="+ data[i].id +"'>"+ data[i].document_name +"</a></td><tr>");
               

                  }
         isLoading = false;        

     });
})
$('#w1').hide();
$('#advance-search').click(function(){
    $('#w1').toggle();
})

$('.deleteproforma').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})
$('input[name="ProformaInvoiceSearch[date]"]').attr('type','date');
$('input[name="ProformaInvoiceSearch[date]"]').attr('style','width:150px');


$('.customer').select2({
        ajax: { 
        url: "customer",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            
            $('#customersearch').trigger('change');
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
});
</script>   
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>    
