<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Vendor;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Product;
use backend\modules\users\models\PurchasePayment;
use backend\modules\master\models\PurchaseOrder;
use backend\modules\master\models\PurchaseTemplates;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\GenericTemplate;

use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();

$settingtypes = GenericTemplate::find()->where(['template_for'=>'Expense'])->all();
$billsettinglist=ArrayHelper::map($settingtypes, 'gt_id', 'template_name');
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\PurchaseBillSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Purchase Bills';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.bigdrop {
    width: 600px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
.btn-danger.disabled, .btn-danger:disabled {
    color: #fff;
    background-color: red;
    border-color: red;
}   
</style>
<?php if (Yii::$app->session->hasFlash('success')): ?>
                    <div class="alert alert-success alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('success') ?>
                    </div>
                    <?php endif; ?>
                    <?php if (Yii::$app->session->hasFlash('error')): ?>
                    <div class="alert alert-danger alert-dismissable">
                         <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
                         <?= Yii::$app->session->getFlash('error') ?>
                    </div>
<?php endif; ?>
<div class="app-main__inner">
				<div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Bill</div>
                                                            </div>
															<div class="widget-content-right">
                                                            <a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Bill</a>



                                                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/create'])->one()!=''){?>
                                                               <a href="<?=Url::base()?>/users/purchase-bill/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Bill</a>&nbsp;
                                                               <?php }else {?>

                                                               <?php } ?>
                                                            
                                                           
                                                           
                          
                                                               <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-creditote" role="button" aria-expanded="false" aria-controls="search-creditote">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>

                                                               <a  class="search_field_buttons"  href="<?=Url::base().'/users/purchase-bill/index'?>" role="button" aria-expanded="false" aria-controls="search-look" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                                                          
															<!-- <a href="purchase-bill-add.html" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Bill</a>
                                                                <a class="btn btn-rounded dj-adv-search" data-toggle="collapse" href="#search-creditnote" role="button" aria-expanded="false" aria-controls="search-creditnote">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a> -->
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card collapse" id="search-creditnote">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                        <div class="form-row">
										
										<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from_date')->textInput(['type'=>'date','maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to_date')->textInput(['type'=>'date','maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Vendor/Sender</label>




                                                    <?php if($model->vendor!=''){?>

                                                    <?php $customer=Vendor::find()->where(['id'=>$model->vendor])->one()?>
                                                    <?=$form->field($model, 'vendor')->dropDownList([$model->vendor=>$customer->business_name], ['options' => [$model->vendor => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "findvendor form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?=$form->field($model, 'vendor')->dropDownList([], ['prompt' => '--Select--', 'class' => "findvendor form-control", 'maxlength' => true])->label(false)?>           
                                                   <?php } ?>


                                                </div>
												
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Setting Type</label>
                                                    <?=$form->field($model, 'setting')->dropDownList($billsettinglist, ['prompt' => '--Select--', 'class' => "form-control selectbilltype", 'maxlength' => true])->label(false)?>

                                                </div>
												
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Amount</label>
                                                    <?= $form->field($model, 'amount')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Product</label>




                                                    <?php if($model->product!=''){?>

                                                    <?php $product=Product::find()->where(['id'=>$model->product])->one()?>
                                                   <?=$form->field($model, 'product')->dropDownList([$model->product=>$product->product_name], ['options' => [$model->product => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "product form-control", 'maxlength' => true])->label(false)?>

                                                   <?php }else {?>
                                                              
                                                    <?=$form->field($model, 'product')->dropDownList([], ['prompt' => '--Select--', 'class' => "product form-control", 'maxlength' => true])->label(false)?>             
                                                   <?php } ?>


                                                </div>
												
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Transaction Type</label>
                                                    <?=$form->field($model, 'transaction')->dropDownList(['1'=>'Accounting Transaction','2'=>'Non-accounting Transaction','3'=>'Recuring Bill'], ['prompt' => '--All--', 'class' => " form-control", 'maxlength' => true])->label(false)?>

                                                     <!-- <select class="multiselect-dropdown form-control">
														<option value="3" selected="selected">--All--</option>
														<option value="1">Accounting Transaction</option>
														<option value="0">Non-accounting Transaction</option>
														<option value="2">Recuring Bill</option>
                                                    </select> -->
                                                </div>
												
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Account</label>
                                                    <?=$form->field($model, 'account')->dropDownList(['1'=>'Expense'], ['prompt' => '--Select an Account--', 'class' => " form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Supplier Bill# </label>
                                                    <?= $form->field($model, 'supplier_bill')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>

                                                   <!-- <input name="amount" id="amount" type="text" class="form-control" placeholder="Vendor Bill"> -->
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">PO NO#</label>
                                                    <?= $form->field($model, 'po')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>

                                                   <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Description</label>
                                                    <?= $form->field($model, 'description')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>

                                                   <!-- <input name="amount" id="amount" type="text" class="form-control"> -->
                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Shipment</label>
                                                    <?=$form->field($model, 'shipment')->dropDownList(['1'=>'RECEIVED','2'=>'PARTIALLY RECEIVED','3'=>'NOT RECEIVED'], ['prompt' => '--Select an Account--', 'class' => " form-control", 'maxlength' => true])->label(false)?>

                                                </div>
                                            </div>
											<div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="notes">GRN No</label>
                                                    <?= $form->field($model, 'grn')->textInput(['maxlength' => true,'class'=>'form-control'])->label(false) ?>
                                                </div>
                                            </div>
											<div class="col-md-9 dj-btn-align" style="padding-top: 5px">
                                            <button class="btn btn-info btn-rounded dj-search" style="padding: 9px 21px"><i class="fa fa-search"></i> Search</button>

											</div>
                                        </div>
                                        <?php ActiveForm::end(); ?> 
                                    
                                </div>
                        </div>
						  <div class="main-card mb-3 card">
                        <div class="card-body">
						<div class="row">
						<div class="col-md-6">

                        <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/delete'])->one()!=''){?>
                       <button id="delete" class="mb-2 mr-2 btn-icon btn btn-danger dj-ap-btn"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                       <?php }else {?>

                       <?php } ?>    
						
                        
							</div>
							<div class="col-md-6">
						<div class="djsec-text-right dj-print-sec">

                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/excel-export'])->one()!=''){?>
                           	  <?php if(Yii::$app->request->getQueryParams()){?>
                                        <a href="<?=Url::current()?>&totalexcel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Details Excel</button></a>
                                       <a href="<?=Url::current()?>&excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>
                                        
                                    <?php } else{ ?>
                                        <a href="<?=Url::current()?>?totalexcel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Details Excel</button></a>
                                         <a href="<?=Url::current()?>?excel=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o" aria-hidden="true"></i>Excel</button></a>

                                    <?php } ?>
                           <?php }else {?>

                           <?php } ?>


                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/purchasebill-template'])->one()!=''){?>
                           <?php if(Yii::$app->request->getQueryParams()){?>
                                <a href="<?=Url::current()?>&print=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Print</button></a>         
                            <?php } else{ ?>
                                <a href="<?=Url::current()?>?print=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Print</button></a>
                            <?php } ?>
                           <?php }else {?>

                           <?php } ?>
							
                                     </div>
							 </div>
							 </div>
                           
                                    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        // 'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            ['class' => 'yii\grid\CheckboxColumn'],
            [
                'label'=>'Bill #',
               'attribute' => 'bill_no',
               'value' => function ($data) {
                return $data->full_bill_name;
               }
            ],
            [
                'label'=>'Vendor / Category Bill No #',
               'attribute' => 'vendor_bill_no',
               'value' => function ($data) {
                return $data->vendor_bill_no;
               }
            ],
            [
                'label'=>'Vendor / Category',
                'contentOptions'=>['style'=>'font-weight:bold'],
               'attribute' => 'vendor_id',
               'value' => function ($data) {
                $val=Vendor::find()->where(['id'=>$data->vendor_id])->one();
                if($val)
                {
                    return $val->business_name;
                }
                else{
                    return '';
                }
                
               }
            ],
            // 'date:date',
            [
                'header'=> 'Date',
                'value'=> function($data){
                    return date(("\ F j  Y"), strtotime($data->date));
                } 
            ],
            
            [
                'label'=>'Total',
               'attribute' => 'total',
               'contentOptions'=>[ 'style'=>'text-align:right'],

               'value' => function ($data) {
                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$data->total);
                return $num; 
                
               }
            ],
            [
                'label'=>'Paid',
                'contentOptions'=>[ 'style'=>'text-align:right'],

               'value' => function ($data) {
               $payment = PurchasePayment::find()->where(['against_bill'=>$data->id])->all();
                $total = 0;
                foreach ($payment as $key => $value) {
                      $total = $total + $value->amount;
                }
                $total = $data->total-($data->pending_amount);  
                $amount = number_format((float)$total, 2, '.', '');
                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$amount);
                return $num;  
                // return number_format($total,2);
               }
            ],
            [
                'contentOptions'=>[ 'style'=>'text-align:right'],

                'label'=>'Pending',
               'value' => function ($data) {
               // $payment = PurchasePayment::find()->where(['against_bill'=>$data->id])->all();
               //  $total = 0;
               //  foreach ($payment as $key => $value) {
               //        $total = $total + $value->amount;
               //  }
                $total = $data->pending_amount;
                 $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,",$total);
                return $num;  
                
                
                // $total = $data->pending_amount-$data->tds_amount;

                // return number_format($total,2);
               }
            ],
            [
                'label'=>'Status',
                'format'=>'raw',
               'value' => function ($data) {
                   $payment = PurchasePayment::find()->where(['against_bill'=>$data->id])->all();
                    $total = 0;
                    foreach ($payment as $key => $value) {
                          $total = $total + $value->amount;
                    }
                //    if($total>=$data->total)
                if(($data->pending_amount)==0)
                   {
                    return '<span class="label-paid">PAID</span>';
                }
                //    else if($total<$data->total && $total!=0)
                   else if(($data->total-($data->pending_amount))>0)
                   {
                    return '<span class="label-partial">PARTIAL</span>';
                }
                //    else if($total==0)
                   else if($data->total==($data->pending_amount))
                   {
                    return '<span class="label-draft">PENDING</span>';
                }
               }
            ],
            [
                'label'=>'Shipment',
                'format'=>'raw',
               'value' => function ($data) {
                $po = PurchaseOrder::find()->where(['id'=>$data->purchase_order_id])->one();
                if($po)
                {
                    if($po->gr_status==0)
                    {
                        return '<span class="label-draft">NOT RECEIVED</span>';
                    }
                    else
                    {
                        return '<span class="label-paid">RECEIVED</span>';
                    }
                }
                else
                {
                    return '<span class="label-draft">NOT RECEIVED</span>';
                }
               
               }
                
            ],
            [
                'label' => 'Action',
                'contentOptions'=>['style'=>'width:35px'],
                'headerOptions' => ['style' => 'color:#495057'],
                'format'=>'raw',
                'value' => function ($data) use ($assign) {

                    $topstring = '<div class="d-inline-block dropdown">
                        <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                        <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                            <ul class="nav flex-column">';
                    $downstring =  '</ul></div></div>';

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/view'])->one()!='')
                    {
                        $viewstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-bill/view?id='.$data->id.' data-method=post>
                           <i class="fa fa-eye"></i>
                            <span class="dj-icon-gap">  View</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $viewstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/purchasebill-template'])->one()!='')
                    {
                        $printstring = '

                         <li class="nav-item">
                                                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/users/purchase-bill/printall?id='.$data->id.' title="Print Bill" data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Print Bill</span>
                                                                                    </a>
                                                                                </li>



                                                                                 
                               </li>
                                <li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/purchase-bill/purchasebill-template?id='.$data->id.'>
                                <i class="fa fa-file-pdf-o"></i>
                                <span class="dj-icon-gap"> PDF Bill</span>
                            </a>
                        </li>';
                    }
                    else
                    {
                        $printstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/update'])->one()!='')
                    {
                        $editstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-bill/update?id='.$data->id.'>
                            <i class="fa fa-pencil-square"></i>
                            <span class="dj-icon-gap"> Edit</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $editstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/delete'])->one()!='')
                    {
                        $deletestring = '<li class="nav-item">
                        <a class="nav-link deleteind" href='.Url::base().'/users/purchase-bill/delete?id='.$data->id.' data-method=post>
                           <i class="fa fa-trash"></i>
                            <span class="dj-icon-gap">  Delete</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $deletestring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/download-attachment'])->one()!='')
                    {
                        $attachmentstring = '<li class="nav-item">
                        <a class="nav-link" href='.Url::base().'/users/purchase-bill/download-attachment?id='.$data->id.'>
                            <i class="fa fa-file"></i>
                            <span class="dj-icon-gap"> Download Attachment</span>
                        </a>
                    </li>';
                    }
                    else
                    {
                        $attachmentstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-payment/create'])->one()!='')
                    {
                        $paymentstring = '<li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/purchase-payment/create?id='.$data->id.'&from=from-bill>
                                <i class="fa fa-plus"></i>
                                <span class="dj-icon-gap"> Add Payment</span>
                            </a>
                        </li>';
                    }
                    else
                    {
                        $paymentstring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/create'])->one()!='')
                    {
                        $duplicatestring = '<li class="nav-item">
                            <a class="nav-link" href='.Url::base().'/users/purchase-bill/create?id='.$data->id.'&from=bill>
                                <i class="fa fa-files-o"></i>
                                <span class="dj-icon-gap">Duplicate Bill</span>
                            </a>
                        </li>';
                    }
                    else
                    {
                        $duplicatestring = '';
                    }

                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/purchase-bill/findbillalldetails'])->one()!='')
                    {
                        $whatsappstring = '<li class="nav-item">
                                                <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                                    <i class="fa fa-whatsapp"></i>
                                                    <span class="dj-icon-gap"> Whatsapp Bill</span>
                                                </a>
                                            </li>';
                    }
                    else
                    {
                        $whatsappstring = '';
                    }

                    return $topstring.''.$viewstring.''.$printstring.''.$editstring.''.$deletestring.''.$attachmentstring.''.$paymentstring.''.$duplicatestring.''.$whatsappstring.''.$downstring;
                },
            ],
            // 'id',
            // 'setting_type',
            // 'vendor_id',
            // 'vendor_bill_no:ntext',
            // 'bill_date',
            //'sender_gst_id:ntext',
            //'notes:ntext',
            //'bill_type',
            //'supply_type',
            //'supply_attracts',
            //'is_ineligible_itc',
            //'point_of_supply',
            //'pricelist',
            //'prefix',
            //'bill_no:ntext',
            //'suffix',
            //'date',
            //'due_date',
            //'bill_notes:ntext',
            //'terms_of_payment',
            //'product_code:ntext',
            //'subtotal',
            //'total',
            //'tcs',
            //'round_off',
            //'payment',
            //'set_reminder',
            //'show_to_store_keeper',
            //'order_type',
            //'terms:ntext',
            //'created_at',
            //'updated_at',

            // ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
                        </div>
                    </div>
                </div>



<div class="modal fade" id="whatapp">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Whatsapp Message</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mobile no. </label>   
                 <div class="col-md-12">
                      <!-- <div class="position-relative form-group"> -->
                         <!-- <label for="customer" class="">Reason </label>  -->
                       
                        <div class="col-md-3" style="float: left;" > <?= $form->field($model, 'c_code')->textInput(['maxlength' => true,'class' => "form-control c_code",'placeholder'=>'Country Code'])->label(false) ?></div> 
                          <div class="col-md-8" style="float: right;" > <?= $form->field($model, 'c_mobile')->textInput(['maxlength' => true,'placeholder'=>'Mobile No.','class' => "form-control c_mobile"])->label(false) ?></div>

                          <?= $form->field($model, 'text_send')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control send_text"])->label(false) ?>
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id",])->label(false) ?> 
                       <!-- </div> -->
                                                
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::Button('<i class="fa fa-check-square-o" aria-hidden="true"></i> Save', ['class' => 'btn dj-blue-btn submit-btn sendwhatapp','target'=>"_blank"]) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>





<?php ob_start();?>
 <script type="text/javascript">
$(function() {

$('.selectbilltype').select2();

 $('.sendwhatapp').click(function()  {  
    var country_code = $('.c_code').val();
    var mobile = $('.c_mobile').val();
    var mobile_no = country_code.concat(mobile);
    var g_text = $('.send_text').val();
    var url= "https://wa.me/"+mobile_no+"/?text="+g_text;
    window.location.href = url; 
 })

 $('.senddetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     $('.cancel_id').val(id);
     jQuery.ajaxSetup({async:false});
     $.get('findbillalldetails',{id:id},function(data)
     {
       var data =$.parseJSON(data);
       $('.c_code').val('91');
       $('.reason').val('');
       jQuery.ajaxSetup({async:false});
       $.get('create-url',{id:id},function(st)
       {
        var st =$.parseJSON(st);
        $('.send_text').text('We have confirmed your Bill '+(data.id)+' has been raised for Rs '+data.total+'. Thank you! For Download Click this link '+st); 
       })
     }); 
 })


    $('.product').select2({
        ajax: { 
        url: "../leads-quotes/productdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });  
    $('.customer').select2({
        ajax: { 
        url: "../credit-note/vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });
// $('#purchasebill-from_date').attr('type','date');
// $('#purchasebill-to_date').attr('type','date');
$('#delete').click(function(){
var ids = $('#w1').yiiGridView('getSelectedRows');
if(ids.length)
var confirm = window.confirm("Are you sure want to delete the selected item!");
else
alert('Please select some item to delete')
if (confirm == true) {
$.post( 'delete',{data: ids}, function( data ) {
   });
}else{
    return false;
}
})
$('.deleteind').click(function(){
var confirm = window.confirm("Are you sure want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})
$('#search-creditnote').hide();
$('#advance-search').click(function(){
    $('#search-creditnote').toggle();
})
$('.product').select2({
        ajax: { 
        url: "../leads-quotes/productdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
$('.findvendor').select2({
        ajax: { 
        url: "../credit-note/vendordetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };         
        },
        cache: true
        }
    });

$('.properprint').click(function(e){
 e.preventDefault();
 canelUrl = $(this).attr("value");
 window.open($(this).attr("value"), "Mohapatra Scientific Pvt Ltd - "+$(this).attr("title"), "width=700,height=700,scrollbars=yes");
});

$(".link").click(function (e) {
    alert();
          e.preventDefault();
          window.location.href = "printall?id=18";
      });

$('input[name="PurchaseBillSearch[date]"]').attr('type','date');
});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
