<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Customer;
use backend\modules\users\models\ReceiptDocuments;
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Receipts Details';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
table, th, td {
  border: 1px solid black !important;
  border-collapse: collapse !important;

}
th, td {
  padding: 5px !important;
  text-align: left !important; 

}
</style>
    <?php 

     // echo $this->render('_search', ['model' => $searchModel]);
      ?>
      <h1 style="text-align:center">Receipts Details</h1>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],
            'setting_type',
            'payment_type',
            'receipt_no',
            'prefix',
            'suffix',
            'receipt_id',
            'receipt_date',
            'invoice_no',
            'cheque_no',
            'cheque_date',
            'payment_mode',
            'bank_name',
            'amount',
            'tds_amount',
            'total_amount',
            [
                'label' => 'Customer',
                'attribute' => 'customer_name',
                'value' => function ($data) {
                  $customer=Customer::find()->where(['id'=>$data->customer_name])->one();
                    return $customer?$customer->business_name:'';
            },
            ],
            [
                'label' => 'Documents',
                'format'    => 'raw',
                // 'attribute' => 'customer_name',
                'value' => function ($data) {
                    $user= ReceiptDocuments::find()->select(['document_name'])->where(['receipt_id' =>$data['id']])->asArray()->column();
                    $documents = implode(",", $user);
                    return $documents;

                    
            },
            ],
            'notes:ntext',
            'created_at',
            'updated_at',
        ],
    ]); ?>


</div>
</div>
</div>
