<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Customer;
use backend\modules\master\models\CustomerType;
use backend\modules\master\models\AccountingLedger;
use backend\modules\users\models\DirectReceipt;
use backend\modules\master\models\SalesTemplates;
use backend\modules\master\models\GenericTemplate;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\ReceiptDetailsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Receipt Details';
$this->params['breadcrumbs'][] = $this->title;

$settingtypes = GenericTemplate::find()->where(['template_for'=>'Receipt'])->all();
$receiptsettinglist=ArrayHelper::map($settingtypes, 'gt_id', 'template_name');
?>
<style>
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
    <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>
                <div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Receipt</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                            <a href="#" class="dj-danger-btn"><i class="fa fa-download"></i> Import Receipt</a>

                                                            <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/create'])->one()!=''){?>
                                                              <a href="create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Receipt</a>
                                                               <?php }else {?>

                                                               <?php } ?>
                                                                
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                             <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                           <div class="row dj-adv-search-row">
                           <div class="col-md-2">
                               <div class="position-relative form-group">
                                 <?= $form->field($model, 'receipt_prifix')->textInput(['maxlength' => true,'class'=>"form-control floating","placeholder"=>"Prefix"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-2">
                               <div class="position-relative form-group">
                                 <?= $form->field($model, 'r_number')->textInput(['maxlength' => true,'class'=>"form-control floating","placeholder"=>"Receipt No"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-2">
                               <div class="position-relative form-group">
                                 <?= $form->field($model, 'receipt_suffix')->textInput(['maxlength' => true,'class'=>"form-control floating","placeholder"=>"Suffix"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-2">
                                <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'search_field_buttons']) ?>
                            </div>
                            <div class="col-md-3">
                            <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-1">
                            <a  class="search_field_buttons"  href="<?=Url::base().'/users/receipt-details/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'> <i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>

                           </div>
                           <?php ActiveForm::end(); ?> 

                                                
                                    <div class="dj-sale-form collapse" id="search-look">

                                            <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                    <form>
                                        <div class="form-row">
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Customer</label>
                                                    

                                                    <?php if($model->customer!=''){?>

                                                    <?php $customer=Customer::find()->where(['id'=>$model->customer])->one()?>
                                                   <?=$form->field($model, 'customer')->dropDownList([$model->customer=>$customer->business_name], ['options' => [$model->customer => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "customer form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?= $form->field($model, 'customer') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control customer",])->label(false)?>            
                                                   <?php } ?>
                                                </div>
                                                
                                            </div>
                                        <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                  <?= $form->field($model, 'from_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                  <?= $form->field($model, 'to_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Customer Type</label>
                                                     <?= $form->field($model, 'type_of_customer') ->dropDownList(ArrayHelper::map(CustomerType::find()->select(['customer_type','id'])
                                                        ->orderBy('customer_type')
                                                        ->asArray ()
                                                        ->all (),'customer_type','customer_type'),['prompt'=>'--Select--','class' => "select_class form-control ",])->label(false)?>
                                                </div>
                                                
                                            </div>
                                            
                                           
                                               <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Bank</label>
                                                    <?= $form->field($model, 'bank')->dropDownList($banks_name,['prompt'=>'--Select--','class'=>"select_class form-control",'maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Note</label>
                                                   <?= $form->field($model, 'receipt_note')->textInput(['maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Setting Type</label>
                                                   <?= $form->field($model, 'setting')->dropDownList($receiptsettinglist,['prompt'=>'--Select--','class'=>'select_class form-control'])->label(false) ?>
                                                </div>
                                            </div>
                                           
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Payment Type</label>
                                                   <?= $form->field($model, 'type_of_payment')->dropDownList($payment_types,['prompt'=>'--Select--','class'=>"select_class form-control",'maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount From</label>
                                                  <?= $form->field($model, 'amount_from')->textInput(['maxlength' => true,'type'=>'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Total Amount To</label>
                                                    <?= $form->field($model, 'amount_upto')->textInput(['maxlength' => true,'type'=>'number','min'=>0,'step'=>.01,'placeholder'=>'0.00'])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">Cheque No.</label>
                                                   <?= $form->field($model, 'cheque_number')->textInput(['maxlength' => true])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4 dj-btn-align" style="padding-top: 5px">
                                             <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>


                                            </div>

                                        </div>
                                         

                                      </form>
                                       <?php ActiveForm::end(); ?>
                                     
                                    </div>
                                </div>
                        </div>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                        <div class="row">

                            <div class="col-sm-6">
                                <div class="djsec-text-left dj-print-sec">

                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/delete'])->one()!=''){?>
                                  <button id='bulkdelete' class='mb-2 mr-2 btn-icon btn btn-danger '><i class="fa fa-trash"></i> Delete</button>   
                                   <?php }else {?>

                                   <?php } ?>
                                           
                               </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="djsec-text-right dj-print-sec">


                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/receipt-pdf'])->one()!=''){?>
                                 <a href="<?=Url::base();?>/users/receipt-details/receipt-pdf?for=all" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-pdf-o"></i> Pdf</button></a>
                                   <?php }else {?>

                                   <?php } ?>

                                   <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/excel-export'])->one()!=''){?>
                                      <a href="<?=Url::base();?>/users/receipt-details/excel-export?detail=true" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details Excel</button></a>
                                      <a href="<?=Url::base();?>/users/receipt-details/excel-export" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                                   <?php }else {?>

                                   <?php } ?>
                                               
                                </div>
                            </div>
                        
                             </div>

                             <?= GridView::widget([
                                'dataProvider' => $dataProvider,
                                 "id" => "grid",
                                // 'filterModel' => $searchModel,
                                'columns' => [
                                   ['class' => 'yii\grid\CheckboxColumn'],
                                   ['class' => 'yii\grid\SerialColumn',
                                     'header'=>"Sl No.",
                                     'headerOptions' => ['style' => 'color:#495057'],
                                      'contentOptions'=>[ 'style'=>'width: 15px'],],
                                    'receipt_id',
                                    

                                    // 'receipt_date:date',
                                    [
                                        'label' => 'Receipt Date',
                                        'attribute' => 'receipt_date',
                                        'value' => function ($data) {
                                             return date('F j Y', strtotime($data->receipt_date));
                                            // $newDate = date("d-m-Y", strtotime($data['date']));
                                            // return $newDate;
                                    },
                                ],
                                [
                                    'label' => 'Amount',
                                    'contentOptions'=>[ 'style'=>'text-align:right'],
                                    'attribute' => 'amount',
                                    'value' => function ($data) {
                                      if($data->amount==NULL)
                                      {
                                        return '0.00';
                                      }
                                      else
                                      {
                                          $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data->amount);
                                            return $num; 
                                      }
                                      
                                       
                                },
                                ],
                                    'bank_name',
                                    [
                                        'label' => 'Customer/Account',
                                        'contentOptions'=>[ 'style'=>'font-weight: bold'],
                                        'attribute' => 'customer_name',
                                        'value' => function ($data) {
                                          $against_ledger =  array();
                                          $all_ledgers = array();
                                            $customer=Customer::find()->where(['id'=>$data->customer_name])->one();

                                            if($customer!='')
                                              {
                                                 return $customer->business_name;
                                              }
                                              else
                                              {
                                                  $against = DirectReceipt::find()->where(['receipt_id'=>$data->id])->all();
                                                  foreach ($against as $key => $value) {
                                                      $against_ledger[$key] = $value->ledger_id;
                                                  }
                                                  foreach ($against_ledger as $key => $val) {
                                                      $ledger = AccountingLedger::find()->where(['accounting_ledger_id'=>$val])->one();
                                                      if($ledger)
                                                        $all_ledgers[$key] = $ledger->ledger_id;
                                                  }
                                                  return implode(",",$all_ledgers);
                                                  
                                              }
                                    },
                                    ],

                                    'notes:ntext',

                                    // ['class' => 'yii\grid\ActionColumn',
                                    //  'header' => 'Action',],

                                    [
                                        'label' => 'Action',
                                        // 'attribute' => 'username',
                                        'headerOptions' => ['style' => 'color:#495057'],
                                        'format'=>'raw',
                                        'contentOptions'=>[ 'style'=>'width: 36px'],
                                        'value' => function ($data) use ($assign) {

                                            $topstring = '<div class="d-inline-block dropdown">
                                                                    <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                                    <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                                        <ul class="nav flex-column">';
                                            $downstring =  '</ul></div></div>';

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/view'])->one()!='')
                                            {
                                                $viewstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/users/receipt-details/view?id='.$data->id.' data-method=post>
                                                   <i class="fa fa-eye"></i>
                                                    <span class="dj-icon-gap">  View</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $viewstring = '';
                                            } 

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/update'])->one()!='')
                                            {
                                                $editstring = '<li class="nav-item">
                                                        <a class="nav-link" href='.Url::base().'/users/receipt-details/update?id='.$data->id.' data-method=post>
                                                           <i class="fa fa-pencil"></i>
                                                            <span class="dj-icon-gap">  Edit</span>
                                                        </a>
                                                    </li>';
                                            }
                                            else
                                            {
                                                $editstring = '';
                                            } 

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/delete'])->one()!='')
                                            {
                                                $deletestring = '<li class="nav-item">
                                                <a class="nav-link deletereceipt" href='.Url::base().'/users/receipt-details/delete?id='.$data->id.'  data-method=post>
                                                   <i class="fa fa-trash"></i>
                                                    <span class="dj-icon-gap">  Delete</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $deletestring = '';
                                            } 

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/receipt-pdf'])->one()!='')
                                            {
                                                $pdfstring = '<li class="nav-item">
                                                <a class="nav-link" href='.Url::base().'/users/receipt-details/receipt-pdf?id='.$data->id.'&from=pdf  >
                                                   <i class="fa fa-file-pdf-o"></i>
                                                    <span class="dj-icon-gap">  PDF Receipt</span>
                                                </a>
                                            </li>


                                            <li class="nav-item">
                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/users/receipt-details/receipt-pdf?id='.$data->id.' title="Print Receipt" data-method="post" >
                                                        <i class="fa fa-file-pdf-o"></i>
                                                        <span class="dj-icon-gap">Print Receipt</span>
                                                    </a>


                                                </li>';
                                            }
                                            else
                                            {
                                                $pdfstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/findreceiptalldetails'])->one()!='')
                                            {
                                                $sendstring = '<li class="nav-item ">
                                                <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                                    <i class="fa fa-envelope-o"></i>
                                                    <span class="dj-icon-gap">Mail Receipt</span>
                                                </a>
                                            </li>
                                            <li class="nav-item">
                                                <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                                    <i class="fa fa-whatsapp"></i>
                                                    <span class="dj-icon-gap"> Whatsapp Receipt</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $sendstring = '';
                                            }

                                            if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/findreceiptalldetails'])->one()!='')
                                            {
                                                $attachmentstring = '<li class="nav-item">
                                                <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#executive_type" value='.$data->id.'>
                                                   <i class="fa fa-paperclip"></i>
                                                    <span class="dj-icon-gap">  Download Attachments</span>
                                                </a>
                                            </li>';
                                            }
                                            else
                                            {
                                                $attachmentstring = '';
                                            }


                                            return $topstring.''.$viewstring.''.$editstring.''.$pdfstring.''.$deletestring.''.$sendstring.''.$attachmentstring.''.$downstring;


                                        },
                                    ],
                                ],
                            ]); ?>

                        </div>          
                    </div>
                </div>


    <div class="modal fade" id="whatapp">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Whatsapp Message</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mobile no. </label>   
                 <div class="col-md-12">
                      <!-- <div class="position-relative form-group"> -->
                         <!-- <label for="customer" class="">Reason </label>  -->
                       
                        <div class="col-md-3" style="float: left;" > <?= $form->field($model, 'c_code')->textInput(['maxlength' => true,'class' => "form-control c_code",'placeholder'=>'Country Code'])->label(false) ?></div> 
                          <div class="col-md-8" style="float: right;" > <?= $form->field($model, 'c_mobile')->textInput(['maxlength' => true,'placeholder'=>'Mobile No.','class' => "form-control c_mobile"])->label(false) ?></div>

                          <?= $form->field($model, 'text_send')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control send_text"])->label(false) ?>
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id",])->label(false) ?> 
                       <!-- </div> -->
                                                
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::Button('<i class="fa fa-check-square-o" aria-hidden="true"></i> Save', ['class' => 'btn dj-blue-btn submit-btn sendwhatapp','target'=>"_blank"]) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>

<div class="modal fade" id="email">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'post']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Email</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mail To </label>   
                 <div class="col-md-12">      
                          <?= $form->field($model, 'send_email')->textInput(['maxlength' => true,'class' => "form-control mail_send"])->label(false) ?>                   
                 </div> 

                 <label for="customer" class="">BCC </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'bcc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_bbc"])->label(false) ?>                                                
                </div>

                <label for="customer" class="">Mail Cc </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'cc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_cc"])->label(false) ?>                            
                </div>

                <label for="customer" class="">Subject </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'email_subject')->textInput(['maxlength' => true,'placeholder'=>'Enter Subject','class' => "form-control mail_subject"])->label(false) ?>
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id"])->label(false) ?> 
                       <!-- </div> -->
                                                
                </div>

                <label for="customer" class="">Message </label>   
                 <div class="col-md-12">

                          <?= $form->field($model, 'email_message')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control message"])->label(false) ?>
                           <?= $form->field($model, 'email_attachment')->fileInput(['class'=>"form-control",'type'=>'file'])->label(false) ?>
                       <!-- </div> -->
                                                
                </div>
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                   <?= Html::submitButton('<i class="fa fa-check-square-o" aria-hidden="true"></i> Send', ['class' => 'btn dj-blue-btn submit-btn']) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>
            


    <div class="modal fade" id="executive_type" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Receipt Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            
            <table id="dinamic">
                <tr><td>dd</td></tr>
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>
         
<?php ob_start();?>

<script type="text/javascript">
$(function() {

 $('.sendwhatapp').click(function()  {  
    var country_code = $('.c_code').val();
    var mobile = $('.c_mobile').val();
    var mobile_no = country_code.concat(mobile);
    var g_text = $('.send_text').val();
    var url= "https://wa.me/"+mobile_no+"/?text="+g_text;
    window.location.href = url; 
 })

 $('.senddetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     $('.cancel_id').val(id);
     jQuery.ajaxSetup({async:false});
     $.get('findreceiptalldetails',{id:id},function(data)
     {
       var data =$.parseJSON(data);
       $('.c_code').val('91');
       $('.reason').val('');
       jQuery.ajaxSetup({async:false});
       $.get('create-url',{id:id},function(st)
       {
        var st =$.parseJSON(st);
        $('.send_text').text('We have confirmed your Receipt '+(data.receipt_id)+' has been raised for Rs '+data.total_amount+'. Thank you! Find the attachemnt below:'); 
       })
     }); 
 })

 $('.sendemail').click(function(){
     var id = $(this).attr('value');
     // $('.reason').val('');
     $('.cancel_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('finduseralldetails',{id:id},function(data)
     {
       var data =$.parseJSON(data);
       $('.send_email').val('');
       $('.mail_bbc').val('');
       $.get('findreceiptalldetails',{id:id},function(st)
       {
        var st =$.parseJSON(st);
        var sub= 'Receipt # '+st.receipt_id+" Date:"+st.receipt_date;
        $('.mail_subject').val(sub);
        $.get('create-url',{id:id},function(link)
        {
            var link =$.parseJSON(link);
            // var obj = $('.message').html('Dear '+(data.business_name)+"\n We have confirmed your order for Invoice # MS/389/21-22. The Invoice has been raised for Rs"+ st.total_price+'\n Thank you! \n MOHASYN \n \n Download attached invoice at: \n'+link).wrap('<pre />'); 
        })
       })
     });
 })   
   
  
 $('.select_class').select2(); 
 $('.customer').select2({
        ajax: { 
        url: "customer",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            
            $('#customersearch').trigger('change');
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
 $('input[name="ReceiptDetailsSearch[receipt_date]"]').attr('type','date');
$('#bulkdelete').click(function(){
    var ids = $('#grid').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure you want to delete selected Receipt?");
        if(x)
        {
            var ids = $('#grid').yiiGridView('getSelectedRows');
            console.log(ids);
            $.post( 'delete',{data: ids}, function( data ) {
             });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some Receipt to delete!");
    }
   
})
var isLoading = false;
$('.attachments').click(function(){
     $("#dinamic").empty();
     isLoading = true;
     var id = $(this).attr('value');
     $.get('findattachments',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           if(data.length==0)
           {
               $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
           }
           for (var i = 0; i < data.length; i++){
                 // $('#dinamic').append("<tr><td  value='" + data[i].id + "'>" + data[i].document_name + "</td><tr>");

                $('#dinamic').append("<tr><td  value='" + data[i].id + "'><a href='<?=Url::base();?>/users/receipt-details/download?id="+ data[i].id +"'>"+ data[i].document_name +"</a></td><tr>");
               

                  }
         isLoading = false;        

     });
})
$('.deletereceipt').click(function(){
var confirm = window.confirm("Are u sure you want to delete the selected Receipt?");
if (confirm == true)
return true;
else
return false;
})
$('#w1').hide();
$('#advance-search').click(function(){
    $('#w1').toggle();
})

 $('.properprint').click(function(e){
    e.preventDefault();
    canelUrl = $(this).attr("value");
 
        window.open($(this).attr("value"), "Mohapatra Scientific Pvt Ltd - "+$(this).attr("title"), "width=700,height=700,scrollbars=yes");
    

});

});
</script>   
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>    
