<?php

use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use yii\widgets\ActiveForm;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use yii\helpers\ArrayHelper;
use backend\modules\master\models\Product;
use backend\modules\master\models\Vendor;
use backend\modules\users\models\Invoice;
use backend\modules\users\models\InvoiceProduct;
use backend\modules\users\models\SaleOrderProduct;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SaleOrderSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Sale Orders';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
.add_product .select2-selection__rendered {
    width: 220px !important;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
 <?php if (Yii::$app->session->hasFlash('success')) {?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?=Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php }?>
<?php if (Yii::$app->session->hasFlash('error')): ?>
<div class="alert alert-danger alert-dismissable" style="text-align:center">
     <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
     <?= Yii::$app->session->getFlash('error') ?>
</div>
<?php endif; ?>

<div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Sales Order</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/create'])->one()!=''){?>
                                                               <a href="<?=Url::base();?>/users/sale-order/create" class="dj-danger-btn"><i class="fa fa-plus-circle" aria-hidden="true"></i> Add Sales Order</a>
                                                               <?php }else {?>

                                                               <?php } ?>
                                                                
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                            <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                           <div class="row dj-adv-search-row">
                           <div class="col-md-6">
                               <div class="position-relative form-group">
                                <?= $form->field($model, 'sale_order')->textInput(['maxlength' => true,'class'=>"form-control floating",'placeholder'=>"SalesOrder No"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-2">
                                <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'search_field_buttons']) ?>
                            </div>
                            
                            <?php ActiveForm::end(); ?>
                           <div class="col-md-3">
                            <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-1">
                            <a  class="search_field_buttons"  href="<?=Url::base().'/users/sale-order/index'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title='Refresh Page'><i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
                           </div>

                           <!-- <div class="dj-sale-form collapse" id="search-look"> -->
                               <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                    <!-- <form> -->
                                        <div class="form-row">
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">From Date</label>
                                                     <?= $form->field($model, 'from_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">To Date</label>
                                                     <?= $form->field($model, 'to_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                          
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Executives</label>
                                                     <?= $form->field($model, 'executives_name') ->dropDownList(ArrayHelper::map(LeadExecutive::find()->select(['name','id'])
                                                        ->orderBy('name')
                                                        ->asArray ()
                                                        ->all (),'id','name'),['prompt'=>'Select Executive','class' => "executives_name form-control "])->label(false)?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group add_product">
                                                    <label for="product">Product</label>
                                                  
                                                <?php if($model->searchproduct!=''){?>

                                                   <?php $product=Product::find()->where(['id'=>$model->searchproduct])->one()?>
                                               <?=$form->field($model, 'searchproduct')->dropDownList([$model->searchproduct=>$product->product_name], ['options' => [$model->searchproduct => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "searchproduct form-control", 'maxlength' => true])->label(false)?>
                                               <?php }else {?>
                                                          
                                                <?=$form->field($model, 'searchproduct')->dropDownList([], ['prompt' => '--Select--', 'class' => "searchproduct form-control", 'maxlength' => true])->label(false)?>             
                                               <?php } ?>
                                                </div>
                                            </div>
                                        </div>
                                       <div class="form-row">
                                            
                                            
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="amount">Total Amount</label>
                                                     <?= $form->field($model, 'sale_total_amount')->textInput(['maxlength' => true,'type'=>'number','min'=>1,'onkeypress'=>"return (event.charCode == 8 || event.charCode == 0) ? null : event.charCode >= 48 && event.charCode <= 57"])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Delivery Date</label>
                                                     <?= $form->field($model, 'delv_date')->textInput(['maxlength' => true,'type'=>'date','class'=>'form-control'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                            
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="status">Status</label>
                                                    <?= $form->field($model, 'saleorder_status')->dropDownList(['Paid'=>'Paid','Pending'=>'Pending','Partially Paid'=>'Partially Paid'],['prompt'=>'--Select--','class'=>'saleorder_status form-control'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="date">Customer/Receiver</label>
                                                   <?php if($model->customer!=''){?>

                                                    <?php $customer=Customer::find()->where(['id'=>$model->customer])->one()?>
                                                   <?=$form->field($model, 'customer')->dropDownList([$model->customer=>$customer->business_name], ['options' => [$model->customer => ['Selected'=>'selected']],'prompt' => '--Select--', 'class' => "customer form-control", 'maxlength' => true])->label(false)?>
                                                   <?php }else {?>
                                                              
                                                    <?= $form->field($model, 'customer') ->dropDownList([],['prompt'=>'--Select--','class' => "form-control customer",])->label(false)?>            
                                                   <?php } ?>

                                                </div>
                                                
                                            </div>
                                            
                                            <div class="col-md-12 dj-btn-align" style="padding-top: 5px">
                                            <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                                            </div>
                                        </div>

                                        <!-- <div class="form-row">
                                             <div class="col-md-3">
                                                <div class="position-relative form-group">
                                                    <label for="area">Area</label>
                                                     <input name="area" id="area" type="text" class="form-control">
                                                </div>                                              
                                            </div>
                                        </div> -->
                                      <!-- </form> -->

                                      <?php ActiveForm::end(); ?> 
                                      <!-- </div>  -->
                                    
                                </div>
                        </div>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                        <div class="row">

                            <div class="col-sm-6">
                                <div class="djsec-text-left dj-print-sec">

                                   <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/delete'])->one()!=''){?>
                                   <button id='bulkdelete' class='mb-2 mr-2 btn-icon btn btn-danger '><i class="fa fa-trash"></i> Delete</button>  
                                   <?php }else {?>

                                   <?php } ?>

                                             
                               </div>
                            </div>
                            <div class="col-sm-6">
                                <div class="djsec-text-right dj-print-sec">
                                       
                                <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/excel-saleorder'])->one()!=''){?>
                                       	     <?php if(Yii::$app->request->getQueryParams()){?>
                                                <a href="<?=Url::current()?>&detail=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i> Details Excel</button></a>
                                                <a href="<?=Url::current()?>&index=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i> Excel</button></a>         
                                             <?php } else{ ?>
                                                <a href="<?=Url::current()?>?detail=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i>Details Excel</button></a>
                                                <a href="<?=Url::current()?>&index=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-file-excel-o"></i>Excel</button></a>
                                             <?php } ?>
                                       <?php }else {?>

                                       <?php } ?>


                                       <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/saleorder-pdf'])->one()!=''){?>
                                       	     <?php if(Yii::$app->request->getQueryParams()){?>
                                                <a href="<?=Url::current()?>&print=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Print</button></a>         
                                             <?php } else{ ?>
                                                <a href="<?=Url::current()?>?print=true" data-method="post" target='_blank'>  <button class="mb-2 mr-2 btn-icon btn  btn-info"><i class="fa fa-print"></i>Print</button></a>
                                             <?php } ?>
                                       <?php }else {?>

                                       <?php } ?>

                                        
                                       
                                        

                                        
                                </div>
                            </div>
                        
                             </div>
                                <?= GridView::widget([
                                'dataProvider' => $dataProvider,
                                // 'filterModel' => $searchModel,
                                "id" => "grid",
                                'columns' => [
                                    ['class' => '\yii\grid\CheckboxColumn',
                                       'checkboxOptions' => function ($model) {
                                            if ($model->dc_status == 0) {
                                                return ['value' => $model->id];
                                            }
                                            return ['disabled' => true, 'style' => ['display' => 'none']]; // OR ['disabled' => true]
                                        },
                                    ],
                                    ['class' => 'yii\grid\SerialColumn',
                                     
                                     'headerOptions' => ['style' => 'color:#495057'],
                                      'contentOptions'=>[ 'style'=>'width: 15px'],],

                                    'sale_order_id',
                                    [
                                        'label' => 'Customer',
                                        'contentOptions'=>['style'=>'font-weight:bold'],
                                        'attribute' => 'customer_id',
                                        'value' => function ($data) {
                                            $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                                            return $user['business_name'];
                                    },
                                    ],
                                   [
                                        'label' => 'Date',
                                        'headerOptions' => ['style' => 'width:10%'],
                                        'contentOptions' => ['style' => 'width:10%'],
                                        'attribute' => 'date',
                                        'value' => function ($data) {    
                                            return date('F j Y', strtotime($data->date));
                                    },
                                    ],
                                    [
                                        'label' => 'Total Amount',
                                        'contentOptions'=>[ 'style'=>'text-align:right'],
              
                                        'attribute' => 'total_amount',
                                        'value' => function ($data) {    
                                           // setlocale(LC_MONETARY, 'en_IN');
                                          $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data->total_amount);
                                          return $num;
                                    },
                                    ],
                                   

                                   // 'delivery_date:date',
                                    [
                                        'label' => 'Delivery Date',
                                        'headerOptions' => ['style' => 'width:10%'],
                                        'contentOptions' => ['style' => 'width:10%'],
                                        
                                        'attribute' => 'delivery_date',
                                        'value' => function ($data) {
                                            
                                            // return Yii::$app->formatter->format($data->delivery_date, 'date');
                                            if($data->delivery_date!='')
                                            {
                                                return date('F j Y', strtotime($data->delivery_date));
                                            }
                                            
                                    },
                                    ],
                                    [
                                        'label' => 'PO Details',
                                        'attribute'=>'po_no',
                                        'headerOptions' => ['style' => 'color:#495057;width:209px'],
                                        'format'=>'raw',
                                        'value' => function ($data) {
                                            return 'PO-Number:'.$data->po_no."</br>".'PO-Date:'.$data->po_date;
                                    },
                                    ],
                                    [
                                        'label' => 'Days Left',
                                        'headerOptions' => ['style' => 'color:#495057'],
                                        'value' => function ($data) {                                          
                                            $today= time();
                                            $date = strtotime($data->po_exp_date);
                                            $diff= $date-$today;
                                            $days = floor($diff/(60*60*24));
                                            if($days<0)
                                            {
                                                return '0'.' Days';
                                            }
                                            else
                                            {
                                                return ($days+1).' Days';
                                            }
                                    },
                                    ],
                                    'cancel_reason',
                                    [
                                        'label'=>'Cov. To',
                                        // 'attribute'=>'converted_to',
                                        'format'=>'raw',
                                       'value' => function($data)
                                        {
                                            if($data->paid_amount==0 && $data->converted_to=='SaleOrder')
                                                {
                                                    return '<span class="label-draft">SaleOrder</span>';
                                                }
                                                elseif (($data->paid_amount>0 && $data->paid_amount<$data->total_amount) || ($data->paid_amount==0 && $data->converted_to=='Invoice') ){
                                                   return '<span class="label-partial">Invoice</span>';
                                                }
                                                elseif ($data->paid_amount>0 && $data->paid_amount>=$data->total_amount) {
                                                    return '<span class="label-paid">Receipt</span>';
                                                }
                                                elseif($data->paid_amount==0 && $data->converted_to=='Proforma Invoice')
                                                {
                                                  return '<span class="label-partial">Proforma Invoice</span>';
                                                }
                                        }

                                    ],
                                    
                                    
                                    [
                                                            'label' => 'Action',
                                                            // 'attribute' => 'username',
                                                            'format'=>'raw',
                                                            'headerOptions' => ['style' => 'width:35px'],
                                                            'contentOptions'=>[ 'style'=>'width: 35px'],
                                                            'value' => function ($data) use ($assign) {

                                                                $topstring = '<div class="d-inline-block dropdown">
                                                                    <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                                    <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                                        <ul class="nav flex-column">';
                                                                    $downstring =  '</ul></div></div>';

                                                                if(($data->dc_status==0 ) && $data->is_cancel==0)
                                                                {

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/view'])->one()!='')
                                                                    {
                                                                        $viewstring = ' <li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/view?id='.$data->id.' data-method=post>
                                                                                       <i class="fa fa-eye"></i>
                                                                                        <span class="dj-icon-gap">  View</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $viewstring = '';
                                                                    }  

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/update'])->one()!='')
                                                                    {
                                                                        $editstring = ' <li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/update?id='.$data->id.'>
                                                                                        <i class="fa fa-pencil-square"></i>
                                                                                        <span class="dj-icon-gap"> Edit</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $editstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/delete'])->one()!='')
                                                                    {
                                                                        $deletestring = '<li class="nav-item">
                                                                                    <a class="nav-link confirmdeletesalesorder" href='.Url::base().'/users/sale-order/delete?id='.$data->id.'  data-method=post>
                                                                                       <i class="fa fa-trash"></i>
                                                                                        <span class="dj-icon-gap">  Delete</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $deletestring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/index'])->one()!='')
                                                                    {
                                                                        $cancelstring = '<li class="nav-item">
                                                                                    <a class="nav-link canceldetails" href=#  data-toggle="modal" data-target="#cancel" value='.$data->id.'>
                                                                                       <i class="fa fa-ban"></i>
                                                                                        <span class="dj-icon-gap">  Cancel</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $cancelstring = '';
                                                                    }


                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/saleorder-pdf'])->one()!='')
                                                                    {
                                                                        $pdfstring = '<li class="nav-item">
                                                                                    <a class="nav-link properpdf" href="javascript:void(0);" class="properpdf" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'&title='.$data->sale_order_id.'  title=Pdf-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Pdf Sale Order</span>
                                                                                    </a>
                                                                                </li>

                                                                                <li class="nav-item">
                                                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'  title=Print-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Print Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $pdfstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/excel-saleorder'])->one()!='')
                                                                    {
                                                                        $excelstring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/excel-saleorder?id='.$data->id.'  >
                                                                                       <i class="fa fa-file-excel-o"></i>
                                                                                        <span class="dj-icon-gap">  Excel Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $excelstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findattachments'])->one()!='')
                                                                    {
                                                                        $attachmentstring = '<li class="nav-item">
                                                                                <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                                                                    <i class="fa fa-paperclip"></i>
                                                                                    <span class="dj-icon-gap">Download Attachments</span>
                                                                                </a>
                                                                            </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $attachmentstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/create'])->one()!='')
                                                                    {
                                                                        $duplicatestring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/create?id='.$data->id.'&from=saleorder data-method=post  >
                                                                                       <i class="fa fa-files-o"></i>
                                                                                        <span class="dj-icon-gap">  Duplicate Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $duplicatestring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findsalealldetails'])->one()!='')
                                                                    {
                                                                        $whatsappstring = '<li class="nav-item">
                                                                                     <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                                                                        <i class="fa fa-whatsapp"></i>
                                                                                        <span class="dj-icon-gap"> Whatsapp Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $whatsappstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findsalealldetails'])->one()!='')
                                                                    {
                                                                        $mailstring = '<li class="nav-item ">
                                                                                  <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                                                                      <i class="fa fa-envelope-o"></i>
                                                                                      <span class="dj-icon-gap">Mail Sale Order</span>
                                                                                  </a>
                                                                              </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $mailstring = '';
                                                                    }

                                                                    return $topstring.''.$viewstring.''.$editstring.''.$deletestring.''.$cancelstring.''.$pdfstring.''.$excelstring.''.$attachmentstring.''.$duplicatestring.''.$whatsappstring.''.$mailstring;


                                                                    
                                                                }
                                                                else if($data->dc_status==1 && $data->is_cancel==0)
                                                                {
                                                                 if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/view'])->one()!='')
                                                                    {
                                                                        $viewstring = ' <li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/view?id='.$data->id.' data-method=post>
                                                                                       <i class="fa fa-eye"></i>
                                                                                        <span class="dj-icon-gap">  View</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $viewstring = '';
                                                                    }  

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/saleorder-pdf'])->one()!='')
                                                                    {
                                                                        $pdfstring = '<li class="nav-item">
                                                                                    <a class="nav-link properpdf" href="javascript:void(0);" class="properpdf" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'&title='.$data->sale_order_id.'  title=Pdf-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Pdf Sale Order</span>
                                                                                    </a>
                                                                                </li>

                                                                                <li class="nav-item">
                                                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'  title=Print-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Print Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $pdfstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/excel-saleorder'])->one()!='')
                                                                    {
                                                                        $excelstring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/excel-saleorder?id='.$data->id.'  >
                                                                                       <i class="fa fa-file-excel-o"></i>
                                                                                        <span class="dj-icon-gap">  Excel Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $excelstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findattachments'])->one()!='')
                                                                    {
                                                                        $attachmentstring = '<li class="nav-item">
                                                                                <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                                                                    <i class="fa fa-paperclip"></i>
                                                                                    <span class="dj-icon-gap">Download Attachments</span>
                                                                                </a>
                                                                            </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $attachmentstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/create'])->one()!='')
                                                                    {
                                                                        $duplicatestring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/create?id='.$data->id.'&from=saleorder data-method=post  >
                                                                                       <i class="fa fa-files-o"></i>
                                                                                        <span class="dj-icon-gap">  Duplicate Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $duplicatestring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/proforma-invoice/create'])->one()!='')
                                                                    {


                                                                        $count = 0;
                                                                        $check_invoices = Invoice::find()->where(['sale_order_id'=>$data->id])->all();
                                                                        foreach($check_invoices as $check){
                                                                            $find_product  = InvoiceProduct::find()->where(['invoice_id'=>$check->id])->all();
                                                                            foreach($find_product as $fd)
                                                                            {
                                                                                $count = $count + $fd->quantity;
                                                                            }
                                                                        }
                                                                        $count_sale =0;
                                                                        $check_sale_product = SaleOrderProduct::find()->where(['sale_order_no'=>$data->id])->all();
                                                                        foreach($check_sale_product as $spd)
                                                                        {
                                                                            $count_sale = $count_sale + $spd->quantity;
                                                                        }
                                                                       
                                                                        if($count>=$count_sale)
                                                                        {
                                                                            $proformastring = '';
                                                                        }
                                                                        else
                                                                        {   
                                                                                $proformastring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/proforma-invoice/create?id='.$data->id.'&from=saleorder data-method=post  >
                                                                                       <i class="fa fa-retweet"></i>
                                                                                        <span class="">  Convert To Proforma Invoice</span>
                                                                                    </a>
                                                                                </li>';
                                                                        } 
                                                                    }
                                                                    else
                                                                    {
                                                                        $proformastring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/invoice/create'])->one()!='')
                                                                    {
                                                                        $count = 0;
                                                                        $check_invoices = Invoice::find()->where(['sale_order_id'=>$data->id])->all();
                                                                        foreach($check_invoices as $check){
                                                                            $find_product  = InvoiceProduct::find()->where(['invoice_id'=>$check->id])->all();
                                                                            foreach($find_product as $fd)
                                                                            {
                                                                                $count = $count + $fd->quantity;
                                                                            }
                                                                        }
                                                                        $count_sale =0;
                                                                        $check_sale_product = SaleOrderProduct::find()->where(['sale_order_no'=>$data->id])->all();
                                                                        foreach($check_sale_product as $spd)
                                                                        {
                                                                            $count_sale = $count_sale + $spd->quantity;
                                                                        }
                                                                        if($count>=$count_sale) 
                                                                        {
                                                                            $invoicestring = '';
                                                                        }
                                                                        else
                                                                        {   
                                                                                $invoicestring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/invoice/create?id='.$data->id.'&from=saleorder data-method=post  >
                                                                                       <i class="fa fa-retweet"></i>
                                                                                        <span class="dj-icon-gap"> Convert To Invoice</span>
                                                                                    </a>
                                                                                </li>';
                                                                        }   

                                                                        
                                                                    }
                                                                    else
                                                                    {
                                                                        $invoicestring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findsalealldetails'])->one()!='')
                                                                    {
                                                                        $whatsappstring = '<li class="nav-item">
                                                                                     <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                                                                        <i class="fa fa-whatsapp"></i>
                                                                                        <span class="dj-icon-gap"> Whatsapp Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $whatsappstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findsalealldetails'])->one()!='')
                                                                    {
                                                                        $mailstring = '<li class="nav-item ">
                                                                                  <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                                                                      <i class="fa fa-envelope-o"></i>
                                                                                      <span class="dj-icon-gap">Mail Sale Order</span>
                                                                                  </a>
                                                                              </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $mailstring = '';
                                                                    }

                                                                    return $topstring.''.$viewstring.''.$pdfstring.''.$excelstring.''.$attachmentstring.''.$duplicatestring.''.$proformastring.''.$invoicestring.''.$whatsappstring.''.$mailstring;   
                                                                }
                                                                else if(($data->dc_status==2 || $data->dc_status==3) && $data->is_cancel==0)
                                                                {

                                                                 if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/view'])->one()!='')
                                                                    {
                                                                        $viewstring = ' <li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/view?id='.$data->id.' data-method=post>
                                                                                       <i class="fa fa-eye"></i>
                                                                                        <span class="dj-icon-gap">  View</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $viewstring = '';
                                                                    }  

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/saleorder-pdf'])->one()!='')
                                                                    {
                                                                       $pdfstring = '<li class="nav-item">
                                                                                    <a class="nav-link properpdf" href="javascript:void(0);" class="properpdf" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'&title='.$data->sale_order_id.'  title=Pdf-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Pdf Sale Order</span>
                                                                                    </a>
                                                                                </li>

                                                                                <li class="nav-item">
                                                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'  title=Print-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Print Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $pdfstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/excel-saleorder'])->one()!='')
                                                                    {
                                                                        $excelstring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/excel-saleorder?id='.$data->id.'  >
                                                                                       <i class="fa fa-file-excel-o"></i>
                                                                                        <span class="dj-icon-gap">  Excel Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $excelstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findattachments'])->one()!='')
                                                                    {
                                                                        $attachmentstring = '<li class="nav-item">
                                                                                <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                                                                    <i class="fa fa-paperclip"></i>
                                                                                    <span class="dj-icon-gap">Download Attachments</span>
                                                                                </a>
                                                                            </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $attachmentstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/create'])->one()!='')
                                                                    {
                                                                        $duplicatestring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/create?id='.$data->id.'&from=saleorder data-method=post  >
                                                                                       <i class="fa fa-files-o"></i>
                                                                                        <span class="dj-icon-gap">  Duplicate Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $duplicatestring = '';
                                                                    }

                                                                  
                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findsalealldetails'])->one()!='')
                                                                    {
                                                                        $whatsappstring = '<li class="nav-item">
                                                                                     <a class="nav-link senddetails" href=#  data-toggle="modal" data-target="#whatapp" value='.$data->id.'>
                                                                                        <i class="fa fa-whatsapp"></i>
                                                                                        <span class="dj-icon-gap"> Whatsapp Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $whatsappstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findsalealldetails'])->one()!='')
                                                                    {
                                                                        $mailstring = '<li class="nav-item ">
                                                                                  <a class="nav-link sendemail" href=# data-toggle="modal" data-target="#email" value='.$data->id.'>
                                                                                      <i class="fa fa-envelope-o"></i>
                                                                                      <span class="dj-icon-gap">Mail Sale Order</span>
                                                                                  </a>
                                                                              </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $mailstring = '';
                                                                    }

                                                                    return $topstring.''.$viewstring.''.$pdfstring.''.$excelstring.''.$attachmentstring.''.$duplicatestring.''.$whatsappstring.''.$mailstring; 
                                                                }
                                                                else
                                                                {


                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/view'])->one()!='')
                                                                    {
                                                                        $viewstring = ' <li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/view?id='.$data->id.' data-method=post>
                                                                                       <i class="fa fa-eye"></i>
                                                                                        <span class="dj-icon-gap">  View</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $viewstring = '';
                                                                    }  

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/delete'])->one()!='')
                                                                    {
                                                                        $deletestring = '<li class="nav-item">
                                                                                    <a class="nav-link confirmdeletesalesorder" href='.Url::base().'/users/sale-order/delete?id='.$data->id.'  data-method=post>
                                                                                       <i class="fa fa-trash"></i>
                                                                                        <span class="dj-icon-gap">  Delete</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $deletestring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/saleorder-pdf'])->one()!='')
                                                                    {
                                                                        $pdfstring = '<li class="nav-item">
                                                                                    <a class="nav-link properpdf" href="javascript:void(0);" class="properpdf" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'&title='.$data->sale_order_id.'  title=Pdf-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Pdf Sale Order</span>
                                                                                    </a>
                                                                                </li>

                                                                                <li class="nav-item">
                                                                                    <a class="nav-link properprint" href="javascript:void(0);" class="properprint" value= '.Url::base().'/users/sale-order/printall?id='.$data->id.'  title=Print-Saleorder data-method="post" >
                                                                                        <i class="fa fa-file-pdf-o"></i>
                                                                                        <span class="dj-icon-gap">Print Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $pdfstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/excel-saleorder'])->one()!='')
                                                                    {
                                                                        $excelstring = '<li class="nav-item">
                                                                                    <a class="nav-link" href='.Url::base().'/users/sale-order/excel-saleorder?id='.$data->id.'  >
                                                                                       <i class="fa fa-file-excel-o"></i>
                                                                                        <span class="dj-icon-gap">  Excel Sale Order</span>
                                                                                    </a>
                                                                                </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $excelstring = '';
                                                                    }

                                                                    if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/findattachments'])->one()!='')
                                                                    {
                                                                        $attachmentstring = '<li class="nav-item">
                                                                                <a class="nav-link attachments" href=#  data-toggle="modal" data-target="#document" value='.$data->id.'>
                                                                                    <i class="fa fa-paperclip"></i>
                                                                                    <span class="dj-icon-gap">Download Attachments</span>
                                                                                </a>
                                                                            </li>';
                                                                    }
                                                                    else
                                                                    {
                                                                        $attachmentstring = '';
                                                                    }

                                                                    return $topstring.''.$viewstring.''.$deletestring.''.$pdfstring.''.$excelstring.''.$attachmentstring; 

                                                                }

                                                                
                                                                
                                                            },
                                                        ],
                                ],
                            ]); ?>
                        </div>
                    </div>
                </div>

<div class="modal fade" id="cancel">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'get']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Add Reason Of Cancel</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <div class="col-md-12">
                      <div class="position-relative form-group">
                         <label for="customer" class="">Reason </label> 
                           <?= $form->field($model, 'cancel_reason')->textInput(['maxlength' => true,'class' => "form-control reason"])->label(false) ?> 
                            <?= $form->field($model, 'findid')->hiddenInput(['maxlength' => true,'class' => "form-control cancel_id"])->label(false) ?> 
                       </div>
                                                
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::submitButton('<i class="fa fa-check-square-o" aria-hidden="true"></i> Save', ['class' => 'btn dj-blue-btn submit-btn']) ?>
                    <a href="" class="btn dj-red-btn" data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>


<div class="modal fade" id="whatapp">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Whatsapp Message</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mobile no. </label>   
                 <div class="col-md-12">
                      <!-- <div class="position-relative form-group"> -->
                         <!-- <label for="customer" class="">Reason </label>  -->
                       
                        <div class="col-md-3" style="float: left;" > <?= $form->field($model, 'c_code')->textInput(['maxlength' => true,'class' => "form-control c_code",'placeholder'=>'Country Code'])->label(false) ?></div> 
                          <div class="col-md-9" style="float: right;" > <?= $form->field($model, 'c_mobile')->textInput(['maxlength' => true,'placeholder'=>'Mobile No.','class' => "form-control c_mobile"])->label(false) ?></div>

                          <?= $form->field($model, 'text_send')->textarea(['rows' => 4,'placeholder'=>'text','class' => "form-control send_text"])->label(false) ?> 
                       <!-- </div> -->
                                                
                    </div> 
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                    <?= Html::Button('<i class="fa fa-check-square-o" aria-hidden="true"></i> Send', ['class' => 'btn dj-blue-btn submit-btn sendwhatapp','target'=>"_blank"]) ?>

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
  </div>

  <div class="modal fade" id="email">
    <div class="modal-dialog modal-md">
        <?php $form = ActiveForm::begin(['method' => 'post']); ?>
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Send Email</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
              
              <form class="dj-sale-form">
                <div class="form-row">
                 <label for="customer" class="">Mail To </label>   
                 <div class="col-md-12">      
                          <?= $form->field($model, 'send_email')->textInput(['maxlength' => true,'class' => "form-control mail_send"])->label(false) ?>                   
                 </div> 

                 <label for="customer" class="">BCC </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'bcc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_bbc"])->label(false) ?>                                                
                </div>

                <label for="customer" class="">Mail Cc </label>   
                 <div class="col-md-12">
                        
                          <?= $form->field($model, 'cc_to_email')->textInput(['maxlength' => true,'class' => "form-control mail_cc"])->label(false) ?>                            
                </div>

                <label for="customer" class="">Subject </label>   
                 <div class="col-md-12">      
                          <?= $form->field($model, 'email_subject')->textInput(['maxlength' => true,'placeholder'=>'Enter Subject','class' => "form-control mail_subject"])->label(false) ?>
                            <?= $form->field($model, 'mail_id')->textInput(['maxlength' => true,'class' => "form-control mail_id"])->label(false) ?>                               
                </div>

                <label for="customer" class="">Message </label>   
                 <div class="col-md-12">

                          <?= $form->field($model, 'email_message')->textarea(['rows' => 2,'placeholder'=>'text','class' => "form-control message",'style' => 'white-space:pre;'])->label(false) ?>
                           <?= $form->field($model, 'email_attachment')->fileInput(['class'=>"form-control",'type'=>'file'])->label(false) ?>
                       <!-- </div> -->
                                                
                </div>
                    
                </div>
              </form>
            </div>
            <div class="modal-footer">
              <div class="col-md-12">                                       
                <div class="djsec-text-right">
                   <?= Html::submitButton('<i class="fa fa-check-square-o" aria-hidden="true"></i> Send', ['class' => 'btn dj-blue-btn submit-btn']) ?>

                    <!-- <a class="btn dj-blue-btn submit-btn" href=# ><i class="fa fa-plus-circle" aria-hidden="true"></i> Send</a> -->

                    <a href="" class="btn dj-red-btn " data-dismiss="modal" aria-label="Close" onclick="window.location.href=window.location.href"><i class="fa fa-ban" aria-hidden="true"></i> Close</a>
                  </div>
                </div>
            </div>
        </div>
        <?php ActiveForm::end(); ?>  
    </div>
</div>


<div class="modal fade" id="document" >
    <div class="modal-dialog modal-md"  >
        
        <div class="modal-content"  >
            <div class="modal-header">
                <h5 class="modal-title" id="exampleModalLongTitle">Sale Order Attachments</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
            
            <table id="dinamic">
               
            </table>
            </div>
            <div class="modal-footer">
              
            </div>
        </div>
    </div>
</div>
<?php ob_start();?>
 <script type="text/javascript">
     
$(function() {

    $('.sendwhatapp').click(function()  {  
    var country_code = $('.c_code').val();
    var mobile = $('.c_mobile').val();
    var mobile_no = country_code.concat(mobile);
    var g_text = $('.send_text').val();
    var url= "https://wa.me/"+mobile_no+"/?text="+g_text;
    window.location.href = url; 
 })

    $('.mail_id').hide();
    $('.senddetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('findsalealldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           $('.c_code').val('91');
           $('.reason').val('');
           jQuery.ajaxSetup({async:false});
           $.get('create-url',{id:id},function(st)
           {
                var st = $.parseJSON(st);
                $('.send_text').text('We have confirmed your SaleOrder '+(data.sale_order_id)+' has been raised for Rs '+data.total_amount+'. Thank you! For Download Click this link '+st); 
           })
           

     });
     
    })


    $('.sendemail').click(function(){
     var id = $(this).attr('value');
     // $('.reason').val('');
     $('.mail_id').val(id);
     // alert($('.cancel_id').val());
     jQuery.ajaxSetup({async:false});
     $.get('finduseralldetails',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           $('.mail_send').val(data.email);
           $('.mail_bbc').val('');
           
           
           // jQuery.ajaxSetup({async:false});
           $.get('findsalealldetails',{id:id},function(st)
           {
                var st =$.parseJSON(st);
                var sub= 'SaleOrder # '+st.sale_order_id+" Date:"+st.date;
                $('.mail_subject').val(sub);
                $.get('create-url',{id:id},function(link)
                {
                    var link =$.parseJSON(link);
                    var obj = $('.message').html('Dear '+(data.business_name)+"\n We have confirmed your order for SaleOrder "+sub+". The SaleOrder has been raised for Rs"+ st.total_amount+'\n Thank you! \n MOHASYN \n \n Find the  attached saleorder below: \n').wrap('<pre />'); 
                })
                // var obj = $("#example").text('this\n has\n newlines');
               
           })
           

     });
     
})




    $('.saleorder_status').select2();
    $('.customer').select2({
        ajax: { 
        url: "customerdetails",
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            
            $('#customersearch').trigger('change');
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    $('.searchproduct').select2({
        ajax: { 
        url: '<?php echo Url::toRoute('leads-quotes/productdetails'); ?>',
        type: "get",
        dataType: 'json',
        delay: 250,
        data: function (params) {
            return {
            searchTerm: params.term // search term
            };
        },
        processResults: function (response) {
           
            return {
                results: $.map(response, function (i,item) {
                    
                return {
                    text: i,
                    slug: "",
                    id: item
                }
            })
        };
                
           
        },
        cache: true
        }
    });
    $('.executives_name').select2();
$('#bulkdelete').click(function(){
    var ids = $('#grid').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure you want to delete selected SalesOrders?");
        if(x)
        {
            var ids = $('#grid').yiiGridView('getSelectedRows');
            console.log(ids);
            $.post( 'delete',{data: ids}, function( data ) {  
               });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some SalesOrder to delete!");
    }
   
})
$('.confirmdeletesalesorder').click(function(){
var confirm = window.confirm("Are u sure you want to delete the selected Saleorder?");
if (confirm == true)
return true;
else
return false;
})
$('#w1').hide();
$('#advance-search').click(function(){
    $('#w1').toggle();
})


$('.canceldetails').click(function(){
     var id = $(this).attr('value');
     $('.reason').val('');
     $('.cancel_id').val(id);
})

var isLoading = false;
$('.attachments').click(function(){
     $("#dinamic").empty();
     isLoading = true;
     var id = $(this).attr('value');
     $.get('findattachments',{id:id},function(data)
     {
           var data =$.parseJSON(data);
           if(data.length==0)
           {
               $('#dinamic').append("<tr><td  value=''>No Attachments Found</td><tr>");
           }
           for (var i = 0; i < data.length; i++){
                $('#dinamic').append("<tr><td  value='" + data[i].id + "'><a href='<?=Url::base();?>/users/sale-order/download?id="+ data[i].id +"'>"+ data[i].document_name +"</a></td><tr>");
               

                  }
         isLoading = false;        

     });
})

$('input[name="SaleOrderSearch[date]"]').attr('type','date');
$('input[name="SaleOrderSearch[date]"]').attr('style','width:75px');
$('input[name="SaleOrderSearch[delivery_date]"]').attr('type','date');
$('input[name="SaleOrderSearch[delivery_date]"]').attr('style','width:75px');


$('.properprint').click(function(e){
 e.preventDefault();
 canelUrl = $(this).attr("value");
 window.open($(this).attr("value"), "Mohapatra Scientific Pvt Ltd - "+$(this).attr("title"), "width=700,height=700,scrollbars=yes");
});
$('.properpdf').click(function(e){
 e.preventDefault();
 canelUrl = $(this).attr("value");
 window.open($(this).attr("value"), "Mohapatra Scientific Pvt Ltd - "+$(this).attr("title"), "width=700,height=700,scrollbars=yes");
});

});
</script>
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>
