<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\helpers\Url;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use backend\modules\users\models\SaleOrderDocument;
use backend\modules\master\models\Product;

use backend\modules\master\models\SalesTemplates;
use backend\modules\master\models\SettingTypes;
use backend\modules\master\models\GenericTemplate;

$saletemplate = SalesTemplates::find()->where(['template_name' => $model->setting_type])->one();
$template = GenericTemplate::find()->where(['gt_id' => $model->setting_type])->one();

$customer=Customer::find()->where(['id'=>$model->customer_id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\models\TicketsSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Sale Order Detail';
$this->params['breadcrumbs'][] = $this->title;
?>
<?php
function AmountInWords(float $amount)
{
   $amount_after_decimal = round($amount - ($num = floor($amount)), 2) * 100;
   // Check if there is any number after decimal
   $amt_hundred = null;
   $count_length = strlen($num);
   $x = 0;
   $string = array();
   $change_words = array(0 => '', 1 => 'One', 2 => 'Two',
     3 => 'Three', 4 => 'Four', 5 => 'Five', 6 => 'Six',
     7 => 'Seven', 8 => 'Eight', 9 => 'Nine',
     10 => 'Ten', 11 => 'Eleven', 12 => 'Twelve',
     13 => 'Thirteen', 14 => 'Fourteen', 15 => 'Fifteen',
     16 => 'Sixteen', 17 => 'Seventeen', 18 => 'Eighteen',
     19 => 'Nineteen', 20 => 'Twenty', 30 => 'Thirty',
     40 => 'Forty', 50 => 'Fifty', 60 => 'Sixty',
     70 => 'Seventy', 80 => 'Eighty', 90 => 'Ninety');
    $here_digits = array('', 'Hundred','Thousand','Lakh', 'Crore');
    while( $x < $count_length ) {
      $get_divider = ($x == 2) ? 10 : 100;
      $amount = floor($num % $get_divider);
      $num = floor($num / $get_divider);
      $x += $get_divider == 10 ? 1 : 2;
      if ($amount) {
       $add_plural = (($counter = count($string)) && $amount > 9) ? 's' : null;
       $amt_hundred = ($counter == 1 && $string[0]) ? ' and ' : null;
       $string [] = ($amount < 21) ? $change_words[$amount].' '. $here_digits[$counter]. $add_plural.' 
       '.$amt_hundred:$change_words[floor($amount / 10) * 10].' '.$change_words[$amount % 10]. ' 
       '.$here_digits[$counter].$add_plural.' '.$amt_hundred;
        }
   else $string[] = null;
   }
   $implode_to_Rupees = implode('', array_reverse($string));
   $get_paise = ($amount_after_decimal > 0) ? "And " . ($change_words[$amount_after_decimal / 10] . " 
   " . $change_words[$amount_after_decimal % 10]) . ' Paise' : '';
   return ($implode_to_Rupees ? $implode_to_Rupees . 'Rupees ' : '') . $get_paise;
}
?>  
 <style>
  body{
  font-family:Liberation Serif;
  color:#333;
  /* font-size:5px; */
  text-align:left;
  /*font-size:18px;*/
  margin:0;
  overflow-x: hidden;
}
* {
  box-sizing: border-box;
}
.container{
  margin:0 auto;
  /*margin-top:35px;*/
  /*padding:40px;*/
  height:auto;
  border-color: 1px solid black;
}

/*.main td{
border: none;
}*/
#main-table{  
    margin: 0 0 0px 0;
    /*padding: 10px;*/
    /* border: 1px solid black; */
    margin-bottom: 30px;
    border:1.4px solid black;
    /*border-radius: 27px;
    box-shadow: 0px 0px 12px 2px rgb(0 0 0 / 45%);*/
}
@media (min-width: 500px) and (max-width: 991px) {
  #main-table {
    /* padding-top: 30px; */
    width: 100%;
    flex:none;
  }
}
.table{

    margin:0 auto;
    background-color: white;
    width: 100%;
    border-spacing: 0;
    /*font-size: 20px;*/

}
td, #bottom { 
 vertical-align:bottom;
 color:#333;

}
.details
{
  /* width: 30%; */
  /*font-style: 20px;*/
  font-size: 10px;
  padding-top:0px;
}
.product
{
  font-size: 12px;
  /* padding-top:10px; */
}
.text-right{
  text-align: right;
}
th{
  background-color: #ccc;
  font-size:8px;
}
td{
  font-size:10px;
  padding-bottom:4px;
}
.heads
{
  text-align: center;
}
h4, p{
  margin:0px;
}
li{
  font-family:Arial, Helvetica, sans-serif;
}
</style>
<body> 
  <!-- <div class=" container " style="margin: 0 auto;"> -->
    <div class="table-responsive-md" id="main-table">
    <table style="text-align:center; width: 100%" >
        <tr >
            <td width="33.33%" style="text-align:left; font-size:12px;font-weight:bold;"><?= $template->company_name ?></td>
            <td width="33.33%" style="text-align:center;padding-left:50px;font-size:12px;font-weight:bold;"><p ><?= $template->template_name ?></p></td>
            <td width="33.33%" style="padding-left:185px;" ><img style="height:39px;" src=".../../theme/images/1569578921_Mohapatra_Logo.jpg" alt="company logo"></td>
        </tr>
    </table>    
    <table class=" table">        
    <tr>
      <td  class='details' style="padding-top: 0px;font-size:10px;width:25%;text-align:left;">
        <!-- <div class="row"> -->
          <div class="col-md-12">
          <?= $template->address ?>,<br /> <?= $template->city ?>,<?= $template->state ?> , Code: <?= $template->pin ?>,<br /> <?= $template->country ?> - <br /> Mobile no: <?= $template->mobile ?>, Phone no: <?= $template->phone_no ?>,<br /> GSTIN : <?= $template->gst_no ?>,<br /> Fax no: <?= $template->fax_no ?> : Trade License :-<?= $template->trade_licence ?>,<br /> Email: <?= $template->email ?>
          </div>
        <!-- </div> -->
      </td>
      <td class='details' style="padding-left:20px;idth:25%;text-align:left;">
        <!-- <div class="row"> -->
            <div class="col-md-12">
            <p>BILLING ADDRESS</p>
            <p style="font-size:12px;font-weight:bold;"><?=$customer->business_name?></p>
            <p>GST No: <?=$customer->gstin_no?></p>
            <p><?=$customer->adderss_line_1?>,<?=$customer->adderss_line_2?>,<?=$customer->adderss_line_3?>,<br><?=$customer->city?>,<?=$customer->state?>,<?=$customer->country?>-<?=$customer->pin_code?></p>
            <p> Mobile no:<?=$customer->mobile?></p>
            <p>Fax no:<?=$customer->fax?></p>
            <p>Email: <?=$customer->email?></p>
          </div>
          <!-- </div> -->
        </td>
      <td class='details' style="padding-left:20px;widht:25%;text-align:left;">
        <div class="row">
          <div class="col-md-12">
            <p>SHIPPING ADDRESS</p>
             <p style="font-size:12px;font-weight:bold"><?=$customer->business_name?></p>
             <p>Shipping to: <?=$customer->sipping_to_name?><p>
            <p>GST No: <?=$customer->gstin_no?></p>
            <p><?=$customer->shipping_address_1?>,<?=$customer->shipping_address_2?>,<?=$customer->shipping_address_3?>,<br><?=$customer->shipping_city?>,<?=$customer->shipping_state?>,<?=$customer->shipping_country?>-<?=$customer->shipping_postcode?></p>
            <p> Mobile no:<?=$customer->mobile?></p>

          </div>
        </div>
      </td>
      <td   style="padding-left:20px; width: 25%; font-size: 10px;text-align:right;">
         <div class="row">
          <div class="col-md-12">
            <p style="font-weight:bold">Sale Order :<?=$model->sale_order_id?></p>
            
              <p class="">Date : <?=date('F j Y', strtotime($model->date))?></p>
             <p class="">Due Date : <?=date('F j Y', strtotime($model->due_date))?></p>
              <p class="">Payment Terms : <?=$model->sale_order_id?></p>
              <p>PO No : <?=$model->po_no?></p>
              <p class="">PO Date : 
              <?php if($model->po_date){?>
              <?=date('F j Y', strtotime($model->po_date))?></p>
              <?php }?>
              <p class="">Challan No :<?=$model->receipt_id?></p>
              <p class="">Challan Date :<?php if($model->receipt_id!=""){?>
                    <?=date('F j Y', strtotime($receipt->receipt_date))?>
                <?php } ?>
              </p>
          </div>
        </div>

      </td>
    </tr>
</table>
<!-- </thead>
 -->
 <table class=" table product">
    <tbody class="mt-2 table-bordered" >
    <tr border="2" style="text-align: center; width: 100%;">
    <th width="" scope="col" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black;">S.N0</th>
    <th width="" rowspan="2" style="border: 1px solid black; ">ITEM</th> 
    <th width="" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">HSN/SAC</th> 
    <th width="" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">BRAND</th> 
    <th width="" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">QTY</th> 
    <th width="" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">UNIT PRICE</th> 
    <th width="" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">ITEM TOTAL</th> 
    <th width="" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">DISCOUNT</th>
    <th width="" rowspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">T/AMT</th>
        <?php if($model->point_of_supply==21){?>
             <th  width="" colspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">SGST</th>
              <th width="" colspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">CGST</th>
        <?php }
        else {?>
           <th  width="fi" colspan="2" style="border-top: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black;">IGST</th>
        <?php } ?> 
    <th rowspan="2" width="" style="border-top: 1px solid black; border-bottom: 1px solid black; ">AMOUNT</th>
    </tr>
    <tr> 
      <?php if($model->point_of_supply==21){?>
                <th style="text-align: center; border-bottom: 1px solid black; border-right: 1px solid black;">%</th>
                <th style="text-align: center; border-bottom: 1px solid black; border-right: 1px solid black;">AMT</th>
                <th style="text-align: center; border-bottom: 1px solid black; border-right: 1px solid black;">%</th>
                <th style="text-align: center; border-bottom: 1px solid black; border-right: 1px solid black;">AMT</th>
            <?php }
            else {?>
               <th style="text-align: center; border-bottom: 1px solid black; border-right: 1px solid black;">%</th>
               <th style="text-align: center; border-bottom: 1px solid black; border-right: 1px solid black;">AMT</th>
            <?php } ?> 
        
    </tr>
    <?php 
        global $total_value_price,$tot_tax;
    foreach($products as $key=>$value){ 
      if($count!=$key+1){
      ?>
        
        <tr style="text-align: center;">
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center"><?=$key+1?></td>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:left;"><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></td> 
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center"><?=Product::find()->where(['id'=>$value->product_id])->one()->hsn_sac_code?></td> 
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center"></td> 
            <!-- <td></td> -->
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center;"><?=$value->quantity?></td> 
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align: right;"><?=$value->unit_price?></td>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align: right;"><?=$value->price?></td>
            <?php $total_value_price+=$value->price;?>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align: right;"><?=$value->discount?> <?=$value->discount_type?></td>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:right;"><?php if($value->discount_type=="FLAT"){?>
                    <?=$value->price-$value->discount?>
                <?php } ?>
                <?php if($value->discount_type=="%"){?>
                    <?=$value->price-(($value->price*$value->discount)/100)?>
                <?php } ?>

                <?php if($value->discount_type==""){?>
                    <?=$value->price?>
                <?php } ?>  
            </td>
            <?php if($model->point_of_supply==21){?>


                <td style="border-right: 1px solid black;border-bottom:none;padding:3px;">
                <?php if($value->tax_included==1){
                  $rows = (new \yii\db\Query())
                      ->select(['tax_rate'])
                      ->from('accounting_tax')
                      ->where(['accounting_tax_id' => explode(',',$value->tax)])
                      ->all();
                      ?>
                      <?php
                      global $total_tax;
                      $total_tax=0;
                      foreach ($rows as $key => $rows) {
                        $total_tax+=$rows['tax_rate'];
                      }
                      echo  $total_tax/2; 
                      ?>
                <?php }
                else {?>
                    <?=0?>
                <?php } ?>
                </td>
                <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align: right;">
                <?php if($value->tax_included==1){?>
                <?php if($value->discount_type=="FLAT"){?>
                        <?=round((($value->price-$value->discount)*(($total_tax)/2))/100,2)?>
                <?php } ?>
                <?php if($value->discount_type=="%"){?>
                  <?=((($value->price-(($value->price*$value->discount)/100))*(($total_tax)/2))/100)?>

                <?php } ?>
                <?php if($value->discount_type==""){?>
                  <?=((($value->price)*(($total_tax)/2))/100)?>
                <?php } ?>
                <?php } ?>
                <?php if($value->tax_included==0){?>
                    <?=0?>
                <?php } ?>  
                </td>

              <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align: right;">
                <?php if($value->tax_included==1){?>
                    <?=$total_tax/2?> 
                <?php }
                else {?>
                    <?=0?>
                <?php } ?>
                </td>
                <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align: right;">
                <?php if($value->tax_included==1){?>
                <?php if($value->discount_type=="FLAT"){?>
                        <?=round((($value->price-$value->discount)*(($total_tax)/2))/100,2)?>
                <?php } ?>
                <?php if($value->discount_type=="%"){?>
                        <?=((($value->price-(($value->price*$value->discount)/100))*(($total_tax)/2))/100)?>
                <?php } ?>
                <?php if($value->discount_type==""){?>
                        <?=((($value->price)*(($total_tax)/2))/100)?>
                <?php } ?>
                <?php } ?>
                <?php if($value->tax_included==0){?>
                    <?=0?>
                <?php } ?>  
                </td>
            <?php }
            else {?>
                <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align: right;">
                    <?php if($value->tax_included==1){
                      $rows = (new \yii\db\Query())
                      ->select(['tax_rate'])
                      ->from('accounting_tax')
                      ->where(['accounting_tax_id' => explode(',',$value->tax)])
                      ->all();
                      ?>
                      <?php
                      global $total_tax;
                      $total_tax=0;
                      foreach ($rows as $key => $rows) {
                        $total_tax+=$rows['tax_rate'];
                      }
                      echo  $total_tax; 
                      ?>
                <?php }
                else {?>
                    <?=0?>
                <?php } ?>
                </td>
                <td style="padding:3px;border:none;border-right:1px solid black;text-align: right;">
                    <?php if($value->tax_included==1){?>
                    <?php if($value->discount_type=="FLAT"){?>
                            <?=round((($value->price-$value->discount)*$total_tax)/100,2)?>
                          <?php  $tot_tax+=round((($value->price-$value->discount)*$total_tax)/100,2);?>
                    <?php } ?>
                    <?php if($value->discount_type=="%"){?>
                            <?=round((($value->price-(($value->price*$value->discount)/100))*$total_tax)/100,2)?>
                           <?php $tot_tax+=round((($value->price-(($value->price*$value->discount)/100))*$total_tax)/100,2);?>
                    <?php } ?>
                    <?php if($value->discount_type==""){?>
                     <?=round($value->price*($total_tax/100),2)?>
                     <?php $tot_tax+=round($value->price*($total_tax/100),2);?>
                    <?php } ?>
                    <?php } ?>
                    <?php if($value->tax_included==0){?>
                        <?=0?>
                    <?php } ?>                
              </td>


            <?php } ?>  
            <?php if($value->tax_included==1){?>
              <td style="border-bottom:none;padding:3px;text-align:right"><?=round(($value->amount),2)?></td>
            <?php }else{ ?>
              <td style="border-bottom:none;padding:3px;text-align:right"><?=round(($value->amount),2)?></td>
            <?php }?>
            

        </tr>
    <?php } else { ?>    
      <tr style="text-align: center;">
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center;padding-bottom:150px;"><?=$key+1?></td>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:left;padding-bottom:150px;"><?=Product::find()->where(['id'=>$value->product_id])->one()->product_name?></td> 
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center;padding-bottom:150px;"></td> 
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center;padding-bottom:150px;"></td> 
            <!-- <td></td> -->
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:center;padding-bottom:150px;"><?=$value->quantity?></td> 
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;text-align:right;padding-bottom:150px;"><?=$value->unit_price?></td>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;padding-bottom:150px;text-align:right;"><?=$value->price?></td>
            <?php $total_value_price+=$value->price;?>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;padding-bottom:150px;text-align: right;"><?=$value->discount?> <?=$value->discount_type?></td>
            <td style="border-right: 1px solid black;border-bottom:none;padding:3px;padding-bottom:150px;text-align: right;"><?php if($value->discount_type=="FLAT"){?>
                    <?=$value->price-$value->discount?>
                <?php } ?>
                <?php if($value->discount_type=="%"){?>
                    <?=$value->price-(($value->price*$value->discount)/100)?>
                <?php } ?>

                <?php if($value->discount_type==""){?>
                    <?=$value->price?>
                <?php } ?>  
            </td>
            <?php if($model->point_of_supply==21){?>


                <td style="border-right: 1px solid black;border-bottom:none;padding-bottom:150px;text-align: right;">
                <?php if($value->tax_included==1){
                  $rows = (new \yii\db\Query())
                      ->select(['tax_rate'])
                      ->from('accounting_tax')
                      ->where(['accounting_tax_id' => explode(',',$value->tax)])
                      ->all();
                      ?>
                      <?php
                      global $total_tax;
                      $total_tax=0;
                      foreach ($rows as $key => $rows) {
                        $total_tax+=$rows['tax_rate'];
                      }
                      echo  $total_tax/2; 
                      ?>
                <?php }
                else {?>
                    <?=0?>
                <?php } ?>
                </td>
                <td style="border-right: 1px solid black;border-bottom:none;padding-bottom:150pxpx;text-align: right;">
                <?php if($value->tax_included==1){?>
                <?php if($value->discount_type=="FLAT"){?>
                        <?=round((($value->price-$value->discount)*(($total_tax)/2))/100,2)?>
                <?php } ?>
                <?php if($value->discount_type=="%"){?>
                  <?=((($value->price-(($value->price*$value->discount)/100))*(($total_tax)/2))/100)?>

                <?php } ?>
                <?php if($value->discount_type==""){?>
                  <?=((($value->price)*(($total_tax)/2))/100)?>
                <?php } ?>
                <?php } ?>
                <?php if($value->tax_included==0){?>
                    <?=0?>
                <?php } ?>  
                </td>

              <td style="border-right: 1px solid black;border-bottom:none;padding-bottom:150px;text-align: right;">
                <?php if($value->tax_included==1){?>
                    <?=$total_tax/2?> 
                <?php }
                else {?>
                    <?=0?>
                <?php } ?>
                </td>
                <td style="border-right: 1px solid black;border-bottom:none;padding-bottom:150px;text-align: right;">
                <?php if($value->tax_included==1){?>
                <?php if($value->discount_type=="FLAT"){?>
                        <?=round((($value->price-$value->discount)*(($total_tax)/2))/100,2)?>
                <?php } ?>
                <?php if($value->discount_type=="%"){?>
                        <?=((($value->price-(($value->price*$value->discount)/100))*(($total_tax)/2))/100)?>
                <?php } ?>
                <?php if($value->discount_type==""){?>
                        <?=((($value->price)*(($total_tax)/2))/100)?>
                <?php } ?>
                <?php } ?>
                <?php if($value->tax_included==0){?>
                    <?=0?>
                <?php } ?>  
                </td>
            <?php }
            else {?>
                <td style="border-right: 1px solid black;border-bottom:none;padding-bottom:150px;text-align: right;">
                    <?php if($value->tax_included==1){
                      $rows = (new \yii\db\Query())
                      ->select(['tax_rate'])
                      ->from('accounting_tax')
                      ->where(['accounting_tax_id' => explode(',',$value->tax)])
                      ->all();
                      ?>
                      <?php
                      global $total_tax;
                      $total_tax=0;
                      foreach ($rows as $key => $rows) {
                        $total_tax+=$rows['tax_rate'];
                      }
                      echo  $total_tax; 
                      ?>
                <?php }
                else {?>
                    <?=0?>
                <?php } ?>
                </td>
                <td style="padding:3px;border:none;padding-bottom:150px;border-right:1px solid black;text-align: right;">
                    <?php if($value->tax_included==1){?>
                    <?php if($value->discount_type=="FLAT"){?>
                            <?=round((($value->price-$value->discount)*$total_tax)/100,2)?>
                          <?php  $tot_tax+=round((($value->price-$value->discount)*$total_tax)/100,2);?>
                    <?php } ?>
                    <?php if($value->discount_type=="%"){?>
                            <?=round((($value->price-(($value->price*$value->discount)/100))*$total_tax)/100,2)?>
                           <?php $tot_tax+=round((($value->price-(($value->price*$value->discount)/100))*$total_tax)/100,2);?>
                    <?php } ?>
                    <?php if($value->discount_type==""){?>
                     <?=round($value->price*($total_tax/100),2)?>
                     <?php $tot_tax+=round($value->price*($total_tax/100),2);?>
                    <?php } ?>
                    <?php } ?>
                    <?php if($value->tax_included==0){?>
                        <?=0?>
                    <?php } ?>                
              </td>


            <?php } ?>  
            <?php if($value->tax_included==1){?>
              <td style="border-bottom:none;padding-bottom:150px;text-align:right"><?=round(($value->amount),2)?></td>
            <?php }else{ ?>
              <td style="border-bottom:none;padding-bottom:150px;text-align:right"><?=round(($value->amount),2)?></td>
            <?php }?>
            

        </tr>
    <?php }
    
    }?> 
        
          <tr style="text-align:center;">

       <td style="border-top:1px solid black;border-right:1px solid black;"></td>
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;"><strong> Subtotal</strong></td> 
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;"></td> 
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;"></td> 
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;text-align: right;"><?=$total_product?></td> 
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;"></td> 
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;text-align: right;"><?= $total_value_price ?></td>
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;text-align:right"></td>
       <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;text-align: right;"><?=$taxable_amount?></td>
           <?php if($model->point_of_supply==21){?>
                 <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;"></td>
                 <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;text-align: right;"><?=$model->cgst_amount ?></td> 
                 <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;text-align: right;"></td>
                 <td style="border-top: 1px solid black;padding:3px;border-right:1px solid black;text-align: right;"><?=$model->cgst_amount ?></td> 
            <?php }
            else {?>
               <td style="border-top:1px solid black;padding:3px;border-right:1px solid black;text-align: right;"></td>
              <td style="border-top:1px solid black;padding:3px;border-right:1px solid black;text-align: right;"><?=$model->igst_amount ?></td> 
            <?php } ?> 
            
            <td style=" border-top: 1px solid black;text-align: right;"><?=$model->total_amount-$model->tcs_amount?></td>
    </tr>
    <?php if($model->point_of_supply==21){?>
      <tr>
       <td colspan="11" style="border-right: 1px solid black; border-top: 1px solid black;padding:3px"><strong><p></p></strong></td> 
       <td colspan="2 " style="text-align: center; border-top: 1px solid black;padding:3px;border-right: 1px solid black;"><strong>CGST TAX</strong></td> 
       <td colspan=""   style="text-align: center; border-top: 1px solid black;padding:3px ;text-align: right;"><strong><?=$model->cgst_amount ?></strong></td>         
    </tr>
    <tr>
       <td colspan="11" style="border-right: 1px solid black; border-top: 1px solid black;padding:3px;" ><strong><p></p></strong></td> 
       <td colspan="2 " style="text-align: center; border-top: 1px solid black;padding:3px;border-right:1px solid black;"><strong>SGST TAX</strong></td> 
       <td colspan="" style="text-align: center; border-top: 1px solid black;padding:3px ;text-align: right;"><strong><?=$model->sgst_amount ?></strong></td>         
    </tr>
    <?php if($model->is_tcs){?>
      <tr>
         <td colspan="11" style="border-right: 1px solid black; border-top: 1px solid black;padding:3px;" ><strong><p></p></strong></td> 
         <td colspan="2 " style="text-align: center; border-top: 1px solid black;padding:3px;border-right:1px solid black;"><strong>TCS</strong></td> 
         <td colspan="" style="text-align: center; border-top: 1px solid black;padding:3px ;text-align: right;"><strong><?= $model->tcs_amount?></strong></td>       
      </tr>
    <?php } ?>
     <tr>
         <td colspan="11" style="border-right: 1px solid black; border-top: 1px solid black;padding:3px;" ><strong><p></p></strong></td> 
         <td colspan="2 " style="text-align: center; border-top: 1px solid black;padding:3px;border-right:1px solid black;"><strong>Round Off (Rs)</strong></td> 
         <?php if($model['round_off']!=null){?>
         <td colspan="" style="text-align: center; border-bottom: 1px solid black;padding:3px;text-align: right;"><strong><?=$model['round_off']?></strong></td>       
         <?php } else{ ?>
          <td colspan="" style="text-align: center; border-bottom: 1px solid black;padding:3px;"><strong>0.00</strong></td>       
          <?php } ?>
      </tr>

      <tr>
        <td colspan="11" style="border-right: 1px solid black; border-top: 1px solid black; padding:3px;" >Amount (in Words) :<strong><div style=" text-transform: capitalize;padding:3px;"><?= AmountInWords($model->total_amount) ?> (INR) Only<div></td> </strong></td> 
        <td colspan="2 " style="text-align: center; border-top: 1px solid black;padding:3px;border-right:1px solid black;"><strong>Total (Rs)</strong></td> 
        <td colspan="" style="text-align: center; border-top: 1px solid black;padding:3px;text-align: right;"><strong><?=$model['total_amount']?></strong></td>
      </tr>
    <?php }
    else {?>
        <tr>
           <td colspan="9" style="border-right: 1px solid black; border-top: 1px solid black;padding:3px" ><strong><p></p></strong></td> 
           <td colspan="2 " style="text-align: center; border-top: 1px solid black;padding:3px;border-right: 1px solid black;"><strong>IGST TAX</strong></td> 
           <td colspan="" style="text-align: center; border-top: 1px solid black;padding:3px;text-align: right;"><strong><?=$tot_tax ?></strong></td>         
        </tr>
        <?php if($model->is_tcs){?>
        <tr>
           <td colspan="9" style="border-right: 1px solid black; border-top: 1px solid black;padding:3px" ><strong><p></p></strong></td> 
           <td colspan="2 " style="text-align: center; border-top: 1px solid black;border-right:1px solid black;padding:3px;"><strong>TCS</strong></td> 
           <td colspan="" style="text-align: center; border-top: 1px solid black;padding:3px;text-align: right;"><strong><?=$model->tcs_amount?></strong></td>         
        </tr>
        <?php } ?>
        <tr>
           <td colspan="9" style="border-right: 1px solid black; border-top: 1px solid black;padding:3px;" ><strong><p></p></strong></td> 
           <td colspan="2 " style="text-align: center; border-top: 1px solid black;border-right:1px solid black;padding:3px;"><strong>Round Off (Rs)</strong></td> 
           <?php if($model['round_off']!=null){?>
         <td colspan="" style="text-align: center; border-bottom: 1px solid black;padding:3px;text-align: right;"><strong><?=$model['round_off']?></strong></td>       
         <?php } else{ ?>
          <td colspan="" style="text-align: center; border-bottom: 1px solid black;padding:3px;text-align: right;"><strong>0.00</strong></td>       
          <?php } ?>
        </tr>

        <tr>
          <td colspan="9" style="border-right: 1px solid black; border-top: 1px solid black;border-bottom: 1px solid black;padding:3px;border-right:1px solid black;" >
            Amount (in Words) :<strong><div style=" text-transform: capitalize;padding:3px;text-align: right;"><?= Yii::$app->formatter->asSpellout($model->total_amount)?> (INR) Only<div></td> </strong>
          <td colspan="2 " style="text-align: center; border-top: 1px solid black;padding:3px;border-right:1px solid black;border-bottom: 1px solid black;"><strong>Total (Rs)</strong></td> 
          <td colspan="" style="text-align: center; border-top: 1px solid black;text-align: right;border-bottom: 1px solid black;"><strong><?=$model['total_amount']?></strong></td>
       </tr>
    <?php } ?>  
  </tbody>
 </table>
    <table class=" table product" >
  <tbody class="table-bordered">
         <tr>
        <td width="40%" style="font-size:10px;">
       
              <strong>Terms and conditions :</strong>
              <?= $template->terms_and_condition ?>
        </td> 
      
         <td colspan="2" style="font-size:10px;border-left: 1px solid black; border-right: 1px solid black;">
          <div class="row">
              <strong>Bank Details</strong>
              <ul>
              <li>BANK - <?= $template->bank_name  ?></li>
                <li>ACCOUNT HOLDER - <?= $template->account_holder ?></li>        
                <li>ACCOUNT NUMBER - <?= $template->acc_no ?></li>
                <li>IFSC CODE - <?= $template->ifsc_code ?></li>
              </ul>
            </div>
         </td> 
         
          <td colspan="4" id="bottom" class="text-right" style="font-size:10px;" > 
          <td align="right" class="bottomline right allpad"><br /> <img border="0" height="33.33" src='<?= Url::base() ?>/template_seals/<?= $template->company_seal ?>' /><br /> <b style=""><?=$template->company_signature?></b><br /> (Authorized Signatory)</td>
          </td> 
    </tr>
  </tbody>
 </table>   
  <!-- </div> -->
  
</body>

<!-- jQuery and JS bundle w/ Popper.js -->
<!-- <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js"></script>
</body>
</html> -->
