<?php
use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ActiveForm;
use yii\helpers\Url;
use backend\modules\master\models\Customer;
use backend\modules\master\models\LeadExecutive;
use yii\helpers\ArrayHelper;
use backend\modules\users\models\SaleOrder;
use backend\modules\users\models\SaleOrderProduct;
use backend\modules\users\models\DeliveredProductList;


use backend\models\AuthAssignment;
use backend\models\AuthItemChild;

$id = Yii::$app->user->identity->id;
$assign = AuthAssignment::find()->where(['user_id'=>$id])->one();
/* @var $this yii\web\View */
/* @var $searchModel backend\modules\users\models\SalesOrdersSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Sales Orders';
$this->params['breadcrumbs'][] = $this->title;
?>
<style>
.select2-container .select2-selection--single {
    height: 42px !important;
}
.select2-container--default .select2-selection--single .select2-selection__rendered
{
    line-height: 39px;
}
.select2-container--default .select2-selection--single .select2-selection__arrow
{
    height: 39px;
}
th a{
    color:#495057;
}
th a:hover{
    color:#495057;
}
body{
    font-family:Arial, Helvetica, sans-serif;
    font-size:13px;
}
.form-control {
    transition: all .2s;
    font-family: Arial, Helvetica, sans-serif;
    font-size: 13px;
}
.pagination li.active a {
    z-index: 1;
    color: #fff;
    background-color: #16aaff;
    border-color: #16aaff;
}
</style>
<script type="text/javascript">
    $ids = [];
</script>


    <?php if (Yii::$app->session->hasFlash('success')){ ?>
    <div class="alert alert-success" style="background-color:#dff0d8 !important; text-align:center">
        <button aria-hidden="true" data-dismiss="alert" class="close" type="button">×</button>
          <strong style="color:#3c763d"><?= Yii::$app->session->getFlash('success');?></strong>
    </div>
<?php } ?>
                <div class="app-main__inner">
                <div class="card no-shadow bg-transparent no-border rm-borders mb-3">
                            <div class="card">
                                <div class="no-gutters row">
                                    <div class="col-md-12 col-lg-12">
                                        <ul class="list-group list-group-flush">
                                            <li class="bg-transparent list-group-item">
                                                <div class="widget-content p-0">
                                                    <div class="widget-content-outer">
                                                        <div class="widget-content-wrapper">
                                                            <div class="widget-content-left">
                                                                <div class="widget-numbers dj-text-success">Pending Orders</div>
                                                            </div>
                                                            <div class="widget-content-right">
                                                           <!--  <a href="#" class="dj-import-btn"><i class="fa fa-download"></i> Import Receipt</a> -->
                                                                
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </li>
                                          
                                        </ul>
                                    </div>
                                   
                                    
                                </div>
                            </div>
                        </div>
                        <div class="main-card mb-3 card">
                           <div class="card-body">
                           <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                           <div class="row dj-adv-search-row">
                           <div class="col-md-6">
                               <div class="position-relative form-group">
                                 <?= $form->field($model, 'commonsearch')->textInput(['maxlength' => true,'class'=>"form-control","placeholder"=>"Customer"])->label(false) ?>
                              </div>
                            </div>
                            <div class="col-md-2">
                                 <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'search_field_buttons']) ?>
                            </div>
                            <?php ActiveForm::end(); ?> 
                            <div class="col-md-3">
                            <a id="advance-search" class="search_field_buttons" data-toggle="collapse" href="#search-look" role="button" aria-expanded="false" aria-controls="search-look" type="button">Advance Search <i class="fa fa-chevron-down" aria-hidden="true"></i></a>
                            </div>
                            <div class="col-md-1">
                            <a  class="search_field_buttons"  href="<?=Url::base().'/users/sale-order/saleorder-pending'?>" role="button" aria-expanded="false" aria-controls="search-look" type="button" title="Refresh Page"><i class="fa fa-refresh" aria-hidden="true"></i></a>
                            </div>
                           </div>
                           
                           <div class="dj-sale-form collapse" id="search-look">
                                <?php $form = ActiveForm::begin(['method' => 'get']); ?>
                                    <form>
                                        <div class="form-row">
                                        
                                        <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">From</label>
                                                    <?= $form->field($model, 'from_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="notes">To</label>
                                                    <?= $form->field($model, 'to_date')->textInput(['type'=>"date",'class'=>"form-control"])->label(false) ?>
                                                </div>
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Status</label>
                                                     
                                                    <?= $form->field($model, 'converted_to')->dropDownList(['Proforma Invoice'=>'Proforma Invoice', 'Invoice'=>'Invoice','Receipt'=>'Receipt'],['prompt'=>'--Select--','class'=>'form-control converted_to'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                            <div class="col-md-4">
                                                <div class="position-relative form-group">
                                                    <label for="date">Source</label>
                                                    <?= $form->field($model, 'saleorder_source')->dropDownList(['Email'=>'Email','Created Manually'=>'Created Manually','Outgoing Shipment'=>'Outgoing Shipment'],['prompt'=>'--Select--','class'=>'form-control saleorder_source'])->label(false) ?>
                                                </div>
                                                
                                            </div>
                                             <div class="col-md-8 dj-btn-align" style="padding-top: 5px">
                                             <?= Html::submitButton('<span class="fa fa-search"></span> Search', ['class' => 'btn btn-info btn-rounded dj-search','style'=>"padding: 9px 21px"]) ?>
                                            </div>
                                        </div>
                                      </form> 
                                      <?php ActiveForm::end(); ?> 
                                    </div>
                                </div>
                        </div>
                          <div class="main-card mb-3 card">
                        <div class="card-body">
                        <div class="row">

                            <div class="col-sm-6">
                                <div class="djsec-text-left dj-print-sec">
                                    <!-- <button id='bulkdelete' class='mb-2 mr-2 btn-icon btn btn-danger '><i class="fa fa-trash"></i> Delete</button>   -->

                                    <button  class='mb-2 mr-2 btn-icon btn btn-info dj-ap-btn convert_button againstdc'><i class="fa fa-retweet"></i> Convert to Invoice</button>           
                               </div>
                            </div>
                            
                            <div class="col-sm-6">
                                <div class="djsec-text-right dj-print-sec">

                                    <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/pending-excel-export'])->one()!=''){?>
                                      <a href="<?=Url::base();?>/users/sale-order/pending-excel-export?detail=true" data-method="post"> <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o"></i> Details Excel</button></a>
                                       <a href="<?=Url::base();?>/users/sale-order/pending-excel-export" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-file-excel-o" aria-hidden="true"></i>  Excel</button></a>
                                       <?php }else {?>

                                       <?php } ?>

                                       <?php if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/sale-order/pending-pdf'])->one()!=''){?>
                                           <a href="<?=Url::base();?>/users/sale-order/pending-pdf" data-method="post">  <button class="mb-2 mr-2 btn-icon btn btn-info dj-ap-btn"><i class="fa fa-print"></i> Print</button></a>
                                       <?php }else {?>

                                       <?php } ?>
                                       
                                        
                                       
                                       
                                       

                                       
                                </div>
                            </div>
                        
                             </div>

                              <?= GridView::widget([
                                    'dataProvider' => $dataProvider,
                                    "id" => "grid",
                                    'columns' => [
                                        ['class' => 'yii\grid\CheckboxColumn',
                                        // 'value' => function ($data) {
                                            
                                        //     return  $data->id;

                                            
                                        // },
                                    ],
                                        ['class' => 'yii\grid\SerialColumn',
                                         
                                          'contentOptions'=>[ 'style'=>'width: 15px'],
                                          
                                      ],
                                        [
                                        'label' => 'Description',
                                        'format'=>'raw',
                                        'value' => function ($data) {
                                            $user= Customer::find()->where(['id' =>$data['customer_id']])->one();
                                            $saleorder = SaleOrder::find()->where(['id'=>$data['saleorder_id']])->one();
                                            return 'No.#-'. $saleorder->sale_order_id."</br>".'Name-'.$user['business_name']."</br>".'Remark-'.$saleorder->other_note;

                                            
                                        },
                                        ],
                                        [
                                        'label' => 'Amount',
                                        'contentOptions'=>[ 'style'=>'text-align:right'],
                                        // 'attribute' => 'total_amount',
                                        'value' => function ($data) {

                                            $saleid = $data->saleorder_id;
                                            $dcid = $data->dc_id;
                                            $saleorders = SaleOrder::find()->where(['id'=>$saleid])->one();
                                            $saleproducts = SaleOrderProduct::find()->where(['sale_order_no'=>$saleid])->all();
                                            $dcproduct = DeliveredProductList::find()->where(['delivered_id'=>$dcid])->all();
                                            $nos_of_dcs = DeliveredProductList::find()->where(['delivered_id'=>$dcid])->count();
                                            $applyed_tcs = 0;
                                            // $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $data->total_amount);
                                            // return $num; 
                                            $amt =0; 
                                            foreach ($saleproducts as $key => $value) {

                                                      foreach ($dcproduct as $key => $val) {

                                                           if($val->product_id == $value->product_id)
                                                           {
                                                                $amt = $amt + ($value->amount/$value->quantity)*$val->qty;
                                                           }
                                                      }
                                                 
                                              } 
                                              if($saleorders->is_tcs == 1) 
                                              {
                                                 $applyed_tcs = $amt/100;
                                                 $amt = $amt + $applyed_tcs;
                                              }
                                                $finalamount = number_format((float)$amt, 2, '.', '');
                                                $num = preg_replace("/(\d+?)(?=(\d\d)+(\d)(?!\d))(\.\d+)?/i", "$1,", $finalamount);
                                                // return $applyed_tcs; 
                                                return $num;
                                            

                                        },
                                        ],
                                        [
                                        'label' => 'Date',
                                        // 'attribute' => 'date',
                                        'value' => function ($data) {
                                            return date('F j Y', strtotime($data->saleorder_date));
                                    },
                                        ],
                                       
[
                                        'label' => 'Source',
                                        // 'attribute' => 'saleorder_source',
                                        'value' => function ($data) {
                                          return $data->source;  
                                        },
                                        ],
                                        [
                                            'label' => 'Convert To',
                                            'format'=>'raw',
                                            'value' => function ($data) {
                                                if($data->convert_to=='Invoice')
                                                {
                                                    return '<span class="label-partial">Invoice</span>';
                                                }
                                                elseif ($data->convert_to=='Receipt') {
                                                   return '<span class="label-paid">Receipt</span>';
                                                }
                                                else {
                                                    
                                                }
                                                
                                                
                                            },
                                            ],

                                        // ['class' => 'yii\grid\ActionColumn'],
                                             [
                                        'label' => 'Action',
                                        // 'attribute' => 'username',
                                        'format'=>'raw',
                                        'contentOptions'=>[ 'style'=>'width: 35px'],
                                        'value' => function ($data) use ($assign) {
                                            $saleorder = SaleOrder::find()->where(['id'=>$data['saleorder_id']])->one();
                                            $topstring = '<div class="d-inline-block dropdown">
                                                <button type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" class="btn-shadow dropdown-toggle btn btn-info dj-action-btn">Action</button>
                                                <div tabindex="-1" role="menu" aria-hidden="true" class="dropdown-menu dropdown-menu-right dj-action-drop">
                                                    <ul class="nav flex-column">';
                                            $downstring =  '</ul></div></div>';
                                            if($data->convert_to=='Receipt')
                                            {
                                                if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/receipt-details/create'])->one()!='')
                                                {
                                                    $receiptstring = '<li class="nav-item">
                                                                <a class="nav-link" href='.Url::base().'/users/receipt-details/create?id='.$data->id.'&from=against_dc>
                                                                    <i class="fa fa-newspaper-o"></i>
                                                                    <span class="dj-icon-gap"> Receipt</span>
                                                                </a>
                                                            </li>';
                                                }
                                                else
                                                {
                                                    $receiptstring = '';
                                                } 
                                                return $topstring.''.$receiptstring.''.$downstring;
                                            }
                                            
                                            else
                                            {
                                                if(AuthItemChild::find()->where(['parent'=>$assign->item_name,'child'=>'/users/invoice/create'])->one()!='')
                                                {
                                                    $invoicestring = '<li class="nav-item">
                                                                <a class="nav-link" href='.Url::base().'/users/invoice/create?id='.$saleorder->id.'&from=against_dc&dc='.$data->id.' onclick="return " data-method=post>
                                                                    <i class="fa fa-retweet"></i>
                                                                    <span class="dj-icon-gap"> Convert To Invoice</span>
                                                                </a>
                                                            </li>';
                                                }
                                                else
                                                {
                                                    $invoicestring = '';
                                                } 
                                                return $topstring.''.$invoicestring.''.$downstring;
                                            }   
                                        },
                                    ],
                                    ],
                                ]); ?>

                        </div>          
                    </div>
                </div>
<?php ob_start();?>
<script type="text/javascript">
$(function() {
    // $('.convert_button').hide();

     // $selected_ids = $('#grid').yiiGridView('getSelectedRows');
     // if($selected_ids!='')
     // {
     //    $('.convert_button').show();
     // }
    $('.converted_to').select2({'width':'100%'});
    $('.saleorder_source').select2({'width':'100%'});
$('#bulkdelete').click(function(){
    // var $ids = $('#grid').yiiGridView('getSelectedRows');
    if(ids != 0)
    {
        var x = confirm("Are you sure you want to delete selected items?");
        if(x)
        {
            var ids = $('#grid').yiiGridView('getSelectedRows');
            // console.log(ids);
            $.post( 'delete-pending-saleorder',{data: ids}, function( data ) {
               });
        }
        else
        {
            return false;
        }
    }
    else
    {
        var x = alert("Please select some itmes to delete!");
    }
   
})
$('.againstdc').click(function()
{
    var ids = $('#grid').yiiGridView('getSelectedRows');
    // console.log(ids);
    if(ids != '')
    {
        var count = 0;
        var ids = $('#grid').yiiGridView('getSelectedRows');
        jQuery.ajaxSetup({async:false});
        $.post( 'check-saleorder',{data: ids}, function( data ) {

            var data =$.parseJSON(data);
            // alert(data);
                if(data==true)
                {
                    
                }
                else
                {
                    count ++;
                }
               });
           
        if(count==0)
        {
           $.post( 'from-saleorder',{data: ids}, function( data ) {
           })
            return true;
            
        }
        if(count!=0)
        {
            alert('Select some valid items.');
            return false;
        }
     }
    else
    {
         var x = alert("Please select some items to convet to invoice!");
         return false;
     }
})


$('.deleteorder').click(function(){
var confirm = window.confirm("Are u sure you want to delete the selected item?");
if (confirm == true)
return true;
else
return false;
})
$('#w1').hide();
$('#advance-search').click(function(){
    $('#w1').toggle();
})
});
</script>   
<?php $this->registerJs(preg_replace('~^\s*<script.*>|</script>\s*$~ U', '', ob_get_clean()))?>    